// $ANTLR 3.2 Sep 23, 2009 12:02:23 H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g 2009-10-07 12:39:28

package jkit.java.parser;
import jkit.compiler.SyntaxError;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

/** A Java 1.5 grammar for ANTLR v3 derived from the spec
 *
 *  This is a very close representation of the spec; the changes
 *  are comestic (remove left recursion) and also fixes (the spec
 *  isn't exactly perfect).  I have run this on the 1.4.2 source
 *  and some nasty looking enums from 1.5, but have not really
 *  tested for 1.5 compatibility.
 *
 *  I built this with: java -Xmx100M org.antlr.Tool java.g 
 *  and got two errors that are ok (for now):
 *  java.g:691:9: Decision can match input such as
 *    "'0'..'9'{'E', 'e'}{'+', '-'}'0'..'9'{'D', 'F', 'd', 'f'}"
 *    using multiple alternatives: 3, 4
 *  As a result, alternative(s) 4 were disabled for that input
 *  java.g:734:35: Decision can match input such as "{'$', 'A'..'Z',
 *    '_', 'a'..'z', '\u00C0'..'\u00D6', '\u00D8'..'\u00F6',
 *    '\u00F8'..'\u1FFF', '\u3040'..'\u318F', '\u3300'..'\u337F',
 *    '\u3400'..'\u3D2D', '\u4E00'..'\u9FFF', '\uF900'..'\uFAFF'}"
 *    using multiple alternatives: 1, 2
 *  As a result, alternative(s) 2 were disabled for that input
 *
 *  You can turn enum on/off as a keyword :)
 *
 *  Version 1.0 -- initial release July 5, 2006 (requires 3.0b2 or higher)
 *
 *  Primary author: Terence Parr, July 2006
 *
 *  Version 1.0.1 -- corrections by Koen Vanderkimpen & Marko van Dooren,
 *      October 25, 2006;
 *      fixed normalInterfaceDeclaration: now uses typeParameters instead
 *          of typeParameter (according to JLS, 3rd edition)
 *      fixed castExpression: no longer allows expression next to type
 *          (according to semantics in JLS, in contrast with syntax in JLS)
 *
 *  Version 1.0.2 -- Terence Parr, Nov 27, 2006
 *      java spec I built this from had some bizarre for-loop control.
 *          Looked weird and so I looked elsewhere...Yep, it's messed up.
 *          simplified.
 *
 *  Version 1.0.3 -- Chris Hogue, Feb 26, 2007
 *      Factored out an annotationName rule and used it in the annotation rule.
 *          Not sure why, but typeName wasn't recognizing references to inner
 *          annotations (e.g. @InterfaceName.InnerAnnotation())
 *      Factored out the elementValue section of an annotation reference.  Created 
 *          elementValuePair and elementValuePairs rules, then used them in the 
 *          annotation rule.  Allows it to recognize annotation references with 
 *          multiple, comma separated attributes.
 *      Updated elementValueArrayInitializer so that it allows multiple elements.
 *          (It was only allowing 0 or 1 element).
 *      Updated localVariableDeclaration to allow annotations.  Interestingly the JLS
 *          doesn't appear to indicate this is legal, but it does work as of at least
 *          JDK 1.5.0_06.
 *      Moved the Identifier portion of annotationTypeElementRest to annotationMethodRest.
 *          Because annotationConstantRest already references variableDeclarator which 
 *          has the Identifier portion in it, the parser would fail on constants in 
 *          annotation definitions because it expected two identifiers.  
 *      Added optional trailing ';' to the alternatives in annotationTypeElementRest.
 *          Wouldn't handle an inner interface that has a trailing ';'.
 *      Swapped the expression and type rule reference order in castExpression to 
 *          make it check for genericized casts first.  It was failing to recognize a
 *          statement like  "Class<Byte> TYPE = (Class<Byte>)...;" because it was seeing
 *          'Class<Byte' in the cast expression as a less than expression, then failing 
 *          on the '>'.
 *      Changed createdName to use typeArguments instead of nonWildcardTypeArguments.
 *          Again, JLS doesn't seem to allow this, but java.lang.Class has an example of
 *          of this construct.
 *      Changed the 'this' alternative in primary to allow 'identifierSuffix' rather than
 *          just 'arguments'.  The case it couldn't handle was a call to an explicit
 *          generic method invocation (e.g. this.<E>doSomething()).  Using identifierSuffix
 *          may be overly aggressive--perhaps should create a more constrained thisSuffix rule?
 * 		
 *  Version 1.0.4 -- Hiroaki Nakamura, May 3, 2007
 *
 *	Fixed formalParameterDecls, localVariableDeclaration, forInit,
 *	and forVarControl to use variableModifier* not 'final'? (annotation)?
 *
 *  Version 1.0.5 -- Terence, June 21, 2007
 *	--a[i].foo didn't work. Fixed unaryExpression
 */
public class JavaParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "UNIT", "PACKAGE", "IMPORT", "STATIC_IMPORT", "CLASS", "INTERFACE", "ENUM", "MODIFIERS", "EXTENDS", "IMPLEMENTS", "FIELD", "METHOD", "PARAMETER", "VARARGS", "TYPE", "VOID", "TYPE_PARAMETER", "THROWS", "ANNOTATION", "SUPER", "INTVAL", "FLOATVAL", "DOUBLEVAL", "CHARVAL", "STRINGVAL", "BOOLVAL", "NULLVAL", "BLOCK", "VARDEF", "ASSERT", "IF", "FOR", "WHILE", "DOWHILE", "RETURN", "THROW", "BREAK", "CONTINUE", "ASSIGN", "VAR", "LOR", "OR", "LAND", "AND", "XOR", "EQ", "NEQ", "INSTANCEOF", "LTEQ", "GTEQ", "LT", "GT", "SHL", "SHR", "USHR", "ADD", "SUB", "DIV", "MUL", "MOD", "DEREF", "NEG", "POSTINC", "PREINC", "PREDEC", "POSTDEC", "NOT", "INV", "CAST", "SELECTOR", "INVOKE", "ARRAYINDEX", "NEW", "GETCLASS", "SYNCHRONIZED", "INIT", "TEST", "STEP", "LABEL", "FOREACH", "TRY", "CATCH", "FINALLY", "CONDEXPR", "ARRAYVAL", "SWITCH", "CASE", "DEFAULT", "ARRAYINIT", "ARGUMENTS", "LABINOP", "NONE", "STATIC", "ENUM_CONSTANT", "ASSIGNOP", "PARAMETERS", "TYPE_PARAMETERS", "Identifier", "FloatingPointLiteral", "CharacterLiteral", "StringLiteral", "HexLiteral", "OctalLiteral", "DecimalLiteral", "HexDigit", "IntegerTypeSuffix", "Exponent", "FloatTypeSuffix", "EscapeSequence", "UnicodeEscape", "OctalEscape", "Letter", "JavaIDDigit", "WS", "COMMENT", "LINE_COMMENT", "'package'", "';'", "'import'", "'static'", "'.'", "'*'", "'class'", "'extends'", "'implements'", "'<'", "','", "'>'", "'&'", "'{'", "'}'", "'interface'", "'void'", "'throws'", "'['", "']'", "'='", "'public'", "'protected'", "'private'", "'abstract'", "'final'", "'native'", "'synchronized'", "'transient'", "'volatile'", "'strictfp'", "'rep'", "'peer'", "'any'", "'boolean'", "'char'", "'byte'", "'short'", "'int'", "'long'", "'float'", "'double'", "'?'", "'super'", "'('", "')'", "'...'", "'null'", "'true'", "'false'", "'@'", "'default'", "'assert'", "':'", "'if'", "'else'", "'for'", "'while'", "'do'", "'try'", "'finally'", "'switch'", "'return'", "'throw'", "'break'", "'continue'", "'catch'", "'case'", "'+'", "'-'", "'/'", "'&='", "'|='", "'^='", "'%'", "'||'", "'&&'", "'|'", "'^'", "'=='", "'!='", "'instanceof'", "'++'", "'--'", "'~'", "'!'", "'new'"
    };
    public static final int PACKAGE=5;
    public static final int SHR=57;
    public static final int T__159=159;
    public static final int T__158=158;
    public static final int SHL=56;
    public static final int MOD=63;
    public static final int PREDEC=68;
    public static final int T__160=160;
    public static final int DEREF=64;
    public static final int NOT=70;
    public static final int T__167=167;
    public static final int T__168=168;
    public static final int EOF=-1;
    public static final int T__165=165;
    public static final int T__166=166;
    public static final int T__163=163;
    public static final int T__164=164;
    public static final int T__161=161;
    public static final int TYPE=18;
    public static final int T__162=162;
    public static final int IMPORT=6;
    public static final int T__148=148;
    public static final int T__147=147;
    public static final int T__149=149;
    public static final int RETURN=38;
    public static final int EQ=49;
    public static final int TYPE_PARAMETERS=100;
    public static final int T__154=154;
    public static final int T__155=155;
    public static final int T__156=156;
    public static final int T__157=157;
    public static final int T__150=150;
    public static final int T__151=151;
    public static final int T__152=152;
    public static final int T__153=153;
    public static final int T__139=139;
    public static final int T__138=138;
    public static final int T__137=137;
    public static final int T__136=136;
    public static final int IntegerTypeSuffix=109;
    public static final int STATIC=96;
    public static final int INV=71;
    public static final int STATIC_IMPORT=7;
    public static final int T__141=141;
    public static final int T__142=142;
    public static final int T__140=140;
    public static final int T__145=145;
    public static final int T__146=146;
    public static final int T__143=143;
    public static final int T__144=144;
    public static final int T__126=126;
    public static final int T__125=125;
    public static final int T__128=128;
    public static final int T__127=127;
    public static final int WS=117;
    public static final int T__129=129;
    public static final int FloatingPointLiteral=102;
    public static final int NONE=95;
    public static final int JavaIDDigit=116;
    public static final int FLOATVAL=25;
    public static final int GT=55;
    public static final int POSTINC=66;
    public static final int INVOKE=74;
    public static final int T__130=130;
    public static final int INIT=79;
    public static final int T__131=131;
    public static final int LAND=46;
    public static final int T__132=132;
    public static final int T__133=133;
    public static final int T__134=134;
    public static final int T__135=135;
    public static final int PARAMETERS=99;
    public static final int ANNOTATION=22;
    public static final int LTEQ=52;
    public static final int T__124=124;
    public static final int T__123=123;
    public static final int T__122=122;
    public static final int STEP=81;
    public static final int T__121=121;
    public static final int SUB=60;
    public static final int T__120=120;
    public static final int ASSIGNOP=98;
    public static final int HexDigit=108;
    public static final int T__202=202;
    public static final int T__203=203;
    public static final int T__204=204;
    public static final int T__205=205;
    public static final int T__206=206;
    public static final int SELECTOR=73;
    public static final int IMPLEMENTS=13;
    public static final int PREINC=67;
    public static final int ARRAYINIT=92;
    public static final int ADD=59;
    public static final int HexLiteral=105;
    public static final int INSTANCEOF=51;
    public static final int StringLiteral=104;
    public static final int ENUM=10;
    public static final int BLOCK=31;
    public static final int INTERFACE=9;
    public static final int DIV=61;
    public static final int OctalEscape=114;
    public static final int LOR=44;
    public static final int CAST=72;
    public static final int LT=54;
    public static final int BOOLVAL=29;
    public static final int WHILE=36;
    public static final int FloatTypeSuffix=111;
    public static final int OctalLiteral=106;
    public static final int CASE=90;
    public static final int NEW=76;
    public static final int BREAK=40;
    public static final int Identifier=101;
    public static final int PARAMETER=16;
    public static final int VAR=43;
    public static final int VOID=19;
    public static final int SUPER=23;
    public static final int COMMENT=118;
    public static final int VARDEF=32;
    public static final int ENUM_CONSTANT=97;
    public static final int GETCLASS=77;
    public static final int ARGUMENTS=93;
    public static final int LINE_COMMENT=119;
    public static final int SWITCH=89;
    public static final int THROWS=21;
    public static final int ARRAYVAL=88;
    public static final int ASSERT=33;
    public static final int MUL=62;
    public static final int TRY=84;
    public static final int CONDEXPR=87;
    public static final int UNIT=4;
    public static final int T__200=200;
    public static final int NULLVAL=30;
    public static final int T__201=201;
    public static final int INTVAL=24;
    public static final int OR=45;
    public static final int TEST=80;
    public static final int FIELD=14;
    public static final int FOREACH=83;
    public static final int CATCH=85;
    public static final int Letter=115;
    public static final int EscapeSequence=112;
    public static final int THROW=39;
    public static final int POSTDEC=69;
    public static final int CLASS=8;
    public static final int VARARGS=17;
    public static final int STRINGVAL=28;
    public static final int CharacterLiteral=103;
    public static final int Exponent=110;
    public static final int FOR=35;
    public static final int AND=47;
    public static final int IF=34;
    public static final int MODIFIERS=11;
    public static final int T__199=199;
    public static final int T__198=198;
    public static final int T__197=197;
    public static final int SYNCHRONIZED=78;
    public static final int T__196=196;
    public static final int T__195=195;
    public static final int T__194=194;
    public static final int T__193=193;
    public static final int CONTINUE=41;
    public static final int T__192=192;
    public static final int T__191=191;
    public static final int T__190=190;
    public static final int ARRAYINDEX=75;
    public static final int T__184=184;
    public static final int T__183=183;
    public static final int T__186=186;
    public static final int T__185=185;
    public static final int T__188=188;
    public static final int XOR=48;
    public static final int T__187=187;
    public static final int T__189=189;
    public static final int CHARVAL=27;
    public static final int T__180=180;
    public static final int T__182=182;
    public static final int DEFAULT=91;
    public static final int T__181=181;
    public static final int DOUBLEVAL=26;
    public static final int GTEQ=53;
    public static final int DecimalLiteral=107;
    public static final int LABINOP=94;
    public static final int T__175=175;
    public static final int T__174=174;
    public static final int T__173=173;
    public static final int T__172=172;
    public static final int T__179=179;
    public static final int TYPE_PARAMETER=20;
    public static final int NEQ=50;
    public static final int T__178=178;
    public static final int T__177=177;
    public static final int T__176=176;
    public static final int FINALLY=86;
    public static final int LABEL=82;
    public static final int UnicodeEscape=113;
    public static final int T__171=171;
    public static final int T__170=170;
    public static final int NEG=65;
    public static final int ASSIGN=42;
    public static final int T__169=169;
    public static final int EXTENDS=12;
    public static final int METHOD=15;
    public static final int USHR=58;
    public static final int DOWHILE=37;

    // delegates
    // delegators


        public JavaParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public JavaParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
            this.state.ruleMemo = new HashMap[393+1];
             
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return JavaParser.tokenNames; }
    public String getGrammarFileName() { return "H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g"; }


        public void displayRecognitionError(String[] tokenNames,
                                            RecognitionException e) {
    	  throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
        }    	


    public static class compilationUnit_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compilationUnit"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:222:1: compilationUnit : ( annotations )? ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* -> ^( UNIT ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* ) ;
    public final JavaParser.compilationUnit_return compilationUnit() throws RecognitionException {
        JavaParser.compilationUnit_return retval = new JavaParser.compilationUnit_return();
        retval.start = input.LT(1);
        int compilationUnit_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.annotations_return annotations1 = null;

        JavaParser.packageDeclaration_return packageDeclaration2 = null;

        JavaParser.importDeclaration_return importDeclaration3 = null;

        JavaParser.typeDeclaration_return typeDeclaration4 = null;


        RewriteRuleSubtreeStream stream_packageDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule packageDeclaration");
        RewriteRuleSubtreeStream stream_annotations=new RewriteRuleSubtreeStream(adaptor,"rule annotations");
        RewriteRuleSubtreeStream stream_typeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule typeDeclaration");
        RewriteRuleSubtreeStream stream_importDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule importDeclaration");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 1) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:2: ( ( annotations )? ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* -> ^( UNIT ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:4: ( annotations )? ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )*
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:4: ( annotations )?
            int alt1=2;
            alt1 = dfa1.predict(input);
            switch (alt1) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: annotations
                    {
                    pushFollow(FOLLOW_annotations_in_compilationUnit475);
                    annotations1=annotations();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_annotations.add(annotations1.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:17: ( packageDeclaration )?
            int alt2=2;
            alt2 = dfa2.predict(input);
            switch (alt2) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: packageDeclaration
                    {
                    pushFollow(FOLLOW_packageDeclaration_in_compilationUnit478);
                    packageDeclaration2=packageDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_packageDeclaration.add(packageDeclaration2.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:37: ( importDeclaration )*
            loop3:
            do {
                int alt3=2;
                alt3 = dfa3.predict(input);
                switch (alt3) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: importDeclaration
            	    {
            	    pushFollow(FOLLOW_importDeclaration_in_compilationUnit481);
            	    importDeclaration3=importDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_importDeclaration.add(importDeclaration3.getTree());

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:56: ( typeDeclaration )*
            loop4:
            do {
                int alt4=2;
                alt4 = dfa4.predict(input);
                switch (alt4) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: typeDeclaration
            	    {
            	    pushFollow(FOLLOW_typeDeclaration_in_compilationUnit484);
            	    typeDeclaration4=typeDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_typeDeclaration.add(typeDeclaration4.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);



            // AST REWRITE
            // elements: importDeclaration, packageDeclaration, typeDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 224:3: -> ^( UNIT ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:224:6: ^( UNIT ( packageDeclaration )? ( importDeclaration )* ( typeDeclaration )* )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(UNIT, "UNIT"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:224:13: ( packageDeclaration )?
                if ( stream_packageDeclaration.hasNext() ) {
                    adaptor.addChild(root_1, stream_packageDeclaration.nextTree());

                }
                stream_packageDeclaration.reset();
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:224:33: ( importDeclaration )*
                while ( stream_importDeclaration.hasNext() ) {
                    adaptor.addChild(root_1, stream_importDeclaration.nextTree());

                }
                stream_importDeclaration.reset();
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:224:52: ( typeDeclaration )*
                while ( stream_typeDeclaration.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeDeclaration.nextTree());

                }
                stream_typeDeclaration.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 1, compilationUnit_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "compilationUnit"

    public static class packageDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "packageDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:227:1: packageDeclaration : 'package' qualifiedName ';' -> ^( PACKAGE qualifiedName ) ;
    public final JavaParser.packageDeclaration_return packageDeclaration() throws RecognitionException {
        JavaParser.packageDeclaration_return retval = new JavaParser.packageDeclaration_return();
        retval.start = input.LT(1);
        int packageDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal5=null;
        Token char_literal7=null;
        JavaParser.qualifiedName_return qualifiedName6 = null;


        Object string_literal5_tree=null;
        Object char_literal7_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_120=new RewriteRuleTokenStream(adaptor,"token 120");
        RewriteRuleSubtreeStream stream_qualifiedName=new RewriteRuleSubtreeStream(adaptor,"rule qualifiedName");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 2) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:228:2: ( 'package' qualifiedName ';' -> ^( PACKAGE qualifiedName ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:228:4: 'package' qualifiedName ';'
            {
            string_literal5=(Token)match(input,120,FOLLOW_120_in_packageDeclaration518); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_120.add(string_literal5);

            pushFollow(FOLLOW_qualifiedName_in_packageDeclaration520);
            qualifiedName6=qualifiedName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_qualifiedName.add(qualifiedName6.getTree());
            char_literal7=(Token)match(input,121,FOLLOW_121_in_packageDeclaration522); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal7);



            // AST REWRITE
            // elements: qualifiedName
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 228:32: -> ^( PACKAGE qualifiedName )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:228:35: ^( PACKAGE qualifiedName )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PACKAGE, "PACKAGE"), root_1);

                adaptor.addChild(root_1, stream_qualifiedName.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 2, packageDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "packageDeclaration"

    public static class importDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "importDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:231:1: importDeclaration : 'import' ( 'static' i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( STATIC_IMPORT ( $i)+ ) | i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( IMPORT ( $i)+ ) ) ;
    public final JavaParser.importDeclaration_return importDeclaration() throws RecognitionException {
        JavaParser.importDeclaration_return retval = new JavaParser.importDeclaration_return();
        retval.start = input.LT(1);
        int importDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal8=null;
        Token string_literal9=null;
        Token char_literal10=null;
        Token char_literal11=null;
        Token char_literal12=null;
        Token char_literal13=null;
        Token char_literal14=null;
        Token char_literal15=null;
        Token i=null;
        List list_i=null;

        Object string_literal8_tree=null;
        Object string_literal9_tree=null;
        Object char_literal10_tree=null;
        Object char_literal11_tree=null;
        Object char_literal12_tree=null;
        Object char_literal13_tree=null;
        Object char_literal14_tree=null;
        Object char_literal15_tree=null;
        Object i_tree=null;
        RewriteRuleTokenStream stream_125=new RewriteRuleTokenStream(adaptor,"token 125");
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_122=new RewriteRuleTokenStream(adaptor,"token 122");
        RewriteRuleTokenStream stream_123=new RewriteRuleTokenStream(adaptor,"token 123");
        RewriteRuleTokenStream stream_124=new RewriteRuleTokenStream(adaptor,"token 124");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 3) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:232:2: ( 'import' ( 'static' i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( STATIC_IMPORT ( $i)+ ) | i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( IMPORT ( $i)+ ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:232:4: 'import' ( 'static' i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( STATIC_IMPORT ( $i)+ ) | i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( IMPORT ( $i)+ ) )
            {
            string_literal8=(Token)match(input,122,FOLLOW_122_in_importDeclaration542); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_122.add(string_literal8);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:232:13: ( 'static' i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( STATIC_IMPORT ( $i)+ ) | i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';' -> ^( IMPORT ( $i)+ ) )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==123) ) {
                alt9=1;
            }
            else if ( (LA9_0==Identifier) ) {
                alt9=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:4: 'static' i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';'
                    {
                    string_literal9=(Token)match(input,123,FOLLOW_123_in_importDeclaration549); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_123.add(string_literal9);

                    i=(Token)match(input,Identifier,FOLLOW_Identifier_in_importDeclaration553); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(i);

                    if (list_i==null) list_i=new ArrayList();
                    list_i.add(i);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:27: ( '.' i+= Identifier )*
                    loop5:
                    do {
                        int alt5=2;
                        int LA5_0 = input.LA(1);

                        if ( (LA5_0==124) ) {
                            int LA5_1 = input.LA(2);

                            if ( (LA5_1==Identifier) ) {
                                alt5=1;
                            }


                        }


                        switch (alt5) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:28: '.' i+= Identifier
                    	    {
                    	    char_literal10=(Token)match(input,124,FOLLOW_124_in_importDeclaration556); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_124.add(char_literal10);

                    	    i=(Token)match(input,Identifier,FOLLOW_Identifier_in_importDeclaration560); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_Identifier.add(i);

                    	    if (list_i==null) list_i=new ArrayList();
                    	    list_i.add(i);


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:48: ( '.' i+= '*' )?
                    int alt6=2;
                    int LA6_0 = input.LA(1);

                    if ( (LA6_0==124) ) {
                        alt6=1;
                    }
                    switch (alt6) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:49: '.' i+= '*'
                            {
                            char_literal11=(Token)match(input,124,FOLLOW_124_in_importDeclaration565); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_124.add(char_literal11);

                            i=(Token)match(input,125,FOLLOW_125_in_importDeclaration569); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_125.add(i);

                            if (list_i==null) list_i=new ArrayList();
                            list_i.add(i);


                            }
                            break;

                    }

                    char_literal12=(Token)match(input,121,FOLLOW_121_in_importDeclaration573); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal12);



                    // AST REWRITE
                    // elements: i
                    // token labels: 
                    // rule labels: retval
                    // token list labels: i
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 233:66: -> ^( STATIC_IMPORT ( $i)+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:233:69: ^( STATIC_IMPORT ( $i)+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(STATIC_IMPORT, "STATIC_IMPORT"), root_1);

                        if ( !(stream_i.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_i.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextNode());

                        }
                        stream_i.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:6: i+= Identifier ( '.' i+= Identifier )* ( '.' i+= '*' )? ';'
                    {
                    i=(Token)match(input,Identifier,FOLLOW_Identifier_in_importDeclaration592); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(i);

                    if (list_i==null) list_i=new ArrayList();
                    list_i.add(i);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:20: ( '.' i+= Identifier )*
                    loop7:
                    do {
                        int alt7=2;
                        int LA7_0 = input.LA(1);

                        if ( (LA7_0==124) ) {
                            int LA7_1 = input.LA(2);

                            if ( (LA7_1==Identifier) ) {
                                alt7=1;
                            }


                        }


                        switch (alt7) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:21: '.' i+= Identifier
                    	    {
                    	    char_literal13=(Token)match(input,124,FOLLOW_124_in_importDeclaration595); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_124.add(char_literal13);

                    	    i=(Token)match(input,Identifier,FOLLOW_Identifier_in_importDeclaration599); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_Identifier.add(i);

                    	    if (list_i==null) list_i=new ArrayList();
                    	    list_i.add(i);


                    	    }
                    	    break;

                    	default :
                    	    break loop7;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:41: ( '.' i+= '*' )?
                    int alt8=2;
                    int LA8_0 = input.LA(1);

                    if ( (LA8_0==124) ) {
                        alt8=1;
                    }
                    switch (alt8) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:42: '.' i+= '*'
                            {
                            char_literal14=(Token)match(input,124,FOLLOW_124_in_importDeclaration604); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_124.add(char_literal14);

                            i=(Token)match(input,125,FOLLOW_125_in_importDeclaration608); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_125.add(i);

                            if (list_i==null) list_i=new ArrayList();
                            list_i.add(i);


                            }
                            break;

                    }

                    char_literal15=(Token)match(input,121,FOLLOW_121_in_importDeclaration612); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal15);



                    // AST REWRITE
                    // elements: i
                    // token labels: 
                    // rule labels: retval
                    // token list labels: i
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 234:59: -> ^( IMPORT ( $i)+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:234:62: ^( IMPORT ( $i)+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(IMPORT, "IMPORT"), root_1);

                        if ( !(stream_i.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_i.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextNode());

                        }
                        stream_i.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 3, importDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "importDeclaration"

    public static class typeDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:238:1: typeDeclaration : ( classOrInterfaceDeclaration | ';' );
    public final JavaParser.typeDeclaration_return typeDeclaration() throws RecognitionException {
        JavaParser.typeDeclaration_return retval = new JavaParser.typeDeclaration_return();
        retval.start = input.LT(1);
        int typeDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal17=null;
        JavaParser.classOrInterfaceDeclaration_return classOrInterfaceDeclaration16 = null;


        Object char_literal17_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 4) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:239:2: ( classOrInterfaceDeclaration | ';' )
            int alt10=2;
            alt10 = dfa10.predict(input);
            switch (alt10) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:239:4: classOrInterfaceDeclaration
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_classOrInterfaceDeclaration_in_typeDeclaration639);
                    classOrInterfaceDeclaration16=classOrInterfaceDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, classOrInterfaceDeclaration16.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:240:9: ';'
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal17=(Token)match(input,121,FOLLOW_121_in_typeDeclaration649); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    char_literal17_tree = (Object)adaptor.create(char_literal17);
                    adaptor.addChild(root_0, char_literal17_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 4, typeDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeDeclaration"

    public static class classOrInterfaceDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classOrInterfaceDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:243:1: classOrInterfaceDeclaration : ( modifier )* ( classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) ) ;
    public final JavaParser.classOrInterfaceDeclaration_return classOrInterfaceDeclaration() throws RecognitionException {
        JavaParser.classOrInterfaceDeclaration_return retval = new JavaParser.classOrInterfaceDeclaration_return();
        retval.start = input.LT(1);
        int classOrInterfaceDeclaration_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.modifier_return modifier18 = null;

        JavaParser.classDeclaration_return classDeclaration19 = null;

        JavaParser.enumDeclaration_return enumDeclaration20 = null;

        JavaParser.normalInterfaceDeclaration_return normalInterfaceDeclaration21 = null;

        JavaParser.annotationTypeDeclaration_return annotationTypeDeclaration22 = null;


        RewriteRuleSubtreeStream stream_modifier=new RewriteRuleSubtreeStream(adaptor,"rule modifier");
        RewriteRuleSubtreeStream stream_annotationTypeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule annotationTypeDeclaration");
        RewriteRuleSubtreeStream stream_classDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule classDeclaration");
        RewriteRuleSubtreeStream stream_enumDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule enumDeclaration");
        RewriteRuleSubtreeStream stream_normalInterfaceDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule normalInterfaceDeclaration");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 5) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:244:2: ( ( modifier )* ( classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:244:4: ( modifier )* ( classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) )
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:244:4: ( modifier )*
            loop11:
            do {
                int alt11=2;
                alt11 = dfa11.predict(input);
                switch (alt11) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: modifier
            	    {
            	    pushFollow(FOLLOW_modifier_in_classOrInterfaceDeclaration661);
            	    modifier18=modifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_modifier.add(modifier18.getTree());

            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:244:14: ( classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) )
            int alt12=4;
            switch ( input.LA(1) ) {
            case 126:
                {
                alt12=1;
                }
                break;
            case ENUM:
                {
                alt12=2;
                }
                break;
            case 135:
                {
                alt12=3;
                }
                break;
            case 170:
                {
                alt12=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }

            switch (alt12) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:245:3: classDeclaration
                    {
                    pushFollow(FOLLOW_classDeclaration_in_classOrInterfaceDeclaration668);
                    classDeclaration19=classDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_classDeclaration.add(classDeclaration19.getTree());


                    // AST REWRITE
                    // elements: classDeclaration, modifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 245:20: -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:245:23: ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CLASS, "CLASS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:245:31: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:245:43: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_classDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:246:5: enumDeclaration
                    {
                    pushFollow(FOLLOW_enumDeclaration_in_classOrInterfaceDeclaration689);
                    enumDeclaration20=enumDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumDeclaration.add(enumDeclaration20.getTree());


                    // AST REWRITE
                    // elements: modifier, enumDeclaration
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 246:21: -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:246:24: ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ENUM, "ENUM"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:246:31: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:246:43: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_enumDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:247:5: normalInterfaceDeclaration
                    {
                    pushFollow(FOLLOW_normalInterfaceDeclaration_in_classOrInterfaceDeclaration710);
                    normalInterfaceDeclaration21=normalInterfaceDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_normalInterfaceDeclaration.add(normalInterfaceDeclaration21.getTree());


                    // AST REWRITE
                    // elements: modifier, normalInterfaceDeclaration
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 247:32: -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:247:35: ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INTERFACE, "INTERFACE"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:247:47: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:247:59: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_normalInterfaceDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:248:5: annotationTypeDeclaration
                    {
                    pushFollow(FOLLOW_annotationTypeDeclaration_in_classOrInterfaceDeclaration731);
                    annotationTypeDeclaration22=annotationTypeDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_annotationTypeDeclaration.add(annotationTypeDeclaration22.getTree());


                    // AST REWRITE
                    // elements: modifier, annotationTypeDeclaration
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 248:31: -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:248:34: ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:248:47: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:248:59: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_annotationTypeDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 5, classOrInterfaceDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "classOrInterfaceDeclaration"

    public static class classDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:252:1: classDeclaration : 'class' Identifier ( typeParameters )? ( 'extends' type )? ( 'implements' typeList )? classBody -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ( type )? ) ^( IMPLEMENTS ( typeList )? ) ( classBody )? ;
    public final JavaParser.classDeclaration_return classDeclaration() throws RecognitionException {
        JavaParser.classDeclaration_return retval = new JavaParser.classDeclaration_return();
        retval.start = input.LT(1);
        int classDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal23=null;
        Token Identifier24=null;
        Token string_literal26=null;
        Token string_literal28=null;
        JavaParser.typeParameters_return typeParameters25 = null;

        JavaParser.type_return type27 = null;

        JavaParser.typeList_return typeList29 = null;

        JavaParser.classBody_return classBody30 = null;


        Object string_literal23_tree=null;
        Object Identifier24_tree=null;
        Object string_literal26_tree=null;
        Object string_literal28_tree=null;
        RewriteRuleTokenStream stream_126=new RewriteRuleTokenStream(adaptor,"token 126");
        RewriteRuleTokenStream stream_127=new RewriteRuleTokenStream(adaptor,"token 127");
        RewriteRuleTokenStream stream_128=new RewriteRuleTokenStream(adaptor,"token 128");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_typeParameters=new RewriteRuleSubtreeStream(adaptor,"rule typeParameters");
        RewriteRuleSubtreeStream stream_classBody=new RewriteRuleSubtreeStream(adaptor,"rule classBody");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 6) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:253:2: ( 'class' Identifier ( typeParameters )? ( 'extends' type )? ( 'implements' typeList )? classBody -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ( type )? ) ^( IMPLEMENTS ( typeList )? ) ( classBody )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:253:4: 'class' Identifier ( typeParameters )? ( 'extends' type )? ( 'implements' typeList )? classBody
            {
            string_literal23=(Token)match(input,126,FOLLOW_126_in_classDeclaration763); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_126.add(string_literal23);

            Identifier24=(Token)match(input,Identifier,FOLLOW_Identifier_in_classDeclaration765); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier24);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:253:23: ( typeParameters )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==129) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:253:24: typeParameters
                    {
                    pushFollow(FOLLOW_typeParameters_in_classDeclaration768);
                    typeParameters25=typeParameters();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeParameters.add(typeParameters25.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:254:9: ( 'extends' type )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==127) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:254:10: 'extends' type
                    {
                    string_literal26=(Token)match(input,127,FOLLOW_127_in_classDeclaration781); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_127.add(string_literal26);

                    pushFollow(FOLLOW_type_in_classDeclaration783);
                    type27=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type27.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:255:9: ( 'implements' typeList )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==128) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:255:10: 'implements' typeList
                    {
                    string_literal28=(Token)match(input,128,FOLLOW_128_in_classDeclaration797); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_128.add(string_literal28);

                    pushFollow(FOLLOW_typeList_in_classDeclaration799);
                    typeList29=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList29.getTree());

                    }
                    break;

            }

            pushFollow(FOLLOW_classBody_in_classDeclaration811);
            classBody30=classBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_classBody.add(classBody30.getTree());


            // AST REWRITE
            // elements: typeParameters, Identifier, type, typeList, classBody
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 256:19: -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ( type )? ) ^( IMPLEMENTS ( typeList )? ) ( classBody )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:22: ^( Identifier ( typeParameters )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:35: ( typeParameters )?
                if ( stream_typeParameters.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeParameters.nextTree());

                }
                stream_typeParameters.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:52: ^( EXTENDS ( type )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(EXTENDS, "EXTENDS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:62: ( type )?
                if ( stream_type.hasNext() ) {
                    adaptor.addChild(root_1, stream_type.nextTree());

                }
                stream_type.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:69: ^( IMPLEMENTS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(IMPLEMENTS, "IMPLEMENTS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:82: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:256:93: ( classBody )?
                if ( stream_classBody.hasNext() ) {
                    adaptor.addChild(root_0, stream_classBody.nextTree());

                }
                stream_classBody.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 6, classDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "classDeclaration"

    public static class typeParameters_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeParameters"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:259:1: typeParameters : '<' t+= typeParameter ( ',' t+= typeParameter )* '>' -> ( $t)* ;
    public final JavaParser.typeParameters_return typeParameters() throws RecognitionException {
        JavaParser.typeParameters_return retval = new JavaParser.typeParameters_return();
        retval.start = input.LT(1);
        int typeParameters_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal31=null;
        Token char_literal32=null;
        Token char_literal33=null;
        List list_t=null;
        RuleReturnScope t = null;
        Object char_literal31_tree=null;
        Object char_literal32_tree=null;
        Object char_literal33_tree=null;
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_typeParameter=new RewriteRuleSubtreeStream(adaptor,"rule typeParameter");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 7) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:260:2: ( '<' t+= typeParameter ( ',' t+= typeParameter )* '>' -> ( $t)* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:260:4: '<' t+= typeParameter ( ',' t+= typeParameter )* '>'
            {
            char_literal31=(Token)match(input,129,FOLLOW_129_in_typeParameters848); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_129.add(char_literal31);

            pushFollow(FOLLOW_typeParameter_in_typeParameters852);
            t=typeParameter();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_typeParameter.add(t.getTree());
            if (list_t==null) list_t=new ArrayList();
            list_t.add(t.getTree());

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:260:25: ( ',' t+= typeParameter )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==130) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:260:26: ',' t+= typeParameter
            	    {
            	    char_literal32=(Token)match(input,130,FOLLOW_130_in_typeParameters855); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_130.add(char_literal32);

            	    pushFollow(FOLLOW_typeParameter_in_typeParameters859);
            	    t=typeParameter();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_typeParameter.add(t.getTree());
            	    if (list_t==null) list_t=new ArrayList();
            	    list_t.add(t.getTree());


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

            char_literal33=(Token)match(input,131,FOLLOW_131_in_typeParameters863); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_131.add(char_literal33);



            // AST REWRITE
            // elements: t
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: t
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_t=new RewriteRuleSubtreeStream(adaptor,"token t",list_t);
            root_0 = (Object)adaptor.nil();
            // 260:53: -> ( $t)*
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:260:56: ( $t)*
                while ( stream_t.hasNext() ) {
                    adaptor.addChild(root_0, stream_t.nextTree());

                }
                stream_t.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 7, typeParameters_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeParameters"

    public static class typeParameter_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeParameter"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:263:1: typeParameter : Identifier ( 'extends' bound )? -> ^( TYPE_PARAMETER ^( Identifier ( ^( EXTENDS bound ) )? ) ) ;
    public final JavaParser.typeParameter_return typeParameter() throws RecognitionException {
        JavaParser.typeParameter_return retval = new JavaParser.typeParameter_return();
        retval.start = input.LT(1);
        int typeParameter_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier34=null;
        Token string_literal35=null;
        JavaParser.bound_return bound36 = null;


        Object Identifier34_tree=null;
        Object string_literal35_tree=null;
        RewriteRuleTokenStream stream_127=new RewriteRuleTokenStream(adaptor,"token 127");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_bound=new RewriteRuleSubtreeStream(adaptor,"rule bound");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 8) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:2: ( Identifier ( 'extends' bound )? -> ^( TYPE_PARAMETER ^( Identifier ( ^( EXTENDS bound ) )? ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:4: Identifier ( 'extends' bound )?
            {
            Identifier34=(Token)match(input,Identifier,FOLLOW_Identifier_in_typeParameter880); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier34);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:15: ( 'extends' bound )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==127) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:16: 'extends' bound
                    {
                    string_literal35=(Token)match(input,127,FOLLOW_127_in_typeParameter883); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_127.add(string_literal35);

                    pushFollow(FOLLOW_bound_in_typeParameter885);
                    bound36=bound();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_bound.add(bound36.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: Identifier, bound
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 264:34: -> ^( TYPE_PARAMETER ^( Identifier ( ^( EXTENDS bound ) )? ) )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:37: ^( TYPE_PARAMETER ^( Identifier ( ^( EXTENDS bound ) )? ) )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETER, "TYPE_PARAMETER"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:54: ^( Identifier ( ^( EXTENDS bound ) )? )
                {
                Object root_2 = (Object)adaptor.nil();
                root_2 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_2);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:67: ( ^( EXTENDS bound ) )?
                if ( stream_bound.hasNext() ) {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:264:67: ^( EXTENDS bound )
                    {
                    Object root_3 = (Object)adaptor.nil();
                    root_3 = (Object)adaptor.becomeRoot((Object)adaptor.create(EXTENDS, "EXTENDS"), root_3);

                    adaptor.addChild(root_3, stream_bound.nextTree());

                    adaptor.addChild(root_2, root_3);
                    }

                }
                stream_bound.reset();

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 8, typeParameter_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeParameter"

    public static class bound_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "bound"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:267:1: bound : t+= type ( '&' t+= type )* -> ( $t)* ;
    public final JavaParser.bound_return bound() throws RecognitionException {
        JavaParser.bound_return retval = new JavaParser.bound_return();
        retval.start = input.LT(1);
        int bound_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal37=null;
        List list_t=null;
        RuleReturnScope t = null;
        Object char_literal37_tree=null;
        RewriteRuleTokenStream stream_132=new RewriteRuleTokenStream(adaptor,"token 132");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 9) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:268:2: (t+= type ( '&' t+= type )* -> ( $t)* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:268:4: t+= type ( '&' t+= type )*
            {
            pushFollow(FOLLOW_type_in_bound919);
            t=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(t.getTree());
            if (list_t==null) list_t=new ArrayList();
            list_t.add(t.getTree());

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:268:12: ( '&' t+= type )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==132) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:268:13: '&' t+= type
            	    {
            	    char_literal37=(Token)match(input,132,FOLLOW_132_in_bound922); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_132.add(char_literal37);

            	    pushFollow(FOLLOW_type_in_bound926);
            	    t=type();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_type.add(t.getTree());
            	    if (list_t==null) list_t=new ArrayList();
            	    list_t.add(t.getTree());


            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);



            // AST REWRITE
            // elements: t
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: t
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_t=new RewriteRuleSubtreeStream(adaptor,"token t",list_t);
            root_0 = (Object)adaptor.nil();
            // 268:27: -> ( $t)*
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:268:30: ( $t)*
                while ( stream_t.hasNext() ) {
                    adaptor.addChild(root_0, stream_t.nextTree());

                }
                stream_t.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 9, bound_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "bound"

    public static class enumDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:271:1: enumDeclaration : ENUM Identifier ( 'implements' typeList )? enumBody -> Identifier ^( IMPLEMENTS ( typeList )? ) ( enumBody )? ;
    public final JavaParser.enumDeclaration_return enumDeclaration() throws RecognitionException {
        JavaParser.enumDeclaration_return retval = new JavaParser.enumDeclaration_return();
        retval.start = input.LT(1);
        int enumDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token ENUM38=null;
        Token Identifier39=null;
        Token string_literal40=null;
        JavaParser.typeList_return typeList41 = null;

        JavaParser.enumBody_return enumBody42 = null;


        Object ENUM38_tree=null;
        Object Identifier39_tree=null;
        Object string_literal40_tree=null;
        RewriteRuleTokenStream stream_128=new RewriteRuleTokenStream(adaptor,"token 128");
        RewriteRuleTokenStream stream_ENUM=new RewriteRuleTokenStream(adaptor,"token ENUM");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_enumBody=new RewriteRuleSubtreeStream(adaptor,"rule enumBody");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 10) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:2: ( ENUM Identifier ( 'implements' typeList )? enumBody -> Identifier ^( IMPLEMENTS ( typeList )? ) ( enumBody )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:4: ENUM Identifier ( 'implements' typeList )? enumBody
            {
            ENUM38=(Token)match(input,ENUM,FOLLOW_ENUM_in_enumDeclaration945); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_ENUM.add(ENUM38);

            Identifier39=(Token)match(input,Identifier,FOLLOW_Identifier_in_enumDeclaration947); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier39);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:20: ( 'implements' typeList )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==128) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:21: 'implements' typeList
                    {
                    string_literal40=(Token)match(input,128,FOLLOW_128_in_enumDeclaration950); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_128.add(string_literal40);

                    pushFollow(FOLLOW_typeList_in_enumDeclaration952);
                    typeList41=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList41.getTree());

                    }
                    break;

            }

            pushFollow(FOLLOW_enumBody_in_enumDeclaration956);
            enumBody42=enumBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_enumBody.add(enumBody42.getTree());


            // AST REWRITE
            // elements: Identifier, enumBody, typeList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 272:54: -> Identifier ^( IMPLEMENTS ( typeList )? ) ( enumBody )?
            {
                adaptor.addChild(root_0, stream_Identifier.nextNode());
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:68: ^( IMPLEMENTS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(IMPLEMENTS, "IMPLEMENTS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:81: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:272:92: ( enumBody )?
                if ( stream_enumBody.hasNext() ) {
                    adaptor.addChild(root_0, stream_enumBody.nextTree());

                }
                stream_enumBody.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 10, enumDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumDeclaration"

    public static class enumBody_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumBody"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:275:1: enumBody : '{' ( enumConstants )? ( ',' )? ( enumBodyDeclarations )? '}' -> ( enumConstants )? ( enumBodyDeclarations )? ;
    public final JavaParser.enumBody_return enumBody() throws RecognitionException {
        JavaParser.enumBody_return retval = new JavaParser.enumBody_return();
        retval.start = input.LT(1);
        int enumBody_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal43=null;
        Token char_literal45=null;
        Token char_literal47=null;
        JavaParser.enumConstants_return enumConstants44 = null;

        JavaParser.enumBodyDeclarations_return enumBodyDeclarations46 = null;


        Object char_literal43_tree=null;
        Object char_literal45_tree=null;
        Object char_literal47_tree=null;
        RewriteRuleTokenStream stream_134=new RewriteRuleTokenStream(adaptor,"token 134");
        RewriteRuleTokenStream stream_133=new RewriteRuleTokenStream(adaptor,"token 133");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_enumBodyDeclarations=new RewriteRuleSubtreeStream(adaptor,"rule enumBodyDeclarations");
        RewriteRuleSubtreeStream stream_enumConstants=new RewriteRuleSubtreeStream(adaptor,"rule enumConstants");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 11) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:2: ( '{' ( enumConstants )? ( ',' )? ( enumBodyDeclarations )? '}' -> ( enumConstants )? ( enumBodyDeclarations )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:4: '{' ( enumConstants )? ( ',' )? ( enumBodyDeclarations )? '}'
            {
            char_literal43=(Token)match(input,133,FOLLOW_133_in_enumBody982); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_133.add(char_literal43);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:8: ( enumConstants )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==Identifier||LA20_0==170) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: enumConstants
                    {
                    pushFollow(FOLLOW_enumConstants_in_enumBody984);
                    enumConstants44=enumConstants();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumConstants.add(enumConstants44.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:23: ( ',' )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==130) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: ','
                    {
                    char_literal45=(Token)match(input,130,FOLLOW_130_in_enumBody987); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_130.add(char_literal45);


                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:28: ( enumBodyDeclarations )?
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==121) ) {
                alt22=1;
            }
            switch (alt22) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: enumBodyDeclarations
                    {
                    pushFollow(FOLLOW_enumBodyDeclarations_in_enumBody990);
                    enumBodyDeclarations46=enumBodyDeclarations();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumBodyDeclarations.add(enumBodyDeclarations46.getTree());

                    }
                    break;

            }

            char_literal47=(Token)match(input,134,FOLLOW_134_in_enumBody993); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_134.add(char_literal47);



            // AST REWRITE
            // elements: enumBodyDeclarations, enumConstants
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 276:54: -> ( enumConstants )? ( enumBodyDeclarations )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:57: ( enumConstants )?
                if ( stream_enumConstants.hasNext() ) {
                    adaptor.addChild(root_0, stream_enumConstants.nextTree());

                }
                stream_enumConstants.reset();
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:276:72: ( enumBodyDeclarations )?
                if ( stream_enumBodyDeclarations.hasNext() ) {
                    adaptor.addChild(root_0, stream_enumBodyDeclarations.nextTree());

                }
                stream_enumBodyDeclarations.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 11, enumBody_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumBody"

    public static class enumConstants_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumConstants"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:279:1: enumConstants : enumConstant ( ',' enumConstant )* -> ( enumConstant )+ ;
    public final JavaParser.enumConstants_return enumConstants() throws RecognitionException {
        JavaParser.enumConstants_return retval = new JavaParser.enumConstants_return();
        retval.start = input.LT(1);
        int enumConstants_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal49=null;
        JavaParser.enumConstant_return enumConstant48 = null;

        JavaParser.enumConstant_return enumConstant50 = null;


        Object char_literal49_tree=null;
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_enumConstant=new RewriteRuleSubtreeStream(adaptor,"rule enumConstant");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 12) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:280:2: ( enumConstant ( ',' enumConstant )* -> ( enumConstant )+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:280:4: enumConstant ( ',' enumConstant )*
            {
            pushFollow(FOLLOW_enumConstant_in_enumConstants1012);
            enumConstant48=enumConstant();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_enumConstant.add(enumConstant48.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:280:17: ( ',' enumConstant )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==130) ) {
                    int LA23_1 = input.LA(2);

                    if ( (LA23_1==Identifier||LA23_1==170) ) {
                        alt23=1;
                    }


                }


                switch (alt23) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:280:18: ',' enumConstant
            	    {
            	    char_literal49=(Token)match(input,130,FOLLOW_130_in_enumConstants1015); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_130.add(char_literal49);

            	    pushFollow(FOLLOW_enumConstant_in_enumConstants1017);
            	    enumConstant50=enumConstant();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_enumConstant.add(enumConstant50.getTree());

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);



            // AST REWRITE
            // elements: enumConstant
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 280:37: -> ( enumConstant )+
            {
                if ( !(stream_enumConstant.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_enumConstant.hasNext() ) {
                    adaptor.addChild(root_0, stream_enumConstant.nextTree());

                }
                stream_enumConstant.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 12, enumConstants_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumConstants"

    public static class enumConstant_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumConstant"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:283:1: enumConstant : ( annotations )? Identifier ( arguments )? ( classBody )? -> ^( ENUM_CONSTANT ( annotations )? Identifier ( arguments )? ( classBody )? ) ;
    public final JavaParser.enumConstant_return enumConstant() throws RecognitionException {
        JavaParser.enumConstant_return retval = new JavaParser.enumConstant_return();
        retval.start = input.LT(1);
        int enumConstant_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier52=null;
        JavaParser.annotations_return annotations51 = null;

        JavaParser.arguments_return arguments53 = null;

        JavaParser.classBody_return classBody54 = null;


        Object Identifier52_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        RewriteRuleSubtreeStream stream_annotations=new RewriteRuleSubtreeStream(adaptor,"rule annotations");
        RewriteRuleSubtreeStream stream_classBody=new RewriteRuleSubtreeStream(adaptor,"rule classBody");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 13) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:2: ( ( annotations )? Identifier ( arguments )? ( classBody )? -> ^( ENUM_CONSTANT ( annotations )? Identifier ( arguments )? ( classBody )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:4: ( annotations )? Identifier ( arguments )? ( classBody )?
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:4: ( annotations )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==170) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: annotations
                    {
                    pushFollow(FOLLOW_annotations_in_enumConstant1036);
                    annotations51=annotations();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_annotations.add(annotations51.getTree());

                    }
                    break;

            }

            Identifier52=(Token)match(input,Identifier,FOLLOW_Identifier_in_enumConstant1039); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier52);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:28: ( arguments )?
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==164) ) {
                alt25=1;
            }
            switch (alt25) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:29: arguments
                    {
                    pushFollow(FOLLOW_arguments_in_enumConstant1042);
                    arguments53=arguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_arguments.add(arguments53.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:41: ( classBody )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==133) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:42: classBody
                    {
                    pushFollow(FOLLOW_classBody_in_enumConstant1047);
                    classBody54=classBody();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_classBody.add(classBody54.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: arguments, annotations, classBody, Identifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 284:54: -> ^( ENUM_CONSTANT ( annotations )? Identifier ( arguments )? ( classBody )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:57: ^( ENUM_CONSTANT ( annotations )? Identifier ( arguments )? ( classBody )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ENUM_CONSTANT, "ENUM_CONSTANT"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:73: ( annotations )?
                if ( stream_annotations.hasNext() ) {
                    adaptor.addChild(root_1, stream_annotations.nextTree());

                }
                stream_annotations.reset();
                adaptor.addChild(root_1, stream_Identifier.nextNode());
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:97: ( arguments )?
                if ( stream_arguments.hasNext() ) {
                    adaptor.addChild(root_1, stream_arguments.nextTree());

                }
                stream_arguments.reset();
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:284:110: ( classBody )?
                if ( stream_classBody.hasNext() ) {
                    adaptor.addChild(root_1, stream_classBody.nextTree());

                }
                stream_classBody.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 13, enumConstant_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumConstant"

    public static class enumBodyDeclarations_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumBodyDeclarations"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:287:1: enumBodyDeclarations : ';' ( classBodyDeclaration )* -> ( classBodyDeclaration )* ;
    public final JavaParser.enumBodyDeclarations_return enumBodyDeclarations() throws RecognitionException {
        JavaParser.enumBodyDeclarations_return retval = new JavaParser.enumBodyDeclarations_return();
        retval.start = input.LT(1);
        int enumBodyDeclarations_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal55=null;
        JavaParser.classBodyDeclaration_return classBodyDeclaration56 = null;


        Object char_literal55_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_classBodyDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule classBodyDeclaration");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 14) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:288:2: ( ';' ( classBodyDeclaration )* -> ( classBodyDeclaration )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:288:4: ';' ( classBodyDeclaration )*
            {
            char_literal55=(Token)match(input,121,FOLLOW_121_in_enumBodyDeclarations1082); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal55);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:288:8: ( classBodyDeclaration )*
            loop27:
            do {
                int alt27=2;
                alt27 = dfa27.predict(input);
                switch (alt27) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:288:9: classBodyDeclaration
            	    {
            	    pushFollow(FOLLOW_classBodyDeclaration_in_enumBodyDeclarations1085);
            	    classBodyDeclaration56=classBodyDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_classBodyDeclaration.add(classBodyDeclaration56.getTree());

            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);



            // AST REWRITE
            // elements: classBodyDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 288:32: -> ( classBodyDeclaration )*
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:288:35: ( classBodyDeclaration )*
                while ( stream_classBodyDeclaration.hasNext() ) {
                    adaptor.addChild(root_0, stream_classBodyDeclaration.nextTree());

                }
                stream_classBodyDeclaration.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 14, enumBodyDeclarations_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumBodyDeclarations"

    public static class normalInterfaceDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "normalInterfaceDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:291:1: normalInterfaceDeclaration : 'interface' Identifier ( typeParameters )? ( 'extends' typeList )? interfaceBody -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ) ^( IMPLEMENTS ( typeList )? ) ( interfaceBody )? ;
    public final JavaParser.normalInterfaceDeclaration_return normalInterfaceDeclaration() throws RecognitionException {
        JavaParser.normalInterfaceDeclaration_return retval = new JavaParser.normalInterfaceDeclaration_return();
        retval.start = input.LT(1);
        int normalInterfaceDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal57=null;
        Token Identifier58=null;
        Token string_literal60=null;
        JavaParser.typeParameters_return typeParameters59 = null;

        JavaParser.typeList_return typeList61 = null;

        JavaParser.interfaceBody_return interfaceBody62 = null;


        Object string_literal57_tree=null;
        Object Identifier58_tree=null;
        Object string_literal60_tree=null;
        RewriteRuleTokenStream stream_135=new RewriteRuleTokenStream(adaptor,"token 135");
        RewriteRuleTokenStream stream_127=new RewriteRuleTokenStream(adaptor,"token 127");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_typeParameters=new RewriteRuleSubtreeStream(adaptor,"rule typeParameters");
        RewriteRuleSubtreeStream stream_interfaceBody=new RewriteRuleSubtreeStream(adaptor,"rule interfaceBody");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 15) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:2: ( 'interface' Identifier ( typeParameters )? ( 'extends' typeList )? interfaceBody -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ) ^( IMPLEMENTS ( typeList )? ) ( interfaceBody )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:4: 'interface' Identifier ( typeParameters )? ( 'extends' typeList )? interfaceBody
            {
            string_literal57=(Token)match(input,135,FOLLOW_135_in_normalInterfaceDeclaration1104); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_135.add(string_literal57);

            Identifier58=(Token)match(input,Identifier,FOLLOW_Identifier_in_normalInterfaceDeclaration1106); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier58);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:27: ( typeParameters )?
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==129) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: typeParameters
                    {
                    pushFollow(FOLLOW_typeParameters_in_normalInterfaceDeclaration1108);
                    typeParameters59=typeParameters();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeParameters.add(typeParameters59.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:43: ( 'extends' typeList )?
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==127) ) {
                alt29=1;
            }
            switch (alt29) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:44: 'extends' typeList
                    {
                    string_literal60=(Token)match(input,127,FOLLOW_127_in_normalInterfaceDeclaration1112); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_127.add(string_literal60);

                    pushFollow(FOLLOW_typeList_in_normalInterfaceDeclaration1114);
                    typeList61=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList61.getTree());

                    }
                    break;

            }

            pushFollow(FOLLOW_interfaceBody_in_normalInterfaceDeclaration1118);
            interfaceBody62=interfaceBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_interfaceBody.add(interfaceBody62.getTree());


            // AST REWRITE
            // elements: typeList, typeParameters, interfaceBody, Identifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 292:79: -> ^( Identifier ( typeParameters )? ) ^( EXTENDS ) ^( IMPLEMENTS ( typeList )? ) ( interfaceBody )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:82: ^( Identifier ( typeParameters )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:95: ( typeParameters )?
                if ( stream_typeParameters.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeParameters.nextTree());

                }
                stream_typeParameters.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:112: ^( EXTENDS )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(EXTENDS, "EXTENDS"), root_1);

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:123: ^( IMPLEMENTS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(IMPLEMENTS, "IMPLEMENTS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:136: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:292:147: ( interfaceBody )?
                if ( stream_interfaceBody.hasNext() ) {
                    adaptor.addChild(root_0, stream_interfaceBody.nextTree());

                }
                stream_interfaceBody.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 15, normalInterfaceDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "normalInterfaceDeclaration"

    public static class typeList_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeList"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:295:1: typeList : type ( ',' type )* ;
    public final JavaParser.typeList_return typeList() throws RecognitionException {
        JavaParser.typeList_return retval = new JavaParser.typeList_return();
        retval.start = input.LT(1);
        int typeList_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal64=null;
        JavaParser.type_return type63 = null;

        JavaParser.type_return type65 = null;


        Object char_literal64_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 16) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:296:2: ( type ( ',' type )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:296:4: type ( ',' type )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_type_in_typeList1153);
            type63=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, type63.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:296:9: ( ',' type )*
            loop30:
            do {
                int alt30=2;
                int LA30_0 = input.LA(1);

                if ( (LA30_0==130) ) {
                    alt30=1;
                }


                switch (alt30) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:296:10: ',' type
            	    {
            	    char_literal64=(Token)match(input,130,FOLLOW_130_in_typeList1156); if (state.failed) return retval;
            	    pushFollow(FOLLOW_type_in_typeList1159);
            	    type65=type();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, type65.getTree());

            	    }
            	    break;

            	default :
            	    break loop30;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 16, typeList_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeList"

    public static class classBody_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classBody"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:299:1: classBody : '{' ( classBodyDeclaration )* '}' ;
    public final JavaParser.classBody_return classBody() throws RecognitionException {
        JavaParser.classBody_return retval = new JavaParser.classBody_return();
        retval.start = input.LT(1);
        int classBody_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal66=null;
        Token char_literal68=null;
        JavaParser.classBodyDeclaration_return classBodyDeclaration67 = null;


        Object char_literal66_tree=null;
        Object char_literal68_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 17) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:300:2: ( '{' ( classBodyDeclaration )* '}' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:300:4: '{' ( classBodyDeclaration )* '}'
            {
            root_0 = (Object)adaptor.nil();

            char_literal66=(Token)match(input,133,FOLLOW_133_in_classBody1173); if (state.failed) return retval;
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:300:9: ( classBodyDeclaration )*
            loop31:
            do {
                int alt31=2;
                alt31 = dfa31.predict(input);
                switch (alt31) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: classBodyDeclaration
            	    {
            	    pushFollow(FOLLOW_classBodyDeclaration_in_classBody1176);
            	    classBodyDeclaration67=classBodyDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, classBodyDeclaration67.getTree());

            	    }
            	    break;

            	default :
            	    break loop31;
                }
            } while (true);

            char_literal68=(Token)match(input,134,FOLLOW_134_in_classBody1179); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 17, classBody_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "classBody"

    public static class interfaceBody_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "interfaceBody"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:303:1: interfaceBody : '{' ( interfaceBodyDeclaration )* '}' ;
    public final JavaParser.interfaceBody_return interfaceBody() throws RecognitionException {
        JavaParser.interfaceBody_return retval = new JavaParser.interfaceBody_return();
        retval.start = input.LT(1);
        int interfaceBody_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal69=null;
        Token char_literal71=null;
        JavaParser.interfaceBodyDeclaration_return interfaceBodyDeclaration70 = null;


        Object char_literal69_tree=null;
        Object char_literal71_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 18) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:304:2: ( '{' ( interfaceBodyDeclaration )* '}' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:304:4: '{' ( interfaceBodyDeclaration )* '}'
            {
            root_0 = (Object)adaptor.nil();

            char_literal69=(Token)match(input,133,FOLLOW_133_in_interfaceBody1192); if (state.failed) return retval;
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:304:9: ( interfaceBodyDeclaration )*
            loop32:
            do {
                int alt32=2;
                alt32 = dfa32.predict(input);
                switch (alt32) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: interfaceBodyDeclaration
            	    {
            	    pushFollow(FOLLOW_interfaceBodyDeclaration_in_interfaceBody1195);
            	    interfaceBodyDeclaration70=interfaceBodyDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, interfaceBodyDeclaration70.getTree());

            	    }
            	    break;

            	default :
            	    break loop32;
                }
            } while (true);

            char_literal71=(Token)match(input,134,FOLLOW_134_in_interfaceBody1198); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 18, interfaceBody_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "interfaceBody"

    public static class classBodyDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classBodyDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:307:1: classBodyDeclaration : ( ';' | 'static' block -> ^( STATIC block ) | ( 'static' )? block -> block | ( modifier )* ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) );
    public final JavaParser.classBodyDeclaration_return classBodyDeclaration() throws RecognitionException {
        JavaParser.classBodyDeclaration_return retval = new JavaParser.classBodyDeclaration_return();
        retval.start = input.LT(1);
        int classBodyDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal72=null;
        Token string_literal73=null;
        Token string_literal75=null;
        Token string_literal81=null;
        Token Identifier82=null;
        Token Identifier84=null;
        JavaParser.block_return block74 = null;

        JavaParser.block_return block76 = null;

        JavaParser.modifier_return modifier77 = null;

        JavaParser.genericMethodOrConstructorDecl_return genericMethodOrConstructorDecl78 = null;

        JavaParser.methodDeclaration_return methodDeclaration79 = null;

        JavaParser.fieldDeclaration_return fieldDeclaration80 = null;

        JavaParser.voidMethodDeclaratorRest_return voidMethodDeclaratorRest83 = null;

        JavaParser.constructorDeclaratorRest_return constructorDeclaratorRest85 = null;

        JavaParser.normalInterfaceDeclaration_return normalInterfaceDeclaration86 = null;

        JavaParser.annotationTypeDeclaration_return annotationTypeDeclaration87 = null;

        JavaParser.classDeclaration_return classDeclaration88 = null;

        JavaParser.enumDeclaration_return enumDeclaration89 = null;


        Object char_literal72_tree=null;
        Object string_literal73_tree=null;
        Object string_literal75_tree=null;
        Object string_literal81_tree=null;
        Object Identifier82_tree=null;
        Object Identifier84_tree=null;
        RewriteRuleTokenStream stream_136=new RewriteRuleTokenStream(adaptor,"token 136");
        RewriteRuleTokenStream stream_123=new RewriteRuleTokenStream(adaptor,"token 123");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_modifier=new RewriteRuleSubtreeStream(adaptor,"rule modifier");
        RewriteRuleSubtreeStream stream_annotationTypeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule annotationTypeDeclaration");
        RewriteRuleSubtreeStream stream_fieldDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule fieldDeclaration");
        RewriteRuleSubtreeStream stream_classDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule classDeclaration");
        RewriteRuleSubtreeStream stream_block=new RewriteRuleSubtreeStream(adaptor,"rule block");
        RewriteRuleSubtreeStream stream_genericMethodOrConstructorDecl=new RewriteRuleSubtreeStream(adaptor,"rule genericMethodOrConstructorDecl");
        RewriteRuleSubtreeStream stream_normalInterfaceDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule normalInterfaceDeclaration");
        RewriteRuleSubtreeStream stream_enumDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule enumDeclaration");
        RewriteRuleSubtreeStream stream_voidMethodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule voidMethodDeclaratorRest");
        RewriteRuleSubtreeStream stream_constructorDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule constructorDeclaratorRest");
        RewriteRuleSubtreeStream stream_methodDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule methodDeclaration");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 19) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:308:2: ( ';' | 'static' block -> ^( STATIC block ) | ( 'static' )? block -> block | ( modifier )* ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) )
            int alt36=4;
            alt36 = dfa36.predict(input);
            switch (alt36) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:308:4: ';'
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal72=(Token)match(input,121,FOLLOW_121_in_classBodyDeclaration1210); if (state.failed) return retval;

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:309:4: 'static' block
                    {
                    string_literal73=(Token)match(input,123,FOLLOW_123_in_classBodyDeclaration1216); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_123.add(string_literal73);

                    pushFollow(FOLLOW_block_in_classBodyDeclaration1218);
                    block74=block();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_block.add(block74.getTree());


                    // AST REWRITE
                    // elements: block
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 309:19: -> ^( STATIC block )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:309:22: ^( STATIC block )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(STATIC, "STATIC"), root_1);

                        adaptor.addChild(root_1, stream_block.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:310:4: ( 'static' )? block
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:310:4: ( 'static' )?
                    int alt33=2;
                    int LA33_0 = input.LA(1);

                    if ( (LA33_0==123) ) {
                        alt33=1;
                    }
                    switch (alt33) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: 'static'
                            {
                            string_literal75=(Token)match(input,123,FOLLOW_123_in_classBodyDeclaration1231); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_123.add(string_literal75);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_block_in_classBodyDeclaration1234);
                    block76=block();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_block.add(block76.getTree());


                    // AST REWRITE
                    // elements: block
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 310:20: -> block
                    {
                        adaptor.addChild(root_0, stream_block.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:311:4: ( modifier )* ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:311:4: ( modifier )*
                    loop34:
                    do {
                        int alt34=2;
                        alt34 = dfa34.predict(input);
                        switch (alt34) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: modifier
                    	    {
                    	    pushFollow(FOLLOW_modifier_in_classBodyDeclaration1243);
                    	    modifier77=modifier();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_modifier.add(modifier77.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop34;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:311:14: ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )
                    int alt35=9;
                    alt35 = dfa35.predict(input);
                    switch (alt35) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:312:6: genericMethodOrConstructorDecl
                            {
                            pushFollow(FOLLOW_genericMethodOrConstructorDecl_in_classBodyDeclaration1253);
                            genericMethodOrConstructorDecl78=genericMethodOrConstructorDecl();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_genericMethodOrConstructorDecl.add(genericMethodOrConstructorDecl78.getTree());


                            // AST REWRITE
                            // elements: genericMethodOrConstructorDecl, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 312:37: -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:312:40: ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:312:49: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:312:61: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_genericMethodOrConstructorDecl.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:9: methodDeclaration
                            {
                            pushFollow(FOLLOW_methodDeclaration_in_classBodyDeclaration1278);
                            methodDeclaration79=methodDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_methodDeclaration.add(methodDeclaration79.getTree());


                            // AST REWRITE
                            // elements: modifier, methodDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 313:27: -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:30: ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:39: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:51: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:62: ^( TYPE_PARAMETERS )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_methodDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 3 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:9: fieldDeclaration
                            {
                            pushFollow(FOLLOW_fieldDeclaration_in_classBodyDeclaration1307);
                            fieldDeclaration80=fieldDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_fieldDeclaration.add(fieldDeclaration80.getTree());


                            // AST REWRITE
                            // elements: modifier, fieldDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 314:26: -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:29: ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FIELD, "FIELD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:37: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:49: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_fieldDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 4 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:8: 'void' Identifier voidMethodDeclaratorRest
                            {
                            string_literal81=(Token)match(input,136,FOLLOW_136_in_classBodyDeclaration1331); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_136.add(string_literal81);

                            Identifier82=(Token)match(input,Identifier,FOLLOW_Identifier_in_classBodyDeclaration1333); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier82);

                            pushFollow(FOLLOW_voidMethodDeclaratorRest_in_classBodyDeclaration1335);
                            voidMethodDeclaratorRest83=voidMethodDeclaratorRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_voidMethodDeclaratorRest.add(voidMethodDeclaratorRest83.getTree());


                            // AST REWRITE
                            // elements: Identifier, modifier, voidMethodDeclaratorRest
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 315:51: -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:54: ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:63: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:75: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:86: ^( TYPE_PARAMETERS )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:116: ^( TYPE VOID )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                adaptor.addChild(root_2, (Object)adaptor.create(VOID, "VOID"));

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:315:129: ( voidMethodDeclaratorRest )?
                                if ( stream_voidMethodDeclaratorRest.hasNext() ) {
                                    adaptor.addChild(root_1, stream_voidMethodDeclaratorRest.nextTree());

                                }
                                stream_voidMethodDeclaratorRest.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 5 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:8: Identifier constructorDeclaratorRest
                            {
                            Identifier84=(Token)match(input,Identifier,FOLLOW_Identifier_in_classBodyDeclaration1372); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier84);

                            pushFollow(FOLLOW_constructorDeclaratorRest_in_classBodyDeclaration1374);
                            constructorDeclaratorRest85=constructorDeclaratorRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_constructorDeclaratorRest.add(constructorDeclaratorRest85.getTree());


                            // AST REWRITE
                            // elements: Identifier, modifier, constructorDeclaratorRest
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 316:45: -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:48: ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:57: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:69: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:80: ^( TYPE_PARAMETERS )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:316:110: ^( NONE )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(NONE, "NONE"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_constructorDeclaratorRest.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 6 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:317:8: normalInterfaceDeclaration
                            {
                            pushFollow(FOLLOW_normalInterfaceDeclaration_in_classBodyDeclaration1408);
                            normalInterfaceDeclaration86=normalInterfaceDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_normalInterfaceDeclaration.add(normalInterfaceDeclaration86.getTree());


                            // AST REWRITE
                            // elements: modifier, normalInterfaceDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 317:35: -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:317:38: ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INTERFACE, "INTERFACE"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:317:50: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:317:62: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_normalInterfaceDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 7 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:318:10: annotationTypeDeclaration
                            {
                            pushFollow(FOLLOW_annotationTypeDeclaration_in_classBodyDeclaration1434);
                            annotationTypeDeclaration87=annotationTypeDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_annotationTypeDeclaration.add(annotationTypeDeclaration87.getTree());


                            // AST REWRITE
                            // elements: annotationTypeDeclaration, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 318:36: -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:318:39: ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:318:52: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:318:64: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_annotationTypeDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 8 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:319:8: classDeclaration
                            {
                            pushFollow(FOLLOW_classDeclaration_in_classBodyDeclaration1458);
                            classDeclaration88=classDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_classDeclaration.add(classDeclaration88.getTree());


                            // AST REWRITE
                            // elements: modifier, classDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 319:25: -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:319:28: ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CLASS, "CLASS"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:319:36: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:319:48: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_classDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 9 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:320:10: enumDeclaration
                            {
                            pushFollow(FOLLOW_enumDeclaration_in_classBodyDeclaration1484);
                            enumDeclaration89=enumDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_enumDeclaration.add(enumDeclaration89.getTree());


                            // AST REWRITE
                            // elements: enumDeclaration, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 320:26: -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:320:29: ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ENUM, "ENUM"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:320:36: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:320:48: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_enumDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 19, classBodyDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "classBodyDeclaration"

    public static class genericMethodOrConstructorDecl_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "genericMethodOrConstructorDecl"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:324:1: genericMethodOrConstructorDecl : typeParameters genericMethodOrConstructorRest -> ^( TYPE_PARAMETERS typeParameters ) genericMethodOrConstructorRest ;
    public final JavaParser.genericMethodOrConstructorDecl_return genericMethodOrConstructorDecl() throws RecognitionException {
        JavaParser.genericMethodOrConstructorDecl_return retval = new JavaParser.genericMethodOrConstructorDecl_return();
        retval.start = input.LT(1);
        int genericMethodOrConstructorDecl_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.typeParameters_return typeParameters90 = null;

        JavaParser.genericMethodOrConstructorRest_return genericMethodOrConstructorRest91 = null;


        RewriteRuleSubtreeStream stream_typeParameters=new RewriteRuleSubtreeStream(adaptor,"rule typeParameters");
        RewriteRuleSubtreeStream stream_genericMethodOrConstructorRest=new RewriteRuleSubtreeStream(adaptor,"rule genericMethodOrConstructorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 20) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:325:2: ( typeParameters genericMethodOrConstructorRest -> ^( TYPE_PARAMETERS typeParameters ) genericMethodOrConstructorRest )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:325:4: typeParameters genericMethodOrConstructorRest
            {
            pushFollow(FOLLOW_typeParameters_in_genericMethodOrConstructorDecl1517);
            typeParameters90=typeParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_typeParameters.add(typeParameters90.getTree());
            pushFollow(FOLLOW_genericMethodOrConstructorRest_in_genericMethodOrConstructorDecl1519);
            genericMethodOrConstructorRest91=genericMethodOrConstructorRest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_genericMethodOrConstructorRest.add(genericMethodOrConstructorRest91.getTree());


            // AST REWRITE
            // elements: genericMethodOrConstructorRest, typeParameters
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 325:50: -> ^( TYPE_PARAMETERS typeParameters ) genericMethodOrConstructorRest
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:325:53: ^( TYPE_PARAMETERS typeParameters )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_1);

                adaptor.addChild(root_1, stream_typeParameters.nextTree());

                adaptor.addChild(root_0, root_1);
                }
                adaptor.addChild(root_0, stream_genericMethodOrConstructorRest.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 20, genericMethodOrConstructorDecl_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "genericMethodOrConstructorDecl"

    public static class genericMethodOrConstructorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "genericMethodOrConstructorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:328:1: genericMethodOrConstructorRest : ( type Identifier methodDeclaratorRest -> Identifier type ( methodDeclaratorRest )? | 'void' Identifier methodDeclaratorRest -> Identifier ^( TYPE VOID ) ( methodDeclaratorRest )? | Identifier constructorDeclaratorRest -> Identifier ^( NONE ) constructorDeclaratorRest );
    public final JavaParser.genericMethodOrConstructorRest_return genericMethodOrConstructorRest() throws RecognitionException {
        JavaParser.genericMethodOrConstructorRest_return retval = new JavaParser.genericMethodOrConstructorRest_return();
        retval.start = input.LT(1);
        int genericMethodOrConstructorRest_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier93=null;
        Token string_literal95=null;
        Token Identifier96=null;
        Token Identifier98=null;
        JavaParser.type_return type92 = null;

        JavaParser.methodDeclaratorRest_return methodDeclaratorRest94 = null;

        JavaParser.methodDeclaratorRest_return methodDeclaratorRest97 = null;

        JavaParser.constructorDeclaratorRest_return constructorDeclaratorRest99 = null;


        Object Identifier93_tree=null;
        Object string_literal95_tree=null;
        Object Identifier96_tree=null;
        Object Identifier98_tree=null;
        RewriteRuleTokenStream stream_136=new RewriteRuleTokenStream(adaptor,"token 136");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_constructorDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule constructorDeclaratorRest");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_methodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule methodDeclaratorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 21) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:329:2: ( type Identifier methodDeclaratorRest -> Identifier type ( methodDeclaratorRest )? | 'void' Identifier methodDeclaratorRest -> Identifier ^( TYPE VOID ) ( methodDeclaratorRest )? | Identifier constructorDeclaratorRest -> Identifier ^( NONE ) constructorDeclaratorRest )
            int alt37=3;
            alt37 = dfa37.predict(input);
            switch (alt37) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:329:4: type Identifier methodDeclaratorRest
                    {
                    pushFollow(FOLLOW_type_in_genericMethodOrConstructorRest1541);
                    type92=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type92.getTree());
                    Identifier93=(Token)match(input,Identifier,FOLLOW_Identifier_in_genericMethodOrConstructorRest1543); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier93);

                    pushFollow(FOLLOW_methodDeclaratorRest_in_genericMethodOrConstructorRest1545);
                    methodDeclaratorRest94=methodDeclaratorRest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_methodDeclaratorRest.add(methodDeclaratorRest94.getTree());


                    // AST REWRITE
                    // elements: Identifier, methodDeclaratorRest, type
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 329:41: -> Identifier type ( methodDeclaratorRest )?
                    {
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        adaptor.addChild(root_0, stream_type.nextTree());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:329:60: ( methodDeclaratorRest )?
                        if ( stream_methodDeclaratorRest.hasNext() ) {
                            adaptor.addChild(root_0, stream_methodDeclaratorRest.nextTree());

                        }
                        stream_methodDeclaratorRest.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:330:4: 'void' Identifier methodDeclaratorRest
                    {
                    string_literal95=(Token)match(input,136,FOLLOW_136_in_genericMethodOrConstructorRest1559); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_136.add(string_literal95);

                    Identifier96=(Token)match(input,Identifier,FOLLOW_Identifier_in_genericMethodOrConstructorRest1561); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier96);

                    pushFollow(FOLLOW_methodDeclaratorRest_in_genericMethodOrConstructorRest1563);
                    methodDeclaratorRest97=methodDeclaratorRest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_methodDeclaratorRest.add(methodDeclaratorRest97.getTree());


                    // AST REWRITE
                    // elements: methodDeclaratorRest, Identifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 330:43: -> Identifier ^( TYPE VOID ) ( methodDeclaratorRest )?
                    {
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:330:57: ^( TYPE VOID )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(VOID, "VOID"));

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:330:70: ( methodDeclaratorRest )?
                        if ( stream_methodDeclaratorRest.hasNext() ) {
                            adaptor.addChild(root_0, stream_methodDeclaratorRest.nextTree());

                        }
                        stream_methodDeclaratorRest.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:331:4: Identifier constructorDeclaratorRest
                    {
                    Identifier98=(Token)match(input,Identifier,FOLLOW_Identifier_in_genericMethodOrConstructorRest1581); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier98);

                    pushFollow(FOLLOW_constructorDeclaratorRest_in_genericMethodOrConstructorRest1583);
                    constructorDeclaratorRest99=constructorDeclaratorRest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructorDeclaratorRest.add(constructorDeclaratorRest99.getTree());


                    // AST REWRITE
                    // elements: Identifier, constructorDeclaratorRest
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 331:41: -> Identifier ^( NONE ) constructorDeclaratorRest
                    {
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:331:55: ^( NONE )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NONE, "NONE"), root_1);

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_constructorDeclaratorRest.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 21, genericMethodOrConstructorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "genericMethodOrConstructorRest"

    public static class methodDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "methodDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:334:1: methodDeclaration : type Identifier methodDeclaratorRest -> Identifier type ( methodDeclaratorRest )? ;
    public final JavaParser.methodDeclaration_return methodDeclaration() throws RecognitionException {
        JavaParser.methodDeclaration_return retval = new JavaParser.methodDeclaration_return();
        retval.start = input.LT(1);
        int methodDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier101=null;
        JavaParser.type_return type100 = null;

        JavaParser.methodDeclaratorRest_return methodDeclaratorRest102 = null;


        Object Identifier101_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_methodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule methodDeclaratorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 22) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:335:2: ( type Identifier methodDeclaratorRest -> Identifier type ( methodDeclaratorRest )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:335:4: type Identifier methodDeclaratorRest
            {
            pushFollow(FOLLOW_type_in_methodDeclaration1604);
            type100=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type100.getTree());
            Identifier101=(Token)match(input,Identifier,FOLLOW_Identifier_in_methodDeclaration1606); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier101);

            pushFollow(FOLLOW_methodDeclaratorRest_in_methodDeclaration1608);
            methodDeclaratorRest102=methodDeclaratorRest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_methodDeclaratorRest.add(methodDeclaratorRest102.getTree());


            // AST REWRITE
            // elements: methodDeclaratorRest, type, Identifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 335:41: -> Identifier type ( methodDeclaratorRest )?
            {
                adaptor.addChild(root_0, stream_Identifier.nextNode());
                adaptor.addChild(root_0, stream_type.nextTree());
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:335:60: ( methodDeclaratorRest )?
                if ( stream_methodDeclaratorRest.hasNext() ) {
                    adaptor.addChild(root_0, stream_methodDeclaratorRest.nextTree());

                }
                stream_methodDeclaratorRest.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 22, methodDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "methodDeclaration"

    public static class fieldDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "fieldDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:338:1: fieldDeclaration : type variableDeclarators ';' -> type variableDeclarators ;
    public final JavaParser.fieldDeclaration_return fieldDeclaration() throws RecognitionException {
        JavaParser.fieldDeclaration_return retval = new JavaParser.fieldDeclaration_return();
        retval.start = input.LT(1);
        int fieldDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal105=null;
        JavaParser.type_return type103 = null;

        JavaParser.variableDeclarators_return variableDeclarators104 = null;


        Object char_literal105_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_variableDeclarators=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclarators");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 23) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:339:2: ( type variableDeclarators ';' -> type variableDeclarators )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:339:4: type variableDeclarators ';'
            {
            pushFollow(FOLLOW_type_in_fieldDeclaration1628);
            type103=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type103.getTree());
            pushFollow(FOLLOW_variableDeclarators_in_fieldDeclaration1630);
            variableDeclarators104=variableDeclarators();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_variableDeclarators.add(variableDeclarators104.getTree());
            char_literal105=(Token)match(input,121,FOLLOW_121_in_fieldDeclaration1632); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal105);



            // AST REWRITE
            // elements: type, variableDeclarators
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 339:33: -> type variableDeclarators
            {
                adaptor.addChild(root_0, stream_type.nextTree());
                adaptor.addChild(root_0, stream_variableDeclarators.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 23, fieldDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "fieldDeclaration"

    public static class interfaceBodyDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "interfaceBodyDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:342:1: interfaceBodyDeclaration : ( ( modifier )* ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) | ';' );
    public final JavaParser.interfaceBodyDeclaration_return interfaceBodyDeclaration() throws RecognitionException {
        JavaParser.interfaceBodyDeclaration_return retval = new JavaParser.interfaceBodyDeclaration_return();
        retval.start = input.LT(1);
        int interfaceBodyDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier109=null;
        Token string_literal112=null;
        Token Identifier113=null;
        Token char_literal119=null;
        JavaParser.modifier_return modifier106 = null;

        JavaParser.constantDeclaration_return constantDeclaration107 = null;

        JavaParser.type_return type108 = null;

        JavaParser.interfaceMethodDeclaratorRest_return interfaceMethodDeclaratorRest110 = null;

        JavaParser.interfaceGenericMethodDecl_return interfaceGenericMethodDecl111 = null;

        JavaParser.voidInterfaceMethodDeclaratorRest_return voidInterfaceMethodDeclaratorRest114 = null;

        JavaParser.normalInterfaceDeclaration_return normalInterfaceDeclaration115 = null;

        JavaParser.annotationTypeDeclaration_return annotationTypeDeclaration116 = null;

        JavaParser.classDeclaration_return classDeclaration117 = null;

        JavaParser.enumDeclaration_return enumDeclaration118 = null;


        Object Identifier109_tree=null;
        Object string_literal112_tree=null;
        Object Identifier113_tree=null;
        Object char_literal119_tree=null;
        RewriteRuleTokenStream stream_136=new RewriteRuleTokenStream(adaptor,"token 136");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_modifier=new RewriteRuleSubtreeStream(adaptor,"rule modifier");
        RewriteRuleSubtreeStream stream_annotationTypeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule annotationTypeDeclaration");
        RewriteRuleSubtreeStream stream_interfaceGenericMethodDecl=new RewriteRuleSubtreeStream(adaptor,"rule interfaceGenericMethodDecl");
        RewriteRuleSubtreeStream stream_interfaceMethodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule interfaceMethodDeclaratorRest");
        RewriteRuleSubtreeStream stream_constantDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule constantDeclaration");
        RewriteRuleSubtreeStream stream_classDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule classDeclaration");
        RewriteRuleSubtreeStream stream_voidInterfaceMethodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule voidInterfaceMethodDeclaratorRest");
        RewriteRuleSubtreeStream stream_normalInterfaceDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule normalInterfaceDeclaration");
        RewriteRuleSubtreeStream stream_enumDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule enumDeclaration");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 24) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:343:2: ( ( modifier )* ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) | ';' )
            int alt40=2;
            alt40 = dfa40.predict(input);
            switch (alt40) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:343:4: ( modifier )* ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:343:4: ( modifier )*
                    loop38:
                    do {
                        int alt38=2;
                        alt38 = dfa38.predict(input);
                        switch (alt38) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: modifier
                    	    {
                    	    pushFollow(FOLLOW_modifier_in_interfaceBodyDeclaration1651);
                    	    modifier106=modifier();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_modifier.add(modifier106.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop38;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:343:14: ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )
                    int alt39=8;
                    alt39 = dfa39.predict(input);
                    switch (alt39) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:3: constantDeclaration
                            {
                            pushFollow(FOLLOW_constantDeclaration_in_interfaceBodyDeclaration1658);
                            constantDeclaration107=constantDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_constantDeclaration.add(constantDeclaration107.getTree());


                            // AST REWRITE
                            // elements: modifier, constantDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 344:23: -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:26: ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FIELD, "FIELD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:34: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:46: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_constantDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:5: type Identifier interfaceMethodDeclaratorRest
                            {
                            pushFollow(FOLLOW_type_in_interfaceBodyDeclaration1679);
                            type108=type();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_type.add(type108.getTree());
                            Identifier109=(Token)match(input,Identifier,FOLLOW_Identifier_in_interfaceBodyDeclaration1681); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier109);

                            pushFollow(FOLLOW_interfaceMethodDeclaratorRest_in_interfaceBodyDeclaration1683);
                            interfaceMethodDeclaratorRest110=interfaceMethodDeclaratorRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_interfaceMethodDeclaratorRest.add(interfaceMethodDeclaratorRest110.getTree());


                            // AST REWRITE
                            // elements: Identifier, modifier, interfaceMethodDeclaratorRest, type
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 345:51: -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:54: ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:63: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:75: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:86: ^( TYPE_PARAMETERS )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                adaptor.addChild(root_1, stream_type.nextTree());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:121: ( interfaceMethodDeclaratorRest )?
                                if ( stream_interfaceMethodDeclaratorRest.hasNext() ) {
                                    adaptor.addChild(root_1, stream_interfaceMethodDeclaratorRest.nextTree());

                                }
                                stream_interfaceMethodDeclaratorRest.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 3 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:346:5: interfaceGenericMethodDecl
                            {
                            pushFollow(FOLLOW_interfaceGenericMethodDecl_in_interfaceBodyDeclaration1713);
                            interfaceGenericMethodDecl111=interfaceGenericMethodDecl();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_interfaceGenericMethodDecl.add(interfaceGenericMethodDecl111.getTree());


                            // AST REWRITE
                            // elements: interfaceGenericMethodDecl, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 346:32: -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:346:35: ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:346:44: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:346:56: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_interfaceGenericMethodDecl.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 4 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:5: 'void' Identifier voidInterfaceMethodDeclaratorRest
                            {
                            string_literal112=(Token)match(input,136,FOLLOW_136_in_interfaceBodyDeclaration1734); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_136.add(string_literal112);

                            Identifier113=(Token)match(input,Identifier,FOLLOW_Identifier_in_interfaceBodyDeclaration1736); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier113);

                            pushFollow(FOLLOW_voidInterfaceMethodDeclaratorRest_in_interfaceBodyDeclaration1738);
                            voidInterfaceMethodDeclaratorRest114=voidInterfaceMethodDeclaratorRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_voidInterfaceMethodDeclaratorRest.add(voidInterfaceMethodDeclaratorRest114.getTree());


                            // AST REWRITE
                            // elements: voidInterfaceMethodDeclaratorRest, Identifier, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 347:57: -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:60: ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:69: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:81: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:92: ^( TYPE_PARAMETERS )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_2);

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:122: ^( TYPE VOID )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                adaptor.addChild(root_2, (Object)adaptor.create(VOID, "VOID"));

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:347:135: ( voidInterfaceMethodDeclaratorRest )?
                                if ( stream_voidInterfaceMethodDeclaratorRest.hasNext() ) {
                                    adaptor.addChild(root_1, stream_voidInterfaceMethodDeclaratorRest.nextTree());

                                }
                                stream_voidInterfaceMethodDeclaratorRest.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 5 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:348:5: normalInterfaceDeclaration
                            {
                            pushFollow(FOLLOW_normalInterfaceDeclaration_in_interfaceBodyDeclaration1772);
                            normalInterfaceDeclaration115=normalInterfaceDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_normalInterfaceDeclaration.add(normalInterfaceDeclaration115.getTree());


                            // AST REWRITE
                            // elements: normalInterfaceDeclaration, modifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 348:32: -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:348:35: ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INTERFACE, "INTERFACE"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:348:47: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:348:59: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_normalInterfaceDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 6 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:349:10: annotationTypeDeclaration
                            {
                            pushFollow(FOLLOW_annotationTypeDeclaration_in_interfaceBodyDeclaration1799);
                            annotationTypeDeclaration116=annotationTypeDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_annotationTypeDeclaration.add(annotationTypeDeclaration116.getTree());


                            // AST REWRITE
                            // elements: modifier, annotationTypeDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 349:36: -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:349:39: ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:349:52: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:349:64: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_annotationTypeDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 7 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:350:5: classDeclaration
                            {
                            pushFollow(FOLLOW_classDeclaration_in_interfaceBodyDeclaration1820);
                            classDeclaration117=classDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_classDeclaration.add(classDeclaration117.getTree());


                            // AST REWRITE
                            // elements: modifier, classDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 350:22: -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:350:25: ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CLASS, "CLASS"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:350:33: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:350:45: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_classDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 8 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:351:10: enumDeclaration
                            {
                            pushFollow(FOLLOW_enumDeclaration_in_interfaceBodyDeclaration1846);
                            enumDeclaration118=enumDeclaration();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_enumDeclaration.add(enumDeclaration118.getTree());


                            // AST REWRITE
                            // elements: modifier, enumDeclaration
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 351:26: -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:351:29: ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ENUM, "ENUM"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:351:36: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:351:48: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_enumDeclaration.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:353:4: ';'
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal119=(Token)match(input,121,FOLLOW_121_in_interfaceBodyDeclaration1870); if (state.failed) return retval;

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 24, interfaceBodyDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "interfaceBodyDeclaration"

    public static class methodDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "methodDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:356:1: methodDeclaratorRest : formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ) ;
    public final JavaParser.methodDeclaratorRest_return methodDeclaratorRest() throws RecognitionException {
        JavaParser.methodDeclaratorRest_return retval = new JavaParser.methodDeclaratorRest_return();
        retval.start = input.LT(1);
        int methodDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal121=null;
        Token char_literal124=null;
        JavaParser.formalParameters_return formalParameters120 = null;

        JavaParser.typeList_return typeList122 = null;

        JavaParser.methodBody_return methodBody123 = null;


        Object string_literal121_tree=null;
        Object char_literal124_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_137=new RewriteRuleTokenStream(adaptor,"token 137");
        RewriteRuleSubtreeStream stream_methodBody=new RewriteRuleSubtreeStream(adaptor,"rule methodBody");
        RewriteRuleSubtreeStream stream_formalParameters=new RewriteRuleSubtreeStream(adaptor,"rule formalParameters");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 25) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:357:2: ( formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:357:4: formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            {
            pushFollow(FOLLOW_formalParameters_in_methodDeclaratorRest1884);
            formalParameters120=formalParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameters.add(formalParameters120.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:358:9: ( 'throws' typeList )?
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==137) ) {
                alt41=1;
            }
            switch (alt41) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:358:10: 'throws' typeList
                    {
                    string_literal121=(Token)match(input,137,FOLLOW_137_in_methodDeclaratorRest1896); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_137.add(string_literal121);

                    pushFollow(FOLLOW_typeList_in_methodDeclaratorRest1898);
                    typeList122=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList122.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:9: ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            int alt42=2;
            int LA42_0 = input.LA(1);

            if ( (LA42_0==133) ) {
                alt42=1;
            }
            else if ( (LA42_0==121) ) {
                alt42=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }
            switch (alt42) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:13: methodBody
                    {
                    pushFollow(FOLLOW_methodBody_in_methodDeclaratorRest1914);
                    methodBody123=methodBody();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_methodBody.add(methodBody123.getTree());


                    // AST REWRITE
                    // elements: typeList, formalParameters, methodBody
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 359:24: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:27: ^( PARAMETERS ( formalParameters )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:40: ( formalParameters )?
                        if ( stream_formalParameters.hasNext() ) {
                            adaptor.addChild(root_1, stream_formalParameters.nextTree());

                        }
                        stream_formalParameters.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:59: ^( THROWS ( typeList )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:359:68: ( typeList )?
                        if ( stream_typeList.hasNext() ) {
                            adaptor.addChild(root_1, stream_typeList.nextTree());

                        }
                        stream_typeList.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_methodBody.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:360:13: ';'
                    {
                    char_literal124=(Token)match(input,121,FOLLOW_121_in_methodDeclaratorRest1946); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal124);



                    // AST REWRITE
                    // elements: typeList, formalParameters
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 360:17: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:360:20: ^( PARAMETERS ( formalParameters )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:360:33: ( formalParameters )?
                        if ( stream_formalParameters.hasNext() ) {
                            adaptor.addChild(root_1, stream_formalParameters.nextTree());

                        }
                        stream_formalParameters.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:360:52: ^( THROWS ( typeList )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:360:61: ( typeList )?
                        if ( stream_typeList.hasNext() ) {
                            adaptor.addChild(root_1, stream_typeList.nextTree());

                        }
                        stream_typeList.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 25, methodDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "methodDeclaratorRest"

    public static class voidMethodDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "voidMethodDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:364:1: voidMethodDeclaratorRest : formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ) ;
    public final JavaParser.voidMethodDeclaratorRest_return voidMethodDeclaratorRest() throws RecognitionException {
        JavaParser.voidMethodDeclaratorRest_return retval = new JavaParser.voidMethodDeclaratorRest_return();
        retval.start = input.LT(1);
        int voidMethodDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal126=null;
        Token char_literal129=null;
        JavaParser.formalParameters_return formalParameters125 = null;

        JavaParser.typeList_return typeList127 = null;

        JavaParser.methodBody_return methodBody128 = null;


        Object string_literal126_tree=null;
        Object char_literal129_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_137=new RewriteRuleTokenStream(adaptor,"token 137");
        RewriteRuleSubtreeStream stream_methodBody=new RewriteRuleSubtreeStream(adaptor,"rule methodBody");
        RewriteRuleSubtreeStream stream_formalParameters=new RewriteRuleSubtreeStream(adaptor,"rule formalParameters");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 26) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:365:2: ( formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:365:4: formalParameters ( 'throws' typeList )? ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            {
            pushFollow(FOLLOW_formalParameters_in_voidMethodDeclaratorRest1984);
            formalParameters125=formalParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameters.add(formalParameters125.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:365:21: ( 'throws' typeList )?
            int alt43=2;
            int LA43_0 = input.LA(1);

            if ( (LA43_0==137) ) {
                alt43=1;
            }
            switch (alt43) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:365:22: 'throws' typeList
                    {
                    string_literal126=(Token)match(input,137,FOLLOW_137_in_voidMethodDeclaratorRest1987); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_137.add(string_literal126);

                    pushFollow(FOLLOW_typeList_in_voidMethodDeclaratorRest1989);
                    typeList127=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList127.getTree());

                    }
                    break;

            }

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:9: ( methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody | ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==133) ) {
                alt44=1;
            }
            else if ( (LA44_0==121) ) {
                alt44=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }
            switch (alt44) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:13: methodBody
                    {
                    pushFollow(FOLLOW_methodBody_in_voidMethodDeclaratorRest2005);
                    methodBody128=methodBody();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_methodBody.add(methodBody128.getTree());


                    // AST REWRITE
                    // elements: typeList, methodBody, formalParameters
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 366:24: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:27: ^( PARAMETERS ( formalParameters )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:40: ( formalParameters )?
                        if ( stream_formalParameters.hasNext() ) {
                            adaptor.addChild(root_1, stream_formalParameters.nextTree());

                        }
                        stream_formalParameters.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:59: ^( THROWS ( typeList )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:366:68: ( typeList )?
                        if ( stream_typeList.hasNext() ) {
                            adaptor.addChild(root_1, stream_typeList.nextTree());

                        }
                        stream_typeList.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_methodBody.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:367:13: ';'
                    {
                    char_literal129=(Token)match(input,121,FOLLOW_121_in_voidMethodDeclaratorRest2037); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal129);



                    // AST REWRITE
                    // elements: typeList, formalParameters
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 367:17: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:367:20: ^( PARAMETERS ( formalParameters )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:367:33: ( formalParameters )?
                        if ( stream_formalParameters.hasNext() ) {
                            adaptor.addChild(root_1, stream_formalParameters.nextTree());

                        }
                        stream_formalParameters.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:367:52: ^( THROWS ( typeList )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:367:61: ( typeList )?
                        if ( stream_typeList.hasNext() ) {
                            adaptor.addChild(root_1, stream_typeList.nextTree());

                        }
                        stream_typeList.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 26, voidMethodDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "voidMethodDeclaratorRest"

    public static class interfaceMethodDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "interfaceMethodDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:371:1: interfaceMethodDeclaratorRest : formalParameters ( 'throws' typeList )? ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ;
    public final JavaParser.interfaceMethodDeclaratorRest_return interfaceMethodDeclaratorRest() throws RecognitionException {
        JavaParser.interfaceMethodDeclaratorRest_return retval = new JavaParser.interfaceMethodDeclaratorRest_return();
        retval.start = input.LT(1);
        int interfaceMethodDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal131=null;
        Token char_literal133=null;
        JavaParser.formalParameters_return formalParameters130 = null;

        JavaParser.typeList_return typeList132 = null;


        Object string_literal131_tree=null;
        Object char_literal133_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_137=new RewriteRuleTokenStream(adaptor,"token 137");
        RewriteRuleSubtreeStream stream_formalParameters=new RewriteRuleSubtreeStream(adaptor,"rule formalParameters");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 27) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:2: ( formalParameters ( 'throws' typeList )? ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:4: formalParameters ( 'throws' typeList )? ';'
            {
            pushFollow(FOLLOW_formalParameters_in_interfaceMethodDeclaratorRest2075);
            formalParameters130=formalParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameters.add(formalParameters130.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:21: ( 'throws' typeList )?
            int alt45=2;
            int LA45_0 = input.LA(1);

            if ( (LA45_0==137) ) {
                alt45=1;
            }
            switch (alt45) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:22: 'throws' typeList
                    {
                    string_literal131=(Token)match(input,137,FOLLOW_137_in_interfaceMethodDeclaratorRest2078); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_137.add(string_literal131);

                    pushFollow(FOLLOW_typeList_in_interfaceMethodDeclaratorRest2080);
                    typeList132=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList132.getTree());

                    }
                    break;

            }

            char_literal133=(Token)match(input,121,FOLLOW_121_in_interfaceMethodDeclaratorRest2084); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal133);



            // AST REWRITE
            // elements: formalParameters, typeList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 372:46: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:49: ^( PARAMETERS ( formalParameters )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:62: ( formalParameters )?
                if ( stream_formalParameters.hasNext() ) {
                    adaptor.addChild(root_1, stream_formalParameters.nextTree());

                }
                stream_formalParameters.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:81: ^( THROWS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:372:90: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 27, interfaceMethodDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "interfaceMethodDeclaratorRest"

    public static class interfaceGenericMethodDecl_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "interfaceGenericMethodDecl"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:375:1: interfaceGenericMethodDecl : typeParameters ( type Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier type interfaceMethodDeclaratorRest | 'void' Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier ^( TYPE VOID ) interfaceMethodDeclaratorRest ) ;
    public final JavaParser.interfaceGenericMethodDecl_return interfaceGenericMethodDecl() throws RecognitionException {
        JavaParser.interfaceGenericMethodDecl_return retval = new JavaParser.interfaceGenericMethodDecl_return();
        retval.start = input.LT(1);
        int interfaceGenericMethodDecl_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier136=null;
        Token string_literal138=null;
        Token Identifier139=null;
        JavaParser.typeParameters_return typeParameters134 = null;

        JavaParser.type_return type135 = null;

        JavaParser.interfaceMethodDeclaratorRest_return interfaceMethodDeclaratorRest137 = null;

        JavaParser.interfaceMethodDeclaratorRest_return interfaceMethodDeclaratorRest140 = null;


        Object Identifier136_tree=null;
        Object string_literal138_tree=null;
        Object Identifier139_tree=null;
        RewriteRuleTokenStream stream_136=new RewriteRuleTokenStream(adaptor,"token 136");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_interfaceMethodDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule interfaceMethodDeclaratorRest");
        RewriteRuleSubtreeStream stream_typeParameters=new RewriteRuleSubtreeStream(adaptor,"rule typeParameters");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 28) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:376:2: ( typeParameters ( type Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier type interfaceMethodDeclaratorRest | 'void' Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier ^( TYPE VOID ) interfaceMethodDeclaratorRest ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:376:4: typeParameters ( type Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier type interfaceMethodDeclaratorRest | 'void' Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier ^( TYPE VOID ) interfaceMethodDeclaratorRest )
            {
            pushFollow(FOLLOW_typeParameters_in_interfaceGenericMethodDecl2112);
            typeParameters134=typeParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_typeParameters.add(typeParameters134.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:377:3: ( type Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier type interfaceMethodDeclaratorRest | 'void' Identifier interfaceMethodDeclaratorRest -> ^( TYPE_PARAMETERS typeParameters ) Identifier ^( TYPE VOID ) interfaceMethodDeclaratorRest )
            int alt46=2;
            int LA46_0 = input.LA(1);

            if ( (LA46_0==Identifier||(LA46_0>=151 && LA46_0<=161)) ) {
                alt46=1;
            }
            else if ( (LA46_0==136) ) {
                alt46=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 46, 0, input);

                throw nvae;
            }
            switch (alt46) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:377:4: type Identifier interfaceMethodDeclaratorRest
                    {
                    pushFollow(FOLLOW_type_in_interfaceGenericMethodDecl2118);
                    type135=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type135.getTree());
                    Identifier136=(Token)match(input,Identifier,FOLLOW_Identifier_in_interfaceGenericMethodDecl2120); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier136);

                    pushFollow(FOLLOW_interfaceMethodDeclaratorRest_in_interfaceGenericMethodDecl2122);
                    interfaceMethodDeclaratorRest137=interfaceMethodDeclaratorRest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_interfaceMethodDeclaratorRest.add(interfaceMethodDeclaratorRest137.getTree());


                    // AST REWRITE
                    // elements: type, Identifier, interfaceMethodDeclaratorRest, typeParameters
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 377:50: -> ^( TYPE_PARAMETERS typeParameters ) Identifier type interfaceMethodDeclaratorRest
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:377:53: ^( TYPE_PARAMETERS typeParameters )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_1);

                        adaptor.addChild(root_1, stream_typeParameters.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        adaptor.addChild(root_0, stream_type.nextTree());
                        adaptor.addChild(root_0, stream_interfaceMethodDeclaratorRest.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:378:5: 'void' Identifier interfaceMethodDeclaratorRest
                    {
                    string_literal138=(Token)match(input,136,FOLLOW_136_in_interfaceGenericMethodDecl2142); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_136.add(string_literal138);

                    Identifier139=(Token)match(input,Identifier,FOLLOW_Identifier_in_interfaceGenericMethodDecl2144); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier139);

                    pushFollow(FOLLOW_interfaceMethodDeclaratorRest_in_interfaceGenericMethodDecl2146);
                    interfaceMethodDeclaratorRest140=interfaceMethodDeclaratorRest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_interfaceMethodDeclaratorRest.add(interfaceMethodDeclaratorRest140.getTree());


                    // AST REWRITE
                    // elements: interfaceMethodDeclaratorRest, Identifier, typeParameters
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 378:53: -> ^( TYPE_PARAMETERS typeParameters ) Identifier ^( TYPE VOID ) interfaceMethodDeclaratorRest
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:378:56: ^( TYPE_PARAMETERS typeParameters )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETERS, "TYPE_PARAMETERS"), root_1);

                        adaptor.addChild(root_1, stream_typeParameters.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:378:101: ^( TYPE VOID )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(VOID, "VOID"));

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, stream_interfaceMethodDeclaratorRest.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 28, interfaceGenericMethodDecl_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "interfaceGenericMethodDecl"

    public static class voidInterfaceMethodDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "voidInterfaceMethodDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:382:1: voidInterfaceMethodDeclaratorRest : formalParameters ( 'throws' typeList )? ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) ;
    public final JavaParser.voidInterfaceMethodDeclaratorRest_return voidInterfaceMethodDeclaratorRest() throws RecognitionException {
        JavaParser.voidInterfaceMethodDeclaratorRest_return retval = new JavaParser.voidInterfaceMethodDeclaratorRest_return();
        retval.start = input.LT(1);
        int voidInterfaceMethodDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal142=null;
        Token char_literal144=null;
        JavaParser.formalParameters_return formalParameters141 = null;

        JavaParser.typeList_return typeList143 = null;


        Object string_literal142_tree=null;
        Object char_literal144_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_137=new RewriteRuleTokenStream(adaptor,"token 137");
        RewriteRuleSubtreeStream stream_formalParameters=new RewriteRuleSubtreeStream(adaptor,"rule formalParameters");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 29) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:2: ( formalParameters ( 'throws' typeList )? ';' -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:4: formalParameters ( 'throws' typeList )? ';'
            {
            pushFollow(FOLLOW_formalParameters_in_voidInterfaceMethodDeclaratorRest2180);
            formalParameters141=formalParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameters.add(formalParameters141.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:21: ( 'throws' typeList )?
            int alt47=2;
            int LA47_0 = input.LA(1);

            if ( (LA47_0==137) ) {
                alt47=1;
            }
            switch (alt47) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:22: 'throws' typeList
                    {
                    string_literal142=(Token)match(input,137,FOLLOW_137_in_voidInterfaceMethodDeclaratorRest2183); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_137.add(string_literal142);

                    pushFollow(FOLLOW_typeList_in_voidInterfaceMethodDeclaratorRest2185);
                    typeList143=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList143.getTree());

                    }
                    break;

            }

            char_literal144=(Token)match(input,121,FOLLOW_121_in_voidInterfaceMethodDeclaratorRest2189); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal144);



            // AST REWRITE
            // elements: formalParameters, typeList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 383:46: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:49: ^( PARAMETERS ( formalParameters )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:62: ( formalParameters )?
                if ( stream_formalParameters.hasNext() ) {
                    adaptor.addChild(root_1, stream_formalParameters.nextTree());

                }
                stream_formalParameters.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:81: ^( THROWS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:383:90: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 29, voidInterfaceMethodDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "voidInterfaceMethodDeclaratorRest"

    public static class constructorDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructorDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:386:1: constructorDeclaratorRest : formalParameters ( 'throws' typeList )? methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody ;
    public final JavaParser.constructorDeclaratorRest_return constructorDeclaratorRest() throws RecognitionException {
        JavaParser.constructorDeclaratorRest_return retval = new JavaParser.constructorDeclaratorRest_return();
        retval.start = input.LT(1);
        int constructorDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal146=null;
        JavaParser.formalParameters_return formalParameters145 = null;

        JavaParser.typeList_return typeList147 = null;

        JavaParser.methodBody_return methodBody148 = null;


        Object string_literal146_tree=null;
        RewriteRuleTokenStream stream_137=new RewriteRuleTokenStream(adaptor,"token 137");
        RewriteRuleSubtreeStream stream_methodBody=new RewriteRuleSubtreeStream(adaptor,"rule methodBody");
        RewriteRuleSubtreeStream stream_formalParameters=new RewriteRuleSubtreeStream(adaptor,"rule formalParameters");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 30) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:2: ( formalParameters ( 'throws' typeList )? methodBody -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:4: formalParameters ( 'throws' typeList )? methodBody
            {
            pushFollow(FOLLOW_formalParameters_in_constructorDeclaratorRest2217);
            formalParameters145=formalParameters();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameters.add(formalParameters145.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:21: ( 'throws' typeList )?
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( (LA48_0==137) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:22: 'throws' typeList
                    {
                    string_literal146=(Token)match(input,137,FOLLOW_137_in_constructorDeclaratorRest2220); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_137.add(string_literal146);

                    pushFollow(FOLLOW_typeList_in_constructorDeclaratorRest2222);
                    typeList147=typeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeList.add(typeList147.getTree());

                    }
                    break;

            }

            pushFollow(FOLLOW_methodBody_in_constructorDeclaratorRest2226);
            methodBody148=methodBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_methodBody.add(methodBody148.getTree());


            // AST REWRITE
            // elements: methodBody, formalParameters, typeList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 387:53: -> ^( PARAMETERS ( formalParameters )? ) ^( THROWS ( typeList )? ) methodBody
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:56: ^( PARAMETERS ( formalParameters )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETERS, "PARAMETERS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:69: ( formalParameters )?
                if ( stream_formalParameters.hasNext() ) {
                    adaptor.addChild(root_1, stream_formalParameters.nextTree());

                }
                stream_formalParameters.reset();

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:88: ^( THROWS ( typeList )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROWS, "THROWS"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:387:97: ( typeList )?
                if ( stream_typeList.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeList.nextTree());

                }
                stream_typeList.reset();

                adaptor.addChild(root_0, root_1);
                }
                adaptor.addChild(root_0, stream_methodBody.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 30, constructorDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constructorDeclaratorRest"

    public static class variableDeclarators_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclarators"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:391:1: variableDeclarators : i+= variableDeclarator ( ',' i+= variableDeclarator )* -> ( $i)+ ;
    public final JavaParser.variableDeclarators_return variableDeclarators() throws RecognitionException {
        JavaParser.variableDeclarators_return retval = new JavaParser.variableDeclarators_return();
        retval.start = input.LT(1);
        int variableDeclarators_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal149=null;
        List list_i=null;
        RuleReturnScope i = null;
        Object char_literal149_tree=null;
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_variableDeclarator=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclarator");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 31) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:392:2: (i+= variableDeclarator ( ',' i+= variableDeclarator )* -> ( $i)+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:392:4: i+= variableDeclarator ( ',' i+= variableDeclarator )*
            {
            pushFollow(FOLLOW_variableDeclarator_in_variableDeclarators2259);
            i=variableDeclarator();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_variableDeclarator.add(i.getTree());
            if (list_i==null) list_i=new ArrayList();
            list_i.add(i.getTree());

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:392:26: ( ',' i+= variableDeclarator )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);

                if ( (LA49_0==130) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:392:27: ',' i+= variableDeclarator
            	    {
            	    char_literal149=(Token)match(input,130,FOLLOW_130_in_variableDeclarators2262); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_130.add(char_literal149);

            	    pushFollow(FOLLOW_variableDeclarator_in_variableDeclarators2266);
            	    i=variableDeclarator();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_variableDeclarator.add(i.getTree());
            	    if (list_i==null) list_i=new ArrayList();
            	    list_i.add(i.getTree());


            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);



            // AST REWRITE
            // elements: i
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: i
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
            root_0 = (Object)adaptor.nil();
            // 392:55: -> ( $i)+
            {
                if ( !(stream_i.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_i.hasNext() ) {
                    adaptor.addChild(root_0, stream_i.nextTree());

                }
                stream_i.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 31, variableDeclarators_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableDeclarators"

    public static class variableDeclarator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclarator"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:395:1: variableDeclarator : Identifier variableDeclaratorRest -> ^( Identifier ( variableDeclaratorRest )? ) ;
    public final JavaParser.variableDeclarator_return variableDeclarator() throws RecognitionException {
        JavaParser.variableDeclarator_return retval = new JavaParser.variableDeclarator_return();
        retval.start = input.LT(1);
        int variableDeclarator_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier150=null;
        JavaParser.variableDeclaratorRest_return variableDeclaratorRest151 = null;


        Object Identifier150_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_variableDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclaratorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 32) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:396:2: ( Identifier variableDeclaratorRest -> ^( Identifier ( variableDeclaratorRest )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:396:4: Identifier variableDeclaratorRest
            {
            Identifier150=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclarator2285); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier150);

            pushFollow(FOLLOW_variableDeclaratorRest_in_variableDeclarator2287);
            variableDeclaratorRest151=variableDeclaratorRest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_variableDeclaratorRest.add(variableDeclaratorRest151.getTree());


            // AST REWRITE
            // elements: Identifier, variableDeclaratorRest
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 396:38: -> ^( Identifier ( variableDeclaratorRest )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:396:41: ^( Identifier ( variableDeclaratorRest )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:396:54: ( variableDeclaratorRest )?
                if ( stream_variableDeclaratorRest.hasNext() ) {
                    adaptor.addChild(root_1, stream_variableDeclaratorRest.nextTree());

                }
                stream_variableDeclaratorRest.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 32, variableDeclarator_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableDeclarator"

    public static class variableDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:399:1: variableDeclaratorRest : ( ( '[' ']' )+ ( '=' variableInitializer )? -> ( '[' )+ ( variableInitializer )? | '=' variableInitializer -> variableInitializer | );
    public final JavaParser.variableDeclaratorRest_return variableDeclaratorRest() throws RecognitionException {
        JavaParser.variableDeclaratorRest_return retval = new JavaParser.variableDeclaratorRest_return();
        retval.start = input.LT(1);
        int variableDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal152=null;
        Token char_literal153=null;
        Token char_literal154=null;
        Token char_literal156=null;
        JavaParser.variableInitializer_return variableInitializer155 = null;

        JavaParser.variableInitializer_return variableInitializer157 = null;


        Object char_literal152_tree=null;
        Object char_literal153_tree=null;
        Object char_literal154_tree=null;
        Object char_literal156_tree=null;
        RewriteRuleTokenStream stream_138=new RewriteRuleTokenStream(adaptor,"token 138");
        RewriteRuleTokenStream stream_139=new RewriteRuleTokenStream(adaptor,"token 139");
        RewriteRuleTokenStream stream_140=new RewriteRuleTokenStream(adaptor,"token 140");
        RewriteRuleSubtreeStream stream_variableInitializer=new RewriteRuleSubtreeStream(adaptor,"rule variableInitializer");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 33) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:2: ( ( '[' ']' )+ ( '=' variableInitializer )? -> ( '[' )+ ( variableInitializer )? | '=' variableInitializer -> variableInitializer | )
            int alt52=3;
            switch ( input.LA(1) ) {
            case 138:
                {
                alt52=1;
                }
                break;
            case 140:
                {
                alt52=2;
                }
                break;
            case EOF:
            case 121:
            case 130:
                {
                alt52=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 52, 0, input);

                throw nvae;
            }

            switch (alt52) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:4: ( '[' ']' )+ ( '=' variableInitializer )?
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:4: ( '[' ']' )+
                    int cnt50=0;
                    loop50:
                    do {
                        int alt50=2;
                        int LA50_0 = input.LA(1);

                        if ( (LA50_0==138) ) {
                            alt50=1;
                        }


                        switch (alt50) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:5: '[' ']'
                    	    {
                    	    char_literal152=(Token)match(input,138,FOLLOW_138_in_variableDeclaratorRest2309); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_138.add(char_literal152);

                    	    char_literal153=(Token)match(input,139,FOLLOW_139_in_variableDeclaratorRest2311); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_139.add(char_literal153);


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt50 >= 1 ) break loop50;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(50, input);
                                throw eee;
                        }
                        cnt50++;
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:15: ( '=' variableInitializer )?
                    int alt51=2;
                    int LA51_0 = input.LA(1);

                    if ( (LA51_0==140) ) {
                        alt51=1;
                    }
                    switch (alt51) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:16: '=' variableInitializer
                            {
                            char_literal154=(Token)match(input,140,FOLLOW_140_in_variableDeclaratorRest2316); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_140.add(char_literal154);

                            pushFollow(FOLLOW_variableInitializer_in_variableDeclaratorRest2318);
                            variableInitializer155=variableInitializer();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_variableInitializer.add(variableInitializer155.getTree());

                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: 138, variableInitializer
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 400:42: -> ( '[' )+ ( variableInitializer )?
                    {
                        if ( !(stream_138.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_138.hasNext() ) {
                            adaptor.addChild(root_0, stream_138.nextNode());

                        }
                        stream_138.reset();
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:400:50: ( variableInitializer )?
                        if ( stream_variableInitializer.hasNext() ) {
                            adaptor.addChild(root_0, stream_variableInitializer.nextTree());

                        }
                        stream_variableInitializer.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:401:4: '=' variableInitializer
                    {
                    char_literal156=(Token)match(input,140,FOLLOW_140_in_variableDeclaratorRest2333); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal156);

                    pushFollow(FOLLOW_variableInitializer_in_variableDeclaratorRest2335);
                    variableInitializer157=variableInitializer();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_variableInitializer.add(variableInitializer157.getTree());


                    // AST REWRITE
                    // elements: variableInitializer
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 401:28: -> variableInitializer
                    {
                        adaptor.addChild(root_0, stream_variableInitializer.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:403:2: 
                    {
                    root_0 = (Object)adaptor.nil();

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 33, variableDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableDeclaratorRest"

    public static class constantDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constantDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:405:1: constantDeclaration : type constantDeclarators ';' -> type constantDeclarators ;
    public final JavaParser.constantDeclaration_return constantDeclaration() throws RecognitionException {
        JavaParser.constantDeclaration_return retval = new JavaParser.constantDeclaration_return();
        retval.start = input.LT(1);
        int constantDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal160=null;
        JavaParser.type_return type158 = null;

        JavaParser.constantDeclarators_return constantDeclarators159 = null;


        Object char_literal160_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_constantDeclarators=new RewriteRuleSubtreeStream(adaptor,"rule constantDeclarators");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 34) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:406:2: ( type constantDeclarators ';' -> type constantDeclarators )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:406:4: type constantDeclarators ';'
            {
            pushFollow(FOLLOW_type_in_constantDeclaration2353);
            type158=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type158.getTree());
            pushFollow(FOLLOW_constantDeclarators_in_constantDeclaration2355);
            constantDeclarators159=constantDeclarators();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constantDeclarators.add(constantDeclarators159.getTree());
            char_literal160=(Token)match(input,121,FOLLOW_121_in_constantDeclaration2357); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal160);



            // AST REWRITE
            // elements: constantDeclarators, type
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 406:33: -> type constantDeclarators
            {
                adaptor.addChild(root_0, stream_type.nextTree());
                adaptor.addChild(root_0, stream_constantDeclarators.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 34, constantDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constantDeclaration"

    public static class constantDeclarator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constantDeclarator"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:409:1: constantDeclarator : Identifier constantDeclaratorRest -> ^( Identifier constantDeclaratorRest ) ;
    public final JavaParser.constantDeclarator_return constantDeclarator() throws RecognitionException {
        JavaParser.constantDeclarator_return retval = new JavaParser.constantDeclarator_return();
        retval.start = input.LT(1);
        int constantDeclarator_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier161=null;
        JavaParser.constantDeclaratorRest_return constantDeclaratorRest162 = null;


        Object Identifier161_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_constantDeclaratorRest=new RewriteRuleSubtreeStream(adaptor,"rule constantDeclaratorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 35) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:410:2: ( Identifier constantDeclaratorRest -> ^( Identifier constantDeclaratorRest ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:410:4: Identifier constantDeclaratorRest
            {
            Identifier161=(Token)match(input,Identifier,FOLLOW_Identifier_in_constantDeclarator2374); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier161);

            pushFollow(FOLLOW_constantDeclaratorRest_in_constantDeclarator2376);
            constantDeclaratorRest162=constantDeclaratorRest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constantDeclaratorRest.add(constantDeclaratorRest162.getTree());


            // AST REWRITE
            // elements: Identifier, constantDeclaratorRest
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 410:38: -> ^( Identifier constantDeclaratorRest )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:410:41: ^( Identifier constantDeclaratorRest )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_1);

                adaptor.addChild(root_1, stream_constantDeclaratorRest.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 35, constantDeclarator_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constantDeclarator"

    public static class constantDeclarators_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constantDeclarators"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:413:1: constantDeclarators : i+= constantDeclarator ( ',' i+= constantDeclarator )* -> ( $i)+ ;
    public final JavaParser.constantDeclarators_return constantDeclarators() throws RecognitionException {
        JavaParser.constantDeclarators_return retval = new JavaParser.constantDeclarators_return();
        retval.start = input.LT(1);
        int constantDeclarators_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal163=null;
        List list_i=null;
        RuleReturnScope i = null;
        Object char_literal163_tree=null;
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_constantDeclarator=new RewriteRuleSubtreeStream(adaptor,"rule constantDeclarator");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 36) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:414:2: (i+= constantDeclarator ( ',' i+= constantDeclarator )* -> ( $i)+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:414:4: i+= constantDeclarator ( ',' i+= constantDeclarator )*
            {
            pushFollow(FOLLOW_constantDeclarator_in_constantDeclarators2399);
            i=constantDeclarator();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constantDeclarator.add(i.getTree());
            if (list_i==null) list_i=new ArrayList();
            list_i.add(i.getTree());

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:414:26: ( ',' i+= constantDeclarator )*
            loop53:
            do {
                int alt53=2;
                int LA53_0 = input.LA(1);

                if ( (LA53_0==130) ) {
                    alt53=1;
                }


                switch (alt53) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:414:27: ',' i+= constantDeclarator
            	    {
            	    char_literal163=(Token)match(input,130,FOLLOW_130_in_constantDeclarators2402); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_130.add(char_literal163);

            	    pushFollow(FOLLOW_constantDeclarator_in_constantDeclarators2406);
            	    i=constantDeclarator();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_constantDeclarator.add(i.getTree());
            	    if (list_i==null) list_i=new ArrayList();
            	    list_i.add(i.getTree());


            	    }
            	    break;

            	default :
            	    break loop53;
                }
            } while (true);



            // AST REWRITE
            // elements: i
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: i
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
            root_0 = (Object)adaptor.nil();
            // 414:55: -> ( $i)+
            {
                if ( !(stream_i.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_i.hasNext() ) {
                    adaptor.addChild(root_0, stream_i.nextTree());

                }
                stream_i.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 36, constantDeclarators_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constantDeclarators"

    public static class constantDeclaratorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constantDeclaratorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:417:1: constantDeclaratorRest : ( '[' ']' )* '=' variableInitializer -> ( '[' )* variableInitializer ;
    public final JavaParser.constantDeclaratorRest_return constantDeclaratorRest() throws RecognitionException {
        JavaParser.constantDeclaratorRest_return retval = new JavaParser.constantDeclaratorRest_return();
        retval.start = input.LT(1);
        int constantDeclaratorRest_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal164=null;
        Token char_literal165=null;
        Token char_literal166=null;
        JavaParser.variableInitializer_return variableInitializer167 = null;


        Object char_literal164_tree=null;
        Object char_literal165_tree=null;
        Object char_literal166_tree=null;
        RewriteRuleTokenStream stream_138=new RewriteRuleTokenStream(adaptor,"token 138");
        RewriteRuleTokenStream stream_139=new RewriteRuleTokenStream(adaptor,"token 139");
        RewriteRuleTokenStream stream_140=new RewriteRuleTokenStream(adaptor,"token 140");
        RewriteRuleSubtreeStream stream_variableInitializer=new RewriteRuleSubtreeStream(adaptor,"rule variableInitializer");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 37) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:418:2: ( ( '[' ']' )* '=' variableInitializer -> ( '[' )* variableInitializer )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:418:4: ( '[' ']' )* '=' variableInitializer
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:418:4: ( '[' ']' )*
            loop54:
            do {
                int alt54=2;
                int LA54_0 = input.LA(1);

                if ( (LA54_0==138) ) {
                    alt54=1;
                }


                switch (alt54) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:418:5: '[' ']'
            	    {
            	    char_literal164=(Token)match(input,138,FOLLOW_138_in_constantDeclaratorRest2427); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_138.add(char_literal164);

            	    char_literal165=(Token)match(input,139,FOLLOW_139_in_constantDeclaratorRest2429); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_139.add(char_literal165);


            	    }
            	    break;

            	default :
            	    break loop54;
                }
            } while (true);

            char_literal166=(Token)match(input,140,FOLLOW_140_in_constantDeclaratorRest2433); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_140.add(char_literal166);

            pushFollow(FOLLOW_variableInitializer_in_constantDeclaratorRest2435);
            variableInitializer167=variableInitializer();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_variableInitializer.add(variableInitializer167.getTree());


            // AST REWRITE
            // elements: variableInitializer, 138
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 418:39: -> ( '[' )* variableInitializer
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:418:42: ( '[' )*
                while ( stream_138.hasNext() ) {
                    adaptor.addChild(root_0, stream_138.nextNode());

                }
                stream_138.reset();
                adaptor.addChild(root_0, stream_variableInitializer.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 37, constantDeclaratorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constantDeclaratorRest"

    public static class variableDeclaratorId_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclaratorId"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:421:1: variableDeclaratorId : Identifier ( '[' ']' )* ;
    public final JavaParser.variableDeclaratorId_return variableDeclaratorId() throws RecognitionException {
        JavaParser.variableDeclaratorId_return retval = new JavaParser.variableDeclaratorId_return();
        retval.start = input.LT(1);
        int variableDeclaratorId_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier168=null;
        Token char_literal169=null;
        Token char_literal170=null;

        Object Identifier168_tree=null;
        Object char_literal169_tree=null;
        Object char_literal170_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 38) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:422:2: ( Identifier ( '[' ']' )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:422:4: Identifier ( '[' ']' )*
            {
            root_0 = (Object)adaptor.nil();

            Identifier168=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaratorId2454); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            Identifier168_tree = (Object)adaptor.create(Identifier168);
            adaptor.addChild(root_0, Identifier168_tree);
            }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:422:15: ( '[' ']' )*
            loop55:
            do {
                int alt55=2;
                int LA55_0 = input.LA(1);

                if ( (LA55_0==138) ) {
                    alt55=1;
                }


                switch (alt55) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:422:16: '[' ']'
            	    {
            	    char_literal169=(Token)match(input,138,FOLLOW_138_in_variableDeclaratorId2457); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal169_tree = (Object)adaptor.create(char_literal169);
            	    adaptor.addChild(root_0, char_literal169_tree);
            	    }
            	    char_literal170=(Token)match(input,139,FOLLOW_139_in_variableDeclaratorId2459); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal170_tree = (Object)adaptor.create(char_literal170);
            	    adaptor.addChild(root_0, char_literal170_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop55;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 38, variableDeclaratorId_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableDeclaratorId"

    public static class variableInitializer_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableInitializer"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:425:1: variableInitializer : ( arrayInitializer | expression );
    public final JavaParser.variableInitializer_return variableInitializer() throws RecognitionException {
        JavaParser.variableInitializer_return retval = new JavaParser.variableInitializer_return();
        retval.start = input.LT(1);
        int variableInitializer_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.arrayInitializer_return arrayInitializer171 = null;

        JavaParser.expression_return expression172 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 39) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:426:2: ( arrayInitializer | expression )
            int alt56=2;
            alt56 = dfa56.predict(input);
            switch (alt56) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:426:4: arrayInitializer
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_arrayInitializer_in_variableInitializer2472);
                    arrayInitializer171=arrayInitializer();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, arrayInitializer171.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:427:9: expression
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_expression_in_variableInitializer2482);
                    expression172=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression172.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 39, variableInitializer_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableInitializer"

    public static class arrayInitializer_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arrayInitializer"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:430:1: arrayInitializer : '{' ( variableInitializer ( ',' variableInitializer )* ( ',' )? )? '}' -> ^( ARRAYVAL ( variableInitializer )* ) ;
    public final JavaParser.arrayInitializer_return arrayInitializer() throws RecognitionException {
        JavaParser.arrayInitializer_return retval = new JavaParser.arrayInitializer_return();
        retval.start = input.LT(1);
        int arrayInitializer_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal173=null;
        Token char_literal175=null;
        Token char_literal177=null;
        Token char_literal178=null;
        JavaParser.variableInitializer_return variableInitializer174 = null;

        JavaParser.variableInitializer_return variableInitializer176 = null;


        Object char_literal173_tree=null;
        Object char_literal175_tree=null;
        Object char_literal177_tree=null;
        Object char_literal178_tree=null;
        RewriteRuleTokenStream stream_134=new RewriteRuleTokenStream(adaptor,"token 134");
        RewriteRuleTokenStream stream_133=new RewriteRuleTokenStream(adaptor,"token 133");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_variableInitializer=new RewriteRuleSubtreeStream(adaptor,"rule variableInitializer");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 40) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:2: ( '{' ( variableInitializer ( ',' variableInitializer )* ( ',' )? )? '}' -> ^( ARRAYVAL ( variableInitializer )* ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:4: '{' ( variableInitializer ( ',' variableInitializer )* ( ',' )? )? '}'
            {
            char_literal173=(Token)match(input,133,FOLLOW_133_in_arrayInitializer2494); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_133.add(char_literal173);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:8: ( variableInitializer ( ',' variableInitializer )* ( ',' )? )?
            int alt59=2;
            alt59 = dfa59.predict(input);
            switch (alt59) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:9: variableInitializer ( ',' variableInitializer )* ( ',' )?
                    {
                    pushFollow(FOLLOW_variableInitializer_in_arrayInitializer2497);
                    variableInitializer174=variableInitializer();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_variableInitializer.add(variableInitializer174.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:29: ( ',' variableInitializer )*
                    loop57:
                    do {
                        int alt57=2;
                        alt57 = dfa57.predict(input);
                        switch (alt57) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:30: ',' variableInitializer
                    	    {
                    	    char_literal175=(Token)match(input,130,FOLLOW_130_in_arrayInitializer2500); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_130.add(char_literal175);

                    	    pushFollow(FOLLOW_variableInitializer_in_arrayInitializer2502);
                    	    variableInitializer176=variableInitializer();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_variableInitializer.add(variableInitializer176.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop57;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:56: ( ',' )?
                    int alt58=2;
                    int LA58_0 = input.LA(1);

                    if ( (LA58_0==130) ) {
                        alt58=1;
                    }
                    switch (alt58) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:57: ','
                            {
                            char_literal177=(Token)match(input,130,FOLLOW_130_in_arrayInitializer2507); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_130.add(char_literal177);


                            }
                            break;

                    }


                    }
                    break;

            }

            char_literal178=(Token)match(input,134,FOLLOW_134_in_arrayInitializer2514); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_134.add(char_literal178);



            // AST REWRITE
            // elements: variableInitializer
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 431:70: -> ^( ARRAYVAL ( variableInitializer )* )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:73: ^( ARRAYVAL ( variableInitializer )* )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ARRAYVAL, "ARRAYVAL"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:431:84: ( variableInitializer )*
                while ( stream_variableInitializer.hasNext() ) {
                    adaptor.addChild(root_1, stream_variableInitializer.nextTree());

                }
                stream_variableInitializer.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 40, arrayInitializer_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "arrayInitializer"

    public static class modifier_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modifier"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:434:1: modifier : ( annotation | 'public' | 'protected' | 'private' | 'static' | 'abstract' | 'final' | 'native' | 'synchronized' | 'transient' | 'volatile' | 'strictfp' );
    public final JavaParser.modifier_return modifier() throws RecognitionException {
        JavaParser.modifier_return retval = new JavaParser.modifier_return();
        retval.start = input.LT(1);
        int modifier_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal180=null;
        Token string_literal181=null;
        Token string_literal182=null;
        Token string_literal183=null;
        Token string_literal184=null;
        Token string_literal185=null;
        Token string_literal186=null;
        Token string_literal187=null;
        Token string_literal188=null;
        Token string_literal189=null;
        Token string_literal190=null;
        JavaParser.annotation_return annotation179 = null;


        Object string_literal180_tree=null;
        Object string_literal181_tree=null;
        Object string_literal182_tree=null;
        Object string_literal183_tree=null;
        Object string_literal184_tree=null;
        Object string_literal185_tree=null;
        Object string_literal186_tree=null;
        Object string_literal187_tree=null;
        Object string_literal188_tree=null;
        Object string_literal189_tree=null;
        Object string_literal190_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 41) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:435:5: ( annotation | 'public' | 'protected' | 'private' | 'static' | 'abstract' | 'final' | 'native' | 'synchronized' | 'transient' | 'volatile' | 'strictfp' )
            int alt60=12;
            alt60 = dfa60.predict(input);
            switch (alt60) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:435:9: annotation
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_annotation_in_modifier2539);
                    annotation179=annotation();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotation179.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:436:9: 'public'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal180=(Token)match(input,141,FOLLOW_141_in_modifier2549); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal180_tree = (Object)adaptor.create(string_literal180);
                    adaptor.addChild(root_0, string_literal180_tree);
                    }

                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:437:9: 'protected'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal181=(Token)match(input,142,FOLLOW_142_in_modifier2559); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal181_tree = (Object)adaptor.create(string_literal181);
                    adaptor.addChild(root_0, string_literal181_tree);
                    }

                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:438:9: 'private'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal182=(Token)match(input,143,FOLLOW_143_in_modifier2569); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal182_tree = (Object)adaptor.create(string_literal182);
                    adaptor.addChild(root_0, string_literal182_tree);
                    }

                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:439:9: 'static'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal183=(Token)match(input,123,FOLLOW_123_in_modifier2579); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal183_tree = (Object)adaptor.create(string_literal183);
                    adaptor.addChild(root_0, string_literal183_tree);
                    }

                    }
                    break;
                case 6 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:440:9: 'abstract'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal184=(Token)match(input,144,FOLLOW_144_in_modifier2589); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal184_tree = (Object)adaptor.create(string_literal184);
                    adaptor.addChild(root_0, string_literal184_tree);
                    }

                    }
                    break;
                case 7 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:441:9: 'final'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal185=(Token)match(input,145,FOLLOW_145_in_modifier2599); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal185_tree = (Object)adaptor.create(string_literal185);
                    adaptor.addChild(root_0, string_literal185_tree);
                    }

                    }
                    break;
                case 8 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:442:9: 'native'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal186=(Token)match(input,146,FOLLOW_146_in_modifier2609); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal186_tree = (Object)adaptor.create(string_literal186);
                    adaptor.addChild(root_0, string_literal186_tree);
                    }

                    }
                    break;
                case 9 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:443:9: 'synchronized'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal187=(Token)match(input,147,FOLLOW_147_in_modifier2619); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal187_tree = (Object)adaptor.create(string_literal187);
                    adaptor.addChild(root_0, string_literal187_tree);
                    }

                    }
                    break;
                case 10 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:444:9: 'transient'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal188=(Token)match(input,148,FOLLOW_148_in_modifier2629); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal188_tree = (Object)adaptor.create(string_literal188);
                    adaptor.addChild(root_0, string_literal188_tree);
                    }

                    }
                    break;
                case 11 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:445:9: 'volatile'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal189=(Token)match(input,149,FOLLOW_149_in_modifier2639); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal189_tree = (Object)adaptor.create(string_literal189);
                    adaptor.addChild(root_0, string_literal189_tree);
                    }

                    }
                    break;
                case 12 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:446:9: 'strictfp'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal190=(Token)match(input,150,FOLLOW_150_in_modifier2649); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal190_tree = (Object)adaptor.create(string_literal190);
                    adaptor.addChild(root_0, string_literal190_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 41, modifier_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "modifier"

    public static class packageOrTypeName_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "packageOrTypeName"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:449:1: packageOrTypeName : Identifier ( '.' Identifier )* ;
    public final JavaParser.packageOrTypeName_return packageOrTypeName() throws RecognitionException {
        JavaParser.packageOrTypeName_return retval = new JavaParser.packageOrTypeName_return();
        retval.start = input.LT(1);
        int packageOrTypeName_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier191=null;
        Token char_literal192=null;
        Token Identifier193=null;

        Object Identifier191_tree=null;
        Object char_literal192_tree=null;
        Object Identifier193_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 42) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:2: ( Identifier ( '.' Identifier )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:4: Identifier ( '.' Identifier )*
            {
            root_0 = (Object)adaptor.nil();

            Identifier191=(Token)match(input,Identifier,FOLLOW_Identifier_in_packageOrTypeName2663); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            Identifier191_tree = (Object)adaptor.create(Identifier191);
            adaptor.addChild(root_0, Identifier191_tree);
            }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:15: ( '.' Identifier )*
            loop61:
            do {
                int alt61=2;
                int LA61_0 = input.LA(1);

                if ( (LA61_0==124) ) {
                    int LA61_1 = input.LA(2);

                    if ( (LA61_1==Identifier) ) {
                        int LA61_2 = input.LA(3);

                        if ( (synpred90_Java()) ) {
                            alt61=1;
                        }


                    }


                }


                switch (alt61) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:16: '.' Identifier
            	    {
            	    char_literal192=(Token)match(input,124,FOLLOW_124_in_packageOrTypeName2666); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal192_tree = (Object)adaptor.create(char_literal192);
            	    adaptor.addChild(root_0, char_literal192_tree);
            	    }
            	    Identifier193=(Token)match(input,Identifier,FOLLOW_Identifier_in_packageOrTypeName2668); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    Identifier193_tree = (Object)adaptor.create(Identifier193);
            	    adaptor.addChild(root_0, Identifier193_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop61;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 42, packageOrTypeName_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "packageOrTypeName"

    public static class enumConstantName_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumConstantName"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:453:1: enumConstantName : Identifier ;
    public final JavaParser.enumConstantName_return enumConstantName() throws RecognitionException {
        JavaParser.enumConstantName_return retval = new JavaParser.enumConstantName_return();
        retval.start = input.LT(1);
        int enumConstantName_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier194=null;

        Object Identifier194_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 43) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:454:5: ( Identifier )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:454:9: Identifier
            {
            root_0 = (Object)adaptor.nil();

            Identifier194=(Token)match(input,Identifier,FOLLOW_Identifier_in_enumConstantName2686); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            Identifier194_tree = (Object)adaptor.create(Identifier194);
            adaptor.addChild(root_0, Identifier194_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 43, enumConstantName_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "enumConstantName"

    public static class typeName_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeName"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:457:1: typeName : ( Identifier | packageOrTypeName '.' Identifier );
    public final JavaParser.typeName_return typeName() throws RecognitionException {
        JavaParser.typeName_return retval = new JavaParser.typeName_return();
        retval.start = input.LT(1);
        int typeName_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier195=null;
        Token char_literal197=null;
        Token Identifier198=null;
        JavaParser.packageOrTypeName_return packageOrTypeName196 = null;


        Object Identifier195_tree=null;
        Object char_literal197_tree=null;
        Object Identifier198_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 44) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:458:2: ( Identifier | packageOrTypeName '.' Identifier )
            int alt62=2;
            int LA62_0 = input.LA(1);

            if ( (LA62_0==Identifier) ) {
                int LA62_1 = input.LA(2);

                if ( (LA62_1==124) ) {
                    alt62=2;
                }
                else if ( (LA62_1==EOF) ) {
                    alt62=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 62, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 62, 0, input);

                throw nvae;
            }
            switch (alt62) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:458:6: Identifier
                    {
                    root_0 = (Object)adaptor.nil();

                    Identifier195=(Token)match(input,Identifier,FOLLOW_Identifier_in_typeName2702); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    Identifier195_tree = (Object)adaptor.create(Identifier195);
                    adaptor.addChild(root_0, Identifier195_tree);
                    }

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:459:9: packageOrTypeName '.' Identifier
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_packageOrTypeName_in_typeName2712);
                    packageOrTypeName196=packageOrTypeName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, packageOrTypeName196.getTree());
                    char_literal197=(Token)match(input,124,FOLLOW_124_in_typeName2714); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    char_literal197_tree = (Object)adaptor.create(char_literal197);
                    adaptor.addChild(root_0, char_literal197_tree);
                    }
                    Identifier198=(Token)match(input,Identifier,FOLLOW_Identifier_in_typeName2716); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    Identifier198_tree = (Object)adaptor.create(Identifier198);
                    adaptor.addChild(root_0, Identifier198_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 44, typeName_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeName"

    public static class type_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "type"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:462:1: type : ( ( uniMod )? i+= refComponent ( '.' i+= refComponent )* ( '[' ']' )* -> ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) | primitiveType ( '[' ']' )* -> ^( TYPE primitiveType ( '[' )* ) );
    public final JavaParser.type_return type() throws RecognitionException {
        JavaParser.type_return retval = new JavaParser.type_return();
        retval.start = input.LT(1);
        int type_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal200=null;
        Token char_literal201=null;
        Token char_literal202=null;
        Token char_literal204=null;
        Token char_literal205=null;
        List list_i=null;
        JavaParser.uniMod_return uniMod199 = null;

        JavaParser.primitiveType_return primitiveType203 = null;

        RuleReturnScope i = null;
        Object char_literal200_tree=null;
        Object char_literal201_tree=null;
        Object char_literal202_tree=null;
        Object char_literal204_tree=null;
        Object char_literal205_tree=null;
        RewriteRuleTokenStream stream_138=new RewriteRuleTokenStream(adaptor,"token 138");
        RewriteRuleTokenStream stream_139=new RewriteRuleTokenStream(adaptor,"token 139");
        RewriteRuleTokenStream stream_124=new RewriteRuleTokenStream(adaptor,"token 124");
        RewriteRuleSubtreeStream stream_refComponent=new RewriteRuleSubtreeStream(adaptor,"rule refComponent");
        RewriteRuleSubtreeStream stream_primitiveType=new RewriteRuleSubtreeStream(adaptor,"rule primitiveType");
        RewriteRuleSubtreeStream stream_uniMod=new RewriteRuleSubtreeStream(adaptor,"rule uniMod");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 45) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:2: ( ( uniMod )? i+= refComponent ( '.' i+= refComponent )* ( '[' ']' )* -> ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) | primitiveType ( '[' ']' )* -> ^( TYPE primitiveType ( '[' )* ) )
            int alt67=2;
            int LA67_0 = input.LA(1);

            if ( (LA67_0==Identifier||(LA67_0>=151 && LA67_0<=153)) ) {
                alt67=1;
            }
            else if ( ((LA67_0>=154 && LA67_0<=161)) ) {
                alt67=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 67, 0, input);

                throw nvae;
            }
            switch (alt67) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:4: ( uniMod )? i+= refComponent ( '.' i+= refComponent )* ( '[' ']' )*
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:4: ( uniMod )?
                    int alt63=2;
                    int LA63_0 = input.LA(1);

                    if ( ((LA63_0>=151 && LA63_0<=153)) ) {
                        alt63=1;
                    }
                    switch (alt63) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: uniMod
                            {
                            pushFollow(FOLLOW_uniMod_in_type2727);
                            uniMod199=uniMod();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_uniMod.add(uniMod199.getTree());

                            }
                            break;

                    }

                    pushFollow(FOLLOW_refComponent_in_type2732);
                    i=refComponent();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_refComponent.add(i.getTree());
                    if (list_i==null) list_i=new ArrayList();
                    list_i.add(i.getTree());

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:28: ( '.' i+= refComponent )*
                    loop64:
                    do {
                        int alt64=2;
                        alt64 = dfa64.predict(input);
                        switch (alt64) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:29: '.' i+= refComponent
                    	    {
                    	    char_literal200=(Token)match(input,124,FOLLOW_124_in_type2735); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_124.add(char_literal200);

                    	    pushFollow(FOLLOW_refComponent_in_type2739);
                    	    i=refComponent();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_refComponent.add(i.getTree());
                    	    if (list_i==null) list_i=new ArrayList();
                    	    list_i.add(i.getTree());


                    	    }
                    	    break;

                    	default :
                    	    break loop64;
                        }
                    } while (true);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:51: ( '[' ']' )*
                    loop65:
                    do {
                        int alt65=2;
                        alt65 = dfa65.predict(input);
                        switch (alt65) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:52: '[' ']'
                    	    {
                    	    char_literal201=(Token)match(input,138,FOLLOW_138_in_type2744); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_138.add(char_literal201);

                    	    char_literal202=(Token)match(input,139,FOLLOW_139_in_type2746); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_139.add(char_literal202);


                    	    }
                    	    break;

                    	default :
                    	    break loop65;
                        }
                    } while (true);



                    // AST REWRITE
                    // elements: uniMod, i, 138
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: i
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
                    root_0 = (Object)adaptor.nil();
                    // 463:62: -> ^( TYPE ( uniMod )? ( $i)+ ( '[' )* )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:65: ^( TYPE ( uniMod )? ( $i)+ ( '[' )* )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:72: ( uniMod )?
                        if ( stream_uniMod.hasNext() ) {
                            adaptor.addChild(root_1, stream_uniMod.nextTree());

                        }
                        stream_uniMod.reset();
                        if ( !(stream_i.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_i.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextTree());

                        }
                        stream_i.reset();
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:463:84: ( '[' )*
                        while ( stream_138.hasNext() ) {
                            adaptor.addChild(root_1, stream_138.nextNode());

                        }
                        stream_138.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:464:4: primitiveType ( '[' ']' )*
                    {
                    pushFollow(FOLLOW_primitiveType_in_type2771);
                    primitiveType203=primitiveType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primitiveType.add(primitiveType203.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:464:18: ( '[' ']' )*
                    loop66:
                    do {
                        int alt66=2;
                        alt66 = dfa66.predict(input);
                        switch (alt66) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:464:19: '[' ']'
                    	    {
                    	    char_literal204=(Token)match(input,138,FOLLOW_138_in_type2774); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_138.add(char_literal204);

                    	    char_literal205=(Token)match(input,139,FOLLOW_139_in_type2776); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_139.add(char_literal205);


                    	    }
                    	    break;

                    	default :
                    	    break loop66;
                        }
                    } while (true);



                    // AST REWRITE
                    // elements: primitiveType, 138
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 464:29: -> ^( TYPE primitiveType ( '[' )* )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:464:32: ^( TYPE primitiveType ( '[' )* )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                        adaptor.addChild(root_1, stream_primitiveType.nextTree());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:464:53: ( '[' )*
                        while ( stream_138.hasNext() ) {
                            adaptor.addChild(root_1, stream_138.nextNode());

                        }
                        stream_138.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 45, type_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "type"

    public static class refComponent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "refComponent"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:467:1: refComponent : Identifier ( typeArguments )? -> ^( Identifier ( typeArguments )? ) ;
    public final JavaParser.refComponent_return refComponent() throws RecognitionException {
        JavaParser.refComponent_return retval = new JavaParser.refComponent_return();
        retval.start = input.LT(1);
        int refComponent_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier206=null;
        JavaParser.typeArguments_return typeArguments207 = null;


        Object Identifier206_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_typeArguments=new RewriteRuleSubtreeStream(adaptor,"rule typeArguments");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 46) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:5: ( Identifier ( typeArguments )? -> ^( Identifier ( typeArguments )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:7: Identifier ( typeArguments )?
            {
            Identifier206=(Token)match(input,Identifier,FOLLOW_Identifier_in_refComponent2805); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier206);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:18: ( typeArguments )?
            int alt68=2;
            alt68 = dfa68.predict(input);
            switch (alt68) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:19: typeArguments
                    {
                    pushFollow(FOLLOW_typeArguments_in_refComponent2808);
                    typeArguments207=typeArguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_typeArguments.add(typeArguments207.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: Identifier, typeArguments
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 468:35: -> ^( Identifier ( typeArguments )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:38: ^( Identifier ( typeArguments )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_Identifier.nextNode(), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:468:51: ( typeArguments )?
                if ( stream_typeArguments.hasNext() ) {
                    adaptor.addChild(root_1, stream_typeArguments.nextTree());

                }
                stream_typeArguments.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 46, refComponent_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "refComponent"

    public static class uniMod_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "uniMod"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:471:1: uniMod : ( 'rep' | 'peer' | 'any' );
    public final JavaParser.uniMod_return uniMod() throws RecognitionException {
        JavaParser.uniMod_return retval = new JavaParser.uniMod_return();
        retval.start = input.LT(1);
        int uniMod_StartIndex = input.index();
        Object root_0 = null;

        Token set208=null;

        Object set208_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 47) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:472:2: ( 'rep' | 'peer' | 'any' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:
            {
            root_0 = (Object)adaptor.nil();

            set208=(Token)input.LT(1);
            if ( (input.LA(1)>=151 && input.LA(1)<=153) ) {
                input.consume();
                if ( state.backtracking==0 ) adaptor.addChild(root_0, (Object)adaptor.create(set208));
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 47, uniMod_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "uniMod"

    public static class primitiveType_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primitiveType"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:477:1: primitiveType : ( 'boolean' | 'char' | 'byte' | 'short' | 'int' | 'long' | 'float' | 'double' );
    public final JavaParser.primitiveType_return primitiveType() throws RecognitionException {
        JavaParser.primitiveType_return retval = new JavaParser.primitiveType_return();
        retval.start = input.LT(1);
        int primitiveType_StartIndex = input.index();
        Object root_0 = null;

        Token set209=null;

        Object set209_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 48) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:478:5: ( 'boolean' | 'char' | 'byte' | 'short' | 'int' | 'long' | 'float' | 'double' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:
            {
            root_0 = (Object)adaptor.nil();

            set209=(Token)input.LT(1);
            if ( (input.LA(1)>=154 && input.LA(1)<=161) ) {
                input.consume();
                if ( state.backtracking==0 ) adaptor.addChild(root_0, (Object)adaptor.create(set209));
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 48, primitiveType_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "primitiveType"

    public static class variableModifier_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableModifier"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:488:1: variableModifier : ( 'final' | annotation );
    public final JavaParser.variableModifier_return variableModifier() throws RecognitionException {
        JavaParser.variableModifier_return retval = new JavaParser.variableModifier_return();
        retval.start = input.LT(1);
        int variableModifier_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal210=null;
        JavaParser.annotation_return annotation211 = null;


        Object string_literal210_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 49) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:489:2: ( 'final' | annotation )
            int alt69=2;
            int LA69_0 = input.LA(1);

            if ( (LA69_0==145) ) {
                alt69=1;
            }
            else if ( (LA69_0==170) ) {
                alt69=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 69, 0, input);

                throw nvae;
            }
            switch (alt69) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:489:4: 'final'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal210=(Token)match(input,145,FOLLOW_145_in_variableModifier2933); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    string_literal210_tree = (Object)adaptor.create(string_literal210);
                    adaptor.addChild(root_0, string_literal210_tree);
                    }

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:490:9: annotation
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_annotation_in_variableModifier2943);
                    annotation211=annotation();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotation211.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 49, variableModifier_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "variableModifier"

    public static class typeArguments_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeArguments"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:493:1: typeArguments : '<' t+= typeArgument ( ',' t+= typeArgument )* '>' -> ( $t)+ ;
    public final JavaParser.typeArguments_return typeArguments() throws RecognitionException {
        JavaParser.typeArguments_return retval = new JavaParser.typeArguments_return();
        retval.start = input.LT(1);
        int typeArguments_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal212=null;
        Token char_literal213=null;
        Token char_literal214=null;
        List list_t=null;
        RuleReturnScope t = null;
        Object char_literal212_tree=null;
        Object char_literal213_tree=null;
        Object char_literal214_tree=null;
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_typeArgument=new RewriteRuleSubtreeStream(adaptor,"rule typeArgument");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 50) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:494:2: ( '<' t+= typeArgument ( ',' t+= typeArgument )* '>' -> ( $t)+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:494:4: '<' t+= typeArgument ( ',' t+= typeArgument )* '>'
            {
            char_literal212=(Token)match(input,129,FOLLOW_129_in_typeArguments2954); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_129.add(char_literal212);

            pushFollow(FOLLOW_typeArgument_in_typeArguments2958);
            t=typeArgument();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_typeArgument.add(t.getTree());
            if (list_t==null) list_t=new ArrayList();
            list_t.add(t.getTree());

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:494:24: ( ',' t+= typeArgument )*
            loop70:
            do {
                int alt70=2;
                int LA70_0 = input.LA(1);

                if ( (LA70_0==130) ) {
                    alt70=1;
                }


                switch (alt70) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:494:25: ',' t+= typeArgument
            	    {
            	    char_literal213=(Token)match(input,130,FOLLOW_130_in_typeArguments2961); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_130.add(char_literal213);

            	    pushFollow(FOLLOW_typeArgument_in_typeArguments2965);
            	    t=typeArgument();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_typeArgument.add(t.getTree());
            	    if (list_t==null) list_t=new ArrayList();
            	    list_t.add(t.getTree());


            	    }
            	    break;

            	default :
            	    break loop70;
                }
            } while (true);

            char_literal214=(Token)match(input,131,FOLLOW_131_in_typeArguments2969); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_131.add(char_literal214);



            // AST REWRITE
            // elements: t
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: t
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_t=new RewriteRuleSubtreeStream(adaptor,"token t",list_t);
            root_0 = (Object)adaptor.nil();
            // 494:51: -> ( $t)+
            {
                if ( !(stream_t.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_t.hasNext() ) {
                    adaptor.addChild(root_0, stream_t.nextTree());

                }
                stream_t.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 50, typeArguments_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeArguments"

    public static class typeArgument_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeArgument"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:497:1: typeArgument : ( type | '?' ( ( 'extends' type )? -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) ) | ( 'super' type )? -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) ) ) );
    public final JavaParser.typeArgument_return typeArgument() throws RecognitionException {
        JavaParser.typeArgument_return retval = new JavaParser.typeArgument_return();
        retval.start = input.LT(1);
        int typeArgument_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal216=null;
        Token string_literal217=null;
        Token string_literal219=null;
        JavaParser.type_return type215 = null;

        JavaParser.type_return type218 = null;

        JavaParser.type_return type220 = null;


        Object char_literal216_tree=null;
        Object string_literal217_tree=null;
        Object string_literal219_tree=null;
        RewriteRuleTokenStream stream_162=new RewriteRuleTokenStream(adaptor,"token 162");
        RewriteRuleTokenStream stream_163=new RewriteRuleTokenStream(adaptor,"token 163");
        RewriteRuleTokenStream stream_127=new RewriteRuleTokenStream(adaptor,"token 127");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 51) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:498:2: ( type | '?' ( ( 'extends' type )? -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) ) | ( 'super' type )? -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) ) ) )
            int alt74=2;
            int LA74_0 = input.LA(1);

            if ( (LA74_0==Identifier||(LA74_0>=151 && LA74_0<=161)) ) {
                alt74=1;
            }
            else if ( (LA74_0==162) ) {
                alt74=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 74, 0, input);

                throw nvae;
            }
            switch (alt74) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:498:4: type
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_type_in_typeArgument2987);
                    type215=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, type215.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:499:4: '?' ( ( 'extends' type )? -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) ) | ( 'super' type )? -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) ) )
                    {
                    char_literal216=(Token)match(input,162,FOLLOW_162_in_typeArgument2992); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_162.add(char_literal216);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:499:8: ( ( 'extends' type )? -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) ) | ( 'super' type )? -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) ) )
                    int alt73=2;
                    alt73 = dfa73.predict(input);
                    switch (alt73) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:4: ( 'extends' type )?
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:4: ( 'extends' type )?
                            int alt71=2;
                            int LA71_0 = input.LA(1);

                            if ( (LA71_0==127) ) {
                                alt71=1;
                            }
                            switch (alt71) {
                                case 1 :
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:5: 'extends' type
                                    {
                                    string_literal217=(Token)match(input,127,FOLLOW_127_in_typeArgument3001); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_127.add(string_literal217);

                                    pushFollow(FOLLOW_type_in_typeArgument3003);
                                    type218=type();

                                    state._fsp--;
                                    if (state.failed) return retval;
                                    if ( state.backtracking==0 ) stream_type.add(type218.getTree());

                                    }
                                    break;

                            }



                            // AST REWRITE
                            // elements: 162, type
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 500:22: -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:25: ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:32: ^( '?' ( ^( EXTENDS type ) )? )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot(stream_162.nextNode(), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:38: ( ^( EXTENDS type ) )?
                                if ( stream_type.hasNext() ) {
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:38: ^( EXTENDS type )
                                    {
                                    Object root_3 = (Object)adaptor.nil();
                                    root_3 = (Object)adaptor.becomeRoot((Object)adaptor.create(EXTENDS, "EXTENDS"), root_3);

                                    adaptor.addChild(root_3, stream_type.nextTree());

                                    adaptor.addChild(root_2, root_3);
                                    }

                                }
                                stream_type.reset();

                                adaptor.addChild(root_1, root_2);
                                }

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:12: ( 'super' type )?
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:12: ( 'super' type )?
                            int alt72=2;
                            int LA72_0 = input.LA(1);

                            if ( (LA72_0==163) ) {
                                alt72=1;
                            }
                            switch (alt72) {
                                case 1 :
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:13: 'super' type
                                    {
                                    string_literal219=(Token)match(input,163,FOLLOW_163_in_typeArgument3036); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_163.add(string_literal219);

                                    pushFollow(FOLLOW_type_in_typeArgument3038);
                                    type220=type();

                                    state._fsp--;
                                    if (state.failed) return retval;
                                    if ( state.backtracking==0 ) stream_type.add(type220.getTree());

                                    }
                                    break;

                            }



                            // AST REWRITE
                            // elements: 162, type
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 501:28: -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:31: ^( TYPE ^( '?' ( ^( SUPER type ) )? ) )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:38: ^( '?' ( ^( SUPER type ) )? )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot(stream_162.nextNode(), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:44: ( ^( SUPER type ) )?
                                if ( stream_type.hasNext() ) {
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:501:44: ^( SUPER type )
                                    {
                                    Object root_3 = (Object)adaptor.nil();
                                    root_3 = (Object)adaptor.becomeRoot((Object)adaptor.create(SUPER, "SUPER"), root_3);

                                    adaptor.addChild(root_3, stream_type.nextTree());

                                    adaptor.addChild(root_2, root_3);
                                    }

                                }
                                stream_type.reset();

                                adaptor.addChild(root_1, root_2);
                                }

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 51, typeArgument_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "typeArgument"

    public static class qualifiedNameList_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qualifiedNameList"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:505:1: qualifiedNameList : qualifiedName ( ',' qualifiedName )* ;
    public final JavaParser.qualifiedNameList_return qualifiedNameList() throws RecognitionException {
        JavaParser.qualifiedNameList_return retval = new JavaParser.qualifiedNameList_return();
        retval.start = input.LT(1);
        int qualifiedNameList_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal222=null;
        JavaParser.qualifiedName_return qualifiedName221 = null;

        JavaParser.qualifiedName_return qualifiedName223 = null;


        Object char_literal222_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 52) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:506:2: ( qualifiedName ( ',' qualifiedName )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:506:4: qualifiedName ( ',' qualifiedName )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_qualifiedName_in_qualifiedNameList3080);
            qualifiedName221=qualifiedName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, qualifiedName221.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:506:18: ( ',' qualifiedName )*
            loop75:
            do {
                int alt75=2;
                int LA75_0 = input.LA(1);

                if ( (LA75_0==130) ) {
                    alt75=1;
                }


                switch (alt75) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:506:19: ',' qualifiedName
            	    {
            	    char_literal222=(Token)match(input,130,FOLLOW_130_in_qualifiedNameList3083); if (state.failed) return retval;
            	    pushFollow(FOLLOW_qualifiedName_in_qualifiedNameList3086);
            	    qualifiedName223=qualifiedName();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, qualifiedName223.getTree());

            	    }
            	    break;

            	default :
            	    break loop75;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 52, qualifiedNameList_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "qualifiedNameList"

    public static class formalParameters_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "formalParameters"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:509:1: formalParameters : '(' ( formalParameterDecls )? ')' -> ( formalParameterDecls )? ;
    public final JavaParser.formalParameters_return formalParameters() throws RecognitionException {
        JavaParser.formalParameters_return retval = new JavaParser.formalParameters_return();
        retval.start = input.LT(1);
        int formalParameters_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal224=null;
        Token char_literal226=null;
        JavaParser.formalParameterDecls_return formalParameterDecls225 = null;


        Object char_literal224_tree=null;
        Object char_literal226_tree=null;
        RewriteRuleTokenStream stream_164=new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_165=new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_formalParameterDecls=new RewriteRuleSubtreeStream(adaptor,"rule formalParameterDecls");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 53) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:510:2: ( '(' ( formalParameterDecls )? ')' -> ( formalParameterDecls )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:510:4: '(' ( formalParameterDecls )? ')'
            {
            char_literal224=(Token)match(input,164,FOLLOW_164_in_formalParameters3100); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_164.add(char_literal224);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:510:8: ( formalParameterDecls )?
            int alt76=2;
            int LA76_0 = input.LA(1);

            if ( (LA76_0==Identifier||LA76_0==145||(LA76_0>=151 && LA76_0<=161)||LA76_0==170) ) {
                alt76=1;
            }
            switch (alt76) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: formalParameterDecls
                    {
                    pushFollow(FOLLOW_formalParameterDecls_in_formalParameters3102);
                    formalParameterDecls225=formalParameterDecls();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_formalParameterDecls.add(formalParameterDecls225.getTree());

                    }
                    break;

            }

            char_literal226=(Token)match(input,165,FOLLOW_165_in_formalParameters3105); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_165.add(char_literal226);



            // AST REWRITE
            // elements: formalParameterDecls
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 510:34: -> ( formalParameterDecls )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:510:37: ( formalParameterDecls )?
                if ( stream_formalParameterDecls.hasNext() ) {
                    adaptor.addChild(root_0, stream_formalParameterDecls.nextTree());

                }
                stream_formalParameterDecls.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 53, formalParameters_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "formalParameters"

    public static class formalParameterDecls_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "formalParameterDecls"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:513:1: formalParameterDecls : ( variableModifier )* type ( variableDeclaratorId ( ',' formalParameterDecls )? -> ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ( formalParameterDecls )? | '...' variableDeclaratorId -> ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ) ;
    public final JavaParser.formalParameterDecls_return formalParameterDecls() throws RecognitionException {
        JavaParser.formalParameterDecls_return retval = new JavaParser.formalParameterDecls_return();
        retval.start = input.LT(1);
        int formalParameterDecls_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal230=null;
        Token string_literal232=null;
        JavaParser.variableModifier_return variableModifier227 = null;

        JavaParser.type_return type228 = null;

        JavaParser.variableDeclaratorId_return variableDeclaratorId229 = null;

        JavaParser.formalParameterDecls_return formalParameterDecls231 = null;

        JavaParser.variableDeclaratorId_return variableDeclaratorId233 = null;


        Object char_literal230_tree=null;
        Object string_literal232_tree=null;
        RewriteRuleTokenStream stream_166=new RewriteRuleTokenStream(adaptor,"token 166");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_variableDeclaratorId=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclaratorId");
        RewriteRuleSubtreeStream stream_formalParameterDecls=new RewriteRuleSubtreeStream(adaptor,"rule formalParameterDecls");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_variableModifier=new RewriteRuleSubtreeStream(adaptor,"rule variableModifier");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 54) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:514:2: ( ( variableModifier )* type ( variableDeclaratorId ( ',' formalParameterDecls )? -> ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ( formalParameterDecls )? | '...' variableDeclaratorId -> ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:514:4: ( variableModifier )* type ( variableDeclaratorId ( ',' formalParameterDecls )? -> ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ( formalParameterDecls )? | '...' variableDeclaratorId -> ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) )
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:514:4: ( variableModifier )*
            loop77:
            do {
                int alt77=2;
                int LA77_0 = input.LA(1);

                if ( (LA77_0==145||LA77_0==170) ) {
                    alt77=1;
                }


                switch (alt77) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
            	    {
            	    pushFollow(FOLLOW_variableModifier_in_formalParameterDecls3122);
            	    variableModifier227=variableModifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_variableModifier.add(variableModifier227.getTree());

            	    }
            	    break;

            	default :
            	    break loop77;
                }
            } while (true);

            pushFollow(FOLLOW_type_in_formalParameterDecls3125);
            type228=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type228.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:514:27: ( variableDeclaratorId ( ',' formalParameterDecls )? -> ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ( formalParameterDecls )? | '...' variableDeclaratorId -> ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) )
            int alt79=2;
            int LA79_0 = input.LA(1);

            if ( (LA79_0==Identifier) ) {
                alt79=1;
            }
            else if ( (LA79_0==166) ) {
                alt79=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 79, 0, input);

                throw nvae;
            }
            switch (alt79) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:9: variableDeclaratorId ( ',' formalParameterDecls )?
                    {
                    pushFollow(FOLLOW_variableDeclaratorId_in_formalParameterDecls3137);
                    variableDeclaratorId229=variableDeclaratorId();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_variableDeclaratorId.add(variableDeclaratorId229.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:30: ( ',' formalParameterDecls )?
                    int alt78=2;
                    int LA78_0 = input.LA(1);

                    if ( (LA78_0==130) ) {
                        alt78=1;
                    }
                    switch (alt78) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:31: ',' formalParameterDecls
                            {
                            char_literal230=(Token)match(input,130,FOLLOW_130_in_formalParameterDecls3140); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_130.add(char_literal230);

                            pushFollow(FOLLOW_formalParameterDecls_in_formalParameterDecls3142);
                            formalParameterDecls231=formalParameterDecls();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_formalParameterDecls.add(formalParameterDecls231.getTree());

                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: variableDeclaratorId, type, formalParameterDecls, variableModifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 515:58: -> ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId ) ( formalParameterDecls )?
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:61: ^( PARAMETER ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETER, "PARAMETER"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:73: ^( MODIFIERS ( variableModifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:85: ( variableModifier )*
                        while ( stream_variableModifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_variableModifier.nextTree());

                        }
                        stream_variableModifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_type.nextTree());
                        adaptor.addChild(root_1, stream_variableDeclaratorId.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:515:131: ( formalParameterDecls )?
                        if ( stream_formalParameterDecls.hasNext() ) {
                            adaptor.addChild(root_0, stream_formalParameterDecls.nextTree());

                        }
                        stream_formalParameterDecls.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:516:11: '...' variableDeclaratorId
                    {
                    string_literal232=(Token)match(input,166,FOLLOW_166_in_formalParameterDecls3176); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_166.add(string_literal232);

                    pushFollow(FOLLOW_variableDeclaratorId_in_formalParameterDecls3178);
                    variableDeclaratorId233=variableDeclaratorId();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_variableDeclaratorId.add(variableDeclaratorId233.getTree());


                    // AST REWRITE
                    // elements: variableModifier, type, variableDeclaratorId
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 516:38: -> ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:516:41: ^( VARARGS ^( MODIFIERS ( variableModifier )* ) type variableDeclaratorId )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARARGS, "VARARGS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:516:51: ^( MODIFIERS ( variableModifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:516:63: ( variableModifier )*
                        while ( stream_variableModifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_variableModifier.nextTree());

                        }
                        stream_variableModifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_type.nextTree());
                        adaptor.addChild(root_1, stream_variableDeclaratorId.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 54, formalParameterDecls_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "formalParameterDecls"

    public static class methodBody_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "methodBody"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:521:1: methodBody : block -> block ;
    public final JavaParser.methodBody_return methodBody() throws RecognitionException {
        JavaParser.methodBody_return retval = new JavaParser.methodBody_return();
        retval.start = input.LT(1);
        int methodBody_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.block_return block234 = null;


        RewriteRuleSubtreeStream stream_block=new RewriteRuleSubtreeStream(adaptor,"rule block");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 55) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:522:2: ( block -> block )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:522:4: block
            {
            pushFollow(FOLLOW_block_in_methodBody3221);
            block234=block();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_block.add(block234.getTree());


            // AST REWRITE
            // elements: block
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 522:10: -> block
            {
                adaptor.addChild(root_0, stream_block.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 55, methodBody_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "methodBody"

    public static class qualifiedName_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qualifiedName"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:525:1: qualifiedName : i+= Identifier ( '.' i+= Identifier )* -> ( $i)+ ;
    public final JavaParser.qualifiedName_return qualifiedName() throws RecognitionException {
        JavaParser.qualifiedName_return retval = new JavaParser.qualifiedName_return();
        retval.start = input.LT(1);
        int qualifiedName_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal235=null;
        Token i=null;
        List list_i=null;

        Object char_literal235_tree=null;
        Object i_tree=null;
        RewriteRuleTokenStream stream_124=new RewriteRuleTokenStream(adaptor,"token 124");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 56) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:526:2: (i+= Identifier ( '.' i+= Identifier )* -> ( $i)+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:526:4: i+= Identifier ( '.' i+= Identifier )*
            {
            i=(Token)match(input,Identifier,FOLLOW_Identifier_in_qualifiedName3239); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(i);

            if (list_i==null) list_i=new ArrayList();
            list_i.add(i);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:526:18: ( '.' i+= Identifier )*
            loop80:
            do {
                int alt80=2;
                int LA80_0 = input.LA(1);

                if ( (LA80_0==124) ) {
                    alt80=1;
                }


                switch (alt80) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:526:19: '.' i+= Identifier
            	    {
            	    char_literal235=(Token)match(input,124,FOLLOW_124_in_qualifiedName3242); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_124.add(char_literal235);

            	    i=(Token)match(input,Identifier,FOLLOW_Identifier_in_qualifiedName3246); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_Identifier.add(i);

            	    if (list_i==null) list_i=new ArrayList();
            	    list_i.add(i);


            	    }
            	    break;

            	default :
            	    break loop80;
                }
            } while (true);



            // AST REWRITE
            // elements: i
            // token labels: 
            // rule labels: retval
            // token list labels: i
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 526:39: -> ( $i)+
            {
                if ( !(stream_i.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_i.hasNext() ) {
                    adaptor.addChild(root_0, stream_i.nextNode());

                }
                stream_i.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 56, qualifiedName_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "qualifiedName"

    public static class literal_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:529:1: literal : ( integerLiteral -> ^( INTVAL integerLiteral ) | FloatingPointLiteral -> ^( FLOATVAL FloatingPointLiteral ) | CharacterLiteral -> ^( CHARVAL CharacterLiteral ) | StringLiteral -> ^( STRINGVAL StringLiteral ) | booleanLiteral -> ^( BOOLVAL booleanLiteral ) | 'null' -> ^( NULLVAL ) );
    public final JavaParser.literal_return literal() throws RecognitionException {
        JavaParser.literal_return retval = new JavaParser.literal_return();
        retval.start = input.LT(1);
        int literal_StartIndex = input.index();
        Object root_0 = null;

        Token FloatingPointLiteral237=null;
        Token CharacterLiteral238=null;
        Token StringLiteral239=null;
        Token string_literal241=null;
        JavaParser.integerLiteral_return integerLiteral236 = null;

        JavaParser.booleanLiteral_return booleanLiteral240 = null;


        Object FloatingPointLiteral237_tree=null;
        Object CharacterLiteral238_tree=null;
        Object StringLiteral239_tree=null;
        Object string_literal241_tree=null;
        RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
        RewriteRuleTokenStream stream_CharacterLiteral=new RewriteRuleTokenStream(adaptor,"token CharacterLiteral");
        RewriteRuleTokenStream stream_FloatingPointLiteral=new RewriteRuleTokenStream(adaptor,"token FloatingPointLiteral");
        RewriteRuleTokenStream stream_167=new RewriteRuleTokenStream(adaptor,"token 167");
        RewriteRuleSubtreeStream stream_booleanLiteral=new RewriteRuleSubtreeStream(adaptor,"rule booleanLiteral");
        RewriteRuleSubtreeStream stream_integerLiteral=new RewriteRuleSubtreeStream(adaptor,"rule integerLiteral");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 57) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:530:2: ( integerLiteral -> ^( INTVAL integerLiteral ) | FloatingPointLiteral -> ^( FLOATVAL FloatingPointLiteral ) | CharacterLiteral -> ^( CHARVAL CharacterLiteral ) | StringLiteral -> ^( STRINGVAL StringLiteral ) | booleanLiteral -> ^( BOOLVAL booleanLiteral ) | 'null' -> ^( NULLVAL ) )
            int alt81=6;
            switch ( input.LA(1) ) {
            case HexLiteral:
            case OctalLiteral:
            case DecimalLiteral:
                {
                alt81=1;
                }
                break;
            case FloatingPointLiteral:
                {
                alt81=2;
                }
                break;
            case CharacterLiteral:
                {
                alt81=3;
                }
                break;
            case StringLiteral:
                {
                alt81=4;
                }
                break;
            case 168:
            case 169:
                {
                alt81=5;
                }
                break;
            case 167:
                {
                alt81=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 81, 0, input);

                throw nvae;
            }

            switch (alt81) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:530:6: integerLiteral
                    {
                    pushFollow(FOLLOW_integerLiteral_in_literal3269);
                    integerLiteral236=integerLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_integerLiteral.add(integerLiteral236.getTree());


                    // AST REWRITE
                    // elements: integerLiteral
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 530:21: -> ^( INTVAL integerLiteral )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:530:24: ^( INTVAL integerLiteral )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INTVAL, "INTVAL"), root_1);

                        adaptor.addChild(root_1, stream_integerLiteral.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:531:9: FloatingPointLiteral
                    {
                    FloatingPointLiteral237=(Token)match(input,FloatingPointLiteral,FOLLOW_FloatingPointLiteral_in_literal3287); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FloatingPointLiteral.add(FloatingPointLiteral237);



                    // AST REWRITE
                    // elements: FloatingPointLiteral
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 531:30: -> ^( FLOATVAL FloatingPointLiteral )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:531:33: ^( FLOATVAL FloatingPointLiteral )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FLOATVAL, "FLOATVAL"), root_1);

                        adaptor.addChild(root_1, stream_FloatingPointLiteral.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:532:9: CharacterLiteral
                    {
                    CharacterLiteral238=(Token)match(input,CharacterLiteral,FOLLOW_CharacterLiteral_in_literal3305); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CharacterLiteral.add(CharacterLiteral238);



                    // AST REWRITE
                    // elements: CharacterLiteral
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 532:26: -> ^( CHARVAL CharacterLiteral )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:532:29: ^( CHARVAL CharacterLiteral )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CHARVAL, "CHARVAL"), root_1);

                        adaptor.addChild(root_1, stream_CharacterLiteral.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:533:9: StringLiteral
                    {
                    StringLiteral239=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_literal3323); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_StringLiteral.add(StringLiteral239);



                    // AST REWRITE
                    // elements: StringLiteral
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 533:23: -> ^( STRINGVAL StringLiteral )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:533:26: ^( STRINGVAL StringLiteral )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(STRINGVAL, "STRINGVAL"), root_1);

                        adaptor.addChild(root_1, stream_StringLiteral.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:534:9: booleanLiteral
                    {
                    pushFollow(FOLLOW_booleanLiteral_in_literal3341);
                    booleanLiteral240=booleanLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_booleanLiteral.add(booleanLiteral240.getTree());


                    // AST REWRITE
                    // elements: booleanLiteral
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 534:24: -> ^( BOOLVAL booleanLiteral )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:534:27: ^( BOOLVAL booleanLiteral )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(BOOLVAL, "BOOLVAL"), root_1);

                        adaptor.addChild(root_1, stream_booleanLiteral.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:535:9: 'null'
                    {
                    string_literal241=(Token)match(input,167,FOLLOW_167_in_literal3359); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_167.add(string_literal241);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 535:16: -> ^( NULLVAL )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:535:19: ^( NULLVAL )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NULLVAL, "NULLVAL"), root_1);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 57, literal_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class integerLiteral_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "integerLiteral"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:538:1: integerLiteral : ( HexLiteral | OctalLiteral | DecimalLiteral );
    public final JavaParser.integerLiteral_return integerLiteral() throws RecognitionException {
        JavaParser.integerLiteral_return retval = new JavaParser.integerLiteral_return();
        retval.start = input.LT(1);
        int integerLiteral_StartIndex = input.index();
        Object root_0 = null;

        Token set242=null;

        Object set242_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 58) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:539:5: ( HexLiteral | OctalLiteral | DecimalLiteral )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:
            {
            root_0 = (Object)adaptor.nil();

            set242=(Token)input.LT(1);
            if ( (input.LA(1)>=HexLiteral && input.LA(1)<=DecimalLiteral) ) {
                input.consume();
                if ( state.backtracking==0 ) adaptor.addChild(root_0, (Object)adaptor.create(set242));
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 58, integerLiteral_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "integerLiteral"

    public static class booleanLiteral_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "booleanLiteral"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:544:1: booleanLiteral : ( 'true' | 'false' );
    public final JavaParser.booleanLiteral_return booleanLiteral() throws RecognitionException {
        JavaParser.booleanLiteral_return retval = new JavaParser.booleanLiteral_return();
        retval.start = input.LT(1);
        int booleanLiteral_StartIndex = input.index();
        Object root_0 = null;

        Token set243=null;

        Object set243_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 59) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:545:5: ( 'true' | 'false' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:
            {
            root_0 = (Object)adaptor.nil();

            set243=(Token)input.LT(1);
            if ( (input.LA(1)>=168 && input.LA(1)<=169) ) {
                input.consume();
                if ( state.backtracking==0 ) adaptor.addChild(root_0, (Object)adaptor.create(set243));
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 59, booleanLiteral_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "booleanLiteral"

    public static class annotations_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotations"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:551:1: annotations : ( annotation )+ ;
    public final JavaParser.annotations_return annotations() throws RecognitionException {
        JavaParser.annotations_return retval = new JavaParser.annotations_return();
        retval.start = input.LT(1);
        int annotations_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.annotation_return annotation244 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 60) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:552:2: ( ( annotation )+ )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:552:4: ( annotation )+
            {
            root_0 = (Object)adaptor.nil();

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:552:4: ( annotation )+
            int cnt82=0;
            loop82:
            do {
                int alt82=2;
                alt82 = dfa82.predict(input);
                switch (alt82) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: annotation
            	    {
            	    pushFollow(FOLLOW_annotation_in_annotations3447);
            	    annotation244=annotation();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotation244.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt82 >= 1 ) break loop82;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(82, input);
                        throw eee;
                }
                cnt82++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 60, annotations_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotations"

    public static class annotation_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotation"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:555:1: annotation : '@' annotationName ( '(' ( elementValuePairs )? ')' )? -> ^( ANNOTATION annotationName ( elementValuePairs )? ) ;
    public final JavaParser.annotation_return annotation() throws RecognitionException {
        JavaParser.annotation_return retval = new JavaParser.annotation_return();
        retval.start = input.LT(1);
        int annotation_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal245=null;
        Token char_literal247=null;
        Token char_literal249=null;
        JavaParser.annotationName_return annotationName246 = null;

        JavaParser.elementValuePairs_return elementValuePairs248 = null;


        Object char_literal245_tree=null;
        Object char_literal247_tree=null;
        Object char_literal249_tree=null;
        RewriteRuleTokenStream stream_170=new RewriteRuleTokenStream(adaptor,"token 170");
        RewriteRuleTokenStream stream_164=new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_165=new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_annotationName=new RewriteRuleSubtreeStream(adaptor,"rule annotationName");
        RewriteRuleSubtreeStream stream_elementValuePairs=new RewriteRuleSubtreeStream(adaptor,"rule elementValuePairs");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 61) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:2: ( '@' annotationName ( '(' ( elementValuePairs )? ')' )? -> ^( ANNOTATION annotationName ( elementValuePairs )? ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:4: '@' annotationName ( '(' ( elementValuePairs )? ')' )?
            {
            char_literal245=(Token)match(input,170,FOLLOW_170_in_annotation3459); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_170.add(char_literal245);

            pushFollow(FOLLOW_annotationName_in_annotation3461);
            annotationName246=annotationName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_annotationName.add(annotationName246.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:23: ( '(' ( elementValuePairs )? ')' )?
            int alt84=2;
            alt84 = dfa84.predict(input);
            switch (alt84) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:24: '(' ( elementValuePairs )? ')'
                    {
                    char_literal247=(Token)match(input,164,FOLLOW_164_in_annotation3464); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_164.add(char_literal247);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:28: ( elementValuePairs )?
                    int alt83=2;
                    alt83 = dfa83.predict(input);
                    switch (alt83) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: elementValuePairs
                            {
                            pushFollow(FOLLOW_elementValuePairs_in_annotation3466);
                            elementValuePairs248=elementValuePairs();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_elementValuePairs.add(elementValuePairs248.getTree());

                            }
                            break;

                    }

                    char_literal249=(Token)match(input,165,FOLLOW_165_in_annotation3469); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_165.add(char_literal249);


                    }
                    break;

            }



            // AST REWRITE
            // elements: elementValuePairs, annotationName
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 556:53: -> ^( ANNOTATION annotationName ( elementValuePairs )? )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:56: ^( ANNOTATION annotationName ( elementValuePairs )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                adaptor.addChild(root_1, stream_annotationName.nextTree());
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:556:84: ( elementValuePairs )?
                if ( stream_elementValuePairs.hasNext() ) {
                    adaptor.addChild(root_1, stream_elementValuePairs.nextTree());

                }
                stream_elementValuePairs.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 61, annotation_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotation"

    public static class annotationName_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationName"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:559:1: annotationName : Identifier ( '.' Identifier )* ;
    public final JavaParser.annotationName_return annotationName() throws RecognitionException {
        JavaParser.annotationName_return retval = new JavaParser.annotationName_return();
        retval.start = input.LT(1);
        int annotationName_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier250=null;
        Token char_literal251=null;
        Token Identifier252=null;

        Object Identifier250_tree=null;
        Object char_literal251_tree=null;
        Object Identifier252_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 62) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:560:2: ( Identifier ( '.' Identifier )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:560:4: Identifier ( '.' Identifier )*
            {
            root_0 = (Object)adaptor.nil();

            Identifier250=(Token)match(input,Identifier,FOLLOW_Identifier_in_annotationName3494); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            Identifier250_tree = (Object)adaptor.create(Identifier250);
            adaptor.addChild(root_0, Identifier250_tree);
            }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:560:15: ( '.' Identifier )*
            loop85:
            do {
                int alt85=2;
                alt85 = dfa85.predict(input);
                switch (alt85) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:560:16: '.' Identifier
            	    {
            	    char_literal251=(Token)match(input,124,FOLLOW_124_in_annotationName3497); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal251_tree = (Object)adaptor.create(char_literal251);
            	    adaptor.addChild(root_0, char_literal251_tree);
            	    }
            	    Identifier252=(Token)match(input,Identifier,FOLLOW_Identifier_in_annotationName3499); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    Identifier252_tree = (Object)adaptor.create(Identifier252);
            	    adaptor.addChild(root_0, Identifier252_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop85;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 62, annotationName_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationName"

    public static class elementValuePairs_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementValuePairs"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:563:1: elementValuePairs : elementValuePair ( ',' elementValuePair )* ;
    public final JavaParser.elementValuePairs_return elementValuePairs() throws RecognitionException {
        JavaParser.elementValuePairs_return retval = new JavaParser.elementValuePairs_return();
        retval.start = input.LT(1);
        int elementValuePairs_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal254=null;
        JavaParser.elementValuePair_return elementValuePair253 = null;

        JavaParser.elementValuePair_return elementValuePair255 = null;


        Object char_literal254_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 63) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:564:2: ( elementValuePair ( ',' elementValuePair )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:564:4: elementValuePair ( ',' elementValuePair )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_elementValuePair_in_elementValuePairs3513);
            elementValuePair253=elementValuePair();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, elementValuePair253.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:564:21: ( ',' elementValuePair )*
            loop86:
            do {
                int alt86=2;
                int LA86_0 = input.LA(1);

                if ( (LA86_0==130) ) {
                    alt86=1;
                }


                switch (alt86) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:564:22: ',' elementValuePair
            	    {
            	    char_literal254=(Token)match(input,130,FOLLOW_130_in_elementValuePairs3516); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal254_tree = (Object)adaptor.create(char_literal254);
            	    adaptor.addChild(root_0, char_literal254_tree);
            	    }
            	    pushFollow(FOLLOW_elementValuePair_in_elementValuePairs3518);
            	    elementValuePair255=elementValuePair();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, elementValuePair255.getTree());

            	    }
            	    break;

            	default :
            	    break loop86;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 63, elementValuePairs_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "elementValuePairs"

    public static class elementValuePair_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementValuePair"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:567:1: elementValuePair : ( ( Identifier '=' ) elementValue -> ^( ASSIGN ^( VAR Identifier ) elementValue ) | elementValue -> elementValue );
    public final JavaParser.elementValuePair_return elementValuePair() throws RecognitionException {
        JavaParser.elementValuePair_return retval = new JavaParser.elementValuePair_return();
        retval.start = input.LT(1);
        int elementValuePair_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier256=null;
        Token char_literal257=null;
        JavaParser.elementValue_return elementValue258 = null;

        JavaParser.elementValue_return elementValue259 = null;


        Object Identifier256_tree=null;
        Object char_literal257_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleTokenStream stream_140=new RewriteRuleTokenStream(adaptor,"token 140");
        RewriteRuleSubtreeStream stream_elementValue=new RewriteRuleSubtreeStream(adaptor,"rule elementValue");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 64) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:2: ( ( Identifier '=' ) elementValue -> ^( ASSIGN ^( VAR Identifier ) elementValue ) | elementValue -> elementValue )
            int alt87=2;
            alt87 = dfa87.predict(input);
            switch (alt87) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:4: ( Identifier '=' ) elementValue
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:4: ( Identifier '=' )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:5: Identifier '='
                    {
                    Identifier256=(Token)match(input,Identifier,FOLLOW_Identifier_in_elementValuePair3533); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier256);

                    char_literal257=(Token)match(input,140,FOLLOW_140_in_elementValuePair3535); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal257);


                    }

                    pushFollow(FOLLOW_elementValue_in_elementValuePair3538);
                    elementValue258=elementValue();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_elementValue.add(elementValue258.getTree());


                    // AST REWRITE
                    // elements: Identifier, elementValue
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 568:34: -> ^( ASSIGN ^( VAR Identifier ) elementValue )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:37: ^( ASSIGN ^( VAR Identifier ) elementValue )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGN, "ASSIGN"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:568:46: ^( VAR Identifier )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(VAR, "VAR"), root_2);

                        adaptor.addChild(root_2, stream_Identifier.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_elementValue.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:569:4: elementValue
                    {
                    pushFollow(FOLLOW_elementValue_in_elementValuePair3557);
                    elementValue259=elementValue();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_elementValue.add(elementValue259.getTree());


                    // AST REWRITE
                    // elements: elementValue
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 569:17: -> elementValue
                    {
                        adaptor.addChild(root_0, stream_elementValue.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 64, elementValuePair_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "elementValuePair"

    public static class elementValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementValue"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:572:1: elementValue : ( conditionalExpression | annotation | elementValueArrayInitializer );
    public final JavaParser.elementValue_return elementValue() throws RecognitionException {
        JavaParser.elementValue_return retval = new JavaParser.elementValue_return();
        retval.start = input.LT(1);
        int elementValue_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.conditionalExpression_return conditionalExpression260 = null;

        JavaParser.annotation_return annotation261 = null;

        JavaParser.elementValueArrayInitializer_return elementValueArrayInitializer262 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 65) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:573:2: ( conditionalExpression | annotation | elementValueArrayInitializer )
            int alt88=3;
            alt88 = dfa88.predict(input);
            switch (alt88) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:573:4: conditionalExpression
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_conditionalExpression_in_elementValue3573);
                    conditionalExpression260=conditionalExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, conditionalExpression260.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:574:6: annotation
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_annotation_in_elementValue3580);
                    annotation261=annotation();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotation261.getTree());

                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:575:6: elementValueArrayInitializer
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_elementValueArrayInitializer_in_elementValue3587);
                    elementValueArrayInitializer262=elementValueArrayInitializer();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, elementValueArrayInitializer262.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 65, elementValue_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "elementValue"

    public static class elementValueArrayInitializer_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementValueArrayInitializer"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:578:1: elementValueArrayInitializer : '{' ( elementValue ( ',' elementValue )* )? '}' -> ^( ARRAYVAL ( elementValue )+ ) ;
    public final JavaParser.elementValueArrayInitializer_return elementValueArrayInitializer() throws RecognitionException {
        JavaParser.elementValueArrayInitializer_return retval = new JavaParser.elementValueArrayInitializer_return();
        retval.start = input.LT(1);
        int elementValueArrayInitializer_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal263=null;
        Token char_literal265=null;
        Token char_literal267=null;
        JavaParser.elementValue_return elementValue264 = null;

        JavaParser.elementValue_return elementValue266 = null;


        Object char_literal263_tree=null;
        Object char_literal265_tree=null;
        Object char_literal267_tree=null;
        RewriteRuleTokenStream stream_134=new RewriteRuleTokenStream(adaptor,"token 134");
        RewriteRuleTokenStream stream_133=new RewriteRuleTokenStream(adaptor,"token 133");
        RewriteRuleTokenStream stream_130=new RewriteRuleTokenStream(adaptor,"token 130");
        RewriteRuleSubtreeStream stream_elementValue=new RewriteRuleSubtreeStream(adaptor,"rule elementValue");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 66) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:2: ( '{' ( elementValue ( ',' elementValue )* )? '}' -> ^( ARRAYVAL ( elementValue )+ ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:4: '{' ( elementValue ( ',' elementValue )* )? '}'
            {
            char_literal263=(Token)match(input,133,FOLLOW_133_in_elementValueArrayInitializer3599); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_133.add(char_literal263);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:8: ( elementValue ( ',' elementValue )* )?
            int alt90=2;
            alt90 = dfa90.predict(input);
            switch (alt90) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:9: elementValue ( ',' elementValue )*
                    {
                    pushFollow(FOLLOW_elementValue_in_elementValueArrayInitializer3602);
                    elementValue264=elementValue();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_elementValue.add(elementValue264.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:22: ( ',' elementValue )*
                    loop89:
                    do {
                        int alt89=2;
                        int LA89_0 = input.LA(1);

                        if ( (LA89_0==130) ) {
                            alt89=1;
                        }


                        switch (alt89) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:23: ',' elementValue
                    	    {
                    	    char_literal265=(Token)match(input,130,FOLLOW_130_in_elementValueArrayInitializer3605); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_130.add(char_literal265);

                    	    pushFollow(FOLLOW_elementValue_in_elementValueArrayInitializer3607);
                    	    elementValue266=elementValue();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_elementValue.add(elementValue266.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop89;
                        }
                    } while (true);


                    }
                    break;

            }

            char_literal267=(Token)match(input,134,FOLLOW_134_in_elementValueArrayInitializer3614); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_134.add(char_literal267);



            // AST REWRITE
            // elements: elementValue
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 579:49: -> ^( ARRAYVAL ( elementValue )+ )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:579:52: ^( ARRAYVAL ( elementValue )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ARRAYVAL, "ARRAYVAL"), root_1);

                if ( !(stream_elementValue.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_elementValue.hasNext() ) {
                    adaptor.addChild(root_1, stream_elementValue.nextTree());

                }
                stream_elementValue.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 66, elementValueArrayInitializer_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "elementValueArrayInitializer"

    public static class annotationTypeDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationTypeDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:582:1: annotationTypeDeclaration : '@' 'interface' Identifier annotationTypeBody -> Identifier ( annotationTypeBody )? ;
    public final JavaParser.annotationTypeDeclaration_return annotationTypeDeclaration() throws RecognitionException {
        JavaParser.annotationTypeDeclaration_return retval = new JavaParser.annotationTypeDeclaration_return();
        retval.start = input.LT(1);
        int annotationTypeDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal268=null;
        Token string_literal269=null;
        Token Identifier270=null;
        JavaParser.annotationTypeBody_return annotationTypeBody271 = null;


        Object char_literal268_tree=null;
        Object string_literal269_tree=null;
        Object Identifier270_tree=null;
        RewriteRuleTokenStream stream_170=new RewriteRuleTokenStream(adaptor,"token 170");
        RewriteRuleTokenStream stream_135=new RewriteRuleTokenStream(adaptor,"token 135");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_annotationTypeBody=new RewriteRuleSubtreeStream(adaptor,"rule annotationTypeBody");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 67) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:583:2: ( '@' 'interface' Identifier annotationTypeBody -> Identifier ( annotationTypeBody )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:583:4: '@' 'interface' Identifier annotationTypeBody
            {
            char_literal268=(Token)match(input,170,FOLLOW_170_in_annotationTypeDeclaration3635); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_170.add(char_literal268);

            string_literal269=(Token)match(input,135,FOLLOW_135_in_annotationTypeDeclaration3637); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_135.add(string_literal269);

            Identifier270=(Token)match(input,Identifier,FOLLOW_Identifier_in_annotationTypeDeclaration3639); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier270);

            pushFollow(FOLLOW_annotationTypeBody_in_annotationTypeDeclaration3641);
            annotationTypeBody271=annotationTypeBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_annotationTypeBody.add(annotationTypeBody271.getTree());


            // AST REWRITE
            // elements: Identifier, annotationTypeBody
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 583:50: -> Identifier ( annotationTypeBody )?
            {
                adaptor.addChild(root_0, stream_Identifier.nextNode());
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:583:64: ( annotationTypeBody )?
                if ( stream_annotationTypeBody.hasNext() ) {
                    adaptor.addChild(root_0, stream_annotationTypeBody.nextTree());

                }
                stream_annotationTypeBody.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 67, annotationTypeDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationTypeDeclaration"

    public static class annotationTypeBody_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationTypeBody"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:586:1: annotationTypeBody : '{' ( annotationTypeElementDeclarations )? '}' ;
    public final JavaParser.annotationTypeBody_return annotationTypeBody() throws RecognitionException {
        JavaParser.annotationTypeBody_return retval = new JavaParser.annotationTypeBody_return();
        retval.start = input.LT(1);
        int annotationTypeBody_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal272=null;
        Token char_literal274=null;
        JavaParser.annotationTypeElementDeclarations_return annotationTypeElementDeclarations273 = null;


        Object char_literal272_tree=null;
        Object char_literal274_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 68) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:2: ( '{' ( annotationTypeElementDeclarations )? '}' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:4: '{' ( annotationTypeElementDeclarations )? '}'
            {
            root_0 = (Object)adaptor.nil();

            char_literal272=(Token)match(input,133,FOLLOW_133_in_annotationTypeBody3660); if (state.failed) return retval;
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:9: ( annotationTypeElementDeclarations )?
            int alt91=2;
            alt91 = dfa91.predict(input);
            switch (alt91) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:10: annotationTypeElementDeclarations
                    {
                    pushFollow(FOLLOW_annotationTypeElementDeclarations_in_annotationTypeBody3664);
                    annotationTypeElementDeclarations273=annotationTypeElementDeclarations();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotationTypeElementDeclarations273.getTree());

                    }
                    break;

            }

            char_literal274=(Token)match(input,134,FOLLOW_134_in_annotationTypeBody3668); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 68, annotationTypeBody_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationTypeBody"

    public static class annotationTypeElementDeclarations_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationTypeElementDeclarations"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:590:1: annotationTypeElementDeclarations : ( annotationTypeElementDeclaration )* ;
    public final JavaParser.annotationTypeElementDeclarations_return annotationTypeElementDeclarations() throws RecognitionException {
        JavaParser.annotationTypeElementDeclarations_return retval = new JavaParser.annotationTypeElementDeclarations_return();
        retval.start = input.LT(1);
        int annotationTypeElementDeclarations_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.annotationTypeElementDeclaration_return annotationTypeElementDeclaration275 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 69) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:591:2: ( ( annotationTypeElementDeclaration )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:591:4: ( annotationTypeElementDeclaration )*
            {
            root_0 = (Object)adaptor.nil();

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:591:4: ( annotationTypeElementDeclaration )*
            loop92:
            do {
                int alt92=2;
                alt92 = dfa92.predict(input);
                switch (alt92) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:591:5: annotationTypeElementDeclaration
            	    {
            	    pushFollow(FOLLOW_annotationTypeElementDeclaration_in_annotationTypeElementDeclarations3682);
            	    annotationTypeElementDeclaration275=annotationTypeElementDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, annotationTypeElementDeclaration275.getTree());

            	    }
            	    break;

            	default :
            	    break loop92;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 69, annotationTypeElementDeclarations_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationTypeElementDeclarations"

    public static class annotationTypeElementDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationTypeElementDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:594:1: annotationTypeElementDeclaration : ( modifier )* ( type ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) ) | classDeclaration ( ';' )? -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration ( ';' )? -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration ( ';' )? -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration ( ';' )? -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) ) ;
    public final JavaParser.annotationTypeElementDeclaration_return annotationTypeElementDeclaration() throws RecognitionException {
        JavaParser.annotationTypeElementDeclaration_return retval = new JavaParser.annotationTypeElementDeclaration_return();
        retval.start = input.LT(1);
        int annotationTypeElementDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal279=null;
        Token char_literal281=null;
        Token char_literal283=null;
        Token char_literal285=null;
        Token char_literal287=null;
        Token char_literal289=null;
        JavaParser.modifier_return modifier276 = null;

        JavaParser.type_return type277 = null;

        JavaParser.annotationMethodRest_return annotationMethodRest278 = null;

        JavaParser.annotationConstantRest_return annotationConstantRest280 = null;

        JavaParser.classDeclaration_return classDeclaration282 = null;

        JavaParser.enumDeclaration_return enumDeclaration284 = null;

        JavaParser.normalInterfaceDeclaration_return normalInterfaceDeclaration286 = null;

        JavaParser.annotationTypeDeclaration_return annotationTypeDeclaration288 = null;


        Object char_literal279_tree=null;
        Object char_literal281_tree=null;
        Object char_literal283_tree=null;
        Object char_literal285_tree=null;
        Object char_literal287_tree=null;
        Object char_literal289_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_modifier=new RewriteRuleSubtreeStream(adaptor,"rule modifier");
        RewriteRuleSubtreeStream stream_annotationTypeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule annotationTypeDeclaration");
        RewriteRuleSubtreeStream stream_annotationMethodRest=new RewriteRuleSubtreeStream(adaptor,"rule annotationMethodRest");
        RewriteRuleSubtreeStream stream_classDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule classDeclaration");
        RewriteRuleSubtreeStream stream_enumDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule enumDeclaration");
        RewriteRuleSubtreeStream stream_normalInterfaceDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule normalInterfaceDeclaration");
        RewriteRuleSubtreeStream stream_annotationConstantRest=new RewriteRuleSubtreeStream(adaptor,"rule annotationConstantRest");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 70) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:595:2: ( ( modifier )* ( type ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) ) | classDeclaration ( ';' )? -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration ( ';' )? -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration ( ';' )? -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration ( ';' )? -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:595:4: ( modifier )* ( type ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) ) | classDeclaration ( ';' )? -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration ( ';' )? -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration ( ';' )? -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration ( ';' )? -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) )
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:595:4: ( modifier )*
            loop93:
            do {
                int alt93=2;
                alt93 = dfa93.predict(input);
                switch (alt93) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:595:5: modifier
            	    {
            	    pushFollow(FOLLOW_modifier_in_annotationTypeElementDeclaration3697);
            	    modifier276=modifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_modifier.add(modifier276.getTree());

            	    }
            	    break;

            	default :
            	    break loop93;
                }
            } while (true);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:596:3: ( type ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) ) | classDeclaration ( ';' )? -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration ( ';' )? -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) | normalInterfaceDeclaration ( ';' )? -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration ( ';' )? -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) )
            int alt99=5;
            switch ( input.LA(1) ) {
            case Identifier:
            case 151:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
                {
                alt99=1;
                }
                break;
            case 126:
                {
                alt99=2;
                }
                break;
            case ENUM:
                {
                alt99=3;
                }
                break;
            case 135:
                {
                alt99=4;
                }
                break;
            case 170:
                {
                alt99=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 99, 0, input);

                throw nvae;
            }

            switch (alt99) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:597:4: type ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) )
                    {
                    pushFollow(FOLLOW_type_in_annotationTypeElementDeclaration3709);
                    type277=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type277.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:598:4: ( annotationMethodRest ';' -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest ) | annotationConstantRest ';' -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest ) )
                    int alt94=2;
                    int LA94_0 = input.LA(1);

                    if ( (LA94_0==Identifier) ) {
                        int LA94_1 = input.LA(2);

                        if ( (LA94_1==164) ) {
                            alt94=1;
                        }
                        else if ( (LA94_1==121||LA94_1==130||LA94_1==138||LA94_1==140) ) {
                            alt94=2;
                        }
                        else {
                            if (state.backtracking>0) {state.failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 94, 1, input);

                            throw nvae;
                        }
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 94, 0, input);

                        throw nvae;
                    }
                    switch (alt94) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:599:5: annotationMethodRest ';'
                            {
                            pushFollow(FOLLOW_annotationMethodRest_in_annotationTypeElementDeclaration3721);
                            annotationMethodRest278=annotationMethodRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_annotationMethodRest.add(annotationMethodRest278.getTree());
                            char_literal279=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3723); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal279);



                            // AST REWRITE
                            // elements: type, modifier, annotationMethodRest
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 599:30: -> ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:599:33: ^( METHOD ^( MODIFIERS ( modifier )* ) type annotationMethodRest )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(METHOD, "METHOD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:599:42: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:599:54: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_type.nextTree());
                                adaptor.addChild(root_1, stream_annotationMethodRest.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:600:7: annotationConstantRest ';'
                            {
                            pushFollow(FOLLOW_annotationConstantRest_in_annotationTypeElementDeclaration3748);
                            annotationConstantRest280=annotationConstantRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_annotationConstantRest.add(annotationConstantRest280.getTree());
                            char_literal281=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3750); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal281);



                            // AST REWRITE
                            // elements: annotationConstantRest, modifier, type
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 600:34: -> ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:600:37: ^( FIELD ^( MODIFIERS ( modifier )* ) type annotationConstantRest )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FIELD, "FIELD"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:600:45: ^( MODIFIERS ( modifier )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:600:57: ( modifier )*
                                while ( stream_modifier.hasNext() ) {
                                    adaptor.addChild(root_2, stream_modifier.nextTree());

                                }
                                stream_modifier.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_type.nextTree());
                                adaptor.addChild(root_1, stream_annotationConstantRest.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:602:6: classDeclaration ( ';' )?
                    {
                    pushFollow(FOLLOW_classDeclaration_in_annotationTypeElementDeclaration3779);
                    classDeclaration282=classDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_classDeclaration.add(classDeclaration282.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:602:23: ( ';' )?
                    int alt95=2;
                    alt95 = dfa95.predict(input);
                    switch (alt95) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: ';'
                            {
                            char_literal283=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3781); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal283);


                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: classDeclaration, modifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 602:28: -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:602:31: ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CLASS, "CLASS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:602:39: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:602:51: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_classDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:603:6: enumDeclaration ( ';' )?
                    {
                    pushFollow(FOLLOW_enumDeclaration_in_annotationTypeElementDeclaration3804);
                    enumDeclaration284=enumDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumDeclaration.add(enumDeclaration284.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:603:22: ( ';' )?
                    int alt96=2;
                    alt96 = dfa96.predict(input);
                    switch (alt96) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: ';'
                            {
                            char_literal285=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3806); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal285);


                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: enumDeclaration, modifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 603:27: -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:603:30: ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ENUM, "ENUM"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:603:37: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:603:49: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_enumDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:604:6: normalInterfaceDeclaration ( ';' )?
                    {
                    pushFollow(FOLLOW_normalInterfaceDeclaration_in_annotationTypeElementDeclaration3829);
                    normalInterfaceDeclaration286=normalInterfaceDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_normalInterfaceDeclaration.add(normalInterfaceDeclaration286.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:604:33: ( ';' )?
                    int alt97=2;
                    alt97 = dfa97.predict(input);
                    switch (alt97) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: ';'
                            {
                            char_literal287=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3831); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal287);


                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: normalInterfaceDeclaration, modifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 604:38: -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:604:41: ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INTERFACE, "INTERFACE"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:604:53: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:604:65: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_normalInterfaceDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:605:6: annotationTypeDeclaration ( ';' )?
                    {
                    pushFollow(FOLLOW_annotationTypeDeclaration_in_annotationTypeElementDeclaration3854);
                    annotationTypeDeclaration288=annotationTypeDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_annotationTypeDeclaration.add(annotationTypeDeclaration288.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:605:32: ( ';' )?
                    int alt98=2;
                    alt98 = dfa98.predict(input);
                    switch (alt98) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: ';'
                            {
                            char_literal289=(Token)match(input,121,FOLLOW_121_in_annotationTypeElementDeclaration3856); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_121.add(char_literal289);


                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: annotationTypeDeclaration, modifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 605:37: -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:605:40: ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:605:53: ^( MODIFIERS ( modifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:605:65: ( modifier )*
                        while ( stream_modifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_modifier.nextTree());

                        }
                        stream_modifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_annotationTypeDeclaration.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 70, annotationTypeElementDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationTypeElementDeclaration"

    public static class annotationMethodRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationMethodRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:609:1: annotationMethodRest : Identifier '(' ')' ( defaultValue )? ;
    public final JavaParser.annotationMethodRest_return annotationMethodRest() throws RecognitionException {
        JavaParser.annotationMethodRest_return retval = new JavaParser.annotationMethodRest_return();
        retval.start = input.LT(1);
        int annotationMethodRest_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier290=null;
        Token char_literal291=null;
        Token char_literal292=null;
        JavaParser.defaultValue_return defaultValue293 = null;


        Object Identifier290_tree=null;
        Object char_literal291_tree=null;
        Object char_literal292_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 71) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:610:3: ( Identifier '(' ')' ( defaultValue )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:610:5: Identifier '(' ')' ( defaultValue )?
            {
            root_0 = (Object)adaptor.nil();

            Identifier290=(Token)match(input,Identifier,FOLLOW_Identifier_in_annotationMethodRest3889); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            Identifier290_tree = (Object)adaptor.create(Identifier290);
            adaptor.addChild(root_0, Identifier290_tree);
            }
            char_literal291=(Token)match(input,164,FOLLOW_164_in_annotationMethodRest3891); if (state.failed) return retval;
            char_literal292=(Token)match(input,165,FOLLOW_165_in_annotationMethodRest3894); if (state.failed) return retval;
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:610:26: ( defaultValue )?
            int alt100=2;
            int LA100_0 = input.LA(1);

            if ( (LA100_0==171) ) {
                alt100=1;
            }
            switch (alt100) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:610:27: defaultValue
                    {
                    pushFollow(FOLLOW_defaultValue_in_annotationMethodRest3898);
                    defaultValue293=defaultValue();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, defaultValue293.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 71, annotationMethodRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationMethodRest"

    public static class annotationConstantRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotationConstantRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:613:1: annotationConstantRest : variableDeclarators ;
    public final JavaParser.annotationConstantRest_return annotationConstantRest() throws RecognitionException {
        JavaParser.annotationConstantRest_return retval = new JavaParser.annotationConstantRest_return();
        retval.start = input.LT(1);
        int annotationConstantRest_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.variableDeclarators_return variableDeclarators294 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 72) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:614:3: ( variableDeclarators )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:614:5: variableDeclarators
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_variableDeclarators_in_annotationConstantRest3915);
            variableDeclarators294=variableDeclarators();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, variableDeclarators294.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 72, annotationConstantRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "annotationConstantRest"

    public static class defaultValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultValue"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:617:1: defaultValue : 'default' elementValue ;
    public final JavaParser.defaultValue_return defaultValue() throws RecognitionException {
        JavaParser.defaultValue_return retval = new JavaParser.defaultValue_return();
        retval.start = input.LT(1);
        int defaultValue_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal295=null;
        JavaParser.elementValue_return elementValue296 = null;


        Object string_literal295_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 73) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:618:3: ( 'default' elementValue )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:618:5: 'default' elementValue
            {
            root_0 = (Object)adaptor.nil();

            string_literal295=(Token)match(input,171,FOLLOW_171_in_defaultValue3930); if (state.failed) return retval;
            pushFollow(FOLLOW_elementValue_in_defaultValue3933);
            elementValue296=elementValue();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, elementValue296.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 73, defaultValue_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "defaultValue"

    public static class block_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "block"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:623:1: block : '{' ( blockStatement )* '}' -> ^( BLOCK ( blockStatement )* ) ;
    public final JavaParser.block_return block() throws RecognitionException {
        JavaParser.block_return retval = new JavaParser.block_return();
        retval.start = input.LT(1);
        int block_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal297=null;
        Token char_literal299=null;
        JavaParser.blockStatement_return blockStatement298 = null;


        Object char_literal297_tree=null;
        Object char_literal299_tree=null;
        RewriteRuleTokenStream stream_134=new RewriteRuleTokenStream(adaptor,"token 134");
        RewriteRuleTokenStream stream_133=new RewriteRuleTokenStream(adaptor,"token 133");
        RewriteRuleSubtreeStream stream_blockStatement=new RewriteRuleSubtreeStream(adaptor,"rule blockStatement");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 74) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:624:2: ( '{' ( blockStatement )* '}' -> ^( BLOCK ( blockStatement )* ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:624:4: '{' ( blockStatement )* '}'
            {
            char_literal297=(Token)match(input,133,FOLLOW_133_in_block3947); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_133.add(char_literal297);

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:624:8: ( blockStatement )*
            loop101:
            do {
                int alt101=2;
                alt101 = dfa101.predict(input);
                switch (alt101) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: blockStatement
            	    {
            	    pushFollow(FOLLOW_blockStatement_in_block3949);
            	    blockStatement298=blockStatement();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_blockStatement.add(blockStatement298.getTree());

            	    }
            	    break;

            	default :
            	    break loop101;
                }
            } while (true);

            char_literal299=(Token)match(input,134,FOLLOW_134_in_block3952); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_134.add(char_literal299);



            // AST REWRITE
            // elements: blockStatement
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 624:28: -> ^( BLOCK ( blockStatement )* )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:624:31: ^( BLOCK ( blockStatement )* )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(BLOCK, "BLOCK"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:624:39: ( blockStatement )*
                while ( stream_blockStatement.hasNext() ) {
                    adaptor.addChild(root_1, stream_blockStatement.nextTree());

                }
                stream_blockStatement.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 74, block_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "block"

    public static class blockStatement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blockStatement"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:627:1: blockStatement : ( localVariableDeclaration | classOrInterfaceDeclaration | statement );
    public final JavaParser.blockStatement_return blockStatement() throws RecognitionException {
        JavaParser.blockStatement_return retval = new JavaParser.blockStatement_return();
        retval.start = input.LT(1);
        int blockStatement_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.localVariableDeclaration_return localVariableDeclaration300 = null;

        JavaParser.classOrInterfaceDeclaration_return classOrInterfaceDeclaration301 = null;

        JavaParser.statement_return statement302 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 75) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:628:2: ( localVariableDeclaration | classOrInterfaceDeclaration | statement )
            int alt102=3;
            alt102 = dfa102.predict(input);
            switch (alt102) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:628:4: localVariableDeclaration
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_localVariableDeclaration_in_blockStatement3973);
                    localVariableDeclaration300=localVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, localVariableDeclaration300.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:629:4: classOrInterfaceDeclaration
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_classOrInterfaceDeclaration_in_blockStatement3978);
                    classOrInterfaceDeclaration301=classOrInterfaceDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, classOrInterfaceDeclaration301.getTree());

                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:630:7: statement
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_statement_in_blockStatement3986);
                    statement302=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, statement302.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 75, blockStatement_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "blockStatement"

    public static class localVariableDeclaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "localVariableDeclaration"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:633:1: localVariableDeclaration : ( variableModifier )* type variableDeclarators ';' -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators ) ;
    public final JavaParser.localVariableDeclaration_return localVariableDeclaration() throws RecognitionException {
        JavaParser.localVariableDeclaration_return retval = new JavaParser.localVariableDeclaration_return();
        retval.start = input.LT(1);
        int localVariableDeclaration_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal306=null;
        JavaParser.variableModifier_return variableModifier303 = null;

        JavaParser.type_return type304 = null;

        JavaParser.variableDeclarators_return variableDeclarators305 = null;


        Object char_literal306_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_variableDeclarators=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclarators");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_variableModifier=new RewriteRuleSubtreeStream(adaptor,"rule variableModifier");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 76) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:2: ( ( variableModifier )* type variableDeclarators ';' -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:4: ( variableModifier )* type variableDeclarators ';'
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:4: ( variableModifier )*
            loop103:
            do {
                int alt103=2;
                int LA103_0 = input.LA(1);

                if ( (LA103_0==145||LA103_0==170) ) {
                    alt103=1;
                }


                switch (alt103) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
            	    {
            	    pushFollow(FOLLOW_variableModifier_in_localVariableDeclaration3998);
            	    variableModifier303=variableModifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_variableModifier.add(variableModifier303.getTree());

            	    }
            	    break;

            	default :
            	    break loop103;
                }
            } while (true);

            pushFollow(FOLLOW_type_in_localVariableDeclaration4001);
            type304=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type304.getTree());
            pushFollow(FOLLOW_variableDeclarators_in_localVariableDeclaration4003);
            variableDeclarators305=variableDeclarators();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_variableDeclarators.add(variableDeclarators305.getTree());
            char_literal306=(Token)match(input,121,FOLLOW_121_in_localVariableDeclaration4005); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_121.add(char_literal306);



            // AST REWRITE
            // elements: type, variableDeclarators, variableModifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 634:51: -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:54: ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARDEF, "VARDEF"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:63: ^( MODIFIERS ( variableModifier )* )
                {
                Object root_2 = (Object)adaptor.nil();
                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:634:75: ( variableModifier )*
                while ( stream_variableModifier.hasNext() ) {
                    adaptor.addChild(root_2, stream_variableModifier.nextTree());

                }
                stream_variableModifier.reset();

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, stream_type.nextTree());
                adaptor.addChild(root_1, stream_variableDeclarators.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 76, localVariableDeclaration_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "localVariableDeclaration"

    public static class statement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "statement"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:637:1: statement : ( block | lc= 'assert' expression ( ':' expression )? ';' -> ^( ASSERT[$lc] expression ( expression )? ) | lc= 'if' parExpression statement ( options {k=1; } : 'else' statement )? -> ^( IF[$lc] parExpression statement ( statement )? ) | lc= 'for' '(' forControl ')' statement -> ^( FOR[$lc] forControl statement ) | lc= 'while' parExpression statement -> ^( WHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'do' statement 'while' parExpression ';' -> ^( DOWHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'try' block ( catches fc= 'finally' block -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) ) | catches -> ^( TRY[$lc] block catches ) | fc= 'finally' block -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) ) ) | lc= 'switch' parExpression '{' switchBlockStatementGroups '}' -> ^( SWITCH[$lc] parExpression switchBlockStatementGroups ) | lc= 'synchronized' parExpression block -> ^( SYNCHRONIZED[$lc] parExpression block ) | lc= 'return' ( expression )? ';' -> ^( RETURN[$lc] ( expression )? ) | lc= 'throw' expression ';' -> ^( THROW[$lc] expression ) | lc= 'break' ( Identifier )? ';' -> ^( BREAK[$lc] ( Identifier )? ) | lc= 'continue' ( Identifier )? ';' -> ^( CONTINUE[$lc] ( Identifier )? ) | ';' -> ^( BLOCK ) | statementExpression ';' -> statementExpression | lc= Identifier ':' statement -> ^( LABEL[$lc] Identifier statement ) );
    public final JavaParser.statement_return statement() throws RecognitionException {
        JavaParser.statement_return retval = new JavaParser.statement_return();
        retval.start = input.LT(1);
        int statement_StartIndex = input.index();
        Object root_0 = null;

        Token lc=null;
        Token fc=null;
        Token char_literal309=null;
        Token char_literal311=null;
        Token string_literal314=null;
        Token char_literal316=null;
        Token char_literal318=null;
        Token string_literal323=null;
        Token char_literal325=null;
        Token char_literal332=null;
        Token char_literal334=null;
        Token char_literal338=null;
        Token char_literal340=null;
        Token Identifier341=null;
        Token char_literal342=null;
        Token Identifier343=null;
        Token char_literal344=null;
        Token char_literal345=null;
        Token char_literal347=null;
        Token char_literal348=null;
        JavaParser.block_return block307 = null;

        JavaParser.expression_return expression308 = null;

        JavaParser.expression_return expression310 = null;

        JavaParser.parExpression_return parExpression312 = null;

        JavaParser.statement_return statement313 = null;

        JavaParser.statement_return statement315 = null;

        JavaParser.forControl_return forControl317 = null;

        JavaParser.statement_return statement319 = null;

        JavaParser.parExpression_return parExpression320 = null;

        JavaParser.statement_return statement321 = null;

        JavaParser.statement_return statement322 = null;

        JavaParser.parExpression_return parExpression324 = null;

        JavaParser.block_return block326 = null;

        JavaParser.catches_return catches327 = null;

        JavaParser.block_return block328 = null;

        JavaParser.catches_return catches329 = null;

        JavaParser.block_return block330 = null;

        JavaParser.parExpression_return parExpression331 = null;

        JavaParser.switchBlockStatementGroups_return switchBlockStatementGroups333 = null;

        JavaParser.parExpression_return parExpression335 = null;

        JavaParser.block_return block336 = null;

        JavaParser.expression_return expression337 = null;

        JavaParser.expression_return expression339 = null;

        JavaParser.statementExpression_return statementExpression346 = null;

        JavaParser.statement_return statement349 = null;


        Object lc_tree=null;
        Object fc_tree=null;
        Object char_literal309_tree=null;
        Object char_literal311_tree=null;
        Object string_literal314_tree=null;
        Object char_literal316_tree=null;
        Object char_literal318_tree=null;
        Object string_literal323_tree=null;
        Object char_literal325_tree=null;
        Object char_literal332_tree=null;
        Object char_literal334_tree=null;
        Object char_literal338_tree=null;
        Object char_literal340_tree=null;
        Object Identifier341_tree=null;
        Object char_literal342_tree=null;
        Object Identifier343_tree=null;
        Object char_literal344_tree=null;
        Object char_literal345_tree=null;
        Object char_literal347_tree=null;
        Object char_literal348_tree=null;
        RewriteRuleTokenStream stream_134=new RewriteRuleTokenStream(adaptor,"token 134");
        RewriteRuleTokenStream stream_133=new RewriteRuleTokenStream(adaptor,"token 133");
        RewriteRuleTokenStream stream_147=new RewriteRuleTokenStream(adaptor,"token 147");
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleTokenStream stream_179=new RewriteRuleTokenStream(adaptor,"token 179");
        RewriteRuleTokenStream stream_178=new RewriteRuleTokenStream(adaptor,"token 178");
        RewriteRuleTokenStream stream_177=new RewriteRuleTokenStream(adaptor,"token 177");
        RewriteRuleTokenStream stream_176=new RewriteRuleTokenStream(adaptor,"token 176");
        RewriteRuleTokenStream stream_165=new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleTokenStream stream_180=new RewriteRuleTokenStream(adaptor,"token 180");
        RewriteRuleTokenStream stream_181=new RewriteRuleTokenStream(adaptor,"token 181");
        RewriteRuleTokenStream stream_182=new RewriteRuleTokenStream(adaptor,"token 182");
        RewriteRuleTokenStream stream_164=new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_183=new RewriteRuleTokenStream(adaptor,"token 183");
        RewriteRuleTokenStream stream_174=new RewriteRuleTokenStream(adaptor,"token 174");
        RewriteRuleTokenStream stream_184=new RewriteRuleTokenStream(adaptor,"token 184");
        RewriteRuleTokenStream stream_175=new RewriteRuleTokenStream(adaptor,"token 175");
        RewriteRuleTokenStream stream_185=new RewriteRuleTokenStream(adaptor,"token 185");
        RewriteRuleTokenStream stream_172=new RewriteRuleTokenStream(adaptor,"token 172");
        RewriteRuleTokenStream stream_173=new RewriteRuleTokenStream(adaptor,"token 173");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_statement=new RewriteRuleSubtreeStream(adaptor,"rule statement");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_parExpression=new RewriteRuleSubtreeStream(adaptor,"rule parExpression");
        RewriteRuleSubtreeStream stream_switchBlockStatementGroups=new RewriteRuleSubtreeStream(adaptor,"rule switchBlockStatementGroups");
        RewriteRuleSubtreeStream stream_catches=new RewriteRuleSubtreeStream(adaptor,"rule catches");
        RewriteRuleSubtreeStream stream_statementExpression=new RewriteRuleSubtreeStream(adaptor,"rule statementExpression");
        RewriteRuleSubtreeStream stream_block=new RewriteRuleSubtreeStream(adaptor,"rule block");
        RewriteRuleSubtreeStream stream_forControl=new RewriteRuleSubtreeStream(adaptor,"rule forControl");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 77) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:638:2: ( block | lc= 'assert' expression ( ':' expression )? ';' -> ^( ASSERT[$lc] expression ( expression )? ) | lc= 'if' parExpression statement ( options {k=1; } : 'else' statement )? -> ^( IF[$lc] parExpression statement ( statement )? ) | lc= 'for' '(' forControl ')' statement -> ^( FOR[$lc] forControl statement ) | lc= 'while' parExpression statement -> ^( WHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'do' statement 'while' parExpression ';' -> ^( DOWHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'try' block ( catches fc= 'finally' block -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) ) | catches -> ^( TRY[$lc] block catches ) | fc= 'finally' block -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) ) ) | lc= 'switch' parExpression '{' switchBlockStatementGroups '}' -> ^( SWITCH[$lc] parExpression switchBlockStatementGroups ) | lc= 'synchronized' parExpression block -> ^( SYNCHRONIZED[$lc] parExpression block ) | lc= 'return' ( expression )? ';' -> ^( RETURN[$lc] ( expression )? ) | lc= 'throw' expression ';' -> ^( THROW[$lc] expression ) | lc= 'break' ( Identifier )? ';' -> ^( BREAK[$lc] ( Identifier )? ) | lc= 'continue' ( Identifier )? ';' -> ^( CONTINUE[$lc] ( Identifier )? ) | ';' -> ^( BLOCK ) | statementExpression ';' -> statementExpression | lc= Identifier ':' statement -> ^( LABEL[$lc] Identifier statement ) )
            int alt110=16;
            alt110 = dfa110.predict(input);
            switch (alt110) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:638:4: block
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_block_in_statement4034);
                    block307=block();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, block307.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:639:7: lc= 'assert' expression ( ':' expression )? ';'
                    {
                    lc=(Token)match(input,172,FOLLOW_172_in_statement4044); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_172.add(lc);

                    pushFollow(FOLLOW_expression_in_statement4046);
                    expression308=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression308.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:639:30: ( ':' expression )?
                    int alt104=2;
                    int LA104_0 = input.LA(1);

                    if ( (LA104_0==173) ) {
                        alt104=1;
                    }
                    switch (alt104) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:639:31: ':' expression
                            {
                            char_literal309=(Token)match(input,173,FOLLOW_173_in_statement4049); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_173.add(char_literal309);

                            pushFollow(FOLLOW_expression_in_statement4051);
                            expression310=expression();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_expression.add(expression310.getTree());

                            }
                            break;

                    }

                    char_literal311=(Token)match(input,121,FOLLOW_121_in_statement4055); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal311);



                    // AST REWRITE
                    // elements: expression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 639:52: -> ^( ASSERT[$lc] expression ( expression )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:639:55: ^( ASSERT[$lc] expression ( expression )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSERT, lc), root_1);

                        adaptor.addChild(root_1, stream_expression.nextTree());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:639:80: ( expression )?
                        if ( stream_expression.hasNext() ) {
                            adaptor.addChild(root_1, stream_expression.nextTree());

                        }
                        stream_expression.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:7: lc= 'if' parExpression statement ( options {k=1; } : 'else' statement )?
                    {
                    lc=(Token)match(input,174,FOLLOW_174_in_statement4077); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_174.add(lc);

                    pushFollow(FOLLOW_parExpression_in_statement4079);
                    parExpression312=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_parExpression.add(parExpression312.getTree());
                    pushFollow(FOLLOW_statement_in_statement4081);
                    statement313=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statement.add(statement313.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:39: ( options {k=1; } : 'else' statement )?
                    int alt105=2;
                    int LA105_0 = input.LA(1);

                    if ( (LA105_0==175) ) {
                        int LA105_2 = input.LA(2);

                        if ( (synpred157_Java()) ) {
                            alt105=1;
                        }
                    }
                    switch (alt105) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:55: 'else' statement
                            {
                            string_literal314=(Token)match(input,175,FOLLOW_175_in_statement4091); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_175.add(string_literal314);

                            pushFollow(FOLLOW_statement_in_statement4093);
                            statement315=statement();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_statement.add(statement315.getTree());

                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: statement, statement, parExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 640:74: -> ^( IF[$lc] parExpression statement ( statement )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:77: ^( IF[$lc] parExpression statement ( statement )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(IF, lc), root_1);

                        adaptor.addChild(root_1, stream_parExpression.nextTree());
                        adaptor.addChild(root_1, stream_statement.nextTree());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:111: ( statement )?
                        if ( stream_statement.hasNext() ) {
                            adaptor.addChild(root_1, stream_statement.nextTree());

                        }
                        stream_statement.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:641:7: lc= 'for' '(' forControl ')' statement
                    {
                    lc=(Token)match(input,176,FOLLOW_176_in_statement4119); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_176.add(lc);

                    char_literal316=(Token)match(input,164,FOLLOW_164_in_statement4121); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_164.add(char_literal316);

                    pushFollow(FOLLOW_forControl_in_statement4123);
                    forControl317=forControl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_forControl.add(forControl317.getTree());
                    char_literal318=(Token)match(input,165,FOLLOW_165_in_statement4125); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_165.add(char_literal318);

                    pushFollow(FOLLOW_statement_in_statement4127);
                    statement319=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statement.add(statement319.getTree());


                    // AST REWRITE
                    // elements: statement, forControl
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 641:45: -> ^( FOR[$lc] forControl statement )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:641:48: ^( FOR[$lc] forControl statement )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FOR, lc), root_1);

                        adaptor.addChild(root_1, stream_forControl.nextTree());
                        adaptor.addChild(root_1, stream_statement.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:642:7: lc= 'while' parExpression statement
                    {
                    lc=(Token)match(input,177,FOLLOW_177_in_statement4148); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_177.add(lc);

                    pushFollow(FOLLOW_parExpression_in_statement4150);
                    parExpression320=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_parExpression.add(parExpression320.getTree());
                    pushFollow(FOLLOW_statement_in_statement4152);
                    statement321=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statement.add(statement321.getTree());


                    // AST REWRITE
                    // elements: statement, parExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 642:42: -> ^( WHILE[$lc] ^( TEST parExpression ) statement )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:642:45: ^( WHILE[$lc] ^( TEST parExpression ) statement )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(WHILE, lc), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:642:58: ^( TEST parExpression )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TEST, "TEST"), root_2);

                        adaptor.addChild(root_2, stream_parExpression.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_statement.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:643:7: lc= 'do' statement 'while' parExpression ';'
                    {
                    lc=(Token)match(input,178,FOLLOW_178_in_statement4177); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_178.add(lc);

                    pushFollow(FOLLOW_statement_in_statement4179);
                    statement322=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statement.add(statement322.getTree());
                    string_literal323=(Token)match(input,177,FOLLOW_177_in_statement4181); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_177.add(string_literal323);

                    pushFollow(FOLLOW_parExpression_in_statement4183);
                    parExpression324=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_parExpression.add(parExpression324.getTree());
                    char_literal325=(Token)match(input,121,FOLLOW_121_in_statement4185); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal325);



                    // AST REWRITE
                    // elements: parExpression, statement
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 643:51: -> ^( DOWHILE[$lc] ^( TEST parExpression ) statement )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:643:54: ^( DOWHILE[$lc] ^( TEST parExpression ) statement )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(DOWHILE, lc), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:643:69: ^( TEST parExpression )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TEST, "TEST"), root_2);

                        adaptor.addChild(root_2, stream_parExpression.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_statement.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:644:7: lc= 'try' block ( catches fc= 'finally' block -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) ) | catches -> ^( TRY[$lc] block catches ) | fc= 'finally' block -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) ) )
                    {
                    lc=(Token)match(input,179,FOLLOW_179_in_statement4210); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_179.add(lc);

                    pushFollow(FOLLOW_block_in_statement4212);
                    block326=block();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_block.add(block326.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:7: ( catches fc= 'finally' block -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) ) | catches -> ^( TRY[$lc] block catches ) | fc= 'finally' block -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) ) )
                    int alt106=3;
                    int LA106_0 = input.LA(1);

                    if ( (LA106_0==186) ) {
                        int LA106_1 = input.LA(2);

                        if ( (LA106_1==164) ) {
                            int LA106_3 = input.LA(3);

                            if ( (synpred162_Java()) ) {
                                alt106=1;
                            }
                            else if ( (synpred163_Java()) ) {
                                alt106=2;
                            }
                            else {
                                if (state.backtracking>0) {state.failed=true; return retval;}
                                NoViableAltException nvae =
                                    new NoViableAltException("", 106, 3, input);

                                throw nvae;
                            }
                        }
                        else {
                            if (state.backtracking>0) {state.failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 106, 1, input);

                            throw nvae;
                        }
                    }
                    else if ( (LA106_0==180) ) {
                        alt106=3;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 106, 0, input);

                        throw nvae;
                    }
                    switch (alt106) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:9: catches fc= 'finally' block
                            {
                            pushFollow(FOLLOW_catches_in_statement4222);
                            catches327=catches();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_catches.add(catches327.getTree());
                            fc=(Token)match(input,180,FOLLOW_180_in_statement4226); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_180.add(fc);

                            pushFollow(FOLLOW_block_in_statement4228);
                            block328=block();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_block.add(block328.getTree());


                            // AST REWRITE
                            // elements: block, block, catches
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 645:36: -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:39: ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TRY, lc), root_1);

                                adaptor.addChild(root_1, stream_block.nextTree());
                                adaptor.addChild(root_1, stream_catches.nextTree());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:64: ^( FINALLY[$fc] block )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(FINALLY, fc), root_2);

                                adaptor.addChild(root_2, stream_block.nextTree());

                                adaptor.addChild(root_1, root_2);
                                }

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:646:9: catches
                            {
                            pushFollow(FOLLOW_catches_in_statement4256);
                            catches329=catches();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_catches.add(catches329.getTree());


                            // AST REWRITE
                            // elements: block, catches
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 646:17: -> ^( TRY[$lc] block catches )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:646:20: ^( TRY[$lc] block catches )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TRY, lc), root_1);

                                adaptor.addChild(root_1, stream_block.nextTree());
                                adaptor.addChild(root_1, stream_catches.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 3 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:647:9: fc= 'finally' block
                            {
                            fc=(Token)match(input,180,FOLLOW_180_in_statement4279); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_180.add(fc);

                            pushFollow(FOLLOW_block_in_statement4281);
                            block330=block();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_block.add(block330.getTree());


                            // AST REWRITE
                            // elements: block, block
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 647:28: -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:647:31: ^( TRY[$lc] block ^( FINALLY[$fc] block ) )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TRY, lc), root_1);

                                adaptor.addChild(root_1, stream_block.nextTree());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:647:48: ^( FINALLY[$fc] block )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(FINALLY, fc), root_2);

                                adaptor.addChild(root_2, stream_block.nextTree());

                                adaptor.addChild(root_1, root_2);
                                }

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 8 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:649:7: lc= 'switch' parExpression '{' switchBlockStatementGroups '}'
                    {
                    lc=(Token)match(input,181,FOLLOW_181_in_statement4315); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_181.add(lc);

                    pushFollow(FOLLOW_parExpression_in_statement4317);
                    parExpression331=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_parExpression.add(parExpression331.getTree());
                    char_literal332=(Token)match(input,133,FOLLOW_133_in_statement4319); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_133.add(char_literal332);

                    pushFollow(FOLLOW_switchBlockStatementGroups_in_statement4321);
                    switchBlockStatementGroups333=switchBlockStatementGroups();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_switchBlockStatementGroups.add(switchBlockStatementGroups333.getTree());
                    char_literal334=(Token)match(input,134,FOLLOW_134_in_statement4323); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_134.add(char_literal334);



                    // AST REWRITE
                    // elements: switchBlockStatementGroups, parExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 649:68: -> ^( SWITCH[$lc] parExpression switchBlockStatementGroups )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:649:71: ^( SWITCH[$lc] parExpression switchBlockStatementGroups )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(SWITCH, lc), root_1);

                        adaptor.addChild(root_1, stream_parExpression.nextTree());
                        adaptor.addChild(root_1, stream_switchBlockStatementGroups.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:650:7: lc= 'synchronized' parExpression block
                    {
                    lc=(Token)match(input,147,FOLLOW_147_in_statement4344); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_147.add(lc);

                    pushFollow(FOLLOW_parExpression_in_statement4346);
                    parExpression335=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_parExpression.add(parExpression335.getTree());
                    pushFollow(FOLLOW_block_in_statement4348);
                    block336=block();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_block.add(block336.getTree());


                    // AST REWRITE
                    // elements: block, parExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 650:45: -> ^( SYNCHRONIZED[$lc] parExpression block )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:650:48: ^( SYNCHRONIZED[$lc] parExpression block )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(SYNCHRONIZED, lc), root_1);

                        adaptor.addChild(root_1, stream_parExpression.nextTree());
                        adaptor.addChild(root_1, stream_block.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:651:7: lc= 'return' ( expression )? ';'
                    {
                    lc=(Token)match(input,182,FOLLOW_182_in_statement4369); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_182.add(lc);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:651:19: ( expression )?
                    int alt107=2;
                    alt107 = dfa107.predict(input);
                    switch (alt107) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: expression
                            {
                            pushFollow(FOLLOW_expression_in_statement4371);
                            expression337=expression();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_expression.add(expression337.getTree());

                            }
                            break;

                    }

                    char_literal338=(Token)match(input,121,FOLLOW_121_in_statement4374); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal338);



                    // AST REWRITE
                    // elements: expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 651:35: -> ^( RETURN[$lc] ( expression )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:651:38: ^( RETURN[$lc] ( expression )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(RETURN, lc), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:651:52: ( expression )?
                        if ( stream_expression.hasNext() ) {
                            adaptor.addChild(root_1, stream_expression.nextTree());

                        }
                        stream_expression.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 11 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:652:7: lc= 'throw' expression ';'
                    {
                    lc=(Token)match(input,183,FOLLOW_183_in_statement4394); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_183.add(lc);

                    pushFollow(FOLLOW_expression_in_statement4396);
                    expression339=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression339.getTree());
                    char_literal340=(Token)match(input,121,FOLLOW_121_in_statement4398); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal340);



                    // AST REWRITE
                    // elements: expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 652:33: -> ^( THROW[$lc] expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:652:36: ^( THROW[$lc] expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(THROW, lc), root_1);

                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 12 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:653:7: lc= 'break' ( Identifier )? ';'
                    {
                    lc=(Token)match(input,184,FOLLOW_184_in_statement4417); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_184.add(lc);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:653:18: ( Identifier )?
                    int alt108=2;
                    int LA108_0 = input.LA(1);

                    if ( (LA108_0==Identifier) ) {
                        alt108=1;
                    }
                    switch (alt108) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: Identifier
                            {
                            Identifier341=(Token)match(input,Identifier,FOLLOW_Identifier_in_statement4419); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier341);


                            }
                            break;

                    }

                    char_literal342=(Token)match(input,121,FOLLOW_121_in_statement4422); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal342);



                    // AST REWRITE
                    // elements: Identifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 653:34: -> ^( BREAK[$lc] ( Identifier )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:653:37: ^( BREAK[$lc] ( Identifier )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(BREAK, lc), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:653:50: ( Identifier )?
                        if ( stream_Identifier.hasNext() ) {
                            adaptor.addChild(root_1, stream_Identifier.nextNode());

                        }
                        stream_Identifier.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 13 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:654:7: lc= 'continue' ( Identifier )? ';'
                    {
                    lc=(Token)match(input,185,FOLLOW_185_in_statement4442); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_185.add(lc);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:654:21: ( Identifier )?
                    int alt109=2;
                    int LA109_0 = input.LA(1);

                    if ( (LA109_0==Identifier) ) {
                        alt109=1;
                    }
                    switch (alt109) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: Identifier
                            {
                            Identifier343=(Token)match(input,Identifier,FOLLOW_Identifier_in_statement4444); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_Identifier.add(Identifier343);


                            }
                            break;

                    }

                    char_literal344=(Token)match(input,121,FOLLOW_121_in_statement4447); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal344);



                    // AST REWRITE
                    // elements: Identifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 654:37: -> ^( CONTINUE[$lc] ( Identifier )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:654:40: ^( CONTINUE[$lc] ( Identifier )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CONTINUE, lc), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:654:56: ( Identifier )?
                        if ( stream_Identifier.hasNext() ) {
                            adaptor.addChild(root_1, stream_Identifier.nextNode());

                        }
                        stream_Identifier.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 14 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:655:7: ';'
                    {
                    char_literal345=(Token)match(input,121,FOLLOW_121_in_statement4465); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal345);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 655:11: -> ^( BLOCK )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:655:14: ^( BLOCK )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(BLOCK, "BLOCK"), root_1);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 15 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:656:7: statementExpression ';'
                    {
                    pushFollow(FOLLOW_statementExpression_in_statement4480);
                    statementExpression346=statementExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statementExpression.add(statementExpression346.getTree());
                    char_literal347=(Token)match(input,121,FOLLOW_121_in_statement4482); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal347);



                    // AST REWRITE
                    // elements: statementExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 656:31: -> statementExpression
                    {
                        adaptor.addChild(root_0, stream_statementExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 16 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:657:7: lc= Identifier ':' statement
                    {
                    lc=(Token)match(input,Identifier,FOLLOW_Identifier_in_statement4496); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(lc);

                    char_literal348=(Token)match(input,173,FOLLOW_173_in_statement4498); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_173.add(char_literal348);

                    pushFollow(FOLLOW_statement_in_statement4500);
                    statement349=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_statement.add(statement349.getTree());


                    // AST REWRITE
                    // elements: statement, Identifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 657:35: -> ^( LABEL[$lc] Identifier statement )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:657:38: ^( LABEL[$lc] Identifier statement )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LABEL, lc), root_1);

                        adaptor.addChild(root_1, stream_Identifier.nextNode());
                        adaptor.addChild(root_1, stream_statement.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 77, statement_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "statement"

    public static class catches_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "catches"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:660:1: catches : catchClause ( catchClause )* ;
    public final JavaParser.catches_return catches() throws RecognitionException {
        JavaParser.catches_return retval = new JavaParser.catches_return();
        retval.start = input.LT(1);
        int catches_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.catchClause_return catchClause350 = null;

        JavaParser.catchClause_return catchClause351 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 78) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:661:2: ( catchClause ( catchClause )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:661:4: catchClause ( catchClause )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_catchClause_in_catches4522);
            catchClause350=catchClause();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, catchClause350.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:661:16: ( catchClause )*
            loop111:
            do {
                int alt111=2;
                alt111 = dfa111.predict(input);
                switch (alt111) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:661:17: catchClause
            	    {
            	    pushFollow(FOLLOW_catchClause_in_catches4525);
            	    catchClause351=catchClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, catchClause351.getTree());

            	    }
            	    break;

            	default :
            	    break loop111;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 78, catches_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "catches"

    public static class catchClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "catchClause"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:664:1: catchClause : lc= 'catch' '(' formalParameter ')' block -> ^( CATCH[$lc] ^( PARAMETER formalParameter ) block ) ;
    public final JavaParser.catchClause_return catchClause() throws RecognitionException {
        JavaParser.catchClause_return retval = new JavaParser.catchClause_return();
        retval.start = input.LT(1);
        int catchClause_StartIndex = input.index();
        Object root_0 = null;

        Token lc=null;
        Token char_literal352=null;
        Token char_literal354=null;
        JavaParser.formalParameter_return formalParameter353 = null;

        JavaParser.block_return block355 = null;


        Object lc_tree=null;
        Object char_literal352_tree=null;
        Object char_literal354_tree=null;
        RewriteRuleTokenStream stream_164=new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_186=new RewriteRuleTokenStream(adaptor,"token 186");
        RewriteRuleTokenStream stream_165=new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_formalParameter=new RewriteRuleSubtreeStream(adaptor,"rule formalParameter");
        RewriteRuleSubtreeStream stream_block=new RewriteRuleSubtreeStream(adaptor,"rule block");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 79) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:665:2: (lc= 'catch' '(' formalParameter ')' block -> ^( CATCH[$lc] ^( PARAMETER formalParameter ) block ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:665:4: lc= 'catch' '(' formalParameter ')' block
            {
            lc=(Token)match(input,186,FOLLOW_186_in_catchClause4541); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_186.add(lc);

            char_literal352=(Token)match(input,164,FOLLOW_164_in_catchClause4543); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_164.add(char_literal352);

            pushFollow(FOLLOW_formalParameter_in_catchClause4545);
            formalParameter353=formalParameter();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_formalParameter.add(formalParameter353.getTree());
            char_literal354=(Token)match(input,165,FOLLOW_165_in_catchClause4547); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_165.add(char_literal354);

            pushFollow(FOLLOW_block_in_catchClause4549);
            block355=block();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_block.add(block355.getTree());


            // AST REWRITE
            // elements: formalParameter, block
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 665:45: -> ^( CATCH[$lc] ^( PARAMETER formalParameter ) block )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:665:48: ^( CATCH[$lc] ^( PARAMETER formalParameter ) block )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CATCH, lc), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:665:61: ^( PARAMETER formalParameter )
                {
                Object root_2 = (Object)adaptor.nil();
                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(PARAMETER, "PARAMETER"), root_2);

                adaptor.addChild(root_2, stream_formalParameter.nextTree());

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, stream_block.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 79, catchClause_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "catchClause"

    public static class formalParameter_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "formalParameter"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:668:1: formalParameter : ( variableModifier )* type variableDeclaratorId ;
    public final JavaParser.formalParameter_return formalParameter() throws RecognitionException {
        JavaParser.formalParameter_return retval = new JavaParser.formalParameter_return();
        retval.start = input.LT(1);
        int formalParameter_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.variableModifier_return variableModifier356 = null;

        JavaParser.type_return type357 = null;

        JavaParser.variableDeclaratorId_return variableDeclaratorId358 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 80) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:669:2: ( ( variableModifier )* type variableDeclaratorId )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:669:4: ( variableModifier )* type variableDeclaratorId
            {
            root_0 = (Object)adaptor.nil();

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:669:4: ( variableModifier )*
            loop112:
            do {
                int alt112=2;
                int LA112_0 = input.LA(1);

                if ( (LA112_0==145||LA112_0==170) ) {
                    alt112=1;
                }


                switch (alt112) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
            	    {
            	    pushFollow(FOLLOW_variableModifier_in_formalParameter4575);
            	    variableModifier356=variableModifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, variableModifier356.getTree());

            	    }
            	    break;

            	default :
            	    break loop112;
                }
            } while (true);

            pushFollow(FOLLOW_type_in_formalParameter4578);
            type357=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, type357.getTree());
            pushFollow(FOLLOW_variableDeclaratorId_in_formalParameter4580);
            variableDeclaratorId358=variableDeclaratorId();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, variableDeclaratorId358.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 80, formalParameter_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "formalParameter"

    public static class switchBlockStatementGroups_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "switchBlockStatementGroups"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:672:1: switchBlockStatementGroups : ( switchBlockStatementGroup )* ;
    public final JavaParser.switchBlockStatementGroups_return switchBlockStatementGroups() throws RecognitionException {
        JavaParser.switchBlockStatementGroups_return retval = new JavaParser.switchBlockStatementGroups_return();
        retval.start = input.LT(1);
        int switchBlockStatementGroups_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.switchBlockStatementGroup_return switchBlockStatementGroup359 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 81) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:673:2: ( ( switchBlockStatementGroup )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:673:4: ( switchBlockStatementGroup )*
            {
            root_0 = (Object)adaptor.nil();

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:673:4: ( switchBlockStatementGroup )*
            loop113:
            do {
                int alt113=2;
                int LA113_0 = input.LA(1);

                if ( (LA113_0==171||LA113_0==187) ) {
                    alt113=1;
                }


                switch (alt113) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:673:5: switchBlockStatementGroup
            	    {
            	    pushFollow(FOLLOW_switchBlockStatementGroup_in_switchBlockStatementGroups4594);
            	    switchBlockStatementGroup359=switchBlockStatementGroup();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, switchBlockStatementGroup359.getTree());

            	    }
            	    break;

            	default :
            	    break loop113;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 81, switchBlockStatementGroups_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "switchBlockStatementGroups"

    public static class switchBlockStatementGroup_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "switchBlockStatementGroup"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:676:1: switchBlockStatementGroup : switchLabel ( blockStatement )* -> ^( switchLabel ^( BLOCK ( blockStatement )* ) ) ;
    public final JavaParser.switchBlockStatementGroup_return switchBlockStatementGroup() throws RecognitionException {
        JavaParser.switchBlockStatementGroup_return retval = new JavaParser.switchBlockStatementGroup_return();
        retval.start = input.LT(1);
        int switchBlockStatementGroup_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.switchLabel_return switchLabel360 = null;

        JavaParser.blockStatement_return blockStatement361 = null;


        RewriteRuleSubtreeStream stream_switchLabel=new RewriteRuleSubtreeStream(adaptor,"rule switchLabel");
        RewriteRuleSubtreeStream stream_blockStatement=new RewriteRuleSubtreeStream(adaptor,"rule blockStatement");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 82) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:2: ( switchLabel ( blockStatement )* -> ^( switchLabel ^( BLOCK ( blockStatement )* ) ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:4: switchLabel ( blockStatement )*
            {
            pushFollow(FOLLOW_switchLabel_in_switchBlockStatementGroup4608);
            switchLabel360=switchLabel();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_switchLabel.add(switchLabel360.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:16: ( blockStatement )*
            loop114:
            do {
                int alt114=2;
                alt114 = dfa114.predict(input);
                switch (alt114) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: blockStatement
            	    {
            	    pushFollow(FOLLOW_blockStatement_in_switchBlockStatementGroup4610);
            	    blockStatement361=blockStatement();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_blockStatement.add(blockStatement361.getTree());

            	    }
            	    break;

            	default :
            	    break loop114;
                }
            } while (true);



            // AST REWRITE
            // elements: switchLabel, blockStatement
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 677:32: -> ^( switchLabel ^( BLOCK ( blockStatement )* ) )
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:35: ^( switchLabel ^( BLOCK ( blockStatement )* ) )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_switchLabel.nextNode(), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:49: ^( BLOCK ( blockStatement )* )
                {
                Object root_2 = (Object)adaptor.nil();
                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(BLOCK, "BLOCK"), root_2);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:677:57: ( blockStatement )*
                while ( stream_blockStatement.hasNext() ) {
                    adaptor.addChild(root_2, stream_blockStatement.nextTree());

                }
                stream_blockStatement.reset();

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 82, switchBlockStatementGroup_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "switchBlockStatementGroup"

    public static class switchLabel_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "switchLabel"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:680:1: switchLabel : (lc= 'case' constantExpression ':' -> ^( CASE[$lc] constantExpression ) | lc= 'case' enumConstantName ':' -> ^( CASE[$lc] enumConstantName ) | lc= 'default' ':' -> ^( DEFAULT ) );
    public final JavaParser.switchLabel_return switchLabel() throws RecognitionException {
        JavaParser.switchLabel_return retval = new JavaParser.switchLabel_return();
        retval.start = input.LT(1);
        int switchLabel_StartIndex = input.index();
        Object root_0 = null;

        Token lc=null;
        Token char_literal363=null;
        Token char_literal365=null;
        Token char_literal366=null;
        JavaParser.constantExpression_return constantExpression362 = null;

        JavaParser.enumConstantName_return enumConstantName364 = null;


        Object lc_tree=null;
        Object char_literal363_tree=null;
        Object char_literal365_tree=null;
        Object char_literal366_tree=null;
        RewriteRuleTokenStream stream_171=new RewriteRuleTokenStream(adaptor,"token 171");
        RewriteRuleTokenStream stream_173=new RewriteRuleTokenStream(adaptor,"token 173");
        RewriteRuleTokenStream stream_187=new RewriteRuleTokenStream(adaptor,"token 187");
        RewriteRuleSubtreeStream stream_constantExpression=new RewriteRuleSubtreeStream(adaptor,"rule constantExpression");
        RewriteRuleSubtreeStream stream_enumConstantName=new RewriteRuleSubtreeStream(adaptor,"rule enumConstantName");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 83) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:681:2: (lc= 'case' constantExpression ':' -> ^( CASE[$lc] constantExpression ) | lc= 'case' enumConstantName ':' -> ^( CASE[$lc] enumConstantName ) | lc= 'default' ':' -> ^( DEFAULT ) )
            int alt115=3;
            alt115 = dfa115.predict(input);
            switch (alt115) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:681:4: lc= 'case' constantExpression ':'
                    {
                    lc=(Token)match(input,187,FOLLOW_187_in_switchLabel4638); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_187.add(lc);

                    pushFollow(FOLLOW_constantExpression_in_switchLabel4640);
                    constantExpression362=constantExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constantExpression.add(constantExpression362.getTree());
                    char_literal363=(Token)match(input,173,FOLLOW_173_in_switchLabel4642); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_173.add(char_literal363);



                    // AST REWRITE
                    // elements: constantExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 681:37: -> ^( CASE[$lc] constantExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:681:40: ^( CASE[$lc] constantExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CASE, lc), root_1);

                        adaptor.addChild(root_1, stream_constantExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:682:4: lc= 'case' enumConstantName ':'
                    {
                    lc=(Token)match(input,187,FOLLOW_187_in_switchLabel4658); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_187.add(lc);

                    pushFollow(FOLLOW_enumConstantName_in_switchLabel4660);
                    enumConstantName364=enumConstantName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumConstantName.add(enumConstantName364.getTree());
                    char_literal365=(Token)match(input,173,FOLLOW_173_in_switchLabel4662); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_173.add(char_literal365);



                    // AST REWRITE
                    // elements: enumConstantName
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 682:35: -> ^( CASE[$lc] enumConstantName )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:682:38: ^( CASE[$lc] enumConstantName )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CASE, lc), root_1);

                        adaptor.addChild(root_1, stream_enumConstantName.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:683:4: lc= 'default' ':'
                    {
                    lc=(Token)match(input,171,FOLLOW_171_in_switchLabel4678); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_171.add(lc);

                    char_literal366=(Token)match(input,173,FOLLOW_173_in_switchLabel4680); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_173.add(char_literal366);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 683:21: -> ^( DEFAULT )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:683:24: ^( DEFAULT )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(DEFAULT, "DEFAULT"), root_1);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 83, switchLabel_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "switchLabel"

    public static class moreStatementExpressions_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "moreStatementExpressions"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:686:1: moreStatementExpressions : ( ',' statementExpression )* ;
    public final JavaParser.moreStatementExpressions_return moreStatementExpressions() throws RecognitionException {
        JavaParser.moreStatementExpressions_return retval = new JavaParser.moreStatementExpressions_return();
        retval.start = input.LT(1);
        int moreStatementExpressions_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal367=null;
        JavaParser.statementExpression_return statementExpression368 = null;


        Object char_literal367_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 84) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:687:2: ( ( ',' statementExpression )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:687:4: ( ',' statementExpression )*
            {
            root_0 = (Object)adaptor.nil();

            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:687:4: ( ',' statementExpression )*
            loop116:
            do {
                int alt116=2;
                int LA116_0 = input.LA(1);

                if ( (LA116_0==130) ) {
                    alt116=1;
                }


                switch (alt116) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:687:5: ',' statementExpression
            	    {
            	    char_literal367=(Token)match(input,130,FOLLOW_130_in_moreStatementExpressions4699); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    char_literal367_tree = (Object)adaptor.create(char_literal367);
            	    adaptor.addChild(root_0, char_literal367_tree);
            	    }
            	    pushFollow(FOLLOW_statementExpression_in_moreStatementExpressions4701);
            	    statementExpression368=statementExpression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, statementExpression368.getTree());

            	    }
            	    break;

            	default :
            	    break loop116;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 84, moreStatementExpressions_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "moreStatementExpressions"

    public static class forControl_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forControl"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:690:1: forControl options {k=3; } : ( forVarControl -> ^( FOREACH forVarControl ) | ( forInit )? ';' (fc= expression )? ';' (fu= forUpdate )? -> ^( INIT ( forInit )? ) ^( TEST ( expression )? ) ^( STEP ( forUpdate )? ) );
    public final JavaParser.forControl_return forControl() throws RecognitionException {
        JavaParser.forControl_return retval = new JavaParser.forControl_return();
        retval.start = input.LT(1);
        int forControl_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal371=null;
        Token char_literal372=null;
        JavaParser.expression_return fc = null;

        JavaParser.forUpdate_return fu = null;

        JavaParser.forVarControl_return forVarControl369 = null;

        JavaParser.forInit_return forInit370 = null;


        Object char_literal371_tree=null;
        Object char_literal372_tree=null;
        RewriteRuleTokenStream stream_121=new RewriteRuleTokenStream(adaptor,"token 121");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_forVarControl=new RewriteRuleSubtreeStream(adaptor,"rule forVarControl");
        RewriteRuleSubtreeStream stream_forInit=new RewriteRuleSubtreeStream(adaptor,"rule forInit");
        RewriteRuleSubtreeStream stream_forUpdate=new RewriteRuleSubtreeStream(adaptor,"rule forUpdate");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 85) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:692:2: ( forVarControl -> ^( FOREACH forVarControl ) | ( forInit )? ';' (fc= expression )? ';' (fu= forUpdate )? -> ^( INIT ( forInit )? ) ^( TEST ( expression )? ) ^( STEP ( forUpdate )? ) )
            int alt120=2;
            alt120 = dfa120.predict(input);
            switch (alt120) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:692:4: forVarControl
                    {
                    pushFollow(FOLLOW_forVarControl_in_forControl4722);
                    forVarControl369=forVarControl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_forVarControl.add(forVarControl369.getTree());


                    // AST REWRITE
                    // elements: forVarControl
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 692:18: -> ^( FOREACH forVarControl )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:692:21: ^( FOREACH forVarControl )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(FOREACH, "FOREACH"), root_1);

                        adaptor.addChild(root_1, stream_forVarControl.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:4: ( forInit )? ';' (fc= expression )? ';' (fu= forUpdate )?
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:4: ( forInit )?
                    int alt117=2;
                    alt117 = dfa117.predict(input);
                    switch (alt117) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: forInit
                            {
                            pushFollow(FOLLOW_forInit_in_forControl4735);
                            forInit370=forInit();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_forInit.add(forInit370.getTree());

                            }
                            break;

                    }

                    char_literal371=(Token)match(input,121,FOLLOW_121_in_forControl4738); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal371);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:19: (fc= expression )?
                    int alt118=2;
                    alt118 = dfa118.predict(input);
                    switch (alt118) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: fc= expression
                            {
                            pushFollow(FOLLOW_expression_in_forControl4742);
                            fc=expression();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_expression.add(fc.getTree());

                            }
                            break;

                    }

                    char_literal372=(Token)match(input,121,FOLLOW_121_in_forControl4745); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_121.add(char_literal372);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:38: (fu= forUpdate )?
                    int alt119=2;
                    alt119 = dfa119.predict(input);
                    switch (alt119) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: fu= forUpdate
                            {
                            pushFollow(FOLLOW_forUpdate_in_forControl4749);
                            fu=forUpdate();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_forUpdate.add(fu.getTree());

                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: expression, forInit, forUpdate
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 693:50: -> ^( INIT ( forInit )? ) ^( TEST ( expression )? ) ^( STEP ( forUpdate )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:53: ^( INIT ( forInit )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INIT, "INIT"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:60: ( forInit )?
                        if ( stream_forInit.hasNext() ) {
                            adaptor.addChild(root_1, stream_forInit.nextTree());

                        }
                        stream_forInit.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:70: ^( TEST ( expression )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TEST, "TEST"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:77: ( expression )?
                        if ( stream_expression.hasNext() ) {
                            adaptor.addChild(root_1, stream_expression.nextTree());

                        }
                        stream_expression.reset();

                        adaptor.addChild(root_0, root_1);
                        }
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:90: ^( STEP ( forUpdate )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(STEP, "STEP"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:693:97: ( forUpdate )?
                        if ( stream_forUpdate.hasNext() ) {
                            adaptor.addChild(root_1, stream_forUpdate.nextTree());

                        }
                        stream_forUpdate.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 85, forControl_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "forControl"

    public static class forInit_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forInit"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:696:1: forInit : ( ( variableModifier )* type variableDeclarators -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators ) | expressionList );
    public final JavaParser.forInit_return forInit() throws RecognitionException {
        JavaParser.forInit_return retval = new JavaParser.forInit_return();
        retval.start = input.LT(1);
        int forInit_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.variableModifier_return variableModifier373 = null;

        JavaParser.type_return type374 = null;

        JavaParser.variableDeclarators_return variableDeclarators375 = null;

        JavaParser.expressionList_return expressionList376 = null;


        RewriteRuleSubtreeStream stream_variableDeclarators=new RewriteRuleSubtreeStream(adaptor,"rule variableDeclarators");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_variableModifier=new RewriteRuleSubtreeStream(adaptor,"rule variableModifier");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 86) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:2: ( ( variableModifier )* type variableDeclarators -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators ) | expressionList )
            int alt122=2;
            alt122 = dfa122.predict(input);
            switch (alt122) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:4: ( variableModifier )* type variableDeclarators
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:4: ( variableModifier )*
                    loop121:
                    do {
                        int alt121=2;
                        int LA121_0 = input.LA(1);

                        if ( (LA121_0==145||LA121_0==170) ) {
                            alt121=1;
                        }


                        switch (alt121) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
                    	    {
                    	    pushFollow(FOLLOW_variableModifier_in_forInit4784);
                    	    variableModifier373=variableModifier();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_variableModifier.add(variableModifier373.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop121;
                        }
                    } while (true);

                    pushFollow(FOLLOW_type_in_forInit4787);
                    type374=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type374.getTree());
                    pushFollow(FOLLOW_variableDeclarators_in_forInit4789);
                    variableDeclarators375=variableDeclarators();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_variableDeclarators.add(variableDeclarators375.getTree());


                    // AST REWRITE
                    // elements: variableModifier, type, variableDeclarators
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 697:47: -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:50: ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARDEF, "VARDEF"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:59: ^( MODIFIERS ( variableModifier )* )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:71: ( variableModifier )*
                        while ( stream_variableModifier.hasNext() ) {
                            adaptor.addChild(root_2, stream_variableModifier.nextTree());

                        }
                        stream_variableModifier.reset();

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_type.nextTree());
                        adaptor.addChild(root_1, stream_variableDeclarators.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:698:4: expressionList
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_expressionList_in_forInit4811);
                    expressionList376=expressionList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expressionList376.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 86, forInit_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "forInit"

    public static class forVarControl_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forVarControl"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:701:1: forVarControl : ( variableModifier )* type Identifier ':' expression -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type Identifier ) expression ;
    public final JavaParser.forVarControl_return forVarControl() throws RecognitionException {
        JavaParser.forVarControl_return retval = new JavaParser.forVarControl_return();
        retval.start = input.LT(1);
        int forVarControl_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier379=null;
        Token char_literal380=null;
        JavaParser.variableModifier_return variableModifier377 = null;

        JavaParser.type_return type378 = null;

        JavaParser.expression_return expression381 = null;


        Object Identifier379_tree=null;
        Object char_literal380_tree=null;
        RewriteRuleTokenStream stream_173=new RewriteRuleTokenStream(adaptor,"token 173");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_variableModifier=new RewriteRuleSubtreeStream(adaptor,"rule variableModifier");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 87) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:2: ( ( variableModifier )* type Identifier ':' expression -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type Identifier ) expression )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:4: ( variableModifier )* type Identifier ':' expression
            {
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:4: ( variableModifier )*
            loop123:
            do {
                int alt123=2;
                int LA123_0 = input.LA(1);

                if ( (LA123_0==145||LA123_0==170) ) {
                    alt123=1;
                }


                switch (alt123) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
            	    {
            	    pushFollow(FOLLOW_variableModifier_in_forVarControl4823);
            	    variableModifier377=variableModifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_variableModifier.add(variableModifier377.getTree());

            	    }
            	    break;

            	default :
            	    break loop123;
                }
            } while (true);

            pushFollow(FOLLOW_type_in_forVarControl4826);
            type378=type();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_type.add(type378.getTree());
            Identifier379=(Token)match(input,Identifier,FOLLOW_Identifier_in_forVarControl4828); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier379);

            char_literal380=(Token)match(input,173,FOLLOW_173_in_forVarControl4830); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_173.add(char_literal380);

            pushFollow(FOLLOW_expression_in_forVarControl4832);
            expression381=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(expression381.getTree());


            // AST REWRITE
            // elements: expression, Identifier, variableModifier, type
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 702:53: -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type Identifier ) expression
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:56: ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type Identifier )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARDEF, "VARDEF"), root_1);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:65: ^( MODIFIERS ( variableModifier )* )
                {
                Object root_2 = (Object)adaptor.nil();
                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(MODIFIERS, "MODIFIERS"), root_2);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:702:77: ( variableModifier )*
                while ( stream_variableModifier.hasNext() ) {
                    adaptor.addChild(root_2, stream_variableModifier.nextTree());

                }
                stream_variableModifier.reset();

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, stream_type.nextTree());
                adaptor.addChild(root_1, stream_Identifier.nextNode());

                adaptor.addChild(root_0, root_1);
                }
                adaptor.addChild(root_0, stream_expression.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 87, forVarControl_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "forVarControl"

    public static class forUpdate_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forUpdate"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:705:1: forUpdate : expressionList ;
    public final JavaParser.forUpdate_return forUpdate() throws RecognitionException {
        JavaParser.forUpdate_return retval = new JavaParser.forUpdate_return();
        retval.start = input.LT(1);
        int forUpdate_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.expressionList_return expressionList382 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 88) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:706:2: ( expressionList )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:706:4: expressionList
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_expressionList_in_forUpdate4862);
            expressionList382=expressionList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expressionList382.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 88, forUpdate_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "forUpdate"

    public static class parExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "parExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:711:1: parExpression : '(' expression ')' ;
    public final JavaParser.parExpression_return parExpression() throws RecognitionException {
        JavaParser.parExpression_return retval = new JavaParser.parExpression_return();
        retval.start = input.LT(1);
        int parExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal383=null;
        Token char_literal385=null;
        JavaParser.expression_return expression384 = null;


        Object char_literal383_tree=null;
        Object char_literal385_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 89) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:712:2: ( '(' expression ')' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:712:4: '(' expression ')'
            {
            root_0 = (Object)adaptor.nil();

            char_literal383=(Token)match(input,164,FOLLOW_164_in_parExpression4875); if (state.failed) return retval;
            pushFollow(FOLLOW_expression_in_parExpression4878);
            expression384=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression384.getTree());
            char_literal385=(Token)match(input,165,FOLLOW_165_in_parExpression4880); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 89, parExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "parExpression"

    public static class expressionList_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expressionList"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:715:1: expressionList : expression ( ',' expression )* ;
    public final JavaParser.expressionList_return expressionList() throws RecognitionException {
        JavaParser.expressionList_return retval = new JavaParser.expressionList_return();
        retval.start = input.LT(1);
        int expressionList_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal387=null;
        JavaParser.expression_return expression386 = null;

        JavaParser.expression_return expression388 = null;


        Object char_literal387_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 90) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:716:5: ( expression ( ',' expression )* )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:716:9: expression ( ',' expression )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_expression_in_expressionList4898);
            expression386=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression386.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:716:20: ( ',' expression )*
            loop124:
            do {
                int alt124=2;
                int LA124_0 = input.LA(1);

                if ( (LA124_0==130) ) {
                    alt124=1;
                }


                switch (alt124) {
            	case 1 :
            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:716:21: ',' expression
            	    {
            	    char_literal387=(Token)match(input,130,FOLLOW_130_in_expressionList4901); if (state.failed) return retval;
            	    pushFollow(FOLLOW_expression_in_expressionList4904);
            	    expression388=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression388.getTree());

            	    }
            	    break;

            	default :
            	    break loop124;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 90, expressionList_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "expressionList"

    public static class statementExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "statementExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:719:1: statementExpression : expression ;
    public final JavaParser.statementExpression_return statementExpression() throws RecognitionException {
        JavaParser.statementExpression_return retval = new JavaParser.statementExpression_return();
        retval.start = input.LT(1);
        int statementExpression_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.expression_return expression389 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 91) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:720:2: ( expression )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:720:4: expression
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_expression_in_statementExpression4920);
            expression389=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression389.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 91, statementExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "statementExpression"

    public static class constantExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constantExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:723:1: constantExpression : expression ;
    public final JavaParser.constantExpression_return constantExpression() throws RecognitionException {
        JavaParser.constantExpression_return retval = new JavaParser.constantExpression_return();
        retval.start = input.LT(1);
        int constantExpression_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.expression_return expression390 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 92) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:724:2: ( expression )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:724:4: expression
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_expression_in_constantExpression4932);
            expression390=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression390.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 92, constantExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "constantExpression"

    public static class expression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:727:1: expression : conditionalExpression ( '=' expression -> ^( ASSIGN conditionalExpression expression ) | '+' '=' expression -> ^( ASSIGNOP ADD conditionalExpression expression ) | '-' '=' expression -> ^( ASSIGNOP SUB conditionalExpression expression ) | '*' '=' expression -> ^( ASSIGNOP MUL conditionalExpression expression ) | '/' '=' expression -> ^( ASSIGNOP DIV conditionalExpression expression ) | '&=' expression -> ^( ASSIGNOP AND conditionalExpression expression ) | '|=' expression -> ^( ASSIGNOP OR conditionalExpression expression ) | '^=' expression -> ^( ASSIGNOP XOR conditionalExpression expression ) | '%' '=' expression -> ^( ASSIGNOP MOD conditionalExpression expression ) | '<' '<' '=' expression -> ^( ASSIGNOP SHL conditionalExpression expression ) | '>' '>' '=' expression -> ^( ASSIGNOP SHR conditionalExpression expression ) | '>' '>' '>' '=' expression -> ^( ASSIGNOP USHR conditionalExpression expression ) | -> conditionalExpression ) ;
    public final JavaParser.expression_return expression() throws RecognitionException {
        JavaParser.expression_return retval = new JavaParser.expression_return();
        retval.start = input.LT(1);
        int expression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal392=null;
        Token char_literal394=null;
        Token char_literal395=null;
        Token char_literal397=null;
        Token char_literal398=null;
        Token char_literal400=null;
        Token char_literal401=null;
        Token char_literal403=null;
        Token char_literal404=null;
        Token string_literal406=null;
        Token string_literal408=null;
        Token string_literal410=null;
        Token char_literal412=null;
        Token char_literal413=null;
        Token char_literal415=null;
        Token char_literal416=null;
        Token char_literal417=null;
        Token char_literal419=null;
        Token char_literal420=null;
        Token char_literal421=null;
        Token char_literal423=null;
        Token char_literal424=null;
        Token char_literal425=null;
        Token char_literal426=null;
        JavaParser.conditionalExpression_return conditionalExpression391 = null;

        JavaParser.expression_return expression393 = null;

        JavaParser.expression_return expression396 = null;

        JavaParser.expression_return expression399 = null;

        JavaParser.expression_return expression402 = null;

        JavaParser.expression_return expression405 = null;

        JavaParser.expression_return expression407 = null;

        JavaParser.expression_return expression409 = null;

        JavaParser.expression_return expression411 = null;

        JavaParser.expression_return expression414 = null;

        JavaParser.expression_return expression418 = null;

        JavaParser.expression_return expression422 = null;

        JavaParser.expression_return expression427 = null;


        Object char_literal392_tree=null;
        Object char_literal394_tree=null;
        Object char_literal395_tree=null;
        Object char_literal397_tree=null;
        Object char_literal398_tree=null;
        Object char_literal400_tree=null;
        Object char_literal401_tree=null;
        Object char_literal403_tree=null;
        Object char_literal404_tree=null;
        Object string_literal406_tree=null;
        Object string_literal408_tree=null;
        Object string_literal410_tree=null;
        Object char_literal412_tree=null;
        Object char_literal413_tree=null;
        Object char_literal415_tree=null;
        Object char_literal416_tree=null;
        Object char_literal417_tree=null;
        Object char_literal419_tree=null;
        Object char_literal420_tree=null;
        Object char_literal421_tree=null;
        Object char_literal423_tree=null;
        Object char_literal424_tree=null;
        Object char_literal425_tree=null;
        Object char_literal426_tree=null;
        RewriteRuleTokenStream stream_125=new RewriteRuleTokenStream(adaptor,"token 125");
        RewriteRuleTokenStream stream_188=new RewriteRuleTokenStream(adaptor,"token 188");
        RewriteRuleTokenStream stream_194=new RewriteRuleTokenStream(adaptor,"token 194");
        RewriteRuleTokenStream stream_189=new RewriteRuleTokenStream(adaptor,"token 189");
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_191=new RewriteRuleTokenStream(adaptor,"token 191");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleTokenStream stream_140=new RewriteRuleTokenStream(adaptor,"token 140");
        RewriteRuleTokenStream stream_190=new RewriteRuleTokenStream(adaptor,"token 190");
        RewriteRuleTokenStream stream_193=new RewriteRuleTokenStream(adaptor,"token 193");
        RewriteRuleTokenStream stream_192=new RewriteRuleTokenStream(adaptor,"token 192");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_conditionalExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 93) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:728:2: ( conditionalExpression ( '=' expression -> ^( ASSIGN conditionalExpression expression ) | '+' '=' expression -> ^( ASSIGNOP ADD conditionalExpression expression ) | '-' '=' expression -> ^( ASSIGNOP SUB conditionalExpression expression ) | '*' '=' expression -> ^( ASSIGNOP MUL conditionalExpression expression ) | '/' '=' expression -> ^( ASSIGNOP DIV conditionalExpression expression ) | '&=' expression -> ^( ASSIGNOP AND conditionalExpression expression ) | '|=' expression -> ^( ASSIGNOP OR conditionalExpression expression ) | '^=' expression -> ^( ASSIGNOP XOR conditionalExpression expression ) | '%' '=' expression -> ^( ASSIGNOP MOD conditionalExpression expression ) | '<' '<' '=' expression -> ^( ASSIGNOP SHL conditionalExpression expression ) | '>' '>' '=' expression -> ^( ASSIGNOP SHR conditionalExpression expression ) | '>' '>' '>' '=' expression -> ^( ASSIGNOP USHR conditionalExpression expression ) | -> conditionalExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:728:4: conditionalExpression ( '=' expression -> ^( ASSIGN conditionalExpression expression ) | '+' '=' expression -> ^( ASSIGNOP ADD conditionalExpression expression ) | '-' '=' expression -> ^( ASSIGNOP SUB conditionalExpression expression ) | '*' '=' expression -> ^( ASSIGNOP MUL conditionalExpression expression ) | '/' '=' expression -> ^( ASSIGNOP DIV conditionalExpression expression ) | '&=' expression -> ^( ASSIGNOP AND conditionalExpression expression ) | '|=' expression -> ^( ASSIGNOP OR conditionalExpression expression ) | '^=' expression -> ^( ASSIGNOP XOR conditionalExpression expression ) | '%' '=' expression -> ^( ASSIGNOP MOD conditionalExpression expression ) | '<' '<' '=' expression -> ^( ASSIGNOP SHL conditionalExpression expression ) | '>' '>' '=' expression -> ^( ASSIGNOP SHR conditionalExpression expression ) | '>' '>' '>' '=' expression -> ^( ASSIGNOP USHR conditionalExpression expression ) | -> conditionalExpression )
            {
            pushFollow(FOLLOW_conditionalExpression_in_expression4944);
            conditionalExpression391=conditionalExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_conditionalExpression.add(conditionalExpression391.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:729:3: ( '=' expression -> ^( ASSIGN conditionalExpression expression ) | '+' '=' expression -> ^( ASSIGNOP ADD conditionalExpression expression ) | '-' '=' expression -> ^( ASSIGNOP SUB conditionalExpression expression ) | '*' '=' expression -> ^( ASSIGNOP MUL conditionalExpression expression ) | '/' '=' expression -> ^( ASSIGNOP DIV conditionalExpression expression ) | '&=' expression -> ^( ASSIGNOP AND conditionalExpression expression ) | '|=' expression -> ^( ASSIGNOP OR conditionalExpression expression ) | '^=' expression -> ^( ASSIGNOP XOR conditionalExpression expression ) | '%' '=' expression -> ^( ASSIGNOP MOD conditionalExpression expression ) | '<' '<' '=' expression -> ^( ASSIGNOP SHL conditionalExpression expression ) | '>' '>' '=' expression -> ^( ASSIGNOP SHR conditionalExpression expression ) | '>' '>' '>' '=' expression -> ^( ASSIGNOP USHR conditionalExpression expression ) | -> conditionalExpression )
            int alt125=13;
            alt125 = dfa125.predict(input);
            switch (alt125) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:730:4: '=' expression
                    {
                    char_literal392=(Token)match(input,140,FOLLOW_140_in_expression4954); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal392);

                    pushFollow(FOLLOW_expression_in_expression4956);
                    expression393=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression393.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 730:19: -> ^( ASSIGN conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:730:22: ^( ASSIGN conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGN, "ASSIGN"), root_1);

                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:731:6: '+' '=' expression
                    {
                    char_literal394=(Token)match(input,188,FOLLOW_188_in_expression4973); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_188.add(char_literal394);

                    char_literal395=(Token)match(input,140,FOLLOW_140_in_expression4975); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal395);

                    pushFollow(FOLLOW_expression_in_expression4977);
                    expression396=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression396.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 731:25: -> ^( ASSIGNOP ADD conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:731:28: ^( ASSIGNOP ADD conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(ADD, "ADD"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:732:6: '-' '=' expression
                    {
                    char_literal397=(Token)match(input,189,FOLLOW_189_in_expression4996); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_189.add(char_literal397);

                    char_literal398=(Token)match(input,140,FOLLOW_140_in_expression4998); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal398);

                    pushFollow(FOLLOW_expression_in_expression5000);
                    expression399=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression399.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 732:25: -> ^( ASSIGNOP SUB conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:732:28: ^( ASSIGNOP SUB conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(SUB, "SUB"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:733:6: '*' '=' expression
                    {
                    char_literal400=(Token)match(input,125,FOLLOW_125_in_expression5019); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_125.add(char_literal400);

                    char_literal401=(Token)match(input,140,FOLLOW_140_in_expression5021); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal401);

                    pushFollow(FOLLOW_expression_in_expression5023);
                    expression402=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression402.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 733:25: -> ^( ASSIGNOP MUL conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:733:28: ^( ASSIGNOP MUL conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(MUL, "MUL"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:734:6: '/' '=' expression
                    {
                    char_literal403=(Token)match(input,190,FOLLOW_190_in_expression5042); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_190.add(char_literal403);

                    char_literal404=(Token)match(input,140,FOLLOW_140_in_expression5044); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal404);

                    pushFollow(FOLLOW_expression_in_expression5046);
                    expression405=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression405.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 734:25: -> ^( ASSIGNOP DIV conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:734:28: ^( ASSIGNOP DIV conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(DIV, "DIV"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:735:6: '&=' expression
                    {
                    string_literal406=(Token)match(input,191,FOLLOW_191_in_expression5068); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_191.add(string_literal406);

                    pushFollow(FOLLOW_expression_in_expression5070);
                    expression407=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression407.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 735:22: -> ^( ASSIGNOP AND conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:735:25: ^( ASSIGNOP AND conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(AND, "AND"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:736:6: '|=' expression
                    {
                    string_literal408=(Token)match(input,192,FOLLOW_192_in_expression5089); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_192.add(string_literal408);

                    pushFollow(FOLLOW_expression_in_expression5091);
                    expression409=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression409.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 736:22: -> ^( ASSIGNOP OR conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:736:25: ^( ASSIGNOP OR conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(OR, "OR"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:737:6: '^=' expression
                    {
                    string_literal410=(Token)match(input,193,FOLLOW_193_in_expression5110); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_193.add(string_literal410);

                    pushFollow(FOLLOW_expression_in_expression5112);
                    expression411=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression411.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 737:22: -> ^( ASSIGNOP XOR conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:737:25: ^( ASSIGNOP XOR conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(XOR, "XOR"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:738:6: '%' '=' expression
                    {
                    char_literal412=(Token)match(input,194,FOLLOW_194_in_expression5134); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_194.add(char_literal412);

                    char_literal413=(Token)match(input,140,FOLLOW_140_in_expression5136); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal413);

                    pushFollow(FOLLOW_expression_in_expression5138);
                    expression414=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression414.getTree());


                    // AST REWRITE
                    // elements: expression, conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 738:25: -> ^( ASSIGNOP MOD conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:738:28: ^( ASSIGNOP MOD conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(MOD, "MOD"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:739:6: '<' '<' '=' expression
                    {
                    char_literal415=(Token)match(input,129,FOLLOW_129_in_expression5157); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_129.add(char_literal415);

                    char_literal416=(Token)match(input,129,FOLLOW_129_in_expression5159); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_129.add(char_literal416);

                    char_literal417=(Token)match(input,140,FOLLOW_140_in_expression5161); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal417);

                    pushFollow(FOLLOW_expression_in_expression5163);
                    expression418=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression418.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 739:29: -> ^( ASSIGNOP SHL conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:739:32: ^( ASSIGNOP SHL conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(SHL, "SHL"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 11 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:740:6: '>' '>' '=' expression
                    {
                    char_literal419=(Token)match(input,131,FOLLOW_131_in_expression5182); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal419);

                    char_literal420=(Token)match(input,131,FOLLOW_131_in_expression5184); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal420);

                    char_literal421=(Token)match(input,140,FOLLOW_140_in_expression5186); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal421);

                    pushFollow(FOLLOW_expression_in_expression5188);
                    expression422=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression422.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 740:29: -> ^( ASSIGNOP SHR conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:740:32: ^( ASSIGNOP SHR conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(SHR, "SHR"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 12 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:741:6: '>' '>' '>' '=' expression
                    {
                    char_literal423=(Token)match(input,131,FOLLOW_131_in_expression5207); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal423);

                    char_literal424=(Token)match(input,131,FOLLOW_131_in_expression5209); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal424);

                    char_literal425=(Token)match(input,131,FOLLOW_131_in_expression5211); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal425);

                    char_literal426=(Token)match(input,140,FOLLOW_140_in_expression5213); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal426);

                    pushFollow(FOLLOW_expression_in_expression5215);
                    expression427=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression427.getTree());


                    // AST REWRITE
                    // elements: conditionalExpression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 741:33: -> ^( ASSIGNOP USHR conditionalExpression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:741:36: ^( ASSIGNOP USHR conditionalExpression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGNOP, "ASSIGNOP"), root_1);

                        adaptor.addChild(root_1, (Object)adaptor.create(USHR, "USHR"));
                        adaptor.addChild(root_1, stream_conditionalExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 13 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:742:6: 
                    {

                    // AST REWRITE
                    // elements: conditionalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 742:6: -> conditionalExpression
                    {
                        adaptor.addChild(root_0, stream_conditionalExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 93, expression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "expression"

    public static class conditionalExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:746:1: conditionalExpression : conditionalOrExpression ( '?' expression ':' expression -> ^( CONDEXPR conditionalOrExpression expression expression ) | -> conditionalOrExpression ) ;
    public final JavaParser.conditionalExpression_return conditionalExpression() throws RecognitionException {
        JavaParser.conditionalExpression_return retval = new JavaParser.conditionalExpression_return();
        retval.start = input.LT(1);
        int conditionalExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal429=null;
        Token char_literal431=null;
        JavaParser.conditionalOrExpression_return conditionalOrExpression428 = null;

        JavaParser.expression_return expression430 = null;

        JavaParser.expression_return expression432 = null;


        Object char_literal429_tree=null;
        Object char_literal431_tree=null;
        RewriteRuleTokenStream stream_162=new RewriteRuleTokenStream(adaptor,"token 162");
        RewriteRuleTokenStream stream_173=new RewriteRuleTokenStream(adaptor,"token 173");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_conditionalOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalOrExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 94) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:747:5: ( conditionalOrExpression ( '?' expression ':' expression -> ^( CONDEXPR conditionalOrExpression expression expression ) | -> conditionalOrExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:747:9: conditionalOrExpression ( '?' expression ':' expression -> ^( CONDEXPR conditionalOrExpression expression expression ) | -> conditionalOrExpression )
            {
            pushFollow(FOLLOW_conditionalOrExpression_in_conditionalExpression5258);
            conditionalOrExpression428=conditionalOrExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_conditionalOrExpression.add(conditionalOrExpression428.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:748:6: ( '?' expression ':' expression -> ^( CONDEXPR conditionalOrExpression expression expression ) | -> conditionalOrExpression )
            int alt126=2;
            alt126 = dfa126.predict(input);
            switch (alt126) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:749:7: '?' expression ':' expression
                    {
                    char_literal429=(Token)match(input,162,FOLLOW_162_in_conditionalExpression5275); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_162.add(char_literal429);

                    pushFollow(FOLLOW_expression_in_conditionalExpression5277);
                    expression430=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression430.getTree());
                    char_literal431=(Token)match(input,173,FOLLOW_173_in_conditionalExpression5279); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_173.add(char_literal431);

                    pushFollow(FOLLOW_expression_in_conditionalExpression5281);
                    expression432=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression432.getTree());


                    // AST REWRITE
                    // elements: conditionalOrExpression, expression, expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 749:37: -> ^( CONDEXPR conditionalOrExpression expression expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:749:40: ^( CONDEXPR conditionalOrExpression expression expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CONDEXPR, "CONDEXPR"), root_1);

                        adaptor.addChild(root_1, stream_conditionalOrExpression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());
                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:750:9: 
                    {

                    // AST REWRITE
                    // elements: conditionalOrExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 750:9: -> conditionalOrExpression
                    {
                        adaptor.addChild(root_0, stream_conditionalOrExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 94, conditionalExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "conditionalExpression"

    public static class conditionalOrExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalOrExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:754:1: conditionalOrExpression : conditionalAndExpression ( ( '||' conditionalOrExpression ) -> ^( LOR conditionalAndExpression conditionalOrExpression ) | -> conditionalAndExpression ) ;
    public final JavaParser.conditionalOrExpression_return conditionalOrExpression() throws RecognitionException {
        JavaParser.conditionalOrExpression_return retval = new JavaParser.conditionalOrExpression_return();
        retval.start = input.LT(1);
        int conditionalOrExpression_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal434=null;
        JavaParser.conditionalAndExpression_return conditionalAndExpression433 = null;

        JavaParser.conditionalOrExpression_return conditionalOrExpression435 = null;


        Object string_literal434_tree=null;
        RewriteRuleTokenStream stream_195=new RewriteRuleTokenStream(adaptor,"token 195");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        RewriteRuleSubtreeStream stream_conditionalOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalOrExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 95) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:755:5: ( conditionalAndExpression ( ( '||' conditionalOrExpression ) -> ^( LOR conditionalAndExpression conditionalOrExpression ) | -> conditionalAndExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:755:9: conditionalAndExpression ( ( '||' conditionalOrExpression ) -> ^( LOR conditionalAndExpression conditionalOrExpression ) | -> conditionalAndExpression )
            {
            pushFollow(FOLLOW_conditionalAndExpression_in_conditionalOrExpression5328);
            conditionalAndExpression433=conditionalAndExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression433.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:756:6: ( ( '||' conditionalOrExpression ) -> ^( LOR conditionalAndExpression conditionalOrExpression ) | -> conditionalAndExpression )
            int alt127=2;
            alt127 = dfa127.predict(input);
            switch (alt127) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:757:7: ( '||' conditionalOrExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:757:7: ( '||' conditionalOrExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:757:8: '||' conditionalOrExpression
                    {
                    string_literal434=(Token)match(input,195,FOLLOW_195_in_conditionalOrExpression5346); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_195.add(string_literal434);

                    pushFollow(FOLLOW_conditionalOrExpression_in_conditionalOrExpression5348);
                    conditionalOrExpression435=conditionalOrExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalOrExpression.add(conditionalOrExpression435.getTree());

                    }



                    // AST REWRITE
                    // elements: conditionalOrExpression, conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 757:38: -> ^( LOR conditionalAndExpression conditionalOrExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:757:41: ^( LOR conditionalAndExpression conditionalOrExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LOR, "LOR"), root_1);

                        adaptor.addChild(root_1, stream_conditionalAndExpression.nextTree());
                        adaptor.addChild(root_1, stream_conditionalOrExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:758:9: 
                    {

                    // AST REWRITE
                    // elements: conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 758:9: -> conditionalAndExpression
                    {
                        adaptor.addChild(root_0, stream_conditionalAndExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 95, conditionalOrExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "conditionalOrExpression"

    public static class conditionalAndExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalAndExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:762:1: conditionalAndExpression : inclusiveOrExpression ( ( '&&' conditionalAndExpression ) -> ^( LAND inclusiveOrExpression conditionalAndExpression ) | -> inclusiveOrExpression ) ;
    public final JavaParser.conditionalAndExpression_return conditionalAndExpression() throws RecognitionException {
        JavaParser.conditionalAndExpression_return retval = new JavaParser.conditionalAndExpression_return();
        retval.start = input.LT(1);
        int conditionalAndExpression_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal437=null;
        JavaParser.inclusiveOrExpression_return inclusiveOrExpression436 = null;

        JavaParser.conditionalAndExpression_return conditionalAndExpression438 = null;


        Object string_literal437_tree=null;
        RewriteRuleTokenStream stream_196=new RewriteRuleTokenStream(adaptor,"token 196");
        RewriteRuleSubtreeStream stream_inclusiveOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule inclusiveOrExpression");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 96) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:763:5: ( inclusiveOrExpression ( ( '&&' conditionalAndExpression ) -> ^( LAND inclusiveOrExpression conditionalAndExpression ) | -> inclusiveOrExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:763:9: inclusiveOrExpression ( ( '&&' conditionalAndExpression ) -> ^( LAND inclusiveOrExpression conditionalAndExpression ) | -> inclusiveOrExpression )
            {
            pushFollow(FOLLOW_inclusiveOrExpression_in_conditionalAndExpression5394);
            inclusiveOrExpression436=inclusiveOrExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_inclusiveOrExpression.add(inclusiveOrExpression436.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:764:6: ( ( '&&' conditionalAndExpression ) -> ^( LAND inclusiveOrExpression conditionalAndExpression ) | -> inclusiveOrExpression )
            int alt128=2;
            alt128 = dfa128.predict(input);
            switch (alt128) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:765:7: ( '&&' conditionalAndExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:765:7: ( '&&' conditionalAndExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:765:8: '&&' conditionalAndExpression
                    {
                    string_literal437=(Token)match(input,196,FOLLOW_196_in_conditionalAndExpression5412); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_196.add(string_literal437);

                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalAndExpression5414);
                    conditionalAndExpression438=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression438.getTree());

                    }



                    // AST REWRITE
                    // elements: inclusiveOrExpression, conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 765:39: -> ^( LAND inclusiveOrExpression conditionalAndExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:765:42: ^( LAND inclusiveOrExpression conditionalAndExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LAND, "LAND"), root_1);

                        adaptor.addChild(root_1, stream_inclusiveOrExpression.nextTree());
                        adaptor.addChild(root_1, stream_conditionalAndExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:766:9: 
                    {

                    // AST REWRITE
                    // elements: inclusiveOrExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 766:9: -> inclusiveOrExpression
                    {
                        adaptor.addChild(root_0, stream_inclusiveOrExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 96, conditionalAndExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "conditionalAndExpression"

    public static class inclusiveOrExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "inclusiveOrExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:770:1: inclusiveOrExpression : exclusiveOrExpression ( ( '|' inclusiveOrExpression ) -> ^( OR exclusiveOrExpression inclusiveOrExpression ) | -> exclusiveOrExpression ) ;
    public final JavaParser.inclusiveOrExpression_return inclusiveOrExpression() throws RecognitionException {
        JavaParser.inclusiveOrExpression_return retval = new JavaParser.inclusiveOrExpression_return();
        retval.start = input.LT(1);
        int inclusiveOrExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal440=null;
        JavaParser.exclusiveOrExpression_return exclusiveOrExpression439 = null;

        JavaParser.inclusiveOrExpression_return inclusiveOrExpression441 = null;


        Object char_literal440_tree=null;
        RewriteRuleTokenStream stream_197=new RewriteRuleTokenStream(adaptor,"token 197");
        RewriteRuleSubtreeStream stream_exclusiveOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule exclusiveOrExpression");
        RewriteRuleSubtreeStream stream_inclusiveOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule inclusiveOrExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 97) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:771:5: ( exclusiveOrExpression ( ( '|' inclusiveOrExpression ) -> ^( OR exclusiveOrExpression inclusiveOrExpression ) | -> exclusiveOrExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:771:9: exclusiveOrExpression ( ( '|' inclusiveOrExpression ) -> ^( OR exclusiveOrExpression inclusiveOrExpression ) | -> exclusiveOrExpression )
            {
            pushFollow(FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression5466);
            exclusiveOrExpression439=exclusiveOrExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_exclusiveOrExpression.add(exclusiveOrExpression439.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:772:9: ( ( '|' inclusiveOrExpression ) -> ^( OR exclusiveOrExpression inclusiveOrExpression ) | -> exclusiveOrExpression )
            int alt129=2;
            alt129 = dfa129.predict(input);
            switch (alt129) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:773:10: ( '|' inclusiveOrExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:773:10: ( '|' inclusiveOrExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:773:11: '|' inclusiveOrExpression
                    {
                    char_literal440=(Token)match(input,197,FOLLOW_197_in_inclusiveOrExpression5488); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_197.add(char_literal440);

                    pushFollow(FOLLOW_inclusiveOrExpression_in_inclusiveOrExpression5490);
                    inclusiveOrExpression441=inclusiveOrExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_inclusiveOrExpression.add(inclusiveOrExpression441.getTree());

                    }



                    // AST REWRITE
                    // elements: inclusiveOrExpression, exclusiveOrExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 773:38: -> ^( OR exclusiveOrExpression inclusiveOrExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:773:41: ^( OR exclusiveOrExpression inclusiveOrExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(OR, "OR"), root_1);

                        adaptor.addChild(root_1, stream_exclusiveOrExpression.nextTree());
                        adaptor.addChild(root_1, stream_inclusiveOrExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:774:6: 
                    {

                    // AST REWRITE
                    // elements: exclusiveOrExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 774:6: -> exclusiveOrExpression
                    {
                        adaptor.addChild(root_0, stream_exclusiveOrExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 97, inclusiveOrExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "inclusiveOrExpression"

    public static class exclusiveOrExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "exclusiveOrExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:778:1: exclusiveOrExpression : andExpression ( ( '^' exclusiveOrExpression ) -> ^( XOR andExpression exclusiveOrExpression ) | -> andExpression ) ;
    public final JavaParser.exclusiveOrExpression_return exclusiveOrExpression() throws RecognitionException {
        JavaParser.exclusiveOrExpression_return retval = new JavaParser.exclusiveOrExpression_return();
        retval.start = input.LT(1);
        int exclusiveOrExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal443=null;
        JavaParser.andExpression_return andExpression442 = null;

        JavaParser.exclusiveOrExpression_return exclusiveOrExpression444 = null;


        Object char_literal443_tree=null;
        RewriteRuleTokenStream stream_198=new RewriteRuleTokenStream(adaptor,"token 198");
        RewriteRuleSubtreeStream stream_andExpression=new RewriteRuleSubtreeStream(adaptor,"rule andExpression");
        RewriteRuleSubtreeStream stream_exclusiveOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule exclusiveOrExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 98) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:779:5: ( andExpression ( ( '^' exclusiveOrExpression ) -> ^( XOR andExpression exclusiveOrExpression ) | -> andExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:779:9: andExpression ( ( '^' exclusiveOrExpression ) -> ^( XOR andExpression exclusiveOrExpression ) | -> andExpression )
            {
            pushFollow(FOLLOW_andExpression_in_exclusiveOrExpression5537);
            andExpression442=andExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_andExpression.add(andExpression442.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:780:5: ( ( '^' exclusiveOrExpression ) -> ^( XOR andExpression exclusiveOrExpression ) | -> andExpression )
            int alt130=2;
            alt130 = dfa130.predict(input);
            switch (alt130) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:781:6: ( '^' exclusiveOrExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:781:6: ( '^' exclusiveOrExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:781:7: '^' exclusiveOrExpression
                    {
                    char_literal443=(Token)match(input,198,FOLLOW_198_in_exclusiveOrExpression5553); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_198.add(char_literal443);

                    pushFollow(FOLLOW_exclusiveOrExpression_in_exclusiveOrExpression5555);
                    exclusiveOrExpression444=exclusiveOrExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exclusiveOrExpression.add(exclusiveOrExpression444.getTree());

                    }



                    // AST REWRITE
                    // elements: exclusiveOrExpression, andExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 781:34: -> ^( XOR andExpression exclusiveOrExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:781:37: ^( XOR andExpression exclusiveOrExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(XOR, "XOR"), root_1);

                        adaptor.addChild(root_1, stream_andExpression.nextTree());
                        adaptor.addChild(root_1, stream_exclusiveOrExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:782:8: 
                    {

                    // AST REWRITE
                    // elements: andExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 782:8: -> andExpression
                    {
                        adaptor.addChild(root_0, stream_andExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 98, exclusiveOrExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "exclusiveOrExpression"

    public static class andExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "andExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:786:1: andExpression : equalityExpression ( ( '&' andExpression ) -> ^( AND equalityExpression andExpression ) | -> equalityExpression ) ;
    public final JavaParser.andExpression_return andExpression() throws RecognitionException {
        JavaParser.andExpression_return retval = new JavaParser.andExpression_return();
        retval.start = input.LT(1);
        int andExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal446=null;
        JavaParser.equalityExpression_return equalityExpression445 = null;

        JavaParser.andExpression_return andExpression447 = null;


        Object char_literal446_tree=null;
        RewriteRuleTokenStream stream_132=new RewriteRuleTokenStream(adaptor,"token 132");
        RewriteRuleSubtreeStream stream_andExpression=new RewriteRuleSubtreeStream(adaptor,"rule andExpression");
        RewriteRuleSubtreeStream stream_equalityExpression=new RewriteRuleSubtreeStream(adaptor,"rule equalityExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 99) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:787:5: ( equalityExpression ( ( '&' andExpression ) -> ^( AND equalityExpression andExpression ) | -> equalityExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:787:9: equalityExpression ( ( '&' andExpression ) -> ^( AND equalityExpression andExpression ) | -> equalityExpression )
            {
            pushFollow(FOLLOW_equalityExpression_in_andExpression5599);
            equalityExpression445=equalityExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_equalityExpression.add(equalityExpression445.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:788:5: ( ( '&' andExpression ) -> ^( AND equalityExpression andExpression ) | -> equalityExpression )
            int alt131=2;
            alt131 = dfa131.predict(input);
            switch (alt131) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:789:6: ( '&' andExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:789:6: ( '&' andExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:789:7: '&' andExpression
                    {
                    char_literal446=(Token)match(input,132,FOLLOW_132_in_andExpression5615); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_132.add(char_literal446);

                    pushFollow(FOLLOW_andExpression_in_andExpression5617);
                    andExpression447=andExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_andExpression.add(andExpression447.getTree());

                    }



                    // AST REWRITE
                    // elements: andExpression, equalityExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 789:26: -> ^( AND equalityExpression andExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:789:29: ^( AND equalityExpression andExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(AND, "AND"), root_1);

                        adaptor.addChild(root_1, stream_equalityExpression.nextTree());
                        adaptor.addChild(root_1, stream_andExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:790:8: 
                    {

                    // AST REWRITE
                    // elements: equalityExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 790:8: -> equalityExpression
                    {
                        adaptor.addChild(root_0, stream_equalityExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 99, andExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "andExpression"

    public static class equalityExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "equalityExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:794:1: equalityExpression : instanceOfExpression ( ( '==' instanceOfExpression ) -> ^( EQ instanceOfExpression instanceOfExpression ) | ( '!=' instanceOfExpression ) -> ^( NEQ instanceOfExpression instanceOfExpression ) | -> instanceOfExpression ) ;
    public final JavaParser.equalityExpression_return equalityExpression() throws RecognitionException {
        JavaParser.equalityExpression_return retval = new JavaParser.equalityExpression_return();
        retval.start = input.LT(1);
        int equalityExpression_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal449=null;
        Token string_literal451=null;
        JavaParser.instanceOfExpression_return instanceOfExpression448 = null;

        JavaParser.instanceOfExpression_return instanceOfExpression450 = null;

        JavaParser.instanceOfExpression_return instanceOfExpression452 = null;


        Object string_literal449_tree=null;
        Object string_literal451_tree=null;
        RewriteRuleTokenStream stream_199=new RewriteRuleTokenStream(adaptor,"token 199");
        RewriteRuleTokenStream stream_200=new RewriteRuleTokenStream(adaptor,"token 200");
        RewriteRuleSubtreeStream stream_instanceOfExpression=new RewriteRuleSubtreeStream(adaptor,"rule instanceOfExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 100) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:795:5: ( instanceOfExpression ( ( '==' instanceOfExpression ) -> ^( EQ instanceOfExpression instanceOfExpression ) | ( '!=' instanceOfExpression ) -> ^( NEQ instanceOfExpression instanceOfExpression ) | -> instanceOfExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:795:9: instanceOfExpression ( ( '==' instanceOfExpression ) -> ^( EQ instanceOfExpression instanceOfExpression ) | ( '!=' instanceOfExpression ) -> ^( NEQ instanceOfExpression instanceOfExpression ) | -> instanceOfExpression )
            {
            pushFollow(FOLLOW_instanceOfExpression_in_equalityExpression5661);
            instanceOfExpression448=instanceOfExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_instanceOfExpression.add(instanceOfExpression448.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:796:5: ( ( '==' instanceOfExpression ) -> ^( EQ instanceOfExpression instanceOfExpression ) | ( '!=' instanceOfExpression ) -> ^( NEQ instanceOfExpression instanceOfExpression ) | -> instanceOfExpression )
            int alt132=3;
            alt132 = dfa132.predict(input);
            switch (alt132) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:797:6: ( '==' instanceOfExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:797:6: ( '==' instanceOfExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:797:7: '==' instanceOfExpression
                    {
                    string_literal449=(Token)match(input,199,FOLLOW_199_in_equalityExpression5677); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_199.add(string_literal449);

                    pushFollow(FOLLOW_instanceOfExpression_in_equalityExpression5679);
                    instanceOfExpression450=instanceOfExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_instanceOfExpression.add(instanceOfExpression450.getTree());

                    }



                    // AST REWRITE
                    // elements: instanceOfExpression, instanceOfExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 797:34: -> ^( EQ instanceOfExpression instanceOfExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:797:37: ^( EQ instanceOfExpression instanceOfExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(EQ, "EQ"), root_1);

                        adaptor.addChild(root_1, stream_instanceOfExpression.nextTree());
                        adaptor.addChild(root_1, stream_instanceOfExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:798:8: ( '!=' instanceOfExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:798:8: ( '!=' instanceOfExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:798:9: '!=' instanceOfExpression
                    {
                    string_literal451=(Token)match(input,200,FOLLOW_200_in_equalityExpression5700); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_200.add(string_literal451);

                    pushFollow(FOLLOW_instanceOfExpression_in_equalityExpression5702);
                    instanceOfExpression452=instanceOfExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_instanceOfExpression.add(instanceOfExpression452.getTree());

                    }



                    // AST REWRITE
                    // elements: instanceOfExpression, instanceOfExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 798:36: -> ^( NEQ instanceOfExpression instanceOfExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:798:39: ^( NEQ instanceOfExpression instanceOfExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEQ, "NEQ"), root_1);

                        adaptor.addChild(root_1, stream_instanceOfExpression.nextTree());
                        adaptor.addChild(root_1, stream_instanceOfExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:799:8: 
                    {

                    // AST REWRITE
                    // elements: instanceOfExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 799:8: -> instanceOfExpression
                    {
                        adaptor.addChild(root_0, stream_instanceOfExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 100, equalityExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "equalityExpression"

    public static class instanceOfExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "instanceOfExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:803:1: instanceOfExpression : relationalExpression ( ( 'instanceof' type ) -> ^( INSTANCEOF relationalExpression type ) | -> relationalExpression ) ;
    public final JavaParser.instanceOfExpression_return instanceOfExpression() throws RecognitionException {
        JavaParser.instanceOfExpression_return retval = new JavaParser.instanceOfExpression_return();
        retval.start = input.LT(1);
        int instanceOfExpression_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal454=null;
        JavaParser.relationalExpression_return relationalExpression453 = null;

        JavaParser.type_return type455 = null;


        Object string_literal454_tree=null;
        RewriteRuleTokenStream stream_201=new RewriteRuleTokenStream(adaptor,"token 201");
        RewriteRuleSubtreeStream stream_relationalExpression=new RewriteRuleSubtreeStream(adaptor,"rule relationalExpression");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 101) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:804:5: ( relationalExpression ( ( 'instanceof' type ) -> ^( INSTANCEOF relationalExpression type ) | -> relationalExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:804:9: relationalExpression ( ( 'instanceof' type ) -> ^( INSTANCEOF relationalExpression type ) | -> relationalExpression )
            {
            pushFollow(FOLLOW_relationalExpression_in_instanceOfExpression5746);
            relationalExpression453=relationalExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_relationalExpression.add(relationalExpression453.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:805:5: ( ( 'instanceof' type ) -> ^( INSTANCEOF relationalExpression type ) | -> relationalExpression )
            int alt133=2;
            alt133 = dfa133.predict(input);
            switch (alt133) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:806:6: ( 'instanceof' type )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:806:6: ( 'instanceof' type )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:806:7: 'instanceof' type
                    {
                    string_literal454=(Token)match(input,201,FOLLOW_201_in_instanceOfExpression5761); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_201.add(string_literal454);

                    pushFollow(FOLLOW_type_in_instanceOfExpression5763);
                    type455=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type455.getTree());

                    }



                    // AST REWRITE
                    // elements: relationalExpression, type
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 806:26: -> ^( INSTANCEOF relationalExpression type )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:806:29: ^( INSTANCEOF relationalExpression type )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INSTANCEOF, "INSTANCEOF"), root_1);

                        adaptor.addChild(root_1, stream_relationalExpression.nextTree());
                        adaptor.addChild(root_1, stream_type.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:807:8: 
                    {

                    // AST REWRITE
                    // elements: relationalExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 807:8: -> relationalExpression
                    {
                        adaptor.addChild(root_0, stream_relationalExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 101, instanceOfExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "instanceOfExpression"

    public static class relationalExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationalExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:811:1: relationalExpression : shiftExpression ( ( '<' '=' shiftExpression ) -> ^( LTEQ shiftExpression shiftExpression ) | ( '<' shiftExpression ) -> ^( LT shiftExpression shiftExpression ) | ( '>' '=' shiftExpression ) -> ^( GTEQ shiftExpression shiftExpression ) | ( '>' shiftExpression ) -> ^( GT shiftExpression shiftExpression ) | -> shiftExpression ) ;
    public final JavaParser.relationalExpression_return relationalExpression() throws RecognitionException {
        JavaParser.relationalExpression_return retval = new JavaParser.relationalExpression_return();
        retval.start = input.LT(1);
        int relationalExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal457=null;
        Token char_literal458=null;
        Token char_literal460=null;
        Token char_literal462=null;
        Token char_literal463=null;
        Token char_literal465=null;
        JavaParser.shiftExpression_return shiftExpression456 = null;

        JavaParser.shiftExpression_return shiftExpression459 = null;

        JavaParser.shiftExpression_return shiftExpression461 = null;

        JavaParser.shiftExpression_return shiftExpression464 = null;

        JavaParser.shiftExpression_return shiftExpression466 = null;


        Object char_literal457_tree=null;
        Object char_literal458_tree=null;
        Object char_literal460_tree=null;
        Object char_literal462_tree=null;
        Object char_literal463_tree=null;
        Object char_literal465_tree=null;
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleTokenStream stream_140=new RewriteRuleTokenStream(adaptor,"token 140");
        RewriteRuleSubtreeStream stream_shiftExpression=new RewriteRuleSubtreeStream(adaptor,"rule shiftExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 102) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:812:5: ( shiftExpression ( ( '<' '=' shiftExpression ) -> ^( LTEQ shiftExpression shiftExpression ) | ( '<' shiftExpression ) -> ^( LT shiftExpression shiftExpression ) | ( '>' '=' shiftExpression ) -> ^( GTEQ shiftExpression shiftExpression ) | ( '>' shiftExpression ) -> ^( GT shiftExpression shiftExpression ) | -> shiftExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:812:9: shiftExpression ( ( '<' '=' shiftExpression ) -> ^( LTEQ shiftExpression shiftExpression ) | ( '<' shiftExpression ) -> ^( LT shiftExpression shiftExpression ) | ( '>' '=' shiftExpression ) -> ^( GTEQ shiftExpression shiftExpression ) | ( '>' shiftExpression ) -> ^( GT shiftExpression shiftExpression ) | -> shiftExpression )
            {
            pushFollow(FOLLOW_shiftExpression_in_relationalExpression5807);
            shiftExpression456=shiftExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_shiftExpression.add(shiftExpression456.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:813:5: ( ( '<' '=' shiftExpression ) -> ^( LTEQ shiftExpression shiftExpression ) | ( '<' shiftExpression ) -> ^( LT shiftExpression shiftExpression ) | ( '>' '=' shiftExpression ) -> ^( GTEQ shiftExpression shiftExpression ) | ( '>' shiftExpression ) -> ^( GT shiftExpression shiftExpression ) | -> shiftExpression )
            int alt134=5;
            alt134 = dfa134.predict(input);
            switch (alt134) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:814:6: ( '<' '=' shiftExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:814:6: ( '<' '=' shiftExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:814:7: '<' '=' shiftExpression
                    {
                    char_literal457=(Token)match(input,129,FOLLOW_129_in_relationalExpression5823); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_129.add(char_literal457);

                    char_literal458=(Token)match(input,140,FOLLOW_140_in_relationalExpression5825); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal458);

                    pushFollow(FOLLOW_shiftExpression_in_relationalExpression5827);
                    shiftExpression459=shiftExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_shiftExpression.add(shiftExpression459.getTree());

                    }



                    // AST REWRITE
                    // elements: shiftExpression, shiftExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 814:32: -> ^( LTEQ shiftExpression shiftExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:814:35: ^( LTEQ shiftExpression shiftExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LTEQ, "LTEQ"), root_1);

                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());
                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:8: ( '<' shiftExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:8: ( '<' shiftExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:9: '<' shiftExpression
                    {
                    char_literal460=(Token)match(input,129,FOLLOW_129_in_relationalExpression5848); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_129.add(char_literal460);

                    pushFollow(FOLLOW_shiftExpression_in_relationalExpression5850);
                    shiftExpression461=shiftExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_shiftExpression.add(shiftExpression461.getTree());

                    }



                    // AST REWRITE
                    // elements: shiftExpression, shiftExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 815:30: -> ^( LT shiftExpression shiftExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:33: ^( LT shiftExpression shiftExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LT, "LT"), root_1);

                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());
                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:816:8: ( '>' '=' shiftExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:816:8: ( '>' '=' shiftExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:816:9: '>' '=' shiftExpression
                    {
                    char_literal462=(Token)match(input,131,FOLLOW_131_in_relationalExpression5871); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal462);

                    char_literal463=(Token)match(input,140,FOLLOW_140_in_relationalExpression5873); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_140.add(char_literal463);

                    pushFollow(FOLLOW_shiftExpression_in_relationalExpression5875);
                    shiftExpression464=shiftExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_shiftExpression.add(shiftExpression464.getTree());

                    }



                    // AST REWRITE
                    // elements: shiftExpression, shiftExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 816:34: -> ^( GTEQ shiftExpression shiftExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:816:37: ^( GTEQ shiftExpression shiftExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(GTEQ, "GTEQ"), root_1);

                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());
                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:817:8: ( '>' shiftExpression )
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:817:8: ( '>' shiftExpression )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:817:9: '>' shiftExpression
                    {
                    char_literal465=(Token)match(input,131,FOLLOW_131_in_relationalExpression5896); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_131.add(char_literal465);

                    pushFollow(FOLLOW_shiftExpression_in_relationalExpression5898);
                    shiftExpression466=shiftExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_shiftExpression.add(shiftExpression466.getTree());

                    }



                    // AST REWRITE
                    // elements: shiftExpression, shiftExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 817:30: -> ^( GT shiftExpression shiftExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:817:33: ^( GT shiftExpression shiftExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(GT, "GT"), root_1);

                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());
                        adaptor.addChild(root_1, stream_shiftExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:818:8: 
                    {

                    // AST REWRITE
                    // elements: shiftExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 818:8: -> shiftExpression
                    {
                        adaptor.addChild(root_0, stream_shiftExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 102, relationalExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "relationalExpression"

    public static class shiftExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "shiftExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:822:1: shiftExpression : additiveExpression ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ -> ^( LABINOP additiveExpression ( $i additiveExpression )+ ) | ( '>' '>' '>' additiveExpression )+ -> ^( USHR additiveExpression ( additiveExpression )+ ) | -> additiveExpression ) ;
    public final JavaParser.shiftExpression_return shiftExpression() throws RecognitionException {
        JavaParser.shiftExpression_return retval = new JavaParser.shiftExpression_return();
        retval.start = input.LT(1);
        int shiftExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal468=null;
        Token char_literal469=null;
        Token char_literal471=null;
        Token char_literal472=null;
        Token char_literal473=null;
        Token i=null;
        List list_i=null;
        JavaParser.additiveExpression_return additiveExpression467 = null;

        JavaParser.additiveExpression_return additiveExpression470 = null;

        JavaParser.additiveExpression_return additiveExpression474 = null;


        Object char_literal468_tree=null;
        Object char_literal469_tree=null;
        Object char_literal471_tree=null;
        Object char_literal472_tree=null;
        Object char_literal473_tree=null;
        Object i_tree=null;
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleSubtreeStream stream_additiveExpression=new RewriteRuleSubtreeStream(adaptor,"rule additiveExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 103) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:823:5: ( additiveExpression ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ -> ^( LABINOP additiveExpression ( $i additiveExpression )+ ) | ( '>' '>' '>' additiveExpression )+ -> ^( USHR additiveExpression ( additiveExpression )+ ) | -> additiveExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:823:9: additiveExpression ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ -> ^( LABINOP additiveExpression ( $i additiveExpression )+ ) | ( '>' '>' '>' additiveExpression )+ -> ^( USHR additiveExpression ( additiveExpression )+ ) | -> additiveExpression )
            {
            pushFollow(FOLLOW_additiveExpression_in_shiftExpression5943);
            additiveExpression467=additiveExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_additiveExpression.add(additiveExpression467.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:824:5: ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ -> ^( LABINOP additiveExpression ( $i additiveExpression )+ ) | ( '>' '>' '>' additiveExpression )+ -> ^( USHR additiveExpression ( additiveExpression )+ ) | -> additiveExpression )
            int alt138=3;
            alt138 = dfa138.predict(input);
            switch (alt138) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:6: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:6: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+
                    int cnt136=0;
                    loop136:
                    do {
                        int alt136=2;
                        alt136 = dfa136.predict(input);
                        switch (alt136) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' ) additiveExpression
                    	    {
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' )
                    	    int alt135=2;
                    	    int LA135_0 = input.LA(1);

                    	    if ( (LA135_0==129) ) {
                    	        alt135=1;
                    	    }
                    	    else if ( (LA135_0==131) ) {
                    	        alt135=2;
                    	    }
                    	    else {
                    	        if (state.backtracking>0) {state.failed=true; return retval;}
                    	        NoViableAltException nvae =
                    	            new NoViableAltException("", 135, 0, input);

                    	        throw nvae;
                    	    }
                    	    switch (alt135) {
                    	        case 1 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:8: i+= '<' '<'
                    	            {
                    	            i=(Token)match(input,129,FOLLOW_129_in_shiftExpression5962); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_129.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);

                    	            char_literal468=(Token)match(input,129,FOLLOW_129_in_shiftExpression5964); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_129.add(char_literal468);


                    	            }
                    	            break;
                    	        case 2 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:19: i+= '>' '>'
                    	            {
                    	            i=(Token)match(input,131,FOLLOW_131_in_shiftExpression5968); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_131.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);

                    	            char_literal469=(Token)match(input,131,FOLLOW_131_in_shiftExpression5970); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_131.add(char_literal469);


                    	            }
                    	            break;

                    	    }

                    	    pushFollow(FOLLOW_additiveExpression_in_shiftExpression5973);
                    	    additiveExpression470=additiveExpression();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_additiveExpression.add(additiveExpression470.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt136 >= 1 ) break loop136;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(136, input);
                                throw eee;
                        }
                        cnt136++;
                    } while (true);



                    // AST REWRITE
                    // elements: i, additiveExpression, additiveExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: i
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 825:52: -> ^( LABINOP additiveExpression ( $i additiveExpression )+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:55: ^( LABINOP additiveExpression ( $i additiveExpression )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LABINOP, "LABINOP"), root_1);

                        adaptor.addChild(root_1, stream_additiveExpression.nextTree());
                        if ( !(stream_i.hasNext()||stream_additiveExpression.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_i.hasNext()||stream_additiveExpression.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextNode());
                            adaptor.addChild(root_1, stream_additiveExpression.nextTree());

                        }
                        stream_i.reset();
                        stream_additiveExpression.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:8: ( '>' '>' '>' additiveExpression )+
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:8: ( '>' '>' '>' additiveExpression )+
                    int cnt137=0;
                    loop137:
                    do {
                        int alt137=2;
                        alt137 = dfa137.predict(input);
                        switch (alt137) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:9: '>' '>' '>' additiveExpression
                    	    {
                    	    char_literal471=(Token)match(input,131,FOLLOW_131_in_shiftExpression6007); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_131.add(char_literal471);

                    	    char_literal472=(Token)match(input,131,FOLLOW_131_in_shiftExpression6009); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_131.add(char_literal472);

                    	    char_literal473=(Token)match(input,131,FOLLOW_131_in_shiftExpression6011); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_131.add(char_literal473);

                    	    pushFollow(FOLLOW_additiveExpression_in_shiftExpression6013);
                    	    additiveExpression474=additiveExpression();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_additiveExpression.add(additiveExpression474.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt137 >= 1 ) break loop137;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(137, input);
                                throw eee;
                        }
                        cnt137++;
                    } while (true);



                    // AST REWRITE
                    // elements: additiveExpression, additiveExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 827:42: -> ^( USHR additiveExpression ( additiveExpression )+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:45: ^( USHR additiveExpression ( additiveExpression )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(USHR, "USHR"), root_1);

                        adaptor.addChild(root_1, stream_additiveExpression.nextTree());
                        if ( !(stream_additiveExpression.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_additiveExpression.hasNext() ) {
                            adaptor.addChild(root_1, stream_additiveExpression.nextTree());

                        }
                        stream_additiveExpression.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:828:8: 
                    {

                    // AST REWRITE
                    // elements: additiveExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 828:8: -> additiveExpression
                    {
                        adaptor.addChild(root_0, stream_additiveExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 103, shiftExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "shiftExpression"

    public static class additiveExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:832:1: additiveExpression : multiplicativeExpression ( ( (i+= '+' | i+= '-' ) multiplicativeExpression )+ -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ ) | -> multiplicativeExpression ) ;
    public final JavaParser.additiveExpression_return additiveExpression() throws RecognitionException {
        JavaParser.additiveExpression_return retval = new JavaParser.additiveExpression_return();
        retval.start = input.LT(1);
        int additiveExpression_StartIndex = input.index();
        Object root_0 = null;

        Token i=null;
        List list_i=null;
        JavaParser.multiplicativeExpression_return multiplicativeExpression475 = null;

        JavaParser.multiplicativeExpression_return multiplicativeExpression476 = null;


        Object i_tree=null;
        RewriteRuleTokenStream stream_188=new RewriteRuleTokenStream(adaptor,"token 188");
        RewriteRuleTokenStream stream_189=new RewriteRuleTokenStream(adaptor,"token 189");
        RewriteRuleSubtreeStream stream_multiplicativeExpression=new RewriteRuleSubtreeStream(adaptor,"rule multiplicativeExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 104) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:833:5: ( multiplicativeExpression ( ( (i+= '+' | i+= '-' ) multiplicativeExpression )+ -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ ) | -> multiplicativeExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:833:9: multiplicativeExpression ( ( (i+= '+' | i+= '-' ) multiplicativeExpression )+ -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ ) | -> multiplicativeExpression )
            {
            pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression6056);
            multiplicativeExpression475=multiplicativeExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression475.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:834:5: ( ( (i+= '+' | i+= '-' ) multiplicativeExpression )+ -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ ) | -> multiplicativeExpression )
            int alt141=2;
            alt141 = dfa141.predict(input);
            switch (alt141) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:6: ( (i+= '+' | i+= '-' ) multiplicativeExpression )+
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:6: ( (i+= '+' | i+= '-' ) multiplicativeExpression )+
                    int cnt140=0;
                    loop140:
                    do {
                        int alt140=2;
                        alt140 = dfa140.predict(input);
                        switch (alt140) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:7: (i+= '+' | i+= '-' ) multiplicativeExpression
                    	    {
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:7: (i+= '+' | i+= '-' )
                    	    int alt139=2;
                    	    int LA139_0 = input.LA(1);

                    	    if ( (LA139_0==188) ) {
                    	        alt139=1;
                    	    }
                    	    else if ( (LA139_0==189) ) {
                    	        alt139=2;
                    	    }
                    	    else {
                    	        if (state.backtracking>0) {state.failed=true; return retval;}
                    	        NoViableAltException nvae =
                    	            new NoViableAltException("", 139, 0, input);

                    	        throw nvae;
                    	    }
                    	    switch (alt139) {
                    	        case 1 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:8: i+= '+'
                    	            {
                    	            i=(Token)match(input,188,FOLLOW_188_in_additiveExpression6075); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_188.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);


                    	            }
                    	            break;
                    	        case 2 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:15: i+= '-'
                    	            {
                    	            i=(Token)match(input,189,FOLLOW_189_in_additiveExpression6079); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_189.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);


                    	            }
                    	            break;

                    	    }

                    	    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression6082);
                    	    multiplicativeExpression476=multiplicativeExpression();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression476.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt140 >= 1 ) break loop140;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(140, input);
                                throw eee;
                        }
                        cnt140++;
                    } while (true);



                    // AST REWRITE
                    // elements: multiplicativeExpression, i, multiplicativeExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: i
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 835:50: -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:835:53: ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LABINOP, "LABINOP"), root_1);

                        adaptor.addChild(root_1, stream_multiplicativeExpression.nextTree());
                        if ( !(stream_i.hasNext()||stream_multiplicativeExpression.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_i.hasNext()||stream_multiplicativeExpression.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextNode());
                            adaptor.addChild(root_1, stream_multiplicativeExpression.nextTree());

                        }
                        stream_i.reset();
                        stream_multiplicativeExpression.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:836:8: 
                    {

                    // AST REWRITE
                    // elements: multiplicativeExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 836:8: -> multiplicativeExpression
                    {
                        adaptor.addChild(root_0, stream_multiplicativeExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 104, additiveExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "additiveExpression"

    public static class multiplicativeExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:840:1: multiplicativeExpression : unaryExpression ( ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+ -> ^( LABINOP unaryExpression ( $i unaryExpression )+ ) | -> unaryExpression ) ;
    public final JavaParser.multiplicativeExpression_return multiplicativeExpression() throws RecognitionException {
        JavaParser.multiplicativeExpression_return retval = new JavaParser.multiplicativeExpression_return();
        retval.start = input.LT(1);
        int multiplicativeExpression_StartIndex = input.index();
        Object root_0 = null;

        Token i=null;
        List list_i=null;
        JavaParser.unaryExpression_return unaryExpression477 = null;

        JavaParser.unaryExpression_return unaryExpression478 = null;


        Object i_tree=null;
        RewriteRuleTokenStream stream_125=new RewriteRuleTokenStream(adaptor,"token 125");
        RewriteRuleTokenStream stream_194=new RewriteRuleTokenStream(adaptor,"token 194");
        RewriteRuleTokenStream stream_190=new RewriteRuleTokenStream(adaptor,"token 190");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 105) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:841:5: ( unaryExpression ( ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+ -> ^( LABINOP unaryExpression ( $i unaryExpression )+ ) | -> unaryExpression ) )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:841:9: unaryExpression ( ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+ -> ^( LABINOP unaryExpression ( $i unaryExpression )+ ) | -> unaryExpression )
            {
            pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression6133);
            unaryExpression477=unaryExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression477.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:842:5: ( ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+ -> ^( LABINOP unaryExpression ( $i unaryExpression )+ ) | -> unaryExpression )
            int alt144=2;
            alt144 = dfa144.predict(input);
            switch (alt144) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:6: ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+
                    {
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:6: ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+
                    int cnt143=0;
                    loop143:
                    do {
                        int alt143=2;
                        alt143 = dfa143.predict(input);
                        switch (alt143) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:8: (i+= '*' | i+= '/' | i+= '%' ) unaryExpression
                    	    {
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:8: (i+= '*' | i+= '/' | i+= '%' )
                    	    int alt142=3;
                    	    switch ( input.LA(1) ) {
                    	    case 125:
                    	        {
                    	        alt142=1;
                    	        }
                    	        break;
                    	    case 190:
                    	        {
                    	        alt142=2;
                    	        }
                    	        break;
                    	    case 194:
                    	        {
                    	        alt142=3;
                    	        }
                    	        break;
                    	    default:
                    	        if (state.backtracking>0) {state.failed=true; return retval;}
                    	        NoViableAltException nvae =
                    	            new NoViableAltException("", 142, 0, input);

                    	        throw nvae;
                    	    }

                    	    switch (alt142) {
                    	        case 1 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:9: i+= '*'
                    	            {
                    	            i=(Token)match(input,125,FOLLOW_125_in_multiplicativeExpression6153); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_125.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);


                    	            }
                    	            break;
                    	        case 2 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:16: i+= '/'
                    	            {
                    	            i=(Token)match(input,190,FOLLOW_190_in_multiplicativeExpression6157); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_190.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);


                    	            }
                    	            break;
                    	        case 3 :
                    	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:23: i+= '%'
                    	            {
                    	            i=(Token)match(input,194,FOLLOW_194_in_multiplicativeExpression6161); if (state.failed) return retval; 
                    	            if ( state.backtracking==0 ) stream_194.add(i);

                    	            if (list_i==null) list_i=new ArrayList();
                    	            list_i.add(i);


                    	            }
                    	            break;

                    	    }

                    	    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression6164);
                    	    unaryExpression478=unaryExpression();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression478.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt143 >= 1 ) break loop143;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(143, input);
                                throw eee;
                        }
                        cnt143++;
                    } while (true);



                    // AST REWRITE
                    // elements: unaryExpression, unaryExpression, i
                    // token labels: 
                    // rule labels: retval
                    // token list labels: i
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_i=new RewriteRuleTokenStream(adaptor,"token i", list_i);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 843:49: -> ^( LABINOP unaryExpression ( $i unaryExpression )+ )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:843:52: ^( LABINOP unaryExpression ( $i unaryExpression )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(LABINOP, "LABINOP"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());
                        if ( !(stream_unaryExpression.hasNext()||stream_i.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_unaryExpression.hasNext()||stream_i.hasNext() ) {
                            adaptor.addChild(root_1, stream_i.nextNode());
                            adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        }
                        stream_unaryExpression.reset();
                        stream_i.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:844:8: 
                    {

                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 844:8: -> unaryExpression
                    {
                        adaptor.addChild(root_0, stream_unaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 105, multiplicativeExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpression"

    public static class unaryExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:848:1: unaryExpression : ( '+' unaryExpression -> unaryExpression | '-' unaryExpression -> ^( NEG unaryExpression ) | '++' unaryExpression -> ^( PREINC unaryExpression ) | '--' unaryExpression -> ^( PREDEC unaryExpression ) | unaryExpressionNotPlusMinus -> unaryExpressionNotPlusMinus );
    public final JavaParser.unaryExpression_return unaryExpression() throws RecognitionException {
        JavaParser.unaryExpression_return retval = new JavaParser.unaryExpression_return();
        retval.start = input.LT(1);
        int unaryExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal479=null;
        Token char_literal481=null;
        Token string_literal483=null;
        Token string_literal485=null;
        JavaParser.unaryExpression_return unaryExpression480 = null;

        JavaParser.unaryExpression_return unaryExpression482 = null;

        JavaParser.unaryExpression_return unaryExpression484 = null;

        JavaParser.unaryExpression_return unaryExpression486 = null;

        JavaParser.unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus487 = null;


        Object char_literal479_tree=null;
        Object char_literal481_tree=null;
        Object string_literal483_tree=null;
        Object string_literal485_tree=null;
        RewriteRuleTokenStream stream_202=new RewriteRuleTokenStream(adaptor,"token 202");
        RewriteRuleTokenStream stream_203=new RewriteRuleTokenStream(adaptor,"token 203");
        RewriteRuleTokenStream stream_188=new RewriteRuleTokenStream(adaptor,"token 188");
        RewriteRuleTokenStream stream_189=new RewriteRuleTokenStream(adaptor,"token 189");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        RewriteRuleSubtreeStream stream_unaryExpressionNotPlusMinus=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpressionNotPlusMinus");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 106) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:849:5: ( '+' unaryExpression -> unaryExpression | '-' unaryExpression -> ^( NEG unaryExpression ) | '++' unaryExpression -> ^( PREINC unaryExpression ) | '--' unaryExpression -> ^( PREDEC unaryExpression ) | unaryExpressionNotPlusMinus -> unaryExpressionNotPlusMinus )
            int alt145=5;
            alt145 = dfa145.predict(input);
            switch (alt145) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:849:9: '+' unaryExpression
                    {
                    char_literal479=(Token)match(input,188,FOLLOW_188_in_unaryExpression6216); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_188.add(char_literal479);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression6218);
                    unaryExpression480=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression480.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 849:29: -> unaryExpression
                    {
                        adaptor.addChild(root_0, stream_unaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:850:7: '-' unaryExpression
                    {
                    char_literal481=(Token)match(input,189,FOLLOW_189_in_unaryExpression6230); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_189.add(char_literal481);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression6232);
                    unaryExpression482=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression482.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 850:27: -> ^( NEG unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:850:30: ^( NEG unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEG, "NEG"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:851:9: '++' unaryExpression
                    {
                    string_literal483=(Token)match(input,202,FOLLOW_202_in_unaryExpression6250); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_202.add(string_literal483);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression6252);
                    unaryExpression484=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression484.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 851:30: -> ^( PREINC unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:851:33: ^( PREINC unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PREINC, "PREINC"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:852:9: '--' unaryExpression
                    {
                    string_literal485=(Token)match(input,203,FOLLOW_203_in_unaryExpression6270); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_203.add(string_literal485);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression6272);
                    unaryExpression486=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression486.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 852:30: -> ^( PREDEC unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:852:33: ^( PREDEC unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PREDEC, "PREDEC"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:853:9: unaryExpressionNotPlusMinus
                    {
                    pushFollow(FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression6290);
                    unaryExpressionNotPlusMinus487=unaryExpressionNotPlusMinus();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpressionNotPlusMinus.add(unaryExpressionNotPlusMinus487.getTree());


                    // AST REWRITE
                    // elements: unaryExpressionNotPlusMinus
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 853:37: -> unaryExpressionNotPlusMinus
                    {
                        adaptor.addChild(root_0, stream_unaryExpressionNotPlusMinus.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 106, unaryExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "unaryExpression"

    public static class unaryExpressionNotPlusMinus_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpressionNotPlusMinus"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:856:1: unaryExpressionNotPlusMinus : ( '~' unaryExpression -> ^( INV unaryExpression ) | '!' unaryExpression -> ^( NOT unaryExpression ) | castExpression | primary ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary ) );
    public final JavaParser.unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus() throws RecognitionException {
        JavaParser.unaryExpressionNotPlusMinus_return retval = new JavaParser.unaryExpressionNotPlusMinus_return();
        retval.start = input.LT(1);
        int unaryExpressionNotPlusMinus_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal488=null;
        Token char_literal490=null;
        Token string_literal495=null;
        Token string_literal496=null;
        Token string_literal497=null;
        Token string_literal498=null;
        JavaParser.unaryExpression_return unaryExpression489 = null;

        JavaParser.unaryExpression_return unaryExpression491 = null;

        JavaParser.castExpression_return castExpression492 = null;

        JavaParser.primary_return primary493 = null;

        JavaParser.selector_return selector494 = null;


        Object char_literal488_tree=null;
        Object char_literal490_tree=null;
        Object string_literal495_tree=null;
        Object string_literal496_tree=null;
        Object string_literal497_tree=null;
        Object string_literal498_tree=null;
        RewriteRuleTokenStream stream_202=new RewriteRuleTokenStream(adaptor,"token 202");
        RewriteRuleTokenStream stream_203=new RewriteRuleTokenStream(adaptor,"token 203");
        RewriteRuleTokenStream stream_204=new RewriteRuleTokenStream(adaptor,"token 204");
        RewriteRuleTokenStream stream_205=new RewriteRuleTokenStream(adaptor,"token 205");
        RewriteRuleSubtreeStream stream_selector=new RewriteRuleSubtreeStream(adaptor,"rule selector");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        RewriteRuleSubtreeStream stream_primary=new RewriteRuleSubtreeStream(adaptor,"rule primary");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 107) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:857:5: ( '~' unaryExpression -> ^( INV unaryExpression ) | '!' unaryExpression -> ^( NOT unaryExpression ) | castExpression | primary ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary ) )
            int alt149=4;
            alt149 = dfa149.predict(input);
            switch (alt149) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:857:9: '~' unaryExpression
                    {
                    char_literal488=(Token)match(input,204,FOLLOW_204_in_unaryExpressionNotPlusMinus6321); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_204.add(char_literal488);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus6323);
                    unaryExpression489=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression489.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 857:29: -> ^( INV unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:857:32: ^( INV unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INV, "INV"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:858:8: '!' unaryExpression
                    {
                    char_literal490=(Token)match(input,205,FOLLOW_205_in_unaryExpressionNotPlusMinus6340); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_205.add(char_literal490);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus6342);
                    unaryExpression491=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression491.getTree());


                    // AST REWRITE
                    // elements: unaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 858:28: -> ^( NOT unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:858:31: ^( NOT unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NOT, "NOT"), root_1);

                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:859:9: castExpression
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_castExpression_in_unaryExpressionNotPlusMinus6360);
                    castExpression492=castExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, castExpression492.getTree());

                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:860:6: primary ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary )
                    {
                    pushFollow(FOLLOW_primary_in_unaryExpressionNotPlusMinus6367);
                    primary493=primary();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primary.add(primary493.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:861:3: ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary )
                    int alt148=4;
                    alt148 = dfa148.predict(input);
                    switch (alt148) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:862:4: ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) )
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:862:4: ( selector )+
                            int cnt146=0;
                            loop146:
                            do {
                                int alt146=2;
                                alt146 = dfa146.predict(input);
                                switch (alt146) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: selector
                            	    {
                            	    pushFollow(FOLLOW_selector_in_unaryExpressionNotPlusMinus6377);
                            	    selector494=selector();

                            	    state._fsp--;
                            	    if (state.failed) return retval;
                            	    if ( state.backtracking==0 ) stream_selector.add(selector494.getTree());

                            	    }
                            	    break;

                            	default :
                            	    if ( cnt146 >= 1 ) break loop146;
                            	    if (state.backtracking>0) {state.failed=true; return retval;}
                                        EarlyExitException eee =
                                            new EarlyExitException(146, input);
                                        throw eee;
                                }
                                cnt146++;
                            } while (true);

                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:863:4: ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) )
                            int alt147=3;
                            alt147 = dfa147.predict(input);
                            switch (alt147) {
                                case 1 :
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:864:5: '++'
                                    {
                                    string_literal495=(Token)match(input,202,FOLLOW_202_in_unaryExpressionNotPlusMinus6390); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_202.add(string_literal495);



                                    // AST REWRITE
                                    // elements: selector, primary
                                    // token labels: 
                                    // rule labels: retval
                                    // token list labels: 
                                    // rule list labels: 
                                    // wildcard labels: 
                                    if ( state.backtracking==0 ) {
                                    retval.tree = root_0;
                                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                                    root_0 = (Object)adaptor.nil();
                                    // 864:10: -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) )
                                    {
                                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:864:13: ^( POSTINC ^( SELECTOR primary ( selector )+ ) )
                                        {
                                        Object root_1 = (Object)adaptor.nil();
                                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(POSTINC, "POSTINC"), root_1);

                                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:864:23: ^( SELECTOR primary ( selector )+ )
                                        {
                                        Object root_2 = (Object)adaptor.nil();
                                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(SELECTOR, "SELECTOR"), root_2);

                                        adaptor.addChild(root_2, stream_primary.nextTree());
                                        if ( !(stream_selector.hasNext()) ) {
                                            throw new RewriteEarlyExitException();
                                        }
                                        while ( stream_selector.hasNext() ) {
                                            adaptor.addChild(root_2, stream_selector.nextTree());

                                        }
                                        stream_selector.reset();

                                        adaptor.addChild(root_1, root_2);
                                        }

                                        adaptor.addChild(root_0, root_1);
                                        }

                                    }

                                    retval.tree = root_0;}
                                    }
                                    break;
                                case 2 :
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:865:6: '--'
                                    {
                                    string_literal496=(Token)match(input,203,FOLLOW_203_in_unaryExpressionNotPlusMinus6412); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_203.add(string_literal496);



                                    // AST REWRITE
                                    // elements: primary, selector
                                    // token labels: 
                                    // rule labels: retval
                                    // token list labels: 
                                    // rule list labels: 
                                    // wildcard labels: 
                                    if ( state.backtracking==0 ) {
                                    retval.tree = root_0;
                                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                                    root_0 = (Object)adaptor.nil();
                                    // 865:11: -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) )
                                    {
                                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:865:14: ^( POSTDEC ^( SELECTOR primary ( selector )+ ) )
                                        {
                                        Object root_1 = (Object)adaptor.nil();
                                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(POSTDEC, "POSTDEC"), root_1);

                                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:865:24: ^( SELECTOR primary ( selector )+ )
                                        {
                                        Object root_2 = (Object)adaptor.nil();
                                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(SELECTOR, "SELECTOR"), root_2);

                                        adaptor.addChild(root_2, stream_primary.nextTree());
                                        if ( !(stream_selector.hasNext()) ) {
                                            throw new RewriteEarlyExitException();
                                        }
                                        while ( stream_selector.hasNext() ) {
                                            adaptor.addChild(root_2, stream_selector.nextTree());

                                        }
                                        stream_selector.reset();

                                        adaptor.addChild(root_1, root_2);
                                        }

                                        adaptor.addChild(root_0, root_1);
                                        }

                                    }

                                    retval.tree = root_0;}
                                    }
                                    break;
                                case 3 :
                                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:866:7: 
                                    {

                                    // AST REWRITE
                                    // elements: primary, selector
                                    // token labels: 
                                    // rule labels: retval
                                    // token list labels: 
                                    // rule list labels: 
                                    // wildcard labels: 
                                    if ( state.backtracking==0 ) {
                                    retval.tree = root_0;
                                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                                    root_0 = (Object)adaptor.nil();
                                    // 866:7: -> ^( SELECTOR primary ( selector )+ )
                                    {
                                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:866:10: ^( SELECTOR primary ( selector )+ )
                                        {
                                        Object root_1 = (Object)adaptor.nil();
                                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(SELECTOR, "SELECTOR"), root_1);

                                        adaptor.addChild(root_1, stream_primary.nextTree());
                                        if ( !(stream_selector.hasNext()) ) {
                                            throw new RewriteEarlyExitException();
                                        }
                                        while ( stream_selector.hasNext() ) {
                                            adaptor.addChild(root_1, stream_selector.nextTree());

                                        }
                                        stream_selector.reset();

                                        adaptor.addChild(root_0, root_1);
                                        }

                                    }

                                    retval.tree = root_0;}
                                    }
                                    break;

                            }


                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:868:6: '++'
                            {
                            string_literal497=(Token)match(input,202,FOLLOW_202_in_unaryExpressionNotPlusMinus6456); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_202.add(string_literal497);



                            // AST REWRITE
                            // elements: primary
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 868:11: -> ^( POSTINC primary )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:868:14: ^( POSTINC primary )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(POSTINC, "POSTINC"), root_1);

                                adaptor.addChild(root_1, stream_primary.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 3 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:869:6: '--'
                            {
                            string_literal498=(Token)match(input,203,FOLLOW_203_in_unaryExpressionNotPlusMinus6471); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_203.add(string_literal498);



                            // AST REWRITE
                            // elements: primary
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 869:11: -> ^( POSTDEC primary )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:869:14: ^( POSTDEC primary )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(POSTDEC, "POSTDEC"), root_1);

                                adaptor.addChild(root_1, stream_primary.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 4 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:870:6: 
                            {

                            // AST REWRITE
                            // elements: primary
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 870:6: -> primary
                            {
                                adaptor.addChild(root_0, stream_primary.nextTree());

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 107, unaryExpressionNotPlusMinus_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "unaryExpressionNotPlusMinus"

    public static class castExpression_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castExpression"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:874:1: castExpression : ( '(' primitiveType ')' unaryExpression -> ^( CAST ^( TYPE primitiveType ) unaryExpression ) | '(' type ')' unaryExpressionNotPlusMinus -> ^( CAST type unaryExpressionNotPlusMinus ) | '(' expression ')' unaryExpressionNotPlusMinus ->);
    public final JavaParser.castExpression_return castExpression() throws RecognitionException {
        JavaParser.castExpression_return retval = new JavaParser.castExpression_return();
        retval.start = input.LT(1);
        int castExpression_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal499=null;
        Token char_literal501=null;
        Token char_literal503=null;
        Token char_literal505=null;
        Token char_literal507=null;
        Token char_literal509=null;
        JavaParser.primitiveType_return primitiveType500 = null;

        JavaParser.unaryExpression_return unaryExpression502 = null;

        JavaParser.type_return type504 = null;

        JavaParser.unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus506 = null;

        JavaParser.expression_return expression508 = null;

        JavaParser.unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus510 = null;


        Object char_literal499_tree=null;
        Object char_literal501_tree=null;
        Object char_literal503_tree=null;
        Object char_literal505_tree=null;
        Object char_literal507_tree=null;
        Object char_literal509_tree=null;
        RewriteRuleTokenStream stream_164=new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_165=new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_primitiveType=new RewriteRuleSubtreeStream(adaptor,"rule primitiveType");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        RewriteRuleSubtreeStream stream_unaryExpressionNotPlusMinus=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpressionNotPlusMinus");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 108) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:5: ( '(' primitiveType ')' unaryExpression -> ^( CAST ^( TYPE primitiveType ) unaryExpression ) | '(' type ')' unaryExpressionNotPlusMinus -> ^( CAST type unaryExpressionNotPlusMinus ) | '(' expression ')' unaryExpressionNotPlusMinus ->)
            int alt150=3;
            alt150 = dfa150.predict(input);
            switch (alt150) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:8: '(' primitiveType ')' unaryExpression
                    {
                    char_literal499=(Token)match(input,164,FOLLOW_164_in_castExpression6510); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_164.add(char_literal499);

                    pushFollow(FOLLOW_primitiveType_in_castExpression6512);
                    primitiveType500=primitiveType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primitiveType.add(primitiveType500.getTree());
                    char_literal501=(Token)match(input,165,FOLLOW_165_in_castExpression6514); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_165.add(char_literal501);

                    pushFollow(FOLLOW_unaryExpression_in_castExpression6516);
                    unaryExpression502=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression502.getTree());


                    // AST REWRITE
                    // elements: unaryExpression, primitiveType
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 875:46: -> ^( CAST ^( TYPE primitiveType ) unaryExpression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:49: ^( CAST ^( TYPE primitiveType ) unaryExpression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CAST, "CAST"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:56: ^( TYPE primitiveType )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                        adaptor.addChild(root_2, stream_primitiveType.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_unaryExpression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:876:8: '(' type ')' unaryExpressionNotPlusMinus
                    {
                    char_literal503=(Token)match(input,164,FOLLOW_164_in_castExpression6539); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_164.add(char_literal503);

                    pushFollow(FOLLOW_type_in_castExpression6541);
                    type504=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type504.getTree());
                    char_literal505=(Token)match(input,165,FOLLOW_165_in_castExpression6543); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_165.add(char_literal505);

                    pushFollow(FOLLOW_unaryExpressionNotPlusMinus_in_castExpression6545);
                    unaryExpressionNotPlusMinus506=unaryExpressionNotPlusMinus();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpressionNotPlusMinus.add(unaryExpressionNotPlusMinus506.getTree());


                    // AST REWRITE
                    // elements: type, unaryExpressionNotPlusMinus
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 876:49: -> ^( CAST type unaryExpressionNotPlusMinus )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:876:52: ^( CAST type unaryExpressionNotPlusMinus )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(CAST, "CAST"), root_1);

                        adaptor.addChild(root_1, stream_type.nextTree());
                        adaptor.addChild(root_1, stream_unaryExpressionNotPlusMinus.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:877:8: '(' expression ')' unaryExpressionNotPlusMinus
                    {
                    char_literal507=(Token)match(input,164,FOLLOW_164_in_castExpression6564); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_164.add(char_literal507);

                    pushFollow(FOLLOW_expression_in_castExpression6566);
                    expression508=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression508.getTree());
                    char_literal509=(Token)match(input,165,FOLLOW_165_in_castExpression6568); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_165.add(char_literal509);

                    pushFollow(FOLLOW_unaryExpressionNotPlusMinus_in_castExpression6570);
                    unaryExpressionNotPlusMinus510=unaryExpressionNotPlusMinus();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpressionNotPlusMinus.add(unaryExpressionNotPlusMinus510.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 877:55: ->
                    {
                        root_0 = null;
                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 108, castExpression_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "castExpression"

    public static class primary_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primary"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:880:1: primary : ( parExpression | nonWildcardTypeArguments explicitGenericInvocationSuffix -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix ) | literal | 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) ) | 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) ) | type '.' 'class' -> ^( GETCLASS type ) | 'void' '.' 'class' -> ^( GETCLASS ^( TYPE VOID ) ) | 'super' ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) ) | Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) ) );
    public final JavaParser.primary_return primary() throws RecognitionException {
        JavaParser.primary_return retval = new JavaParser.primary_return();
        retval.start = input.LT(1);
        int primary_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal515=null;
        Token char_literal518=null;
        Token char_literal520=null;
        Token char_literal521=null;
        Token char_literal522=null;
        Token char_literal523=null;
        Token char_literal524=null;
        Token string_literal526=null;
        Token char_literal529=null;
        Token char_literal530=null;
        Token char_literal532=null;
        Token char_literal533=null;
        Token char_literal534=null;
        Token char_literal535=null;
        Token char_literal536=null;
        Token char_literal540=null;
        Token string_literal541=null;
        Token string_literal542=null;
        Token char_literal543=null;
        Token string_literal544=null;
        Token string_literal545=null;
        Token Identifier547=null;
        List list_i=null;
        JavaParser.parExpression_return parExpression511 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments512 = null;

        JavaParser.explicitGenericInvocationSuffix_return explicitGenericInvocationSuffix513 = null;

        JavaParser.literal_return literal514 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments516 = null;

        JavaParser.primitiveType_return primitiveType517 = null;

        JavaParser.expression_return expression519 = null;

        JavaParser.arrayInitializer_return arrayInitializer525 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments527 = null;

        JavaParser.uniMod_return uniMod528 = null;

        JavaParser.expression_return expression531 = null;

        JavaParser.arrayInitializer_return arrayInitializer537 = null;

        JavaParser.classCreatorRest_return classCreatorRest538 = null;

        JavaParser.type_return type539 = null;

        JavaParser.arguments_return arguments546 = null;

        JavaParser.arguments_return arguments548 = null;

        RuleReturnScope i = null;
        Object string_literal515_tree=null;
        Object char_literal518_tree=null;
        Object char_literal520_tree=null;
        Object char_literal521_tree=null;
        Object char_literal522_tree=null;
        Object char_literal523_tree=null;
        Object char_literal524_tree=null;
        Object string_literal526_tree=null;
        Object char_literal529_tree=null;
        Object char_literal530_tree=null;
        Object char_literal532_tree=null;
        Object char_literal533_tree=null;
        Object char_literal534_tree=null;
        Object char_literal535_tree=null;
        Object char_literal536_tree=null;
        Object char_literal540_tree=null;
        Object string_literal541_tree=null;
        Object string_literal542_tree=null;
        Object char_literal543_tree=null;
        Object string_literal544_tree=null;
        Object string_literal545_tree=null;
        Object Identifier547_tree=null;
        RewriteRuleTokenStream stream_126=new RewriteRuleTokenStream(adaptor,"token 126");
        RewriteRuleTokenStream stream_163=new RewriteRuleTokenStream(adaptor,"token 163");
        RewriteRuleTokenStream stream_138=new RewriteRuleTokenStream(adaptor,"token 138");
        RewriteRuleTokenStream stream_139=new RewriteRuleTokenStream(adaptor,"token 139");
        RewriteRuleTokenStream stream_136=new RewriteRuleTokenStream(adaptor,"token 136");
        RewriteRuleTokenStream stream_124=new RewriteRuleTokenStream(adaptor,"token 124");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleTokenStream stream_206=new RewriteRuleTokenStream(adaptor,"token 206");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        RewriteRuleSubtreeStream stream_refComponent=new RewriteRuleSubtreeStream(adaptor,"rule refComponent");
        RewriteRuleSubtreeStream stream_arrayInitializer=new RewriteRuleSubtreeStream(adaptor,"rule arrayInitializer");
        RewriteRuleSubtreeStream stream_primitiveType=new RewriteRuleSubtreeStream(adaptor,"rule primitiveType");
        RewriteRuleSubtreeStream stream_nonWildcardTypeArguments=new RewriteRuleSubtreeStream(adaptor,"rule nonWildcardTypeArguments");
        RewriteRuleSubtreeStream stream_uniMod=new RewriteRuleSubtreeStream(adaptor,"rule uniMod");
        RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_classCreatorRest=new RewriteRuleSubtreeStream(adaptor,"rule classCreatorRest");
        RewriteRuleSubtreeStream stream_explicitGenericInvocationSuffix=new RewriteRuleSubtreeStream(adaptor,"rule explicitGenericInvocationSuffix");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 109) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:881:5: ( parExpression | nonWildcardTypeArguments explicitGenericInvocationSuffix -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix ) | literal | 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) ) | 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) ) | type '.' 'class' -> ^( GETCLASS type ) | 'void' '.' 'class' -> ^( GETCLASS ^( TYPE VOID ) ) | 'super' ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) ) | Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) ) )
            int alt165=9;
            alt165 = dfa165.predict(input);
            switch (alt165) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:881:7: parExpression
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_parExpression_in_primary6590);
                    parExpression511=parExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, parExpression511.getTree());

                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:882:6: nonWildcardTypeArguments explicitGenericInvocationSuffix
                    {
                    pushFollow(FOLLOW_nonWildcardTypeArguments_in_primary6597);
                    nonWildcardTypeArguments512=nonWildcardTypeArguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_nonWildcardTypeArguments.add(nonWildcardTypeArguments512.getTree());
                    pushFollow(FOLLOW_explicitGenericInvocationSuffix_in_primary6599);
                    explicitGenericInvocationSuffix513=explicitGenericInvocationSuffix();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_explicitGenericInvocationSuffix.add(explicitGenericInvocationSuffix513.getTree());


                    // AST REWRITE
                    // elements: nonWildcardTypeArguments, explicitGenericInvocationSuffix
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 882:63: -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:882:66: ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:882:75: ^( TYPE_PARAMETER nonWildcardTypeArguments )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETER, "TYPE_PARAMETER"), root_2);

                        adaptor.addChild(root_2, stream_nonWildcardTypeArguments.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_explicitGenericInvocationSuffix.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:883:9: literal
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_literal_in_primary6623);
                    literal514=literal();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, literal514.getTree());

                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:884:9: 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) )
                    {
                    string_literal515=(Token)match(input,206,FOLLOW_206_in_primary6633); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_206.add(string_literal515);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:884:15: ( nonWildcardTypeArguments )?
                    int alt151=2;
                    int LA151_0 = input.LA(1);

                    if ( (LA151_0==129) ) {
                        alt151=1;
                    }
                    switch (alt151) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: nonWildcardTypeArguments
                            {
                            pushFollow(FOLLOW_nonWildcardTypeArguments_in_primary6635);
                            nonWildcardTypeArguments516=nonWildcardTypeArguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nonWildcardTypeArguments.add(nonWildcardTypeArguments516.getTree());

                            }
                            break;

                    }

                    pushFollow(FOLLOW_primitiveType_in_primary6638);
                    primitiveType517=primitiveType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primitiveType.add(primitiveType517.getTree());
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:885:6: ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) )
                    int alt155=2;
                    alt155 = dfa155.predict(input);
                    switch (alt155) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:7: ( '[' expression ']' )+ ( '[' ']' )*
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:7: ( '[' expression ']' )+
                            int cnt152=0;
                            loop152:
                            do {
                                int alt152=2;
                                alt152 = dfa152.predict(input);
                                switch (alt152) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:8: '[' expression ']'
                            	    {
                            	    char_literal518=(Token)match(input,138,FOLLOW_138_in_primary6654); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal518);

                            	    pushFollow(FOLLOW_expression_in_primary6656);
                            	    expression519=expression();

                            	    state._fsp--;
                            	    if (state.failed) return retval;
                            	    if ( state.backtracking==0 ) stream_expression.add(expression519.getTree());
                            	    char_literal520=(Token)match(input,139,FOLLOW_139_in_primary6658); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal520);


                            	    }
                            	    break;

                            	default :
                            	    if ( cnt152 >= 1 ) break loop152;
                            	    if (state.backtracking>0) {state.failed=true; return retval;}
                                        EarlyExitException eee =
                                            new EarlyExitException(152, input);
                                        throw eee;
                                }
                                cnt152++;
                            } while (true);

                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:29: ( '[' ']' )*
                            loop153:
                            do {
                                int alt153=2;
                                alt153 = dfa153.predict(input);
                                switch (alt153) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:30: '[' ']'
                            	    {
                            	    char_literal521=(Token)match(input,138,FOLLOW_138_in_primary6663); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal521);

                            	    char_literal522=(Token)match(input,139,FOLLOW_139_in_primary6665); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal522);


                            	    }
                            	    break;

                            	default :
                            	    break loop153;
                                }
                            } while (true);



                            // AST REWRITE
                            // elements: primitiveType, expression, 138
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 886:40: -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:43: ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEW, "NEW"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:49: ^( TYPE primitiveType ( '[' )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                adaptor.addChild(root_2, stream_primitiveType.nextTree());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:70: ( '[' )*
                                while ( stream_138.hasNext() ) {
                                    adaptor.addChild(root_2, stream_138.nextNode());

                                }
                                stream_138.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:76: ( expression )*
                                while ( stream_expression.hasNext() ) {
                                    adaptor.addChild(root_1, stream_expression.nextTree());

                                }
                                stream_expression.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:9: ( '[' ']' )+ arrayInitializer
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:9: ( '[' ']' )+
                            int cnt154=0;
                            loop154:
                            do {
                                int alt154=2;
                                int LA154_0 = input.LA(1);

                                if ( (LA154_0==138) ) {
                                    alt154=1;
                                }


                                switch (alt154) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:10: '[' ']'
                            	    {
                            	    char_literal523=(Token)match(input,138,FOLLOW_138_in_primary6696); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal523);

                            	    char_literal524=(Token)match(input,139,FOLLOW_139_in_primary6698); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal524);


                            	    }
                            	    break;

                            	default :
                            	    if ( cnt154 >= 1 ) break loop154;
                            	    if (state.backtracking>0) {state.failed=true; return retval;}
                                        EarlyExitException eee =
                                            new EarlyExitException(154, input);
                                        throw eee;
                                }
                                cnt154++;
                            } while (true);

                            pushFollow(FOLLOW_arrayInitializer_in_primary6702);
                            arrayInitializer525=arrayInitializer();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_arrayInitializer.add(arrayInitializer525.getTree());


                            // AST REWRITE
                            // elements: primitiveType, 138, arrayInitializer
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 887:37: -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:40: ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ARRAYINIT, "ARRAYINIT"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:52: ^( TYPE primitiveType ( '[' )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                adaptor.addChild(root_2, stream_primitiveType.nextTree());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:73: ( '[' )*
                                while ( stream_138.hasNext() ) {
                                    adaptor.addChild(root_2, stream_138.nextNode());

                                }
                                stream_138.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_arrayInitializer.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:9: 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) )
                    {
                    string_literal526=(Token)match(input,206,FOLLOW_206_in_primary6734); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_206.add(string_literal526);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:15: ( nonWildcardTypeArguments )?
                    int alt156=2;
                    int LA156_0 = input.LA(1);

                    if ( (LA156_0==129) ) {
                        alt156=1;
                    }
                    switch (alt156) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: nonWildcardTypeArguments
                            {
                            pushFollow(FOLLOW_nonWildcardTypeArguments_in_primary6736);
                            nonWildcardTypeArguments527=nonWildcardTypeArguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nonWildcardTypeArguments.add(nonWildcardTypeArguments527.getTree());

                            }
                            break;

                    }

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:41: ( uniMod )?
                    int alt157=2;
                    int LA157_0 = input.LA(1);

                    if ( ((LA157_0>=151 && LA157_0<=153)) ) {
                        alt157=1;
                    }
                    switch (alt157) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: uniMod
                            {
                            pushFollow(FOLLOW_uniMod_in_primary6739);
                            uniMod528=uniMod();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_uniMod.add(uniMod528.getTree());

                            }
                            break;

                    }

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:49: (i+= refComponent ( '.' i+= refComponent )* )
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:50: i+= refComponent ( '.' i+= refComponent )*
                    {
                    pushFollow(FOLLOW_refComponent_in_primary6745);
                    i=refComponent();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_refComponent.add(i.getTree());
                    if (list_i==null) list_i=new ArrayList();
                    list_i.add(i.getTree());

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:66: ( '.' i+= refComponent )*
                    loop158:
                    do {
                        int alt158=2;
                        int LA158_0 = input.LA(1);

                        if ( (LA158_0==124) ) {
                            alt158=1;
                        }


                        switch (alt158) {
                    	case 1 :
                    	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:67: '.' i+= refComponent
                    	    {
                    	    char_literal529=(Token)match(input,124,FOLLOW_124_in_primary6748); if (state.failed) return retval; 
                    	    if ( state.backtracking==0 ) stream_124.add(char_literal529);

                    	    pushFollow(FOLLOW_refComponent_in_primary6752);
                    	    i=refComponent();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_refComponent.add(i.getTree());
                    	    if (list_i==null) list_i=new ArrayList();
                    	    list_i.add(i.getTree());


                    	    }
                    	    break;

                    	default :
                    	    break loop158;
                        }
                    } while (true);


                    }

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:890:6: ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) )
                    int alt162=3;
                    alt162 = dfa162.predict(input);
                    switch (alt162) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:7: ( '[' expression ']' )+ ( '[' ']' )*
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:7: ( '[' expression ']' )+
                            int cnt159=0;
                            loop159:
                            do {
                                int alt159=2;
                                alt159 = dfa159.predict(input);
                                switch (alt159) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:8: '[' expression ']'
                            	    {
                            	    char_literal530=(Token)match(input,138,FOLLOW_138_in_primary6771); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal530);

                            	    pushFollow(FOLLOW_expression_in_primary6773);
                            	    expression531=expression();

                            	    state._fsp--;
                            	    if (state.failed) return retval;
                            	    if ( state.backtracking==0 ) stream_expression.add(expression531.getTree());
                            	    char_literal532=(Token)match(input,139,FOLLOW_139_in_primary6775); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal532);


                            	    }
                            	    break;

                            	default :
                            	    if ( cnt159 >= 1 ) break loop159;
                            	    if (state.backtracking>0) {state.failed=true; return retval;}
                                        EarlyExitException eee =
                                            new EarlyExitException(159, input);
                                        throw eee;
                                }
                                cnt159++;
                            } while (true);

                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:29: ( '[' ']' )*
                            loop160:
                            do {
                                int alt160=2;
                                alt160 = dfa160.predict(input);
                                switch (alt160) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:30: '[' ']'
                            	    {
                            	    char_literal533=(Token)match(input,138,FOLLOW_138_in_primary6780); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal533);

                            	    char_literal534=(Token)match(input,139,FOLLOW_139_in_primary6782); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal534);


                            	    }
                            	    break;

                            	default :
                            	    break loop160;
                                }
                            } while (true);



                            // AST REWRITE
                            // elements: i, expression, 138, uniMod
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: i
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                            RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
                            root_0 = (Object)adaptor.nil();
                            // 891:40: -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:43: ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEW, "NEW"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:49: ^( TYPE ( uniMod )? ( $i)+ ( '[' )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:56: ( uniMod )?
                                if ( stream_uniMod.hasNext() ) {
                                    adaptor.addChild(root_2, stream_uniMod.nextTree());

                                }
                                stream_uniMod.reset();
                                if ( !(stream_i.hasNext()) ) {
                                    throw new RewriteEarlyExitException();
                                }
                                while ( stream_i.hasNext() ) {
                                    adaptor.addChild(root_2, stream_i.nextTree());

                                }
                                stream_i.reset();
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:68: ( '[' )*
                                while ( stream_138.hasNext() ) {
                                    adaptor.addChild(root_2, stream_138.nextNode());

                                }
                                stream_138.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:74: ( expression )*
                                while ( stream_expression.hasNext() ) {
                                    adaptor.addChild(root_1, stream_expression.nextTree());

                                }
                                stream_expression.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:9: ( '[' ']' )+ arrayInitializer
                            {
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:9: ( '[' ']' )+
                            int cnt161=0;
                            loop161:
                            do {
                                int alt161=2;
                                int LA161_0 = input.LA(1);

                                if ( (LA161_0==138) ) {
                                    alt161=1;
                                }


                                switch (alt161) {
                            	case 1 :
                            	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:10: '[' ']'
                            	    {
                            	    char_literal535=(Token)match(input,138,FOLLOW_138_in_primary6818); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_138.add(char_literal535);

                            	    char_literal536=(Token)match(input,139,FOLLOW_139_in_primary6820); if (state.failed) return retval; 
                            	    if ( state.backtracking==0 ) stream_139.add(char_literal536);


                            	    }
                            	    break;

                            	default :
                            	    if ( cnt161 >= 1 ) break loop161;
                            	    if (state.backtracking>0) {state.failed=true; return retval;}
                                        EarlyExitException eee =
                                            new EarlyExitException(161, input);
                                        throw eee;
                                }
                                cnt161++;
                            } while (true);

                            pushFollow(FOLLOW_arrayInitializer_in_primary6824);
                            arrayInitializer537=arrayInitializer();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_arrayInitializer.add(arrayInitializer537.getTree());


                            // AST REWRITE
                            // elements: arrayInitializer, i, 138, uniMod
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: i
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                            RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
                            root_0 = (Object)adaptor.nil();
                            // 892:37: -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:40: ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ARRAYINIT, "ARRAYINIT"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:52: ^( TYPE ( uniMod )? ( $i)+ ( '[' )* )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:59: ( uniMod )?
                                if ( stream_uniMod.hasNext() ) {
                                    adaptor.addChild(root_2, stream_uniMod.nextTree());

                                }
                                stream_uniMod.reset();
                                if ( !(stream_i.hasNext()) ) {
                                    throw new RewriteEarlyExitException();
                                }
                                while ( stream_i.hasNext() ) {
                                    adaptor.addChild(root_2, stream_i.nextTree());

                                }
                                stream_i.reset();
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:71: ( '[' )*
                                while ( stream_138.hasNext() ) {
                                    adaptor.addChild(root_2, stream_138.nextNode());

                                }
                                stream_138.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                adaptor.addChild(root_1, stream_arrayInitializer.nextTree());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 3 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:9: classCreatorRest
                            {
                            pushFollow(FOLLOW_classCreatorRest_in_primary6856);
                            classCreatorRest538=classCreatorRest();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_classCreatorRest.add(classCreatorRest538.getTree());


                            // AST REWRITE
                            // elements: classCreatorRest, i, uniMod
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: i
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                            RewriteRuleSubtreeStream stream_i=new RewriteRuleSubtreeStream(adaptor,"token i",list_i);
                            root_0 = (Object)adaptor.nil();
                            // 893:26: -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:29: ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEW, "NEW"), root_1);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:35: ^( TYPE ( uniMod )? ( $i)+ )
                                {
                                Object root_2 = (Object)adaptor.nil();
                                root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:42: ( uniMod )?
                                if ( stream_uniMod.hasNext() ) {
                                    adaptor.addChild(root_2, stream_uniMod.nextTree());

                                }
                                stream_uniMod.reset();
                                if ( !(stream_i.hasNext()) ) {
                                    throw new RewriteEarlyExitException();
                                }
                                while ( stream_i.hasNext() ) {
                                    adaptor.addChild(root_2, stream_i.nextTree());

                                }
                                stream_i.reset();

                                adaptor.addChild(root_1, root_2);
                                }
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:55: ( classCreatorRest )?
                                if ( stream_classCreatorRest.hasNext() ) {
                                    adaptor.addChild(root_1, stream_classCreatorRest.nextTree());

                                }
                                stream_classCreatorRest.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 6 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:895:9: type '.' 'class'
                    {
                    pushFollow(FOLLOW_type_in_primary6891);
                    type539=type();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_type.add(type539.getTree());
                    char_literal540=(Token)match(input,124,FOLLOW_124_in_primary6893); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal540);

                    string_literal541=(Token)match(input,126,FOLLOW_126_in_primary6895); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_126.add(string_literal541);



                    // AST REWRITE
                    // elements: type
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 895:26: -> ^( GETCLASS type )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:895:29: ^( GETCLASS type )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(GETCLASS, "GETCLASS"), root_1);

                        adaptor.addChild(root_1, stream_type.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:896:9: 'void' '.' 'class'
                    {
                    string_literal542=(Token)match(input,136,FOLLOW_136_in_primary6917); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_136.add(string_literal542);

                    char_literal543=(Token)match(input,124,FOLLOW_124_in_primary6919); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal543);

                    string_literal544=(Token)match(input,126,FOLLOW_126_in_primary6921); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_126.add(string_literal544);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 896:28: -> ^( GETCLASS ^( TYPE VOID ) )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:896:31: ^( GETCLASS ^( TYPE VOID ) )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(GETCLASS, "GETCLASS"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:896:42: ^( TYPE VOID )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_2);

                        adaptor.addChild(root_2, (Object)adaptor.create(VOID, "VOID"));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:897:8: 'super' ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) )
                    {
                    string_literal545=(Token)match(input,163,FOLLOW_163_in_primary6942); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_163.add(string_literal545);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:898:3: ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) )
                    int alt163=2;
                    alt163 = dfa163.predict(input);
                    switch (alt163) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:899:4: arguments
                            {
                            pushFollow(FOLLOW_arguments_in_primary6952);
                            arguments546=arguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_arguments.add(arguments546.getTree());


                            // AST REWRITE
                            // elements: 163, arguments
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 899:14: -> ^( INVOKE 'super' ( arguments )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:899:17: ^( INVOKE 'super' ( arguments )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                                adaptor.addChild(root_1, stream_163.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:899:34: ( arguments )?
                                if ( stream_arguments.hasNext() ) {
                                    adaptor.addChild(root_1, stream_arguments.nextTree());

                                }
                                stream_arguments.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:900:6: 
                            {

                            // AST REWRITE
                            // elements: 163
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 900:6: -> ^( VAR 'super' )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:900:9: ^( VAR 'super' )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VAR, "VAR"), root_1);

                                adaptor.addChild(root_1, stream_163.nextNode());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 9 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:902:9: Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) )
                    {
                    Identifier547=(Token)match(input,Identifier,FOLLOW_Identifier_in_primary6990); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier547);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:903:6: ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) )
                    int alt164=2;
                    alt164 = dfa164.predict(input);
                    switch (alt164) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:904:7: arguments
                            {
                            pushFollow(FOLLOW_arguments_in_primary7006);
                            arguments548=arguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_arguments.add(arguments548.getTree());


                            // AST REWRITE
                            // elements: Identifier, arguments
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 904:17: -> ^( INVOKE Identifier ( arguments )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:904:20: ^( INVOKE Identifier ( arguments )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:904:40: ( arguments )?
                                if ( stream_arguments.hasNext() ) {
                                    adaptor.addChild(root_1, stream_arguments.nextTree());

                                }
                                stream_arguments.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:905:9: 
                            {

                            // AST REWRITE
                            // elements: Identifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 905:9: -> ^( VAR Identifier )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:905:12: ^( VAR Identifier )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VAR, "VAR"), root_1);

                                adaptor.addChild(root_1, stream_Identifier.nextNode());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 109, primary_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "primary"

    public static class innerCreator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "innerCreator"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:909:1: innerCreator : Identifier classCreatorRest -> ^( TYPE Identifier ) ( classCreatorRest )? ;
    public final JavaParser.innerCreator_return innerCreator() throws RecognitionException {
        JavaParser.innerCreator_return retval = new JavaParser.innerCreator_return();
        retval.start = input.LT(1);
        int innerCreator_StartIndex = input.index();
        Object root_0 = null;

        Token Identifier549=null;
        JavaParser.classCreatorRest_return classCreatorRest550 = null;


        Object Identifier549_tree=null;
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_classCreatorRest=new RewriteRuleSubtreeStream(adaptor,"rule classCreatorRest");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 110) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:910:2: ( Identifier classCreatorRest -> ^( TYPE Identifier ) ( classCreatorRest )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:910:4: Identifier classCreatorRest
            {
            Identifier549=(Token)match(input,Identifier,FOLLOW_Identifier_in_innerCreator7051); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_Identifier.add(Identifier549);

            pushFollow(FOLLOW_classCreatorRest_in_innerCreator7053);
            classCreatorRest550=classCreatorRest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_classCreatorRest.add(classCreatorRest550.getTree());


            // AST REWRITE
            // elements: classCreatorRest, Identifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 910:32: -> ^( TYPE Identifier ) ( classCreatorRest )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:910:35: ^( TYPE Identifier )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE, "TYPE"), root_1);

                adaptor.addChild(root_1, stream_Identifier.nextNode());

                adaptor.addChild(root_0, root_1);
                }
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:910:54: ( classCreatorRest )?
                if ( stream_classCreatorRest.hasNext() ) {
                    adaptor.addChild(root_0, stream_classCreatorRest.nextTree());

                }
                stream_classCreatorRest.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 110, innerCreator_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "innerCreator"

    public static class classCreatorRest_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classCreatorRest"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:913:1: classCreatorRest : arguments ( classBody )? -> ( arguments )? ( classBody )? ;
    public final JavaParser.classCreatorRest_return classCreatorRest() throws RecognitionException {
        JavaParser.classCreatorRest_return retval = new JavaParser.classCreatorRest_return();
        retval.start = input.LT(1);
        int classCreatorRest_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.arguments_return arguments551 = null;

        JavaParser.classBody_return classBody552 = null;


        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        RewriteRuleSubtreeStream stream_classBody=new RewriteRuleSubtreeStream(adaptor,"rule classBody");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 111) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:914:2: ( arguments ( classBody )? -> ( arguments )? ( classBody )? )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:914:4: arguments ( classBody )?
            {
            pushFollow(FOLLOW_arguments_in_classCreatorRest7075);
            arguments551=arguments();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_arguments.add(arguments551.getTree());
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:914:14: ( classBody )?
            int alt166=2;
            alt166 = dfa166.predict(input);
            switch (alt166) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: classBody
                    {
                    pushFollow(FOLLOW_classBody_in_classCreatorRest7077);
                    classBody552=classBody();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_classBody.add(classBody552.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: arguments, classBody
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 914:25: -> ( arguments )? ( classBody )?
            {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:914:28: ( arguments )?
                if ( stream_arguments.hasNext() ) {
                    adaptor.addChild(root_0, stream_arguments.nextTree());

                }
                stream_arguments.reset();
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:914:39: ( classBody )?
                if ( stream_classBody.hasNext() ) {
                    adaptor.addChild(root_0, stream_classBody.nextTree());

                }
                stream_classBody.reset();

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 111, classCreatorRest_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "classCreatorRest"

    public static class explicitGenericInvocation_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "explicitGenericInvocation"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:917:1: explicitGenericInvocation : nonWildcardTypeArguments explicitGenericInvocationSuffix ;
    public final JavaParser.explicitGenericInvocation_return explicitGenericInvocation() throws RecognitionException {
        JavaParser.explicitGenericInvocation_return retval = new JavaParser.explicitGenericInvocation_return();
        retval.start = input.LT(1);
        int explicitGenericInvocation_StartIndex = input.index();
        Object root_0 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments553 = null;

        JavaParser.explicitGenericInvocationSuffix_return explicitGenericInvocationSuffix554 = null;



        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 112) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:918:2: ( nonWildcardTypeArguments explicitGenericInvocationSuffix )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:918:4: nonWildcardTypeArguments explicitGenericInvocationSuffix
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_nonWildcardTypeArguments_in_explicitGenericInvocation7098);
            nonWildcardTypeArguments553=nonWildcardTypeArguments();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, nonWildcardTypeArguments553.getTree());
            pushFollow(FOLLOW_explicitGenericInvocationSuffix_in_explicitGenericInvocation7100);
            explicitGenericInvocationSuffix554=explicitGenericInvocationSuffix();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, explicitGenericInvocationSuffix554.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 112, explicitGenericInvocation_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "explicitGenericInvocation"

    public static class nonWildcardTypeArguments_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nonWildcardTypeArguments"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:921:1: nonWildcardTypeArguments : '<' typeList '>' -> typeList ;
    public final JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments() throws RecognitionException {
        JavaParser.nonWildcardTypeArguments_return retval = new JavaParser.nonWildcardTypeArguments_return();
        retval.start = input.LT(1);
        int nonWildcardTypeArguments_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal555=null;
        Token char_literal557=null;
        JavaParser.typeList_return typeList556 = null;


        Object char_literal555_tree=null;
        Object char_literal557_tree=null;
        RewriteRuleTokenStream stream_131=new RewriteRuleTokenStream(adaptor,"token 131");
        RewriteRuleTokenStream stream_129=new RewriteRuleTokenStream(adaptor,"token 129");
        RewriteRuleSubtreeStream stream_typeList=new RewriteRuleSubtreeStream(adaptor,"rule typeList");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 113) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:922:2: ( '<' typeList '>' -> typeList )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:922:4: '<' typeList '>'
            {
            char_literal555=(Token)match(input,129,FOLLOW_129_in_nonWildcardTypeArguments7112); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_129.add(char_literal555);

            pushFollow(FOLLOW_typeList_in_nonWildcardTypeArguments7114);
            typeList556=typeList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_typeList.add(typeList556.getTree());
            char_literal557=(Token)match(input,131,FOLLOW_131_in_nonWildcardTypeArguments7116); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_131.add(char_literal557);



            // AST REWRITE
            // elements: typeList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 922:21: -> typeList
            {
                adaptor.addChild(root_0, stream_typeList.nextTree());

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 113, nonWildcardTypeArguments_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "nonWildcardTypeArguments"

    public static class explicitGenericInvocationSuffix_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "explicitGenericInvocationSuffix"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:925:1: explicitGenericInvocationSuffix : ( 'super' superSuffix -> 'super' ( superSuffix )? | Identifier arguments -> Identifier ( arguments )? );
    public final JavaParser.explicitGenericInvocationSuffix_return explicitGenericInvocationSuffix() throws RecognitionException {
        JavaParser.explicitGenericInvocationSuffix_return retval = new JavaParser.explicitGenericInvocationSuffix_return();
        retval.start = input.LT(1);
        int explicitGenericInvocationSuffix_StartIndex = input.index();
        Object root_0 = null;

        Token string_literal558=null;
        Token Identifier560=null;
        JavaParser.superSuffix_return superSuffix559 = null;

        JavaParser.arguments_return arguments561 = null;


        Object string_literal558_tree=null;
        Object Identifier560_tree=null;
        RewriteRuleTokenStream stream_163=new RewriteRuleTokenStream(adaptor,"token 163");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        RewriteRuleSubtreeStream stream_superSuffix=new RewriteRuleSubtreeStream(adaptor,"rule superSuffix");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 114) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:926:2: ( 'super' superSuffix -> 'super' ( superSuffix )? | Identifier arguments -> Identifier ( arguments )? )
            int alt167=2;
            int LA167_0 = input.LA(1);

            if ( (LA167_0==163) ) {
                alt167=1;
            }
            else if ( (LA167_0==Identifier) ) {
                alt167=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 167, 0, input);

                throw nvae;
            }
            switch (alt167) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:926:4: 'super' superSuffix
                    {
                    string_literal558=(Token)match(input,163,FOLLOW_163_in_explicitGenericInvocationSuffix7132); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_163.add(string_literal558);

                    pushFollow(FOLLOW_superSuffix_in_explicitGenericInvocationSuffix7134);
                    superSuffix559=superSuffix();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_superSuffix.add(superSuffix559.getTree());


                    // AST REWRITE
                    // elements: superSuffix, 163
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 926:24: -> 'super' ( superSuffix )?
                    {
                        adaptor.addChild(root_0, stream_163.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:926:35: ( superSuffix )?
                        if ( stream_superSuffix.hasNext() ) {
                            adaptor.addChild(root_0, stream_superSuffix.nextTree());

                        }
                        stream_superSuffix.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:927:6: Identifier arguments
                    {
                    Identifier560=(Token)match(input,Identifier,FOLLOW_Identifier_in_explicitGenericInvocationSuffix7148); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier560);

                    pushFollow(FOLLOW_arguments_in_explicitGenericInvocationSuffix7150);
                    arguments561=arguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_arguments.add(arguments561.getTree());


                    // AST REWRITE
                    // elements: arguments, Identifier
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 927:27: -> Identifier ( arguments )?
                    {
                        adaptor.addChild(root_0, stream_Identifier.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:927:41: ( arguments )?
                        if ( stream_arguments.hasNext() ) {
                            adaptor.addChild(root_0, stream_arguments.nextTree());

                        }
                        stream_arguments.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 114, explicitGenericInvocationSuffix_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "explicitGenericInvocationSuffix"

    public static class superSuffix_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "superSuffix"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:930:1: superSuffix : ( arguments -> ( arguments )? | '.' Identifier ( arguments )? );
    public final JavaParser.superSuffix_return superSuffix() throws RecognitionException {
        JavaParser.superSuffix_return retval = new JavaParser.superSuffix_return();
        retval.start = input.LT(1);
        int superSuffix_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal563=null;
        Token Identifier564=null;
        JavaParser.arguments_return arguments562 = null;

        JavaParser.arguments_return arguments565 = null;


        Object char_literal563_tree=null;
        Object Identifier564_tree=null;
        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 115) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:931:2: ( arguments -> ( arguments )? | '.' Identifier ( arguments )? )
            int alt169=2;
            int LA169_0 = input.LA(1);

            if ( (LA169_0==164) ) {
                alt169=1;
            }
            else if ( (LA169_0==124) ) {
                alt169=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 169, 0, input);

                throw nvae;
            }
            switch (alt169) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:931:4: arguments
                    {
                    pushFollow(FOLLOW_arguments_in_superSuffix7169);
                    arguments562=arguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_arguments.add(arguments562.getTree());


                    // AST REWRITE
                    // elements: arguments
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 931:14: -> ( arguments )?
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:931:17: ( arguments )?
                        if ( stream_arguments.hasNext() ) {
                            adaptor.addChild(root_0, stream_arguments.nextTree());

                        }
                        stream_arguments.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:932:6: '.' Identifier ( arguments )?
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal563=(Token)match(input,124,FOLLOW_124_in_superSuffix7181); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    char_literal563_tree = (Object)adaptor.create(char_literal563);
                    adaptor.addChild(root_0, char_literal563_tree);
                    }
                    Identifier564=(Token)match(input,Identifier,FOLLOW_Identifier_in_superSuffix7183); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    Identifier564_tree = (Object)adaptor.create(Identifier564);
                    adaptor.addChild(root_0, Identifier564_tree);
                    }
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:932:21: ( arguments )?
                    int alt168=2;
                    alt168 = dfa168.predict(input);
                    switch (alt168) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:932:22: arguments
                            {
                            pushFollow(FOLLOW_arguments_in_superSuffix7186);
                            arguments565=arguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) adaptor.addChild(root_0, arguments565.getTree());

                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 115, superSuffix_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "superSuffix"

    public static class selector_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "selector"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:935:1: selector : ( '.' 'super' arguments -> ^( INVOKE 'super' ( arguments )? ) | '.' 'new' ( nonWildcardTypeArguments )? innerCreator -> ^( NEW innerCreator ) | '.' nonWildcardTypeArguments explicitGenericInvocationSuffix -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix ) | '.' Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( DEREF Identifier ) ) | '[' expression ']' -> ^( ARRAYINDEX expression ) );
    public final JavaParser.selector_return selector() throws RecognitionException {
        JavaParser.selector_return retval = new JavaParser.selector_return();
        retval.start = input.LT(1);
        int selector_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal566=null;
        Token string_literal567=null;
        Token char_literal569=null;
        Token string_literal570=null;
        Token char_literal573=null;
        Token char_literal576=null;
        Token Identifier577=null;
        Token char_literal579=null;
        Token char_literal581=null;
        JavaParser.arguments_return arguments568 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments571 = null;

        JavaParser.innerCreator_return innerCreator572 = null;

        JavaParser.nonWildcardTypeArguments_return nonWildcardTypeArguments574 = null;

        JavaParser.explicitGenericInvocationSuffix_return explicitGenericInvocationSuffix575 = null;

        JavaParser.arguments_return arguments578 = null;

        JavaParser.expression_return expression580 = null;


        Object char_literal566_tree=null;
        Object string_literal567_tree=null;
        Object char_literal569_tree=null;
        Object string_literal570_tree=null;
        Object char_literal573_tree=null;
        Object char_literal576_tree=null;
        Object Identifier577_tree=null;
        Object char_literal579_tree=null;
        Object char_literal581_tree=null;
        RewriteRuleTokenStream stream_163=new RewriteRuleTokenStream(adaptor,"token 163");
        RewriteRuleTokenStream stream_138=new RewriteRuleTokenStream(adaptor,"token 138");
        RewriteRuleTokenStream stream_139=new RewriteRuleTokenStream(adaptor,"token 139");
        RewriteRuleTokenStream stream_124=new RewriteRuleTokenStream(adaptor,"token 124");
        RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
        RewriteRuleTokenStream stream_206=new RewriteRuleTokenStream(adaptor,"token 206");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_innerCreator=new RewriteRuleSubtreeStream(adaptor,"rule innerCreator");
        RewriteRuleSubtreeStream stream_arguments=new RewriteRuleSubtreeStream(adaptor,"rule arguments");
        RewriteRuleSubtreeStream stream_nonWildcardTypeArguments=new RewriteRuleSubtreeStream(adaptor,"rule nonWildcardTypeArguments");
        RewriteRuleSubtreeStream stream_explicitGenericInvocationSuffix=new RewriteRuleSubtreeStream(adaptor,"rule explicitGenericInvocationSuffix");
        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 116) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:936:2: ( '.' 'super' arguments -> ^( INVOKE 'super' ( arguments )? ) | '.' 'new' ( nonWildcardTypeArguments )? innerCreator -> ^( NEW innerCreator ) | '.' nonWildcardTypeArguments explicitGenericInvocationSuffix -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix ) | '.' Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( DEREF Identifier ) ) | '[' expression ']' -> ^( ARRAYINDEX expression ) )
            int alt172=5;
            int LA172_0 = input.LA(1);

            if ( (LA172_0==124) ) {
                switch ( input.LA(2) ) {
                case 163:
                    {
                    alt172=1;
                    }
                    break;
                case 206:
                    {
                    alt172=2;
                    }
                    break;
                case Identifier:
                    {
                    alt172=4;
                    }
                    break;
                case 129:
                    {
                    alt172=3;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 172, 1, input);

                    throw nvae;
                }

            }
            else if ( (LA172_0==138) ) {
                alt172=5;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 172, 0, input);

                throw nvae;
            }
            switch (alt172) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:936:4: '.' 'super' arguments
                    {
                    char_literal566=(Token)match(input,124,FOLLOW_124_in_selector7200); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal566);

                    string_literal567=(Token)match(input,163,FOLLOW_163_in_selector7202); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_163.add(string_literal567);

                    pushFollow(FOLLOW_arguments_in_selector7204);
                    arguments568=arguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_arguments.add(arguments568.getTree());


                    // AST REWRITE
                    // elements: 163, arguments
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 936:26: -> ^( INVOKE 'super' ( arguments )? )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:936:29: ^( INVOKE 'super' ( arguments )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                        adaptor.addChild(root_1, stream_163.nextNode());
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:936:46: ( arguments )?
                        if ( stream_arguments.hasNext() ) {
                            adaptor.addChild(root_1, stream_arguments.nextTree());

                        }
                        stream_arguments.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:937:6: '.' 'new' ( nonWildcardTypeArguments )? innerCreator
                    {
                    char_literal569=(Token)match(input,124,FOLLOW_124_in_selector7222); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal569);

                    string_literal570=(Token)match(input,206,FOLLOW_206_in_selector7224); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_206.add(string_literal570);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:937:16: ( nonWildcardTypeArguments )?
                    int alt170=2;
                    int LA170_0 = input.LA(1);

                    if ( (LA170_0==129) ) {
                        alt170=1;
                    }
                    switch (alt170) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:937:17: nonWildcardTypeArguments
                            {
                            pushFollow(FOLLOW_nonWildcardTypeArguments_in_selector7227);
                            nonWildcardTypeArguments571=nonWildcardTypeArguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_nonWildcardTypeArguments.add(nonWildcardTypeArguments571.getTree());

                            }
                            break;

                    }

                    pushFollow(FOLLOW_innerCreator_in_selector7231);
                    innerCreator572=innerCreator();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_innerCreator.add(innerCreator572.getTree());


                    // AST REWRITE
                    // elements: innerCreator
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 937:57: -> ^( NEW innerCreator )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:937:60: ^( NEW innerCreator )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(NEW, "NEW"), root_1);

                        adaptor.addChild(root_1, stream_innerCreator.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:938:5: '.' nonWildcardTypeArguments explicitGenericInvocationSuffix
                    {
                    char_literal573=(Token)match(input,124,FOLLOW_124_in_selector7246); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal573);

                    pushFollow(FOLLOW_nonWildcardTypeArguments_in_selector7248);
                    nonWildcardTypeArguments574=nonWildcardTypeArguments();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_nonWildcardTypeArguments.add(nonWildcardTypeArguments574.getTree());
                    pushFollow(FOLLOW_explicitGenericInvocationSuffix_in_selector7250);
                    explicitGenericInvocationSuffix575=explicitGenericInvocationSuffix();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_explicitGenericInvocationSuffix.add(explicitGenericInvocationSuffix575.getTree());


                    // AST REWRITE
                    // elements: nonWildcardTypeArguments, explicitGenericInvocationSuffix
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 938:66: -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:938:69: ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:938:78: ^( TYPE_PARAMETER nonWildcardTypeArguments )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot((Object)adaptor.create(TYPE_PARAMETER, "TYPE_PARAMETER"), root_2);

                        adaptor.addChild(root_2, stream_nonWildcardTypeArguments.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, stream_explicitGenericInvocationSuffix.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:939:4: '.' Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( DEREF Identifier ) )
                    {
                    char_literal576=(Token)match(input,124,FOLLOW_124_in_selector7269); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_124.add(char_literal576);

                    Identifier577=(Token)match(input,Identifier,FOLLOW_Identifier_in_selector7271); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_Identifier.add(Identifier577);

                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:940:3: ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( DEREF Identifier ) )
                    int alt171=2;
                    alt171 = dfa171.predict(input);
                    switch (alt171) {
                        case 1 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:941:4: arguments
                            {
                            pushFollow(FOLLOW_arguments_in_selector7281);
                            arguments578=arguments();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_arguments.add(arguments578.getTree());


                            // AST REWRITE
                            // elements: Identifier, arguments
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 941:14: -> ^( INVOKE Identifier ( arguments )? )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:941:17: ^( INVOKE Identifier ( arguments )? )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(INVOKE, "INVOKE"), root_1);

                                adaptor.addChild(root_1, stream_Identifier.nextNode());
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:941:37: ( arguments )?
                                if ( stream_arguments.hasNext() ) {
                                    adaptor.addChild(root_1, stream_arguments.nextTree());

                                }
                                stream_arguments.reset();

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;
                        case 2 :
                            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:942:6: 
                            {

                            // AST REWRITE
                            // elements: Identifier
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (Object)adaptor.nil();
                            // 942:6: -> ^( DEREF Identifier )
                            {
                                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:942:9: ^( DEREF Identifier )
                                {
                                Object root_1 = (Object)adaptor.nil();
                                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(DEREF, "DEREF"), root_1);

                                adaptor.addChild(root_1, stream_Identifier.nextNode());

                                adaptor.addChild(root_0, root_1);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    }
                    break;
                case 5 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:944:6: '[' expression ']'
                    {
                    char_literal579=(Token)match(input,138,FOLLOW_138_in_selector7316); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_138.add(char_literal579);

                    pushFollow(FOLLOW_expression_in_selector7318);
                    expression580=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(expression580.getTree());
                    char_literal581=(Token)match(input,139,FOLLOW_139_in_selector7320); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_139.add(char_literal581);



                    // AST REWRITE
                    // elements: expression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 944:25: -> ^( ARRAYINDEX expression )
                    {
                        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:944:28: ^( ARRAYINDEX expression )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ARRAYINDEX, "ARRAYINDEX"), root_1);

                        adaptor.addChild(root_1, stream_expression.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 116, selector_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "selector"

    public static class arguments_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arguments"
    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:947:1: arguments : '(' ( expressionList )? ')' ;
    public final JavaParser.arguments_return arguments() throws RecognitionException {
        JavaParser.arguments_return retval = new JavaParser.arguments_return();
        retval.start = input.LT(1);
        int arguments_StartIndex = input.index();
        Object root_0 = null;

        Token char_literal582=null;
        Token char_literal584=null;
        JavaParser.expressionList_return expressionList583 = null;


        Object char_literal582_tree=null;
        Object char_literal584_tree=null;

        try {
            if ( state.backtracking>0 && alreadyParsedRule(input, 117) ) { return retval; }
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:948:2: ( '(' ( expressionList )? ')' )
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:948:4: '(' ( expressionList )? ')'
            {
            root_0 = (Object)adaptor.nil();

            char_literal582=(Token)match(input,164,FOLLOW_164_in_arguments7339); if (state.failed) return retval;
            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:948:9: ( expressionList )?
            int alt173=2;
            alt173 = dfa173.predict(input);
            switch (alt173) {
                case 1 :
                    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: expressionList
                    {
                    pushFollow(FOLLOW_expressionList_in_arguments7342);
                    expressionList583=expressionList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expressionList583.getTree());

                    }
                    break;

            }

            char_literal584=(Token)match(input,165,FOLLOW_165_in_arguments7345); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
         
         catch(RecognitionException e) {  
          throw new SyntaxError("error on \"" + e.token.getText()+"\"",e.line,e.charPositionInLine,e.token.getText().length());
         } 
        finally {
            if ( state.backtracking>0 ) { memoize(input, 117, arguments_StartIndex); }
        }
        return retval;
    }
    // $ANTLR end "arguments"

    // $ANTLR start synpred1_Java
    public final void synpred1_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:4: ( annotations )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:223:4: annotations
        {
        pushFollow(FOLLOW_annotations_in_synpred1_Java475);
        annotations();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred1_Java

    // $ANTLR start synpred36_Java
    public final void synpred36_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:309:4: ( 'static' block )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:309:4: 'static' block
        {
        match(input,123,FOLLOW_123_in_synpred36_Java1216); if (state.failed) return ;
        pushFollow(FOLLOW_block_in_synpred36_Java1218);
        block();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred36_Java

    // $ANTLR start synpred38_Java
    public final void synpred38_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:310:4: ( ( 'static' )? block )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:310:4: ( 'static' )? block
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:310:4: ( 'static' )?
        int alt176=2;
        int LA176_0 = input.LA(1);

        if ( (LA176_0==123) ) {
            alt176=1;
        }
        switch (alt176) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: 'static'
                {
                match(input,123,FOLLOW_123_in_synpred38_Java1231); if (state.failed) return ;

                }
                break;

        }

        pushFollow(FOLLOW_block_in_synpred38_Java1234);
        block();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred38_Java

    // $ANTLR start synpred41_Java
    public final void synpred41_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:9: ( methodDeclaration )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:313:9: methodDeclaration
        {
        pushFollow(FOLLOW_methodDeclaration_in_synpred41_Java1278);
        methodDeclaration();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred41_Java

    // $ANTLR start synpred42_Java
    public final void synpred42_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:9: ( fieldDeclaration )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:314:9: fieldDeclaration
        {
        pushFollow(FOLLOW_fieldDeclaration_in_synpred42_Java1307);
        fieldDeclaration();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred42_Java

    // $ANTLR start synpred51_Java
    public final void synpred51_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:3: ( constantDeclaration )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:344:3: constantDeclaration
        {
        pushFollow(FOLLOW_constantDeclaration_in_synpred51_Java1658);
        constantDeclaration();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred51_Java

    // $ANTLR start synpred52_Java
    public final void synpred52_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:5: ( type Identifier interfaceMethodDeclaratorRest )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:345:5: type Identifier interfaceMethodDeclaratorRest
        {
        pushFollow(FOLLOW_type_in_synpred52_Java1679);
        type();

        state._fsp--;
        if (state.failed) return ;
        match(input,Identifier,FOLLOW_Identifier_in_synpred52_Java1681); if (state.failed) return ;
        pushFollow(FOLLOW_interfaceMethodDeclaratorRest_in_synpred52_Java1683);
        interfaceMethodDeclaratorRest();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred52_Java

    // $ANTLR start synpred90_Java
    public final void synpred90_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:16: ( '.' Identifier )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:450:16: '.' Identifier
        {
        match(input,124,FOLLOW_124_in_synpred90_Java2666); if (state.failed) return ;
        match(input,Identifier,FOLLOW_Identifier_in_synpred90_Java2668); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred90_Java

    // $ANTLR start synpred111_Java
    public final void synpred111_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:4: ( ( 'extends' type )? )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:4: ( 'extends' type )?
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:4: ( 'extends' type )?
        int alt186=2;
        int LA186_0 = input.LA(1);

        if ( (LA186_0==127) ) {
            alt186=1;
        }
        switch (alt186) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:500:5: 'extends' type
                {
                match(input,127,FOLLOW_127_in_synpred111_Java3001); if (state.failed) return ;
                pushFollow(FOLLOW_type_in_synpred111_Java3003);
                type();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }


        }
    }
    // $ANTLR end synpred111_Java

    // $ANTLR start synpred127_Java
    public final void synpred127_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:552:4: ( annotation )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:552:4: annotation
        {
        pushFollow(FOLLOW_annotation_in_synpred127_Java3447);
        annotation();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred127_Java

    // $ANTLR start synpred137_Java
    public final void synpred137_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:10: ( annotationTypeElementDeclarations )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:587:10: annotationTypeElementDeclarations
        {
        pushFollow(FOLLOW_annotationTypeElementDeclarations_in_synpred137_Java3664);
        annotationTypeElementDeclarations();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred137_Java

    // $ANTLR start synpred151_Java
    public final void synpred151_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:628:4: ( localVariableDeclaration )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:628:4: localVariableDeclaration
        {
        pushFollow(FOLLOW_localVariableDeclaration_in_synpred151_Java3973);
        localVariableDeclaration();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred151_Java

    // $ANTLR start synpred152_Java
    public final void synpred152_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:629:4: ( classOrInterfaceDeclaration )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:629:4: classOrInterfaceDeclaration
        {
        pushFollow(FOLLOW_classOrInterfaceDeclaration_in_synpred152_Java3978);
        classOrInterfaceDeclaration();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred152_Java

    // $ANTLR start synpred157_Java
    public final void synpred157_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:55: ( 'else' statement )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:640:55: 'else' statement
        {
        match(input,175,FOLLOW_175_in_synpred157_Java4091); if (state.failed) return ;
        pushFollow(FOLLOW_statement_in_synpred157_Java4093);
        statement();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred157_Java

    // $ANTLR start synpred162_Java
    public final void synpred162_Java_fragment() throws RecognitionException {   
        Token fc=null;

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:9: ( catches fc= 'finally' block )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:645:9: catches fc= 'finally' block
        {
        pushFollow(FOLLOW_catches_in_synpred162_Java4222);
        catches();

        state._fsp--;
        if (state.failed) return ;
        fc=(Token)match(input,180,FOLLOW_180_in_synpred162_Java4226); if (state.failed) return ;
        pushFollow(FOLLOW_block_in_synpred162_Java4228);
        block();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred162_Java

    // $ANTLR start synpred163_Java
    public final void synpred163_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:646:9: ( catches )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:646:9: catches
        {
        pushFollow(FOLLOW_catches_in_synpred163_Java4256);
        catches();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred163_Java

    // $ANTLR start synpred180_Java
    public final void synpred180_Java_fragment() throws RecognitionException {   
        Token lc=null;

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:681:4: (lc= 'case' constantExpression ':' )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:681:4: lc= 'case' constantExpression ':'
        {
        lc=(Token)match(input,187,FOLLOW_187_in_synpred180_Java4638); if (state.failed) return ;
        pushFollow(FOLLOW_constantExpression_in_synpred180_Java4640);
        constantExpression();

        state._fsp--;
        if (state.failed) return ;
        match(input,173,FOLLOW_173_in_synpred180_Java4642); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred180_Java

    // $ANTLR start synpred181_Java
    public final void synpred181_Java_fragment() throws RecognitionException {   
        Token lc=null;

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:682:4: (lc= 'case' enumConstantName ':' )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:682:4: lc= 'case' enumConstantName ':'
        {
        lc=(Token)match(input,187,FOLLOW_187_in_synpred181_Java4658); if (state.failed) return ;
        pushFollow(FOLLOW_enumConstantName_in_synpred181_Java4660);
        enumConstantName();

        state._fsp--;
        if (state.failed) return ;
        match(input,173,FOLLOW_173_in_synpred181_Java4662); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred181_Java

    // $ANTLR start synpred183_Java
    public final void synpred183_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:692:4: ( forVarControl )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:692:4: forVarControl
        {
        pushFollow(FOLLOW_forVarControl_in_synpred183_Java4722);
        forVarControl();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred183_Java

    // $ANTLR start synpred188_Java
    public final void synpred188_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:4: ( ( variableModifier )* type variableDeclarators )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:4: ( variableModifier )* type variableDeclarators
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:697:4: ( variableModifier )*
        loop200:
        do {
            int alt200=2;
            int LA200_0 = input.LA(1);

            if ( (LA200_0==145||LA200_0==170) ) {
                alt200=1;
            }


            switch (alt200) {
        	case 1 :
        	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: variableModifier
        	    {
        	    pushFollow(FOLLOW_variableModifier_in_synpred188_Java4784);
        	    variableModifier();

        	    state._fsp--;
        	    if (state.failed) return ;

        	    }
        	    break;

        	default :
        	    break loop200;
            }
        } while (true);

        pushFollow(FOLLOW_type_in_synpred188_Java4787);
        type();

        state._fsp--;
        if (state.failed) return ;
        pushFollow(FOLLOW_variableDeclarators_in_synpred188_Java4789);
        variableDeclarators();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred188_Java

    // $ANTLR start synpred191_Java
    public final void synpred191_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:730:4: ( '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:730:4: '=' expression
        {
        match(input,140,FOLLOW_140_in_synpred191_Java4954); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred191_Java4956);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred191_Java

    // $ANTLR start synpred192_Java
    public final void synpred192_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:731:6: ( '+' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:731:6: '+' '=' expression
        {
        match(input,188,FOLLOW_188_in_synpred192_Java4973); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred192_Java4975); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred192_Java4977);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred192_Java

    // $ANTLR start synpred193_Java
    public final void synpred193_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:732:6: ( '-' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:732:6: '-' '=' expression
        {
        match(input,189,FOLLOW_189_in_synpred193_Java4996); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred193_Java4998); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred193_Java5000);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred193_Java

    // $ANTLR start synpred194_Java
    public final void synpred194_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:733:6: ( '*' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:733:6: '*' '=' expression
        {
        match(input,125,FOLLOW_125_in_synpred194_Java5019); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred194_Java5021); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred194_Java5023);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred194_Java

    // $ANTLR start synpred195_Java
    public final void synpred195_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:734:6: ( '/' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:734:6: '/' '=' expression
        {
        match(input,190,FOLLOW_190_in_synpred195_Java5042); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred195_Java5044); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred195_Java5046);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred195_Java

    // $ANTLR start synpred196_Java
    public final void synpred196_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:735:6: ( '&=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:735:6: '&=' expression
        {
        match(input,191,FOLLOW_191_in_synpred196_Java5068); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred196_Java5070);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred196_Java

    // $ANTLR start synpred197_Java
    public final void synpred197_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:736:6: ( '|=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:736:6: '|=' expression
        {
        match(input,192,FOLLOW_192_in_synpred197_Java5089); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred197_Java5091);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred197_Java

    // $ANTLR start synpred198_Java
    public final void synpred198_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:737:6: ( '^=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:737:6: '^=' expression
        {
        match(input,193,FOLLOW_193_in_synpred198_Java5110); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred198_Java5112);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred198_Java

    // $ANTLR start synpred199_Java
    public final void synpred199_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:738:6: ( '%' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:738:6: '%' '=' expression
        {
        match(input,194,FOLLOW_194_in_synpred199_Java5134); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred199_Java5136); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred199_Java5138);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred199_Java

    // $ANTLR start synpred200_Java
    public final void synpred200_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:739:6: ( '<' '<' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:739:6: '<' '<' '=' expression
        {
        match(input,129,FOLLOW_129_in_synpred200_Java5157); if (state.failed) return ;
        match(input,129,FOLLOW_129_in_synpred200_Java5159); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred200_Java5161); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred200_Java5163);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred200_Java

    // $ANTLR start synpred201_Java
    public final void synpred201_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:740:6: ( '>' '>' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:740:6: '>' '>' '=' expression
        {
        match(input,131,FOLLOW_131_in_synpred201_Java5182); if (state.failed) return ;
        match(input,131,FOLLOW_131_in_synpred201_Java5184); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred201_Java5186); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred201_Java5188);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred201_Java

    // $ANTLR start synpred202_Java
    public final void synpred202_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:741:6: ( '>' '>' '>' '=' expression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:741:6: '>' '>' '>' '=' expression
        {
        match(input,131,FOLLOW_131_in_synpred202_Java5207); if (state.failed) return ;
        match(input,131,FOLLOW_131_in_synpred202_Java5209); if (state.failed) return ;
        match(input,131,FOLLOW_131_in_synpred202_Java5211); if (state.failed) return ;
        match(input,140,FOLLOW_140_in_synpred202_Java5213); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred202_Java5215);
        expression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred202_Java

    // $ANTLR start synpred213_Java
    public final void synpred213_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:8: ( ( '<' shiftExpression ) )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:8: ( '<' shiftExpression )
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:8: ( '<' shiftExpression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:815:9: '<' shiftExpression
        {
        match(input,129,FOLLOW_129_in_synpred213_Java5848); if (state.failed) return ;
        pushFollow(FOLLOW_shiftExpression_in_synpred213_Java5850);
        shiftExpression();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred213_Java

    // $ANTLR start synpred217_Java
    public final void synpred217_Java_fragment() throws RecognitionException {   
        Token i=null;
        List list_i=null;

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' ) additiveExpression
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' )
        int alt201=2;
        int LA201_0 = input.LA(1);

        if ( (LA201_0==129) ) {
            alt201=1;
        }
        else if ( (LA201_0==131) ) {
            alt201=2;
        }
        else {
            if (state.backtracking>0) {state.failed=true; return ;}
            NoViableAltException nvae =
                new NoViableAltException("", 201, 0, input);

            throw nvae;
        }
        switch (alt201) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:8: i+= '<' '<'
                {
                i=(Token)match(input,129,FOLLOW_129_in_synpred217_Java5962); if (state.failed) return ;
                if (list_i==null) list_i=new ArrayList();
                list_i.add(i);

                match(input,129,FOLLOW_129_in_synpred217_Java5964); if (state.failed) return ;

                }
                break;
            case 2 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:19: i+= '>' '>'
                {
                i=(Token)match(input,131,FOLLOW_131_in_synpred217_Java5968); if (state.failed) return ;
                if (list_i==null) list_i=new ArrayList();
                list_i.add(i);

                match(input,131,FOLLOW_131_in_synpred217_Java5970); if (state.failed) return ;

                }
                break;

        }

        pushFollow(FOLLOW_additiveExpression_in_synpred217_Java5973);
        additiveExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred217_Java

    // $ANTLR start synpred218_Java
    public final void synpred218_Java_fragment() throws RecognitionException {   
        Token i=null;
        List list_i=null;

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:6: ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:6: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:6: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+
        int cnt203=0;
        loop203:
        do {
            int alt203=2;
            int LA203_0 = input.LA(1);

            if ( (LA203_0==129||LA203_0==131) ) {
                alt203=1;
            }


            switch (alt203) {
        	case 1 :
        	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' ) additiveExpression
        	    {
        	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:7: (i+= '<' '<' | i+= '>' '>' )
        	    int alt202=2;
        	    int LA202_0 = input.LA(1);

        	    if ( (LA202_0==129) ) {
        	        alt202=1;
        	    }
        	    else if ( (LA202_0==131) ) {
        	        alt202=2;
        	    }
        	    else {
        	        if (state.backtracking>0) {state.failed=true; return ;}
        	        NoViableAltException nvae =
        	            new NoViableAltException("", 202, 0, input);

        	        throw nvae;
        	    }
        	    switch (alt202) {
        	        case 1 :
        	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:8: i+= '<' '<'
        	            {
        	            i=(Token)match(input,129,FOLLOW_129_in_synpred218_Java5962); if (state.failed) return ;
        	            if (list_i==null) list_i=new ArrayList();
        	            list_i.add(i);

        	            match(input,129,FOLLOW_129_in_synpred218_Java5964); if (state.failed) return ;

        	            }
        	            break;
        	        case 2 :
        	            // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:825:19: i+= '>' '>'
        	            {
        	            i=(Token)match(input,131,FOLLOW_131_in_synpred218_Java5968); if (state.failed) return ;
        	            if (list_i==null) list_i=new ArrayList();
        	            list_i.add(i);

        	            match(input,131,FOLLOW_131_in_synpred218_Java5970); if (state.failed) return ;

        	            }
        	            break;

        	    }

        	    pushFollow(FOLLOW_additiveExpression_in_synpred218_Java5973);
        	    additiveExpression();

        	    state._fsp--;
        	    if (state.failed) return ;

        	    }
        	    break;

        	default :
        	    if ( cnt203 >= 1 ) break loop203;
        	    if (state.backtracking>0) {state.failed=true; return ;}
                    EarlyExitException eee =
                        new EarlyExitException(203, input);
                    throw eee;
            }
            cnt203++;
        } while (true);


        }
    }
    // $ANTLR end synpred218_Java

    // $ANTLR start synpred219_Java
    public final void synpred219_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:9: ( '>' '>' '>' additiveExpression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:9: '>' '>' '>' additiveExpression
        {
        match(input,131,FOLLOW_131_in_synpred219_Java6007); if (state.failed) return ;
        match(input,131,FOLLOW_131_in_synpred219_Java6009); if (state.failed) return ;
        match(input,131,FOLLOW_131_in_synpred219_Java6011); if (state.failed) return ;
        pushFollow(FOLLOW_additiveExpression_in_synpred219_Java6013);
        additiveExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred219_Java

    // $ANTLR start synpred220_Java
    public final void synpred220_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:8: ( ( '>' '>' '>' additiveExpression )+ )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:8: ( '>' '>' '>' additiveExpression )+
        {
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:8: ( '>' '>' '>' additiveExpression )+
        int cnt204=0;
        loop204:
        do {
            int alt204=2;
            int LA204_0 = input.LA(1);

            if ( (LA204_0==131) ) {
                alt204=1;
            }


            switch (alt204) {
        	case 1 :
        	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:827:9: '>' '>' '>' additiveExpression
        	    {
        	    match(input,131,FOLLOW_131_in_synpred220_Java6007); if (state.failed) return ;
        	    match(input,131,FOLLOW_131_in_synpred220_Java6009); if (state.failed) return ;
        	    match(input,131,FOLLOW_131_in_synpred220_Java6011); if (state.failed) return ;
        	    pushFollow(FOLLOW_additiveExpression_in_synpred220_Java6013);
        	    additiveExpression();

        	    state._fsp--;
        	    if (state.failed) return ;

        	    }
        	    break;

        	default :
        	    if ( cnt204 >= 1 ) break loop204;
        	    if (state.backtracking>0) {state.failed=true; return ;}
                    EarlyExitException eee =
                        new EarlyExitException(204, input);
                    throw eee;
            }
            cnt204++;
        } while (true);


        }
    }
    // $ANTLR end synpred220_Java

    // $ANTLR start synpred234_Java
    public final void synpred234_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:859:9: ( castExpression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:859:9: castExpression
        {
        pushFollow(FOLLOW_castExpression_in_synpred234_Java6360);
        castExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred234_Java

    // $ANTLR start synpred241_Java
    public final void synpred241_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:8: ( '(' primitiveType ')' unaryExpression )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:875:8: '(' primitiveType ')' unaryExpression
        {
        match(input,164,FOLLOW_164_in_synpred241_Java6510); if (state.failed) return ;
        pushFollow(FOLLOW_primitiveType_in_synpred241_Java6512);
        primitiveType();

        state._fsp--;
        if (state.failed) return ;
        match(input,165,FOLLOW_165_in_synpred241_Java6514); if (state.failed) return ;
        pushFollow(FOLLOW_unaryExpression_in_synpred241_Java6516);
        unaryExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred241_Java

    // $ANTLR start synpred242_Java
    public final void synpred242_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:876:8: ( '(' type ')' unaryExpressionNotPlusMinus )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:876:8: '(' type ')' unaryExpressionNotPlusMinus
        {
        match(input,164,FOLLOW_164_in_synpred242_Java6539); if (state.failed) return ;
        pushFollow(FOLLOW_type_in_synpred242_Java6541);
        type();

        state._fsp--;
        if (state.failed) return ;
        match(input,165,FOLLOW_165_in_synpred242_Java6543); if (state.failed) return ;
        pushFollow(FOLLOW_unaryExpressionNotPlusMinus_in_synpred242_Java6545);
        unaryExpressionNotPlusMinus();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred242_Java

    // $ANTLR start synpred247_Java
    public final void synpred247_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:8: ( '[' expression ']' )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:8: '[' expression ']'
        {
        match(input,138,FOLLOW_138_in_synpred247_Java6654); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred247_Java6656);
        expression();

        state._fsp--;
        if (state.failed) return ;
        match(input,139,FOLLOW_139_in_synpred247_Java6658); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred247_Java

    // $ANTLR start synpred251_Java
    public final void synpred251_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:884:9: ( 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer ) )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:884:9: 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer )
        {
        match(input,206,FOLLOW_206_in_synpred251_Java6633); if (state.failed) return ;
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:884:15: ( nonWildcardTypeArguments )?
        int alt215=2;
        int LA215_0 = input.LA(1);

        if ( (LA215_0==129) ) {
            alt215=1;
        }
        switch (alt215) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: nonWildcardTypeArguments
                {
                pushFollow(FOLLOW_nonWildcardTypeArguments_in_synpred251_Java6635);
                nonWildcardTypeArguments();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }

        pushFollow(FOLLOW_primitiveType_in_synpred251_Java6638);
        primitiveType();

        state._fsp--;
        if (state.failed) return ;
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:885:6: ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer )
        int alt219=2;
        alt219 = dfa219.predict(input);
        switch (alt219) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:7: ( '[' expression ']' )+ ( '[' ']' )*
                {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:7: ( '[' expression ']' )+
                int cnt216=0;
                loop216:
                do {
                    int alt216=2;
                    alt216 = dfa216.predict(input);
                    switch (alt216) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:8: '[' expression ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred251_Java6654); if (state.failed) return ;
                	    pushFollow(FOLLOW_expression_in_synpred251_Java6656);
                	    expression();

                	    state._fsp--;
                	    if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred251_Java6658); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    if ( cnt216 >= 1 ) break loop216;
                	    if (state.backtracking>0) {state.failed=true; return ;}
                            EarlyExitException eee =
                                new EarlyExitException(216, input);
                            throw eee;
                    }
                    cnt216++;
                } while (true);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:29: ( '[' ']' )*
                loop217:
                do {
                    int alt217=2;
                    int LA217_0 = input.LA(1);

                    if ( (LA217_0==138) ) {
                        alt217=1;
                    }


                    switch (alt217) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:886:30: '[' ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred251_Java6663); if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred251_Java6665); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    break loop217;
                    }
                } while (true);


                }
                break;
            case 2 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:9: ( '[' ']' )+ arrayInitializer
                {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:9: ( '[' ']' )+
                int cnt218=0;
                loop218:
                do {
                    int alt218=2;
                    int LA218_0 = input.LA(1);

                    if ( (LA218_0==138) ) {
                        alt218=1;
                    }


                    switch (alt218) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:887:10: '[' ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred251_Java6696); if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred251_Java6698); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    if ( cnt218 >= 1 ) break loop218;
                	    if (state.backtracking>0) {state.failed=true; return ;}
                            EarlyExitException eee =
                                new EarlyExitException(218, input);
                            throw eee;
                    }
                    cnt218++;
                } while (true);

                pushFollow(FOLLOW_arrayInitializer_in_synpred251_Java6702);
                arrayInitializer();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }


        }
    }
    // $ANTLR end synpred251_Java

    // $ANTLR start synpred255_Java
    public final void synpred255_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:8: ( '[' expression ']' )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:8: '[' expression ']'
        {
        match(input,138,FOLLOW_138_in_synpred255_Java6771); if (state.failed) return ;
        pushFollow(FOLLOW_expression_in_synpred255_Java6773);
        expression();

        state._fsp--;
        if (state.failed) return ;
        match(input,139,FOLLOW_139_in_synpred255_Java6775); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred255_Java

    // $ANTLR start synpred260_Java
    public final void synpred260_Java_fragment() throws RecognitionException {   
        List list_i=null;
        RuleReturnScope i = null;
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:9: ( 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer | classCreatorRest ) )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:9: 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer | classCreatorRest )
        {
        match(input,206,FOLLOW_206_in_synpred260_Java6734); if (state.failed) return ;
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:15: ( nonWildcardTypeArguments )?
        int alt223=2;
        int LA223_0 = input.LA(1);

        if ( (LA223_0==129) ) {
            alt223=1;
        }
        switch (alt223) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: nonWildcardTypeArguments
                {
                pushFollow(FOLLOW_nonWildcardTypeArguments_in_synpred260_Java6736);
                nonWildcardTypeArguments();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:41: ( uniMod )?
        int alt224=2;
        int LA224_0 = input.LA(1);

        if ( ((LA224_0>=151 && LA224_0<=153)) ) {
            alt224=1;
        }
        switch (alt224) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:0:0: uniMod
                {
                pushFollow(FOLLOW_uniMod_in_synpred260_Java6739);
                uniMod();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:49: (i+= refComponent ( '.' i+= refComponent )* )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:50: i+= refComponent ( '.' i+= refComponent )*
        {
        pushFollow(FOLLOW_refComponent_in_synpred260_Java6745);
        i=refComponent();

        state._fsp--;
        if (state.failed) return ;
        if (list_i==null) list_i=new ArrayList();
        list_i.add(i);

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:66: ( '.' i+= refComponent )*
        loop225:
        do {
            int alt225=2;
            int LA225_0 = input.LA(1);

            if ( (LA225_0==124) ) {
                alt225=1;
            }


            switch (alt225) {
        	case 1 :
        	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:889:67: '.' i+= refComponent
        	    {
        	    match(input,124,FOLLOW_124_in_synpred260_Java6748); if (state.failed) return ;
        	    pushFollow(FOLLOW_refComponent_in_synpred260_Java6752);
        	    i=refComponent();

        	    state._fsp--;
        	    if (state.failed) return ;
        	    if (list_i==null) list_i=new ArrayList();
        	    list_i.add(i);


        	    }
        	    break;

        	default :
        	    break loop225;
            }
        } while (true);


        }

        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:890:6: ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer | classCreatorRest )
        int alt229=3;
        alt229 = dfa229.predict(input);
        switch (alt229) {
            case 1 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:7: ( '[' expression ']' )+ ( '[' ']' )*
                {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:7: ( '[' expression ']' )+
                int cnt226=0;
                loop226:
                do {
                    int alt226=2;
                    alt226 = dfa226.predict(input);
                    switch (alt226) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:8: '[' expression ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred260_Java6771); if (state.failed) return ;
                	    pushFollow(FOLLOW_expression_in_synpred260_Java6773);
                	    expression();

                	    state._fsp--;
                	    if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred260_Java6775); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    if ( cnt226 >= 1 ) break loop226;
                	    if (state.backtracking>0) {state.failed=true; return ;}
                            EarlyExitException eee =
                                new EarlyExitException(226, input);
                            throw eee;
                    }
                    cnt226++;
                } while (true);

                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:29: ( '[' ']' )*
                loop227:
                do {
                    int alt227=2;
                    int LA227_0 = input.LA(1);

                    if ( (LA227_0==138) ) {
                        alt227=1;
                    }


                    switch (alt227) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:891:30: '[' ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred260_Java6780); if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred260_Java6782); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    break loop227;
                    }
                } while (true);


                }
                break;
            case 2 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:9: ( '[' ']' )+ arrayInitializer
                {
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:9: ( '[' ']' )+
                int cnt228=0;
                loop228:
                do {
                    int alt228=2;
                    int LA228_0 = input.LA(1);

                    if ( (LA228_0==138) ) {
                        alt228=1;
                    }


                    switch (alt228) {
                	case 1 :
                	    // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:892:10: '[' ']'
                	    {
                	    match(input,138,FOLLOW_138_in_synpred260_Java6818); if (state.failed) return ;
                	    match(input,139,FOLLOW_139_in_synpred260_Java6820); if (state.failed) return ;

                	    }
                	    break;

                	default :
                	    if ( cnt228 >= 1 ) break loop228;
                	    if (state.backtracking>0) {state.failed=true; return ;}
                            EarlyExitException eee =
                                new EarlyExitException(228, input);
                            throw eee;
                    }
                    cnt228++;
                } while (true);

                pushFollow(FOLLOW_arrayInitializer_in_synpred260_Java6824);
                arrayInitializer();

                state._fsp--;
                if (state.failed) return ;

                }
                break;
            case 3 :
                // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:893:9: classCreatorRest
                {
                pushFollow(FOLLOW_classCreatorRest_in_synpred260_Java6856);
                classCreatorRest();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }


        }
    }
    // $ANTLR end synpred260_Java

    // $ANTLR start synpred261_Java
    public final void synpred261_Java_fragment() throws RecognitionException {   
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:895:9: ( type '.' 'class' )
        // H:\\private\\post doc\\jkit-parser\\jkit\\jkit\\java\\parser\\Java.g:895:9: type '.' 'class'
        {
        pushFollow(FOLLOW_type_in_synpred261_Java6891);
        type();

        state._fsp--;
        if (state.failed) return ;
        match(input,124,FOLLOW_124_in_synpred261_Java6893); if (state.failed) return ;
        match(input,126,FOLLOW_126_in_synpred261_Java6895); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred261_Java

    // Delegated rules

    public final boolean synpred255_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred255_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred193_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred193_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred157_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred157_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred261_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred261_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred202_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred202_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred220_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred220_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred219_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred219_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred218_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred218_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred196_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred196_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred191_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred191_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred151_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred151_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred162_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred162_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred217_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred217_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred194_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred194_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred188_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred188_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred137_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred137_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred111_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred111_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred42_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred42_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred38_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred38_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred51_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred51_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred41_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred41_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred163_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred163_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred152_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred152_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred213_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred213_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred197_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred197_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred242_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred242_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred199_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred199_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred183_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred183_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred52_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred52_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred247_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred247_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred260_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred260_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred198_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred198_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred36_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred36_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred195_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred195_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred90_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred90_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred192_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred192_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred241_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred241_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred127_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred127_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred180_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred180_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred200_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred200_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred234_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred234_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred251_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred251_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred201_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred201_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred181_Java() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred181_Java_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA1 dfa1 = new DFA1(this);
    protected DFA2 dfa2 = new DFA2(this);
    protected DFA3 dfa3 = new DFA3(this);
    protected DFA4 dfa4 = new DFA4(this);
    protected DFA10 dfa10 = new DFA10(this);
    protected DFA11 dfa11 = new DFA11(this);
    protected DFA27 dfa27 = new DFA27(this);
    protected DFA31 dfa31 = new DFA31(this);
    protected DFA32 dfa32 = new DFA32(this);
    protected DFA36 dfa36 = new DFA36(this);
    protected DFA34 dfa34 = new DFA34(this);
    protected DFA35 dfa35 = new DFA35(this);
    protected DFA37 dfa37 = new DFA37(this);
    protected DFA40 dfa40 = new DFA40(this);
    protected DFA38 dfa38 = new DFA38(this);
    protected DFA39 dfa39 = new DFA39(this);
    protected DFA56 dfa56 = new DFA56(this);
    protected DFA59 dfa59 = new DFA59(this);
    protected DFA57 dfa57 = new DFA57(this);
    protected DFA60 dfa60 = new DFA60(this);
    protected DFA64 dfa64 = new DFA64(this);
    protected DFA65 dfa65 = new DFA65(this);
    protected DFA66 dfa66 = new DFA66(this);
    protected DFA68 dfa68 = new DFA68(this);
    protected DFA73 dfa73 = new DFA73(this);
    protected DFA82 dfa82 = new DFA82(this);
    protected DFA84 dfa84 = new DFA84(this);
    protected DFA83 dfa83 = new DFA83(this);
    protected DFA85 dfa85 = new DFA85(this);
    protected DFA87 dfa87 = new DFA87(this);
    protected DFA88 dfa88 = new DFA88(this);
    protected DFA90 dfa90 = new DFA90(this);
    protected DFA91 dfa91 = new DFA91(this);
    protected DFA92 dfa92 = new DFA92(this);
    protected DFA93 dfa93 = new DFA93(this);
    protected DFA95 dfa95 = new DFA95(this);
    protected DFA96 dfa96 = new DFA96(this);
    protected DFA97 dfa97 = new DFA97(this);
    protected DFA98 dfa98 = new DFA98(this);
    protected DFA101 dfa101 = new DFA101(this);
    protected DFA102 dfa102 = new DFA102(this);
    protected DFA110 dfa110 = new DFA110(this);
    protected DFA107 dfa107 = new DFA107(this);
    protected DFA111 dfa111 = new DFA111(this);
    protected DFA114 dfa114 = new DFA114(this);
    protected DFA115 dfa115 = new DFA115(this);
    protected DFA120 dfa120 = new DFA120(this);
    protected DFA117 dfa117 = new DFA117(this);
    protected DFA118 dfa118 = new DFA118(this);
    protected DFA119 dfa119 = new DFA119(this);
    protected DFA122 dfa122 = new DFA122(this);
    protected DFA125 dfa125 = new DFA125(this);
    protected DFA126 dfa126 = new DFA126(this);
    protected DFA127 dfa127 = new DFA127(this);
    protected DFA128 dfa128 = new DFA128(this);
    protected DFA129 dfa129 = new DFA129(this);
    protected DFA130 dfa130 = new DFA130(this);
    protected DFA131 dfa131 = new DFA131(this);
    protected DFA132 dfa132 = new DFA132(this);
    protected DFA133 dfa133 = new DFA133(this);
    protected DFA134 dfa134 = new DFA134(this);
    protected DFA138 dfa138 = new DFA138(this);
    protected DFA136 dfa136 = new DFA136(this);
    protected DFA137 dfa137 = new DFA137(this);
    protected DFA141 dfa141 = new DFA141(this);
    protected DFA140 dfa140 = new DFA140(this);
    protected DFA144 dfa144 = new DFA144(this);
    protected DFA143 dfa143 = new DFA143(this);
    protected DFA145 dfa145 = new DFA145(this);
    protected DFA149 dfa149 = new DFA149(this);
    protected DFA148 dfa148 = new DFA148(this);
    protected DFA146 dfa146 = new DFA146(this);
    protected DFA147 dfa147 = new DFA147(this);
    protected DFA150 dfa150 = new DFA150(this);
    protected DFA165 dfa165 = new DFA165(this);
    protected DFA155 dfa155 = new DFA155(this);
    protected DFA152 dfa152 = new DFA152(this);
    protected DFA153 dfa153 = new DFA153(this);
    protected DFA162 dfa162 = new DFA162(this);
    protected DFA159 dfa159 = new DFA159(this);
    protected DFA160 dfa160 = new DFA160(this);
    protected DFA163 dfa163 = new DFA163(this);
    protected DFA164 dfa164 = new DFA164(this);
    protected DFA166 dfa166 = new DFA166(this);
    protected DFA168 dfa168 = new DFA168(this);
    protected DFA171 dfa171 = new DFA171(this);
    protected DFA173 dfa173 = new DFA173(this);
    protected DFA219 dfa219 = new DFA219(this);
    protected DFA216 dfa216 = new DFA216(this);
    protected DFA229 dfa229 = new DFA229(this);
    protected DFA226 dfa226 = new DFA226(this);
    static final String DFA1_eotS =
        "\27\uffff";
    static final String DFA1_eofS =
        "\1\2\26\uffff";
    static final String DFA1_minS =
        "\1\12\1\145\23\uffff\1\0\1\uffff";
    static final String DFA1_maxS =
        "\1\u00aa\1\u0087\23\uffff\1\0\1\uffff";
    static final String DFA1_acceptS =
        "\2\uffff\1\2\23\uffff\1\1";
    static final String DFA1_specialS =
        "\25\uffff\1\0\1\uffff}>";
    static final String[] DFA1_transitionS = {
            "\1\2\155\uffff\4\2\2\uffff\1\2\10\uffff\1\2\5\uffff\12\2\23"+
            "\uffff\1\1",
            "\1\25\41\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            ""
    };

    static final short[] DFA1_eot = DFA.unpackEncodedString(DFA1_eotS);
    static final short[] DFA1_eof = DFA.unpackEncodedString(DFA1_eofS);
    static final char[] DFA1_min = DFA.unpackEncodedStringToUnsignedChars(DFA1_minS);
    static final char[] DFA1_max = DFA.unpackEncodedStringToUnsignedChars(DFA1_maxS);
    static final short[] DFA1_accept = DFA.unpackEncodedString(DFA1_acceptS);
    static final short[] DFA1_special = DFA.unpackEncodedString(DFA1_specialS);
    static final short[][] DFA1_transition;

    static {
        int numStates = DFA1_transitionS.length;
        DFA1_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA1_transition[i] = DFA.unpackEncodedString(DFA1_transitionS[i]);
        }
    }

    class DFA1 extends DFA {

        public DFA1(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 1;
            this.eot = DFA1_eot;
            this.eof = DFA1_eof;
            this.min = DFA1_min;
            this.max = DFA1_max;
            this.accept = DFA1_accept;
            this.special = DFA1_special;
            this.transition = DFA1_transition;
        }
        public String getDescription() {
            return "223:4: ( annotations )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA1_21 = input.LA(1);

                         
                        int index1_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_Java()) ) {s = 22;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index1_21);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 1, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA2_eotS =
        "\24\uffff";
    static final String DFA2_eofS =
        "\1\2\23\uffff";
    static final String DFA2_minS =
        "\1\12\23\uffff";
    static final String DFA2_maxS =
        "\1\u00aa\23\uffff";
    static final String DFA2_acceptS =
        "\1\uffff\1\1\1\2\21\uffff";
    static final String DFA2_specialS =
        "\24\uffff}>";
    static final String[] DFA2_transitionS = {
            "\1\2\155\uffff\1\1\3\2\2\uffff\1\2\10\uffff\1\2\5\uffff\12"+
            "\2\23\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA2_eot = DFA.unpackEncodedString(DFA2_eotS);
    static final short[] DFA2_eof = DFA.unpackEncodedString(DFA2_eofS);
    static final char[] DFA2_min = DFA.unpackEncodedStringToUnsignedChars(DFA2_minS);
    static final char[] DFA2_max = DFA.unpackEncodedStringToUnsignedChars(DFA2_maxS);
    static final short[] DFA2_accept = DFA.unpackEncodedString(DFA2_acceptS);
    static final short[] DFA2_special = DFA.unpackEncodedString(DFA2_specialS);
    static final short[][] DFA2_transition;

    static {
        int numStates = DFA2_transitionS.length;
        DFA2_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA2_transition[i] = DFA.unpackEncodedString(DFA2_transitionS[i]);
        }
    }

    class DFA2 extends DFA {

        public DFA2(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 2;
            this.eot = DFA2_eot;
            this.eof = DFA2_eof;
            this.min = DFA2_min;
            this.max = DFA2_max;
            this.accept = DFA2_accept;
            this.special = DFA2_special;
            this.transition = DFA2_transition;
        }
        public String getDescription() {
            return "223:17: ( packageDeclaration )?";
        }
    }
    static final String DFA3_eotS =
        "\23\uffff";
    static final String DFA3_eofS =
        "\1\1\22\uffff";
    static final String DFA3_minS =
        "\1\12\22\uffff";
    static final String DFA3_maxS =
        "\1\u00aa\22\uffff";
    static final String DFA3_acceptS =
        "\1\uffff\1\2\20\uffff\1\1";
    static final String DFA3_specialS =
        "\23\uffff}>";
    static final String[] DFA3_transitionS = {
            "\1\1\156\uffff\1\1\1\22\1\1\2\uffff\1\1\10\uffff\1\1\5\uffff"+
            "\12\1\23\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA3_eot = DFA.unpackEncodedString(DFA3_eotS);
    static final short[] DFA3_eof = DFA.unpackEncodedString(DFA3_eofS);
    static final char[] DFA3_min = DFA.unpackEncodedStringToUnsignedChars(DFA3_minS);
    static final char[] DFA3_max = DFA.unpackEncodedStringToUnsignedChars(DFA3_maxS);
    static final short[] DFA3_accept = DFA.unpackEncodedString(DFA3_acceptS);
    static final short[] DFA3_special = DFA.unpackEncodedString(DFA3_specialS);
    static final short[][] DFA3_transition;

    static {
        int numStates = DFA3_transitionS.length;
        DFA3_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA3_transition[i] = DFA.unpackEncodedString(DFA3_transitionS[i]);
        }
    }

    class DFA3 extends DFA {

        public DFA3(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 3;
            this.eot = DFA3_eot;
            this.eof = DFA3_eof;
            this.min = DFA3_min;
            this.max = DFA3_max;
            this.accept = DFA3_accept;
            this.special = DFA3_special;
            this.transition = DFA3_transition;
        }
        public String getDescription() {
            return "()* loopback of 223:37: ( importDeclaration )*";
        }
    }
    static final String DFA4_eotS =
        "\22\uffff";
    static final String DFA4_eofS =
        "\1\1\21\uffff";
    static final String DFA4_minS =
        "\1\12\21\uffff";
    static final String DFA4_maxS =
        "\1\u00aa\21\uffff";
    static final String DFA4_acceptS =
        "\1\uffff\1\2\1\1\17\uffff";
    static final String DFA4_specialS =
        "\22\uffff}>";
    static final String[] DFA4_transitionS = {
            "\1\2\156\uffff\1\2\1\uffff\1\2\2\uffff\1\2\10\uffff\1\2\5\uffff"+
            "\12\2\23\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA4_eot = DFA.unpackEncodedString(DFA4_eotS);
    static final short[] DFA4_eof = DFA.unpackEncodedString(DFA4_eofS);
    static final char[] DFA4_min = DFA.unpackEncodedStringToUnsignedChars(DFA4_minS);
    static final char[] DFA4_max = DFA.unpackEncodedStringToUnsignedChars(DFA4_maxS);
    static final short[] DFA4_accept = DFA.unpackEncodedString(DFA4_acceptS);
    static final short[] DFA4_special = DFA.unpackEncodedString(DFA4_specialS);
    static final short[][] DFA4_transition;

    static {
        int numStates = DFA4_transitionS.length;
        DFA4_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA4_transition[i] = DFA.unpackEncodedString(DFA4_transitionS[i]);
        }
    }

    class DFA4 extends DFA {

        public DFA4(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 4;
            this.eot = DFA4_eot;
            this.eof = DFA4_eof;
            this.min = DFA4_min;
            this.max = DFA4_max;
            this.accept = DFA4_accept;
            this.special = DFA4_special;
            this.transition = DFA4_transition;
        }
        public String getDescription() {
            return "()* loopback of 223:56: ( typeDeclaration )*";
        }
    }
    static final String DFA10_eotS =
        "\21\uffff";
    static final String DFA10_eofS =
        "\21\uffff";
    static final String DFA10_minS =
        "\1\12\20\uffff";
    static final String DFA10_maxS =
        "\1\u00aa\20\uffff";
    static final String DFA10_acceptS =
        "\1\uffff\1\1\16\uffff\1\2";
    static final String DFA10_specialS =
        "\21\uffff}>";
    static final String[] DFA10_transitionS = {
            "\1\1\156\uffff\1\20\1\uffff\1\1\2\uffff\1\1\10\uffff\1\1\5"+
            "\uffff\12\1\23\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA10_eot = DFA.unpackEncodedString(DFA10_eotS);
    static final short[] DFA10_eof = DFA.unpackEncodedString(DFA10_eofS);
    static final char[] DFA10_min = DFA.unpackEncodedStringToUnsignedChars(DFA10_minS);
    static final char[] DFA10_max = DFA.unpackEncodedStringToUnsignedChars(DFA10_maxS);
    static final short[] DFA10_accept = DFA.unpackEncodedString(DFA10_acceptS);
    static final short[] DFA10_special = DFA.unpackEncodedString(DFA10_specialS);
    static final short[][] DFA10_transition;

    static {
        int numStates = DFA10_transitionS.length;
        DFA10_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA10_transition[i] = DFA.unpackEncodedString(DFA10_transitionS[i]);
        }
    }

    class DFA10 extends DFA {

        public DFA10(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 10;
            this.eot = DFA10_eot;
            this.eof = DFA10_eof;
            this.min = DFA10_min;
            this.max = DFA10_max;
            this.accept = DFA10_accept;
            this.special = DFA10_special;
            this.transition = DFA10_transition;
        }
        public String getDescription() {
            return "238:1: typeDeclaration : ( classOrInterfaceDeclaration | ';' );";
        }
    }
    static final String DFA11_eotS =
        "\22\uffff";
    static final String DFA11_eofS =
        "\22\uffff";
    static final String DFA11_minS =
        "\1\12\3\uffff\1\145\15\uffff";
    static final String DFA11_maxS =
        "\1\u00aa\3\uffff\1\u0087\15\uffff";
    static final String DFA11_acceptS =
        "\1\uffff\1\2\3\uffff\1\1\14\uffff";
    static final String DFA11_specialS =
        "\22\uffff}>";
    static final String[] DFA11_transitionS = {
            "\1\1\160\uffff\1\5\2\uffff\1\1\10\uffff\1\1\5\uffff\12\5\23"+
            "\uffff\1\4",
            "",
            "",
            "",
            "\1\5\41\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA11_eot = DFA.unpackEncodedString(DFA11_eotS);
    static final short[] DFA11_eof = DFA.unpackEncodedString(DFA11_eofS);
    static final char[] DFA11_min = DFA.unpackEncodedStringToUnsignedChars(DFA11_minS);
    static final char[] DFA11_max = DFA.unpackEncodedStringToUnsignedChars(DFA11_maxS);
    static final short[] DFA11_accept = DFA.unpackEncodedString(DFA11_acceptS);
    static final short[] DFA11_special = DFA.unpackEncodedString(DFA11_specialS);
    static final short[][] DFA11_transition;

    static {
        int numStates = DFA11_transitionS.length;
        DFA11_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA11_transition[i] = DFA.unpackEncodedString(DFA11_transitionS[i]);
        }
    }

    class DFA11 extends DFA {

        public DFA11(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 11;
            this.eot = DFA11_eot;
            this.eof = DFA11_eof;
            this.min = DFA11_min;
            this.max = DFA11_max;
            this.accept = DFA11_accept;
            this.special = DFA11_special;
            this.transition = DFA11_transition;
        }
        public String getDescription() {
            return "()* loopback of 244:4: ( modifier )*";
        }
    }
    static final String DFA27_eotS =
        "\31\uffff";
    static final String DFA27_eofS =
        "\1\1\30\uffff";
    static final String DFA27_minS =
        "\1\12\30\uffff";
    static final String DFA27_maxS =
        "\1\u00aa\30\uffff";
    static final String DFA27_acceptS =
        "\1\uffff\1\2\1\uffff\1\1\25\uffff";
    static final String DFA27_specialS =
        "\31\uffff}>";
    static final String[] DFA27_transitionS = {
            "\1\3\132\uffff\1\3\23\uffff\1\3\1\uffff\1\3\2\uffff\1\3\2\uffff"+
            "\1\3\3\uffff\1\3\1\1\2\3\4\uffff\25\3\10\uffff\1\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA27_eot = DFA.unpackEncodedString(DFA27_eotS);
    static final short[] DFA27_eof = DFA.unpackEncodedString(DFA27_eofS);
    static final char[] DFA27_min = DFA.unpackEncodedStringToUnsignedChars(DFA27_minS);
    static final char[] DFA27_max = DFA.unpackEncodedStringToUnsignedChars(DFA27_maxS);
    static final short[] DFA27_accept = DFA.unpackEncodedString(DFA27_acceptS);
    static final short[] DFA27_special = DFA.unpackEncodedString(DFA27_specialS);
    static final short[][] DFA27_transition;

    static {
        int numStates = DFA27_transitionS.length;
        DFA27_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA27_transition[i] = DFA.unpackEncodedString(DFA27_transitionS[i]);
        }
    }

    class DFA27 extends DFA {

        public DFA27(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 27;
            this.eot = DFA27_eot;
            this.eof = DFA27_eof;
            this.min = DFA27_min;
            this.max = DFA27_max;
            this.accept = DFA27_accept;
            this.special = DFA27_special;
            this.transition = DFA27_transition;
        }
        public String getDescription() {
            return "()* loopback of 288:8: ( classBodyDeclaration )*";
        }
    }
    static final String DFA31_eotS =
        "\30\uffff";
    static final String DFA31_eofS =
        "\30\uffff";
    static final String DFA31_minS =
        "\1\12\27\uffff";
    static final String DFA31_maxS =
        "\1\u00aa\27\uffff";
    static final String DFA31_acceptS =
        "\1\uffff\1\2\1\1\25\uffff";
    static final String DFA31_specialS =
        "\30\uffff}>";
    static final String[] DFA31_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\2\1\uffff\1\2\2\uffff\1\2\2\uffff"+
            "\1\2\3\uffff\1\2\1\1\2\2\4\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA31_eot = DFA.unpackEncodedString(DFA31_eotS);
    static final short[] DFA31_eof = DFA.unpackEncodedString(DFA31_eofS);
    static final char[] DFA31_min = DFA.unpackEncodedStringToUnsignedChars(DFA31_minS);
    static final char[] DFA31_max = DFA.unpackEncodedStringToUnsignedChars(DFA31_maxS);
    static final short[] DFA31_accept = DFA.unpackEncodedString(DFA31_acceptS);
    static final short[] DFA31_special = DFA.unpackEncodedString(DFA31_specialS);
    static final short[][] DFA31_transition;

    static {
        int numStates = DFA31_transitionS.length;
        DFA31_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA31_transition[i] = DFA.unpackEncodedString(DFA31_transitionS[i]);
        }
    }

    class DFA31 extends DFA {

        public DFA31(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 31;
            this.eot = DFA31_eot;
            this.eof = DFA31_eof;
            this.min = DFA31_min;
            this.max = DFA31_max;
            this.accept = DFA31_accept;
            this.special = DFA31_special;
            this.transition = DFA31_transition;
        }
        public String getDescription() {
            return "()* loopback of 300:9: ( classBodyDeclaration )*";
        }
    }
    static final String DFA32_eotS =
        "\27\uffff";
    static final String DFA32_eofS =
        "\27\uffff";
    static final String DFA32_minS =
        "\1\12\26\uffff";
    static final String DFA32_maxS =
        "\1\u00aa\26\uffff";
    static final String DFA32_acceptS =
        "\1\uffff\1\2\1\1\24\uffff";
    static final String DFA32_specialS =
        "\27\uffff}>";
    static final String[] DFA32_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\2\1\uffff\1\2\2\uffff\1\2\2\uffff"+
            "\1\2\4\uffff\1\1\2\2\4\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA32_eot = DFA.unpackEncodedString(DFA32_eotS);
    static final short[] DFA32_eof = DFA.unpackEncodedString(DFA32_eofS);
    static final char[] DFA32_min = DFA.unpackEncodedStringToUnsignedChars(DFA32_minS);
    static final char[] DFA32_max = DFA.unpackEncodedStringToUnsignedChars(DFA32_maxS);
    static final short[] DFA32_accept = DFA.unpackEncodedString(DFA32_acceptS);
    static final short[] DFA32_special = DFA.unpackEncodedString(DFA32_specialS);
    static final short[][] DFA32_transition;

    static {
        int numStates = DFA32_transitionS.length;
        DFA32_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA32_transition[i] = DFA.unpackEncodedString(DFA32_transitionS[i]);
        }
    }

    class DFA32 extends DFA {

        public DFA32(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 32;
            this.eot = DFA32_eot;
            this.eof = DFA32_eof;
            this.min = DFA32_min;
            this.max = DFA32_max;
            this.accept = DFA32_accept;
            this.special = DFA32_special;
            this.transition = DFA32_transition;
        }
        public String getDescription() {
            return "()* loopback of 304:9: ( interfaceBodyDeclaration )*";
        }
    }
    static final String DFA36_eotS =
        "\55\uffff";
    static final String DFA36_eofS =
        "\55\uffff";
    static final String DFA36_minS =
        "\1\12\1\uffff\1\12\24\uffff\1\0\25\uffff";
    static final String DFA36_maxS =
        "\1\u00aa\1\uffff\1\u00aa\24\uffff\1\0\25\uffff";
    static final String DFA36_acceptS =
        "\1\uffff\1\1\1\uffff\1\3\1\4\47\uffff\1\2";
    static final String DFA36_specialS =
        "\27\uffff\1\0\25\uffff}>";
    static final String[] DFA36_transitionS = {
            "\1\4\132\uffff\1\4\23\uffff\1\1\1\uffff\1\2\2\uffff\1\4\2\uffff"+
            "\1\4\3\uffff\1\3\1\uffff\2\4\4\uffff\25\4\10\uffff\1\4",
            "",
            "\1\4\132\uffff\1\4\25\uffff\1\4\2\uffff\1\4\2\uffff\1\4\3"+
            "\uffff\1\27\1\uffff\2\4\4\uffff\25\4\10\uffff\1\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA36_eot = DFA.unpackEncodedString(DFA36_eotS);
    static final short[] DFA36_eof = DFA.unpackEncodedString(DFA36_eofS);
    static final char[] DFA36_min = DFA.unpackEncodedStringToUnsignedChars(DFA36_minS);
    static final char[] DFA36_max = DFA.unpackEncodedStringToUnsignedChars(DFA36_maxS);
    static final short[] DFA36_accept = DFA.unpackEncodedString(DFA36_acceptS);
    static final short[] DFA36_special = DFA.unpackEncodedString(DFA36_specialS);
    static final short[][] DFA36_transition;

    static {
        int numStates = DFA36_transitionS.length;
        DFA36_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA36_transition[i] = DFA.unpackEncodedString(DFA36_transitionS[i]);
        }
    }

    class DFA36 extends DFA {

        public DFA36(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 36;
            this.eot = DFA36_eot;
            this.eof = DFA36_eof;
            this.min = DFA36_min;
            this.max = DFA36_max;
            this.accept = DFA36_accept;
            this.special = DFA36_special;
            this.transition = DFA36_transition;
        }
        public String getDescription() {
            return "307:1: classBodyDeclaration : ( ';' | 'static' block -> ^( STATIC block ) | ( 'static' )? block -> block | ( modifier )* ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA36_23 = input.LA(1);

                         
                        int index36_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred36_Java()) ) {s = 44;}

                        else if ( (synpred38_Java()) ) {s = 3;}

                         
                        input.seek(index36_23);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 36, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA34_eotS =
        "\27\uffff";
    static final String DFA34_eofS =
        "\27\uffff";
    static final String DFA34_minS =
        "\1\12\6\uffff\1\145\17\uffff";
    static final String DFA34_maxS =
        "\1\u00aa\6\uffff\1\u0087\17\uffff";
    static final String DFA34_acceptS =
        "\1\uffff\1\2\10\uffff\1\1\14\uffff";
    static final String DFA34_specialS =
        "\27\uffff}>";
    static final String[] DFA34_transitionS = {
            "\1\1\132\uffff\1\1\25\uffff\1\12\2\uffff\1\1\2\uffff\1\1\5"+
            "\uffff\2\1\4\uffff\12\12\13\1\10\uffff\1\7",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\12\41\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA34_eot = DFA.unpackEncodedString(DFA34_eotS);
    static final short[] DFA34_eof = DFA.unpackEncodedString(DFA34_eofS);
    static final char[] DFA34_min = DFA.unpackEncodedStringToUnsignedChars(DFA34_minS);
    static final char[] DFA34_max = DFA.unpackEncodedStringToUnsignedChars(DFA34_maxS);
    static final short[] DFA34_accept = DFA.unpackEncodedString(DFA34_acceptS);
    static final short[] DFA34_special = DFA.unpackEncodedString(DFA34_specialS);
    static final short[][] DFA34_transition;

    static {
        int numStates = DFA34_transitionS.length;
        DFA34_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA34_transition[i] = DFA.unpackEncodedString(DFA34_transitionS[i]);
        }
    }

    class DFA34 extends DFA {

        public DFA34(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 34;
            this.eot = DFA34_eot;
            this.eof = DFA34_eof;
            this.min = DFA34_min;
            this.max = DFA34_max;
            this.accept = DFA34_accept;
            this.special = DFA34_special;
            this.transition = DFA34_transition;
        }
        public String getDescription() {
            return "()* loopback of 311:4: ( modifier )*";
        }
    }
    static final String DFA35_eotS =
        "\24\uffff";
    static final String DFA35_eofS =
        "\24\uffff";
    static final String DFA35_minS =
        "\1\12\1\uffff\3\145\5\uffff\5\0\1\uffff\2\0\2\uffff";
    static final String DFA35_maxS =
        "\1\u00aa\1\uffff\1\145\1\u00a4\1\u008a\5\uffff\5\0\1\uffff\2\0"+
        "\2\uffff";
    static final String DFA35_acceptS =
        "\1\uffff\1\1\3\uffff\1\4\1\6\1\7\1\10\1\11\5\uffff\1\5\2\uffff"+
        "\1\2\1\3";
    static final String DFA35_specialS =
        "\12\uffff\1\0\1\1\1\2\1\3\1\4\1\uffff\1\5\1\6\2\uffff}>";
    static final String[] DFA35_transitionS = {
            "\1\11\132\uffff\1\3\30\uffff\1\10\2\uffff\1\1\5\uffff\1\6\1"+
            "\5\16\uffff\3\2\10\4\10\uffff\1\7",
            "",
            "\1\12",
            "\1\16\26\uffff\1\14\4\uffff\1\13\10\uffff\1\15\31\uffff\1"+
            "\17",
            "\1\21\44\uffff\1\20",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            ""
    };

    static final short[] DFA35_eot = DFA.unpackEncodedString(DFA35_eotS);
    static final short[] DFA35_eof = DFA.unpackEncodedString(DFA35_eofS);
    static final char[] DFA35_min = DFA.unpackEncodedStringToUnsignedChars(DFA35_minS);
    static final char[] DFA35_max = DFA.unpackEncodedStringToUnsignedChars(DFA35_maxS);
    static final short[] DFA35_accept = DFA.unpackEncodedString(DFA35_acceptS);
    static final short[] DFA35_special = DFA.unpackEncodedString(DFA35_specialS);
    static final short[][] DFA35_transition;

    static {
        int numStates = DFA35_transitionS.length;
        DFA35_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA35_transition[i] = DFA.unpackEncodedString(DFA35_transitionS[i]);
        }
    }

    class DFA35 extends DFA {

        public DFA35(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 35;
            this.eot = DFA35_eot;
            this.eof = DFA35_eof;
            this.min = DFA35_min;
            this.max = DFA35_max;
            this.accept = DFA35_accept;
            this.special = DFA35_special;
            this.transition = DFA35_transition;
        }
        public String getDescription() {
            return "311:14: ( genericMethodOrConstructorDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) genericMethodOrConstructorDecl ) | methodDeclaration -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) methodDeclaration ) | fieldDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) fieldDeclaration ) | 'void' Identifier voidMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidMethodDeclaratorRest )? ) | Identifier constructorDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( NONE ) constructorDeclaratorRest ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA35_10 = input.LA(1);

                         
                        int index35_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_10);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA35_11 = input.LA(1);

                         
                        int index35_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_11);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA35_12 = input.LA(1);

                         
                        int index35_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_12);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA35_13 = input.LA(1);

                         
                        int index35_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_13);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA35_14 = input.LA(1);

                         
                        int index35_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_14);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA35_16 = input.LA(1);

                         
                        int index35_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_16);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA35_17 = input.LA(1);

                         
                        int index35_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_Java()) ) {s = 18;}

                        else if ( (synpred42_Java()) ) {s = 19;}

                         
                        input.seek(index35_17);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 35, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA37_eotS =
        "\12\uffff";
    static final String DFA37_eofS =
        "\12\uffff";
    static final String DFA37_minS =
        "\1\145\1\uffff\1\145\7\uffff";
    static final String DFA37_maxS =
        "\1\u00a1\1\uffff\1\u00a4\7\uffff";
    static final String DFA37_acceptS =
        "\1\uffff\1\1\2\uffff\1\2\4\uffff\1\3";
    static final String DFA37_specialS =
        "\12\uffff}>";
    static final String[] DFA37_transitionS = {
            "\1\2\42\uffff\1\4\16\uffff\13\1",
            "",
            "\1\1\26\uffff\1\1\4\uffff\1\1\10\uffff\1\1\31\uffff\1\11",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA37_eot = DFA.unpackEncodedString(DFA37_eotS);
    static final short[] DFA37_eof = DFA.unpackEncodedString(DFA37_eofS);
    static final char[] DFA37_min = DFA.unpackEncodedStringToUnsignedChars(DFA37_minS);
    static final char[] DFA37_max = DFA.unpackEncodedStringToUnsignedChars(DFA37_maxS);
    static final short[] DFA37_accept = DFA.unpackEncodedString(DFA37_acceptS);
    static final short[] DFA37_special = DFA.unpackEncodedString(DFA37_specialS);
    static final short[][] DFA37_transition;

    static {
        int numStates = DFA37_transitionS.length;
        DFA37_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA37_transition[i] = DFA.unpackEncodedString(DFA37_transitionS[i]);
        }
    }

    class DFA37 extends DFA {

        public DFA37(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 37;
            this.eot = DFA37_eot;
            this.eof = DFA37_eof;
            this.min = DFA37_min;
            this.max = DFA37_max;
            this.accept = DFA37_accept;
            this.special = DFA37_special;
            this.transition = DFA37_transition;
        }
        public String getDescription() {
            return "328:1: genericMethodOrConstructorRest : ( type Identifier methodDeclaratorRest -> Identifier type ( methodDeclaratorRest )? | 'void' Identifier methodDeclaratorRest -> Identifier ^( TYPE VOID ) ( methodDeclaratorRest )? | Identifier constructorDeclaratorRest -> Identifier ^( NONE ) constructorDeclaratorRest );";
        }
    }
    static final String DFA40_eotS =
        "\26\uffff";
    static final String DFA40_eofS =
        "\26\uffff";
    static final String DFA40_minS =
        "\1\12\25\uffff";
    static final String DFA40_maxS =
        "\1\u00aa\25\uffff";
    static final String DFA40_acceptS =
        "\1\uffff\1\1\23\uffff\1\2";
    static final String DFA40_specialS =
        "\26\uffff}>";
    static final String[] DFA40_transitionS = {
            "\1\1\132\uffff\1\1\23\uffff\1\25\1\uffff\1\1\2\uffff\1\1\2"+
            "\uffff\1\1\5\uffff\2\1\4\uffff\25\1\10\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA40_eot = DFA.unpackEncodedString(DFA40_eotS);
    static final short[] DFA40_eof = DFA.unpackEncodedString(DFA40_eofS);
    static final char[] DFA40_min = DFA.unpackEncodedStringToUnsignedChars(DFA40_minS);
    static final char[] DFA40_max = DFA.unpackEncodedStringToUnsignedChars(DFA40_maxS);
    static final short[] DFA40_accept = DFA.unpackEncodedString(DFA40_acceptS);
    static final short[] DFA40_special = DFA.unpackEncodedString(DFA40_specialS);
    static final short[][] DFA40_transition;

    static {
        int numStates = DFA40_transitionS.length;
        DFA40_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA40_transition[i] = DFA.unpackEncodedString(DFA40_transitionS[i]);
        }
    }

    class DFA40 extends DFA {

        public DFA40(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 40;
            this.eot = DFA40_eot;
            this.eof = DFA40_eof;
            this.min = DFA40_min;
            this.max = DFA40_max;
            this.accept = DFA40_accept;
            this.special = DFA40_special;
            this.transition = DFA40_transition;
        }
        public String getDescription() {
            return "342:1: interfaceBodyDeclaration : ( ( modifier )* ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) ) | ';' );";
        }
    }
    static final String DFA38_eotS =
        "\27\uffff";
    static final String DFA38_eofS =
        "\27\uffff";
    static final String DFA38_minS =
        "\1\12\6\uffff\1\145\17\uffff";
    static final String DFA38_maxS =
        "\1\u00aa\6\uffff\1\u0087\17\uffff";
    static final String DFA38_acceptS =
        "\1\uffff\1\2\10\uffff\1\1\14\uffff";
    static final String DFA38_specialS =
        "\27\uffff}>";
    static final String[] DFA38_transitionS = {
            "\1\1\132\uffff\1\1\25\uffff\1\12\2\uffff\1\1\2\uffff\1\1\5"+
            "\uffff\2\1\4\uffff\12\12\13\1\10\uffff\1\7",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\12\41\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA38_eot = DFA.unpackEncodedString(DFA38_eotS);
    static final short[] DFA38_eof = DFA.unpackEncodedString(DFA38_eofS);
    static final char[] DFA38_min = DFA.unpackEncodedStringToUnsignedChars(DFA38_minS);
    static final char[] DFA38_max = DFA.unpackEncodedStringToUnsignedChars(DFA38_maxS);
    static final short[] DFA38_accept = DFA.unpackEncodedString(DFA38_acceptS);
    static final short[] DFA38_special = DFA.unpackEncodedString(DFA38_specialS);
    static final short[][] DFA38_transition;

    static {
        int numStates = DFA38_transitionS.length;
        DFA38_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA38_transition[i] = DFA.unpackEncodedString(DFA38_transitionS[i]);
        }
    }

    class DFA38 extends DFA {

        public DFA38(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 38;
            this.eot = DFA38_eot;
            this.eof = DFA38_eof;
            this.min = DFA38_min;
            this.max = DFA38_max;
            this.accept = DFA38_accept;
            this.special = DFA38_special;
            this.transition = DFA38_transition;
        }
        public String getDescription() {
            return "()* loopback of 343:4: ( modifier )*";
        }
    }
    static final String DFA39_eotS =
        "\23\uffff";
    static final String DFA39_eofS =
        "\23\uffff";
    static final String DFA39_minS =
        "\1\12\3\145\6\uffff\7\0\2\uffff";
    static final String DFA39_maxS =
        "\1\u00aa\1\145\2\u008a\6\uffff\7\0\2\uffff";
    static final String DFA39_acceptS =
        "\4\uffff\1\3\1\4\1\5\1\6\1\7\1\10\7\uffff\1\1\1\2";
    static final String DFA39_specialS =
        "\12\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\2\uffff}>";
    static final String[] DFA39_transitionS = {
            "\1\11\132\uffff\1\2\30\uffff\1\10\2\uffff\1\4\5\uffff\1\6\1"+
            "\5\16\uffff\3\1\10\3\10\uffff\1\7",
            "\1\12",
            "\1\16\26\uffff\1\14\4\uffff\1\13\10\uffff\1\15",
            "\1\20\44\uffff\1\17",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            ""
    };

    static final short[] DFA39_eot = DFA.unpackEncodedString(DFA39_eotS);
    static final short[] DFA39_eof = DFA.unpackEncodedString(DFA39_eofS);
    static final char[] DFA39_min = DFA.unpackEncodedStringToUnsignedChars(DFA39_minS);
    static final char[] DFA39_max = DFA.unpackEncodedStringToUnsignedChars(DFA39_maxS);
    static final short[] DFA39_accept = DFA.unpackEncodedString(DFA39_acceptS);
    static final short[] DFA39_special = DFA.unpackEncodedString(DFA39_specialS);
    static final short[][] DFA39_transition;

    static {
        int numStates = DFA39_transitionS.length;
        DFA39_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA39_transition[i] = DFA.unpackEncodedString(DFA39_transitionS[i]);
        }
    }

    class DFA39 extends DFA {

        public DFA39(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 39;
            this.eot = DFA39_eot;
            this.eof = DFA39_eof;
            this.min = DFA39_min;
            this.max = DFA39_max;
            this.accept = DFA39_accept;
            this.special = DFA39_special;
            this.transition = DFA39_transition;
        }
        public String getDescription() {
            return "343:14: ( constantDeclaration -> ^( FIELD ^( MODIFIERS ( modifier )* ) constantDeclaration ) | type Identifier interfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier type ( interfaceMethodDeclaratorRest )? ) | interfaceGenericMethodDecl -> ^( METHOD ^( MODIFIERS ( modifier )* ) interfaceGenericMethodDecl ) | 'void' Identifier voidInterfaceMethodDeclaratorRest -> ^( METHOD ^( MODIFIERS ( modifier )* ) ^( TYPE_PARAMETERS ) Identifier ^( TYPE VOID ) ( voidInterfaceMethodDeclaratorRest )? ) | normalInterfaceDeclaration -> ^( INTERFACE ^( MODIFIERS ( modifier )* ) normalInterfaceDeclaration ) | annotationTypeDeclaration -> ^( ANNOTATION ^( MODIFIERS ( modifier )* ) annotationTypeDeclaration ) | classDeclaration -> ^( CLASS ^( MODIFIERS ( modifier )* ) classDeclaration ) | enumDeclaration -> ^( ENUM ^( MODIFIERS ( modifier )* ) enumDeclaration ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA39_10 = input.LA(1);

                         
                        int index39_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_10);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA39_11 = input.LA(1);

                         
                        int index39_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_11);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA39_12 = input.LA(1);

                         
                        int index39_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_12);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA39_13 = input.LA(1);

                         
                        int index39_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_13);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA39_14 = input.LA(1);

                         
                        int index39_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_14);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA39_15 = input.LA(1);

                         
                        int index39_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_15);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA39_16 = input.LA(1);

                         
                        int index39_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_Java()) ) {s = 17;}

                        else if ( (synpred52_Java()) ) {s = 18;}

                         
                        input.seek(index39_16);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 39, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA56_eotS =
        "\26\uffff";
    static final String DFA56_eofS =
        "\26\uffff";
    static final String DFA56_minS =
        "\1\145\25\uffff";
    static final String DFA56_maxS =
        "\1\u00ce\25\uffff";
    static final String DFA56_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA56_specialS =
        "\26\uffff}>";
    static final String[] DFA56_transitionS = {
            "\7\2\25\uffff\1\2\3\uffff\1\1\2\uffff\1\2\16\uffff\13\2\1\uffff"+
            "\2\2\2\uffff\3\2\22\uffff\2\2\14\uffff\5\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA56_eot = DFA.unpackEncodedString(DFA56_eotS);
    static final short[] DFA56_eof = DFA.unpackEncodedString(DFA56_eofS);
    static final char[] DFA56_min = DFA.unpackEncodedStringToUnsignedChars(DFA56_minS);
    static final char[] DFA56_max = DFA.unpackEncodedStringToUnsignedChars(DFA56_maxS);
    static final short[] DFA56_accept = DFA.unpackEncodedString(DFA56_acceptS);
    static final short[] DFA56_special = DFA.unpackEncodedString(DFA56_specialS);
    static final short[][] DFA56_transition;

    static {
        int numStates = DFA56_transitionS.length;
        DFA56_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA56_transition[i] = DFA.unpackEncodedString(DFA56_transitionS[i]);
        }
    }

    class DFA56 extends DFA {

        public DFA56(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 56;
            this.eot = DFA56_eot;
            this.eof = DFA56_eof;
            this.min = DFA56_min;
            this.max = DFA56_max;
            this.accept = DFA56_accept;
            this.special = DFA56_special;
            this.transition = DFA56_transition;
        }
        public String getDescription() {
            return "425:1: variableInitializer : ( arrayInitializer | expression );";
        }
    }
    static final String DFA59_eotS =
        "\27\uffff";
    static final String DFA59_eofS =
        "\27\uffff";
    static final String DFA59_minS =
        "\1\145\26\uffff";
    static final String DFA59_maxS =
        "\1\u00ce\26\uffff";
    static final String DFA59_acceptS =
        "\1\uffff\1\1\24\uffff\1\2";
    static final String DFA59_specialS =
        "\27\uffff}>";
    static final String[] DFA59_transitionS = {
            "\7\1\25\uffff\1\1\3\uffff\1\1\1\26\1\uffff\1\1\16\uffff\13"+
            "\1\1\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA59_eot = DFA.unpackEncodedString(DFA59_eotS);
    static final short[] DFA59_eof = DFA.unpackEncodedString(DFA59_eofS);
    static final char[] DFA59_min = DFA.unpackEncodedStringToUnsignedChars(DFA59_minS);
    static final char[] DFA59_max = DFA.unpackEncodedStringToUnsignedChars(DFA59_maxS);
    static final short[] DFA59_accept = DFA.unpackEncodedString(DFA59_acceptS);
    static final short[] DFA59_special = DFA.unpackEncodedString(DFA59_specialS);
    static final short[][] DFA59_transition;

    static {
        int numStates = DFA59_transitionS.length;
        DFA59_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA59_transition[i] = DFA.unpackEncodedString(DFA59_transitionS[i]);
        }
    }

    class DFA59 extends DFA {

        public DFA59(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 59;
            this.eot = DFA59_eot;
            this.eof = DFA59_eof;
            this.min = DFA59_min;
            this.max = DFA59_max;
            this.accept = DFA59_accept;
            this.special = DFA59_special;
            this.transition = DFA59_transition;
        }
        public String getDescription() {
            return "431:8: ( variableInitializer ( ',' variableInitializer )* ( ',' )? )?";
        }
    }
    static final String DFA57_eotS =
        "\31\uffff";
    static final String DFA57_eofS =
        "\31\uffff";
    static final String DFA57_minS =
        "\1\u0082\1\145\27\uffff";
    static final String DFA57_maxS =
        "\1\u0086\1\u00ce\27\uffff";
    static final String DFA57_acceptS =
        "\2\uffff\1\2\1\1\25\uffff";
    static final String DFA57_specialS =
        "\31\uffff}>";
    static final String[] DFA57_transitionS = {
            "\1\1\3\uffff\1\2",
            "\7\3\25\uffff\1\3\3\uffff\1\3\1\2\1\uffff\1\3\16\uffff\13"+
            "\3\1\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA57_eot = DFA.unpackEncodedString(DFA57_eotS);
    static final short[] DFA57_eof = DFA.unpackEncodedString(DFA57_eofS);
    static final char[] DFA57_min = DFA.unpackEncodedStringToUnsignedChars(DFA57_minS);
    static final char[] DFA57_max = DFA.unpackEncodedStringToUnsignedChars(DFA57_maxS);
    static final short[] DFA57_accept = DFA.unpackEncodedString(DFA57_acceptS);
    static final short[] DFA57_special = DFA.unpackEncodedString(DFA57_specialS);
    static final short[][] DFA57_transition;

    static {
        int numStates = DFA57_transitionS.length;
        DFA57_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA57_transition[i] = DFA.unpackEncodedString(DFA57_transitionS[i]);
        }
    }

    class DFA57 extends DFA {

        public DFA57(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 57;
            this.eot = DFA57_eot;
            this.eof = DFA57_eof;
            this.min = DFA57_min;
            this.max = DFA57_max;
            this.accept = DFA57_accept;
            this.special = DFA57_special;
            this.transition = DFA57_transition;
        }
        public String getDescription() {
            return "()* loopback of 431:29: ( ',' variableInitializer )*";
        }
    }
    static final String DFA60_eotS =
        "\15\uffff";
    static final String DFA60_eofS =
        "\15\uffff";
    static final String DFA60_minS =
        "\1\173\14\uffff";
    static final String DFA60_maxS =
        "\1\u00aa\14\uffff";
    static final String DFA60_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14";
    static final String DFA60_specialS =
        "\15\uffff}>";
    static final String[] DFA60_transitionS = {
            "\1\5\21\uffff\1\2\1\3\1\4\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
            "\23\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA60_eot = DFA.unpackEncodedString(DFA60_eotS);
    static final short[] DFA60_eof = DFA.unpackEncodedString(DFA60_eofS);
    static final char[] DFA60_min = DFA.unpackEncodedStringToUnsignedChars(DFA60_minS);
    static final char[] DFA60_max = DFA.unpackEncodedStringToUnsignedChars(DFA60_maxS);
    static final short[] DFA60_accept = DFA.unpackEncodedString(DFA60_acceptS);
    static final short[] DFA60_special = DFA.unpackEncodedString(DFA60_specialS);
    static final short[][] DFA60_transition;

    static {
        int numStates = DFA60_transitionS.length;
        DFA60_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA60_transition[i] = DFA.unpackEncodedString(DFA60_transitionS[i]);
        }
    }

    class DFA60 extends DFA {

        public DFA60(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 60;
            this.eot = DFA60_eot;
            this.eof = DFA60_eof;
            this.min = DFA60_min;
            this.max = DFA60_max;
            this.accept = DFA60_accept;
            this.special = DFA60_special;
            this.transition = DFA60_transition;
        }
        public String getDescription() {
            return "434:1: modifier : ( annotation | 'public' | 'protected' | 'private' | 'static' | 'abstract' | 'final' | 'native' | 'synchronized' | 'transient' | 'volatile' | 'strictfp' );";
        }
    }
    static final String DFA64_eotS =
        "\43\uffff";
    static final String DFA64_eofS =
        "\1\1\42\uffff";
    static final String DFA64_minS =
        "\1\145\37\uffff\1\145\2\uffff";
    static final String DFA64_maxS =
        "\1\u00c8\37\uffff\1\176\2\uffff";
    static final String DFA64_acceptS =
        "\1\uffff\1\2\40\uffff\1\1";
    static final String DFA64_specialS =
        "\43\uffff}>";
    static final String[] DFA64_transitionS = {
            "\1\1\23\uffff\1\1\2\uffff\1\40\1\1\2\uffff\7\1\3\uffff\3\1"+
            "\25\uffff\1\1\2\uffff\2\1\6\uffff\1\1\16\uffff\15\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\42\30\uffff\1\1",
            "",
            ""
    };

    static final short[] DFA64_eot = DFA.unpackEncodedString(DFA64_eotS);
    static final short[] DFA64_eof = DFA.unpackEncodedString(DFA64_eofS);
    static final char[] DFA64_min = DFA.unpackEncodedStringToUnsignedChars(DFA64_minS);
    static final char[] DFA64_max = DFA.unpackEncodedStringToUnsignedChars(DFA64_maxS);
    static final short[] DFA64_accept = DFA.unpackEncodedString(DFA64_acceptS);
    static final short[] DFA64_special = DFA.unpackEncodedString(DFA64_specialS);
    static final short[][] DFA64_transition;

    static {
        int numStates = DFA64_transitionS.length;
        DFA64_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA64_transition[i] = DFA.unpackEncodedString(DFA64_transitionS[i]);
        }
    }

    class DFA64 extends DFA {

        public DFA64(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 64;
            this.eot = DFA64_eot;
            this.eof = DFA64_eof;
            this.min = DFA64_min;
            this.max = DFA64_max;
            this.accept = DFA64_accept;
            this.special = DFA64_special;
            this.transition = DFA64_transition;
        }
        public String getDescription() {
            return "()* loopback of 463:28: ( '.' i+= refComponent )*";
        }
    }
    static final String DFA65_eotS =
        "\41\uffff";
    static final String DFA65_eofS =
        "\1\1\40\uffff";
    static final String DFA65_minS =
        "\1\145\40\uffff";
    static final String DFA65_maxS =
        "\1\u00c8\40\uffff";
    static final String DFA65_acceptS =
        "\1\uffff\1\2\36\uffff\1\1";
    static final String DFA65_specialS =
        "\41\uffff}>";
    static final String[] DFA65_transitionS = {
            "\1\1\23\uffff\1\1\2\uffff\2\1\2\uffff\7\1\3\uffff\1\40\2\1"+
            "\25\uffff\1\1\2\uffff\2\1\6\uffff\1\1\16\uffff\15\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA65_eot = DFA.unpackEncodedString(DFA65_eotS);
    static final short[] DFA65_eof = DFA.unpackEncodedString(DFA65_eofS);
    static final char[] DFA65_min = DFA.unpackEncodedStringToUnsignedChars(DFA65_minS);
    static final char[] DFA65_max = DFA.unpackEncodedStringToUnsignedChars(DFA65_maxS);
    static final short[] DFA65_accept = DFA.unpackEncodedString(DFA65_acceptS);
    static final short[] DFA65_special = DFA.unpackEncodedString(DFA65_specialS);
    static final short[][] DFA65_transition;

    static {
        int numStates = DFA65_transitionS.length;
        DFA65_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA65_transition[i] = DFA.unpackEncodedString(DFA65_transitionS[i]);
        }
    }

    class DFA65 extends DFA {

        public DFA65(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 65;
            this.eot = DFA65_eot;
            this.eof = DFA65_eof;
            this.min = DFA65_min;
            this.max = DFA65_max;
            this.accept = DFA65_accept;
            this.special = DFA65_special;
            this.transition = DFA65_transition;
        }
        public String getDescription() {
            return "()* loopback of 463:51: ( '[' ']' )*";
        }
    }
    static final String DFA66_eotS =
        "\41\uffff";
    static final String DFA66_eofS =
        "\1\1\40\uffff";
    static final String DFA66_minS =
        "\1\145\40\uffff";
    static final String DFA66_maxS =
        "\1\u00c8\40\uffff";
    static final String DFA66_acceptS =
        "\1\uffff\1\2\36\uffff\1\1";
    static final String DFA66_specialS =
        "\41\uffff}>";
    static final String[] DFA66_transitionS = {
            "\1\1\23\uffff\1\1\2\uffff\2\1\2\uffff\7\1\3\uffff\1\40\2\1"+
            "\25\uffff\1\1\2\uffff\2\1\6\uffff\1\1\16\uffff\15\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA66_eot = DFA.unpackEncodedString(DFA66_eotS);
    static final short[] DFA66_eof = DFA.unpackEncodedString(DFA66_eofS);
    static final char[] DFA66_min = DFA.unpackEncodedStringToUnsignedChars(DFA66_minS);
    static final char[] DFA66_max = DFA.unpackEncodedStringToUnsignedChars(DFA66_maxS);
    static final short[] DFA66_accept = DFA.unpackEncodedString(DFA66_acceptS);
    static final short[] DFA66_special = DFA.unpackEncodedString(DFA66_specialS);
    static final short[][] DFA66_transition;

    static {
        int numStates = DFA66_transitionS.length;
        DFA66_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA66_transition[i] = DFA.unpackEncodedString(DFA66_transitionS[i]);
        }
    }

    class DFA66 extends DFA {

        public DFA66(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 66;
            this.eot = DFA66_eot;
            this.eof = DFA66_eof;
            this.min = DFA66_min;
            this.max = DFA66_max;
            this.accept = DFA66_accept;
            this.special = DFA66_special;
            this.transition = DFA66_transition;
        }
        public String getDescription() {
            return "()* loopback of 464:18: ( '[' ']' )*";
        }
    }
    static final String DFA68_eotS =
        "\47\uffff";
    static final String DFA68_eofS =
        "\1\2\46\uffff";
    static final String DFA68_minS =
        "\2\145\45\uffff";
    static final String DFA68_maxS =
        "\1\u00c8\1\u00a2\45\uffff";
    static final String DFA68_acceptS =
        "\2\uffff\1\2\40\uffff\1\1\3\uffff";
    static final String DFA68_specialS =
        "\47\uffff}>";
    static final String[] DFA68_transitionS = {
            "\1\2\23\uffff\1\2\2\uffff\2\2\2\uffff\1\2\1\1\5\2\3\uffff\3"+
            "\2\25\uffff\1\2\1\uffff\3\2\6\uffff\1\2\16\uffff\15\2",
            "\1\43\33\uffff\1\2\25\uffff\14\43",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA68_eot = DFA.unpackEncodedString(DFA68_eotS);
    static final short[] DFA68_eof = DFA.unpackEncodedString(DFA68_eofS);
    static final char[] DFA68_min = DFA.unpackEncodedStringToUnsignedChars(DFA68_minS);
    static final char[] DFA68_max = DFA.unpackEncodedStringToUnsignedChars(DFA68_maxS);
    static final short[] DFA68_accept = DFA.unpackEncodedString(DFA68_acceptS);
    static final short[] DFA68_special = DFA.unpackEncodedString(DFA68_specialS);
    static final short[][] DFA68_transition;

    static {
        int numStates = DFA68_transitionS.length;
        DFA68_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA68_transition[i] = DFA.unpackEncodedString(DFA68_transitionS[i]);
        }
    }

    class DFA68 extends DFA {

        public DFA68(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 68;
            this.eot = DFA68_eot;
            this.eof = DFA68_eof;
            this.min = DFA68_min;
            this.max = DFA68_max;
            this.accept = DFA68_accept;
            this.special = DFA68_special;
            this.transition = DFA68_transition;
        }
        public String getDescription() {
            return "468:18: ( typeArguments )?";
        }
    }
    static final String DFA73_eotS =
        "\53\uffff";
    static final String DFA73_eofS =
        "\1\4\52\uffff";
    static final String DFA73_minS =
        "\1\177\1\uffff\3\0\46\uffff";
    static final String DFA73_maxS =
        "\1\u00a3\1\uffff\3\0\46\uffff";
    static final String DFA73_acceptS =
        "\1\uffff\1\1\3\uffff\1\2\45\uffff";
    static final String DFA73_specialS =
        "\2\uffff\1\0\1\1\1\2\46\uffff}>";
    static final String[] DFA73_transitionS = {
            "\1\1\2\uffff\1\2\1\3\37\uffff\1\5",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA73_eot = DFA.unpackEncodedString(DFA73_eotS);
    static final short[] DFA73_eof = DFA.unpackEncodedString(DFA73_eofS);
    static final char[] DFA73_min = DFA.unpackEncodedStringToUnsignedChars(DFA73_minS);
    static final char[] DFA73_max = DFA.unpackEncodedStringToUnsignedChars(DFA73_maxS);
    static final short[] DFA73_accept = DFA.unpackEncodedString(DFA73_acceptS);
    static final short[] DFA73_special = DFA.unpackEncodedString(DFA73_specialS);
    static final short[][] DFA73_transition;

    static {
        int numStates = DFA73_transitionS.length;
        DFA73_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA73_transition[i] = DFA.unpackEncodedString(DFA73_transitionS[i]);
        }
    }

    class DFA73 extends DFA {

        public DFA73(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 73;
            this.eot = DFA73_eot;
            this.eof = DFA73_eof;
            this.min = DFA73_min;
            this.max = DFA73_max;
            this.accept = DFA73_accept;
            this.special = DFA73_special;
            this.transition = DFA73_transition;
        }
        public String getDescription() {
            return "499:8: ( ( 'extends' type )? -> ^( TYPE ^( '?' ( ^( EXTENDS type ) )? ) ) | ( 'super' type )? -> ^( TYPE ^( '?' ( ^( SUPER type ) )? ) ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA73_2 = input.LA(1);

                         
                        int index73_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred111_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index73_2);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA73_3 = input.LA(1);

                         
                        int index73_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred111_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index73_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA73_4 = input.LA(1);

                         
                        int index73_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred111_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index73_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 73, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA82_eotS =
        "\30\uffff";
    static final String DFA82_eofS =
        "\1\1\27\uffff";
    static final String DFA82_minS =
        "\1\12\2\uffff\1\145\22\uffff\1\0\1\uffff";
    static final String DFA82_maxS =
        "\1\u00aa\2\uffff\1\u0087\22\uffff\1\0\1\uffff";
    static final String DFA82_acceptS =
        "\1\uffff\1\2\25\uffff\1\1";
    static final String DFA82_specialS =
        "\26\uffff\1\0\1\uffff}>";
    static final String[] DFA82_transitionS = {
            "\1\1\132\uffff\1\1\22\uffff\4\1\2\uffff\1\1\10\uffff\1\1\5"+
            "\uffff\12\1\23\uffff\1\3",
            "",
            "",
            "\1\26\41\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            ""
    };

    static final short[] DFA82_eot = DFA.unpackEncodedString(DFA82_eotS);
    static final short[] DFA82_eof = DFA.unpackEncodedString(DFA82_eofS);
    static final char[] DFA82_min = DFA.unpackEncodedStringToUnsignedChars(DFA82_minS);
    static final char[] DFA82_max = DFA.unpackEncodedStringToUnsignedChars(DFA82_maxS);
    static final short[] DFA82_accept = DFA.unpackEncodedString(DFA82_acceptS);
    static final short[] DFA82_special = DFA.unpackEncodedString(DFA82_specialS);
    static final short[][] DFA82_transition;

    static {
        int numStates = DFA82_transitionS.length;
        DFA82_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA82_transition[i] = DFA.unpackEncodedString(DFA82_transitionS[i]);
        }
    }

    class DFA82 extends DFA {

        public DFA82(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 82;
            this.eot = DFA82_eot;
            this.eof = DFA82_eof;
            this.min = DFA82_min;
            this.max = DFA82_max;
            this.accept = DFA82_accept;
            this.special = DFA82_special;
            this.transition = DFA82_transition;
        }
        public String getDescription() {
            return "()+ loopback of 552:4: ( annotation )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA82_22 = input.LA(1);

                         
                        int index82_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred127_Java()) ) {s = 23;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index82_22);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 82, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA84_eotS =
        "\35\uffff";
    static final String DFA84_eofS =
        "\1\2\34\uffff";
    static final String DFA84_minS =
        "\1\12\34\uffff";
    static final String DFA84_maxS =
        "\1\u00aa\34\uffff";
    static final String DFA84_acceptS =
        "\1\uffff\1\1\1\2\32\uffff";
    static final String DFA84_specialS =
        "\35\uffff}>";
    static final String[] DFA84_transitionS = {
            "\1\2\132\uffff\1\2\22\uffff\4\2\2\uffff\1\2\2\uffff\2\2\3\uffff"+
            "\3\2\4\uffff\25\2\2\uffff\1\1\1\2\4\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA84_eot = DFA.unpackEncodedString(DFA84_eotS);
    static final short[] DFA84_eof = DFA.unpackEncodedString(DFA84_eofS);
    static final char[] DFA84_min = DFA.unpackEncodedStringToUnsignedChars(DFA84_minS);
    static final char[] DFA84_max = DFA.unpackEncodedStringToUnsignedChars(DFA84_maxS);
    static final short[] DFA84_accept = DFA.unpackEncodedString(DFA84_acceptS);
    static final short[] DFA84_special = DFA.unpackEncodedString(DFA84_specialS);
    static final short[][] DFA84_transition;

    static {
        int numStates = DFA84_transitionS.length;
        DFA84_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA84_transition[i] = DFA.unpackEncodedString(DFA84_transitionS[i]);
        }
    }

    class DFA84 extends DFA {

        public DFA84(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 84;
            this.eot = DFA84_eot;
            this.eof = DFA84_eof;
            this.min = DFA84_min;
            this.max = DFA84_max;
            this.accept = DFA84_accept;
            this.special = DFA84_special;
            this.transition = DFA84_transition;
        }
        public String getDescription() {
            return "556:23: ( '(' ( elementValuePairs )? ')' )?";
        }
    }
    static final String DFA83_eotS =
        "\30\uffff";
    static final String DFA83_eofS =
        "\30\uffff";
    static final String DFA83_minS =
        "\1\145\27\uffff";
    static final String DFA83_maxS =
        "\1\u00ce\27\uffff";
    static final String DFA83_acceptS =
        "\1\uffff\1\1\25\uffff\1\2";
    static final String DFA83_specialS =
        "\30\uffff}>";
    static final String[] DFA83_transitionS = {
            "\7\1\25\uffff\1\1\3\uffff\1\1\2\uffff\1\1\16\uffff\13\1\1\uffff"+
            "\2\1\1\27\1\uffff\4\1\21\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA83_eot = DFA.unpackEncodedString(DFA83_eotS);
    static final short[] DFA83_eof = DFA.unpackEncodedString(DFA83_eofS);
    static final char[] DFA83_min = DFA.unpackEncodedStringToUnsignedChars(DFA83_minS);
    static final char[] DFA83_max = DFA.unpackEncodedStringToUnsignedChars(DFA83_maxS);
    static final short[] DFA83_accept = DFA.unpackEncodedString(DFA83_acceptS);
    static final short[] DFA83_special = DFA.unpackEncodedString(DFA83_specialS);
    static final short[][] DFA83_transition;

    static {
        int numStates = DFA83_transitionS.length;
        DFA83_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA83_transition[i] = DFA.unpackEncodedString(DFA83_transitionS[i]);
        }
    }

    class DFA83 extends DFA {

        public DFA83(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 83;
            this.eot = DFA83_eot;
            this.eof = DFA83_eof;
            this.min = DFA83_min;
            this.max = DFA83_max;
            this.accept = DFA83_accept;
            this.special = DFA83_special;
            this.transition = DFA83_transition;
        }
        public String getDescription() {
            return "556:28: ( elementValuePairs )?";
        }
    }
    static final String DFA85_eotS =
        "\36\uffff";
    static final String DFA85_eofS =
        "\1\1\35\uffff";
    static final String DFA85_minS =
        "\1\12\35\uffff";
    static final String DFA85_maxS =
        "\1\u00aa\35\uffff";
    static final String DFA85_acceptS =
        "\1\uffff\1\2\33\uffff\1\1";
    static final String DFA85_specialS =
        "\36\uffff}>";
    static final String[] DFA85_transitionS = {
            "\1\1\132\uffff\1\1\22\uffff\4\1\1\35\1\uffff\1\1\2\uffff\2"+
            "\1\3\uffff\3\1\4\uffff\25\1\2\uffff\2\1\4\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA85_eot = DFA.unpackEncodedString(DFA85_eotS);
    static final short[] DFA85_eof = DFA.unpackEncodedString(DFA85_eofS);
    static final char[] DFA85_min = DFA.unpackEncodedStringToUnsignedChars(DFA85_minS);
    static final char[] DFA85_max = DFA.unpackEncodedStringToUnsignedChars(DFA85_maxS);
    static final short[] DFA85_accept = DFA.unpackEncodedString(DFA85_acceptS);
    static final short[] DFA85_special = DFA.unpackEncodedString(DFA85_specialS);
    static final short[][] DFA85_transition;

    static {
        int numStates = DFA85_transitionS.length;
        DFA85_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA85_transition[i] = DFA.unpackEncodedString(DFA85_transitionS[i]);
        }
    }

    class DFA85 extends DFA {

        public DFA85(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 85;
            this.eot = DFA85_eot;
            this.eof = DFA85_eof;
            this.min = DFA85_min;
            this.max = DFA85_max;
            this.accept = DFA85_accept;
            this.special = DFA85_special;
            this.transition = DFA85_transition;
        }
        public String getDescription() {
            return "()* loopback of 560:15: ( '.' Identifier )*";
        }
    }
    static final String DFA87_eotS =
        "\60\uffff";
    static final String DFA87_eofS =
        "\1\uffff\1\2\56\uffff";
    static final String DFA87_minS =
        "\1\145\1\174\56\uffff";
    static final String DFA87_maxS =
        "\1\u00ce\1\u00cb\56\uffff";
    static final String DFA87_acceptS =
        "\2\uffff\1\2\24\uffff\1\1\30\uffff";
    static final String DFA87_specialS =
        "\60\uffff}>";
    static final String[] DFA87_transitionS = {
            "\1\1\6\2\25\uffff\1\2\3\uffff\1\2\2\uffff\1\2\16\uffff\13\2"+
            "\1\uffff\2\2\2\uffff\4\2\21\uffff\2\2\14\uffff\5\2",
            "\2\2\3\uffff\4\2\5\uffff\1\2\1\uffff\1\27\25\uffff\1\2\1\uffff"+
            "\2\2\26\uffff\3\2\3\uffff\12\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA87_eot = DFA.unpackEncodedString(DFA87_eotS);
    static final short[] DFA87_eof = DFA.unpackEncodedString(DFA87_eofS);
    static final char[] DFA87_min = DFA.unpackEncodedStringToUnsignedChars(DFA87_minS);
    static final char[] DFA87_max = DFA.unpackEncodedStringToUnsignedChars(DFA87_maxS);
    static final short[] DFA87_accept = DFA.unpackEncodedString(DFA87_acceptS);
    static final short[] DFA87_special = DFA.unpackEncodedString(DFA87_specialS);
    static final short[][] DFA87_transition;

    static {
        int numStates = DFA87_transitionS.length;
        DFA87_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA87_transition[i] = DFA.unpackEncodedString(DFA87_transitionS[i]);
        }
    }

    class DFA87 extends DFA {

        public DFA87(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 87;
            this.eot = DFA87_eot;
            this.eof = DFA87_eof;
            this.min = DFA87_min;
            this.max = DFA87_max;
            this.accept = DFA87_accept;
            this.special = DFA87_special;
            this.transition = DFA87_transition;
        }
        public String getDescription() {
            return "567:1: elementValuePair : ( ( Identifier '=' ) elementValue -> ^( ASSIGN ^( VAR Identifier ) elementValue ) | elementValue -> elementValue );";
        }
    }
    static final String DFA88_eotS =
        "\27\uffff";
    static final String DFA88_eofS =
        "\27\uffff";
    static final String DFA88_minS =
        "\1\145\26\uffff";
    static final String DFA88_maxS =
        "\1\u00ce\26\uffff";
    static final String DFA88_acceptS =
        "\1\uffff\1\1\23\uffff\1\2\1\3";
    static final String DFA88_specialS =
        "\27\uffff}>";
    static final String[] DFA88_transitionS = {
            "\7\1\25\uffff\1\1\3\uffff\1\26\2\uffff\1\1\16\uffff\13\1\1"+
            "\uffff\2\1\2\uffff\3\1\1\25\21\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA88_eot = DFA.unpackEncodedString(DFA88_eotS);
    static final short[] DFA88_eof = DFA.unpackEncodedString(DFA88_eofS);
    static final char[] DFA88_min = DFA.unpackEncodedStringToUnsignedChars(DFA88_minS);
    static final char[] DFA88_max = DFA.unpackEncodedStringToUnsignedChars(DFA88_maxS);
    static final short[] DFA88_accept = DFA.unpackEncodedString(DFA88_acceptS);
    static final short[] DFA88_special = DFA.unpackEncodedString(DFA88_specialS);
    static final short[][] DFA88_transition;

    static {
        int numStates = DFA88_transitionS.length;
        DFA88_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA88_transition[i] = DFA.unpackEncodedString(DFA88_transitionS[i]);
        }
    }

    class DFA88 extends DFA {

        public DFA88(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 88;
            this.eot = DFA88_eot;
            this.eof = DFA88_eof;
            this.min = DFA88_min;
            this.max = DFA88_max;
            this.accept = DFA88_accept;
            this.special = DFA88_special;
            this.transition = DFA88_transition;
        }
        public String getDescription() {
            return "572:1: elementValue : ( conditionalExpression | annotation | elementValueArrayInitializer );";
        }
    }
    static final String DFA90_eotS =
        "\30\uffff";
    static final String DFA90_eofS =
        "\30\uffff";
    static final String DFA90_minS =
        "\1\145\27\uffff";
    static final String DFA90_maxS =
        "\1\u00ce\27\uffff";
    static final String DFA90_acceptS =
        "\1\uffff\1\1\25\uffff\1\2";
    static final String DFA90_specialS =
        "\30\uffff}>";
    static final String[] DFA90_transitionS = {
            "\7\1\25\uffff\1\1\3\uffff\1\1\1\27\1\uffff\1\1\16\uffff\13"+
            "\1\1\uffff\2\1\2\uffff\4\1\21\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA90_eot = DFA.unpackEncodedString(DFA90_eotS);
    static final short[] DFA90_eof = DFA.unpackEncodedString(DFA90_eofS);
    static final char[] DFA90_min = DFA.unpackEncodedStringToUnsignedChars(DFA90_minS);
    static final char[] DFA90_max = DFA.unpackEncodedStringToUnsignedChars(DFA90_maxS);
    static final short[] DFA90_accept = DFA.unpackEncodedString(DFA90_acceptS);
    static final short[] DFA90_special = DFA.unpackEncodedString(DFA90_specialS);
    static final short[][] DFA90_transition;

    static {
        int numStates = DFA90_transitionS.length;
        DFA90_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA90_transition[i] = DFA.unpackEncodedString(DFA90_transitionS[i]);
        }
    }

    class DFA90 extends DFA {

        public DFA90(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 90;
            this.eot = DFA90_eot;
            this.eof = DFA90_eof;
            this.min = DFA90_min;
            this.max = DFA90_max;
            this.accept = DFA90_accept;
            this.special = DFA90_special;
            this.transition = DFA90_transition;
        }
        public String getDescription() {
            return "579:8: ( elementValue ( ',' elementValue )* )?";
        }
    }
    static final String DFA91_eotS =
        "\111\uffff";
    static final String DFA91_eofS =
        "\111\uffff";
    static final String DFA91_minS =
        "\1\12\22\uffff\1\0\65\uffff";
    static final String DFA91_maxS =
        "\1\u00aa\22\uffff\1\0\65\uffff";
    static final String DFA91_acceptS =
        "\1\uffff\1\1\106\uffff\1\2";
    static final String DFA91_specialS =
        "\23\uffff\1\0\65\uffff}>";
    static final String[] DFA91_transitionS = {
            "\1\1\132\uffff\1\1\25\uffff\1\1\2\uffff\1\1\7\uffff\1\23\1"+
            "\1\5\uffff\25\1\10\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA91_eot = DFA.unpackEncodedString(DFA91_eotS);
    static final short[] DFA91_eof = DFA.unpackEncodedString(DFA91_eofS);
    static final char[] DFA91_min = DFA.unpackEncodedStringToUnsignedChars(DFA91_minS);
    static final char[] DFA91_max = DFA.unpackEncodedStringToUnsignedChars(DFA91_maxS);
    static final short[] DFA91_accept = DFA.unpackEncodedString(DFA91_acceptS);
    static final short[] DFA91_special = DFA.unpackEncodedString(DFA91_specialS);
    static final short[][] DFA91_transition;

    static {
        int numStates = DFA91_transitionS.length;
        DFA91_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA91_transition[i] = DFA.unpackEncodedString(DFA91_transitionS[i]);
        }
    }

    class DFA91 extends DFA {

        public DFA91(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 91;
            this.eot = DFA91_eot;
            this.eof = DFA91_eof;
            this.min = DFA91_min;
            this.max = DFA91_max;
            this.accept = DFA91_accept;
            this.special = DFA91_special;
            this.transition = DFA91_transition;
        }
        public String getDescription() {
            return "587:9: ( annotationTypeElementDeclarations )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA91_19 = input.LA(1);

                         
                        int index91_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred137_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 72;}

                         
                        input.seek(index91_19);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 91, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA92_eotS =
        "\25\uffff";
    static final String DFA92_eofS =
        "\1\1\24\uffff";
    static final String DFA92_minS =
        "\1\12\24\uffff";
    static final String DFA92_maxS =
        "\1\u00aa\24\uffff";
    static final String DFA92_acceptS =
        "\1\uffff\1\2\1\uffff\1\1\21\uffff";
    static final String DFA92_specialS =
        "\25\uffff}>";
    static final String[] DFA92_transitionS = {
            "\1\3\132\uffff\1\3\25\uffff\1\3\2\uffff\1\3\7\uffff\1\1\1\3"+
            "\5\uffff\25\3\10\uffff\1\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA92_eot = DFA.unpackEncodedString(DFA92_eotS);
    static final short[] DFA92_eof = DFA.unpackEncodedString(DFA92_eofS);
    static final char[] DFA92_min = DFA.unpackEncodedStringToUnsignedChars(DFA92_minS);
    static final char[] DFA92_max = DFA.unpackEncodedStringToUnsignedChars(DFA92_maxS);
    static final short[] DFA92_accept = DFA.unpackEncodedString(DFA92_acceptS);
    static final short[] DFA92_special = DFA.unpackEncodedString(DFA92_specialS);
    static final short[][] DFA92_transition;

    static {
        int numStates = DFA92_transitionS.length;
        DFA92_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA92_transition[i] = DFA.unpackEncodedString(DFA92_transitionS[i]);
        }
    }

    class DFA92 extends DFA {

        public DFA92(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 92;
            this.eot = DFA92_eot;
            this.eof = DFA92_eof;
            this.min = DFA92_min;
            this.max = DFA92_max;
            this.accept = DFA92_accept;
            this.special = DFA92_special;
            this.transition = DFA92_transition;
        }
        public String getDescription() {
            return "()* loopback of 591:4: ( annotationTypeElementDeclaration )*";
        }
    }
    static final String DFA93_eotS =
        "\25\uffff";
    static final String DFA93_eofS =
        "\25\uffff";
    static final String DFA93_minS =
        "\1\12\6\uffff\1\145\15\uffff";
    static final String DFA93_maxS =
        "\1\u00aa\6\uffff\1\u0087\15\uffff";
    static final String DFA93_acceptS =
        "\1\uffff\1\2\6\uffff\1\1\14\uffff";
    static final String DFA93_specialS =
        "\25\uffff}>";
    static final String[] DFA93_transitionS = {
            "\1\1\132\uffff\1\1\25\uffff\1\10\2\uffff\1\1\10\uffff\1\1\5"+
            "\uffff\12\10\13\1\10\uffff\1\7",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\10\41\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA93_eot = DFA.unpackEncodedString(DFA93_eotS);
    static final short[] DFA93_eof = DFA.unpackEncodedString(DFA93_eofS);
    static final char[] DFA93_min = DFA.unpackEncodedStringToUnsignedChars(DFA93_minS);
    static final char[] DFA93_max = DFA.unpackEncodedStringToUnsignedChars(DFA93_maxS);
    static final short[] DFA93_accept = DFA.unpackEncodedString(DFA93_acceptS);
    static final short[] DFA93_special = DFA.unpackEncodedString(DFA93_specialS);
    static final short[][] DFA93_transition;

    static {
        int numStates = DFA93_transitionS.length;
        DFA93_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA93_transition[i] = DFA.unpackEncodedString(DFA93_transitionS[i]);
        }
    }

    class DFA93 extends DFA {

        public DFA93(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 93;
            this.eot = DFA93_eot;
            this.eof = DFA93_eof;
            this.min = DFA93_min;
            this.max = DFA93_max;
            this.accept = DFA93_accept;
            this.special = DFA93_special;
            this.transition = DFA93_transition;
        }
        public String getDescription() {
            return "()* loopback of 595:4: ( modifier )*";
        }
    }
    static final String DFA95_eotS =
        "\26\uffff";
    static final String DFA95_eofS =
        "\1\2\25\uffff";
    static final String DFA95_minS =
        "\1\12\25\uffff";
    static final String DFA95_maxS =
        "\1\u00aa\25\uffff";
    static final String DFA95_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA95_specialS =
        "\26\uffff}>";
    static final String[] DFA95_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\1\1\uffff\1\2\2\uffff\1\2\7\uffff"+
            "\2\2\5\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA95_eot = DFA.unpackEncodedString(DFA95_eotS);
    static final short[] DFA95_eof = DFA.unpackEncodedString(DFA95_eofS);
    static final char[] DFA95_min = DFA.unpackEncodedStringToUnsignedChars(DFA95_minS);
    static final char[] DFA95_max = DFA.unpackEncodedStringToUnsignedChars(DFA95_maxS);
    static final short[] DFA95_accept = DFA.unpackEncodedString(DFA95_acceptS);
    static final short[] DFA95_special = DFA.unpackEncodedString(DFA95_specialS);
    static final short[][] DFA95_transition;

    static {
        int numStates = DFA95_transitionS.length;
        DFA95_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA95_transition[i] = DFA.unpackEncodedString(DFA95_transitionS[i]);
        }
    }

    class DFA95 extends DFA {

        public DFA95(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 95;
            this.eot = DFA95_eot;
            this.eof = DFA95_eof;
            this.min = DFA95_min;
            this.max = DFA95_max;
            this.accept = DFA95_accept;
            this.special = DFA95_special;
            this.transition = DFA95_transition;
        }
        public String getDescription() {
            return "602:23: ( ';' )?";
        }
    }
    static final String DFA96_eotS =
        "\26\uffff";
    static final String DFA96_eofS =
        "\1\2\25\uffff";
    static final String DFA96_minS =
        "\1\12\25\uffff";
    static final String DFA96_maxS =
        "\1\u00aa\25\uffff";
    static final String DFA96_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA96_specialS =
        "\26\uffff}>";
    static final String[] DFA96_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\1\1\uffff\1\2\2\uffff\1\2\7\uffff"+
            "\2\2\5\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA96_eot = DFA.unpackEncodedString(DFA96_eotS);
    static final short[] DFA96_eof = DFA.unpackEncodedString(DFA96_eofS);
    static final char[] DFA96_min = DFA.unpackEncodedStringToUnsignedChars(DFA96_minS);
    static final char[] DFA96_max = DFA.unpackEncodedStringToUnsignedChars(DFA96_maxS);
    static final short[] DFA96_accept = DFA.unpackEncodedString(DFA96_acceptS);
    static final short[] DFA96_special = DFA.unpackEncodedString(DFA96_specialS);
    static final short[][] DFA96_transition;

    static {
        int numStates = DFA96_transitionS.length;
        DFA96_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA96_transition[i] = DFA.unpackEncodedString(DFA96_transitionS[i]);
        }
    }

    class DFA96 extends DFA {

        public DFA96(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 96;
            this.eot = DFA96_eot;
            this.eof = DFA96_eof;
            this.min = DFA96_min;
            this.max = DFA96_max;
            this.accept = DFA96_accept;
            this.special = DFA96_special;
            this.transition = DFA96_transition;
        }
        public String getDescription() {
            return "603:22: ( ';' )?";
        }
    }
    static final String DFA97_eotS =
        "\26\uffff";
    static final String DFA97_eofS =
        "\1\2\25\uffff";
    static final String DFA97_minS =
        "\1\12\25\uffff";
    static final String DFA97_maxS =
        "\1\u00aa\25\uffff";
    static final String DFA97_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA97_specialS =
        "\26\uffff}>";
    static final String[] DFA97_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\1\1\uffff\1\2\2\uffff\1\2\7\uffff"+
            "\2\2\5\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA97_eot = DFA.unpackEncodedString(DFA97_eotS);
    static final short[] DFA97_eof = DFA.unpackEncodedString(DFA97_eofS);
    static final char[] DFA97_min = DFA.unpackEncodedStringToUnsignedChars(DFA97_minS);
    static final char[] DFA97_max = DFA.unpackEncodedStringToUnsignedChars(DFA97_maxS);
    static final short[] DFA97_accept = DFA.unpackEncodedString(DFA97_acceptS);
    static final short[] DFA97_special = DFA.unpackEncodedString(DFA97_specialS);
    static final short[][] DFA97_transition;

    static {
        int numStates = DFA97_transitionS.length;
        DFA97_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA97_transition[i] = DFA.unpackEncodedString(DFA97_transitionS[i]);
        }
    }

    class DFA97 extends DFA {

        public DFA97(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 97;
            this.eot = DFA97_eot;
            this.eof = DFA97_eof;
            this.min = DFA97_min;
            this.max = DFA97_max;
            this.accept = DFA97_accept;
            this.special = DFA97_special;
            this.transition = DFA97_transition;
        }
        public String getDescription() {
            return "604:33: ( ';' )?";
        }
    }
    static final String DFA98_eotS =
        "\26\uffff";
    static final String DFA98_eofS =
        "\1\2\25\uffff";
    static final String DFA98_minS =
        "\1\12\25\uffff";
    static final String DFA98_maxS =
        "\1\u00aa\25\uffff";
    static final String DFA98_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA98_specialS =
        "\26\uffff}>";
    static final String[] DFA98_transitionS = {
            "\1\2\132\uffff\1\2\23\uffff\1\1\1\uffff\1\2\2\uffff\1\2\7\uffff"+
            "\2\2\5\uffff\25\2\10\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA98_eot = DFA.unpackEncodedString(DFA98_eotS);
    static final short[] DFA98_eof = DFA.unpackEncodedString(DFA98_eofS);
    static final char[] DFA98_min = DFA.unpackEncodedStringToUnsignedChars(DFA98_minS);
    static final char[] DFA98_max = DFA.unpackEncodedStringToUnsignedChars(DFA98_maxS);
    static final short[] DFA98_accept = DFA.unpackEncodedString(DFA98_acceptS);
    static final short[] DFA98_special = DFA.unpackEncodedString(DFA98_specialS);
    static final short[][] DFA98_transition;

    static {
        int numStates = DFA98_transitionS.length;
        DFA98_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA98_transition[i] = DFA.unpackEncodedString(DFA98_transitionS[i]);
        }
    }

    class DFA98 extends DFA {

        public DFA98(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 98;
            this.eot = DFA98_eot;
            this.eof = DFA98_eof;
            this.min = DFA98_min;
            this.max = DFA98_max;
            this.accept = DFA98_accept;
            this.special = DFA98_special;
            this.transition = DFA98_transition;
        }
        public String getDescription() {
            return "605:32: ( ';' )?";
        }
    }
    static final String DFA101_eotS =
        "\62\uffff";
    static final String DFA101_eofS =
        "\62\uffff";
    static final String DFA101_minS =
        "\1\12\61\uffff";
    static final String DFA101_maxS =
        "\1\u00ce\61\uffff";
    static final String DFA101_acceptS =
        "\1\uffff\1\2\1\1\57\uffff";
    static final String DFA101_specialS =
        "\62\uffff}>";
    static final String[] DFA101_transitionS = {
            "\1\2\132\uffff\7\2\15\uffff\1\2\1\uffff\1\2\2\uffff\1\2\2\uffff"+
            "\1\2\3\uffff\1\2\1\1\2\2\4\uffff\25\2\1\uffff\2\2\2\uffff\4"+
            "\2\1\uffff\1\2\1\uffff\1\2\1\uffff\4\2\1\uffff\5\2\2\uffff\2"+
            "\2\14\uffff\5\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA101_eot = DFA.unpackEncodedString(DFA101_eotS);
    static final short[] DFA101_eof = DFA.unpackEncodedString(DFA101_eofS);
    static final char[] DFA101_min = DFA.unpackEncodedStringToUnsignedChars(DFA101_minS);
    static final char[] DFA101_max = DFA.unpackEncodedStringToUnsignedChars(DFA101_maxS);
    static final short[] DFA101_accept = DFA.unpackEncodedString(DFA101_acceptS);
    static final short[] DFA101_special = DFA.unpackEncodedString(DFA101_specialS);
    static final short[][] DFA101_transition;

    static {
        int numStates = DFA101_transitionS.length;
        DFA101_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA101_transition[i] = DFA.unpackEncodedString(DFA101_transitionS[i]);
        }
    }

    class DFA101 extends DFA {

        public DFA101(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 101;
            this.eot = DFA101_eot;
            this.eof = DFA101_eof;
            this.min = DFA101_min;
            this.max = DFA101_max;
            this.accept = DFA101_accept;
            this.special = DFA101_special;
            this.transition = DFA101_transition;
        }
        public String getDescription() {
            return "()* loopback of 624:8: ( blockStatement )*";
        }
    }
    static final String DFA102_eotS =
        "\165\uffff";
    static final String DFA102_eofS =
        "\165\uffff";
    static final String DFA102_minS =
        "\2\12\4\145\6\uffff\1\12\47\uffff\2\0\16\uffff\2\0\1\uffff\3\0"+
        "\30\uffff\1\0\22\uffff";
    static final String DFA102_maxS =
        "\1\u00ce\1\u00aa\1\u0087\1\145\1\u00cb\1\u008a\6\uffff\1\u00aa"+
        "\47\uffff\2\0\16\uffff\2\0\1\uffff\3\0\30\uffff\1\0\22\uffff";
    static final String DFA102_acceptS =
        "\6\uffff\1\2\14\uffff\1\3\35\uffff\1\1\103\uffff";
    static final String DFA102_specialS =
        "\64\uffff\1\0\1\1\16\uffff\1\2\1\3\1\uffff\1\4\1\5\1\6\30\uffff"+
        "\1\7\22\uffff}>";
    static final String[] DFA102_transitionS = {
            "\1\6\132\uffff\1\4\6\23\15\uffff\1\23\1\uffff\1\6\2\uffff\1"+
            "\6\2\uffff\1\23\3\uffff\1\23\1\uffff\1\6\1\23\4\uffff\4\6\1"+
            "\1\1\6\1\14\3\6\3\3\10\5\1\uffff\2\23\2\uffff\3\23\1\2\1\uffff"+
            "\1\23\1\uffff\1\23\1\uffff\4\23\1\uffff\5\23\2\uffff\2\23\14"+
            "\uffff\5\23",
            "\1\6\132\uffff\1\61\25\uffff\1\6\2\uffff\1\6\10\uffff\1\6"+
            "\5\uffff\4\6\1\64\5\6\13\61\10\uffff\1\65",
            "\1\104\41\uffff\1\6",
            "\1\105",
            "\1\61\23\uffff\1\23\2\uffff\1\110\1\23\3\uffff\1\107\1\uffff"+
            "\2\23\5\uffff\1\111\1\uffff\1\23\25\uffff\1\23\1\uffff\1\23"+
            "\10\uffff\1\23\16\uffff\20\23",
            "\1\61\26\uffff\1\23\15\uffff\1\142",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\6\160\uffff\1\6\2\uffff\1\6\10\uffff\1\6\5\uffff\12\6\15"+
            "\uffff\1\23\5\uffff\1\6",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA102_eot = DFA.unpackEncodedString(DFA102_eotS);
    static final short[] DFA102_eof = DFA.unpackEncodedString(DFA102_eofS);
    static final char[] DFA102_min = DFA.unpackEncodedStringToUnsignedChars(DFA102_minS);
    static final char[] DFA102_max = DFA.unpackEncodedStringToUnsignedChars(DFA102_maxS);
    static final short[] DFA102_accept = DFA.unpackEncodedString(DFA102_acceptS);
    static final short[] DFA102_special = DFA.unpackEncodedString(DFA102_specialS);
    static final short[][] DFA102_transition;

    static {
        int numStates = DFA102_transitionS.length;
        DFA102_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA102_transition[i] = DFA.unpackEncodedString(DFA102_transitionS[i]);
        }
    }

    class DFA102 extends DFA {

        public DFA102(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 102;
            this.eot = DFA102_eot;
            this.eof = DFA102_eof;
            this.min = DFA102_min;
            this.max = DFA102_max;
            this.accept = DFA102_accept;
            this.special = DFA102_special;
            this.transition = DFA102_transition;
        }
        public String getDescription() {
            return "627:1: blockStatement : ( localVariableDeclaration | classOrInterfaceDeclaration | statement );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA102_52 = input.LA(1);

                         
                        int index102_52 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (synpred152_Java()) ) {s = 6;}

                         
                        input.seek(index102_52);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA102_53 = input.LA(1);

                         
                        int index102_53 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (synpred152_Java()) ) {s = 6;}

                         
                        input.seek(index102_53);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA102_68 = input.LA(1);

                         
                        int index102_68 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (synpred152_Java()) ) {s = 6;}

                         
                        input.seek(index102_68);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA102_69 = input.LA(1);

                         
                        int index102_69 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index102_69);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA102_71 = input.LA(1);

                         
                        int index102_71 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index102_71);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA102_72 = input.LA(1);

                         
                        int index102_72 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index102_72);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA102_73 = input.LA(1);

                         
                        int index102_73 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index102_73);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA102_98 = input.LA(1);

                         
                        int index102_98 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred151_Java()) ) {s = 49;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index102_98);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 102, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA110_eotS =
        "\76\uffff";
    static final String DFA110_eofS =
        "\76\uffff";
    static final String DFA110_minS =
        "\1\145\36\uffff\1\171\36\uffff";
    static final String DFA110_maxS =
        "\1\u00ce\36\uffff\1\u00cb\36\uffff";
    static final String DFA110_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1"+
        "\15\1\16\1\17\23\uffff\1\20\32\uffff";
    static final String DFA110_specialS =
        "\76\uffff}>";
    static final String[] DFA110_transitionS = {
            "\1\37\6\17\15\uffff\1\16\7\uffff\1\17\3\uffff\1\1\2\uffff\1"+
            "\17\12\uffff\1\11\3\uffff\13\17\1\uffff\2\17\2\uffff\3\17\2"+
            "\uffff\1\2\1\uffff\1\3\1\uffff\1\4\1\5\1\6\1\7\1\uffff\1\10"+
            "\1\12\1\13\1\14\1\15\2\uffff\2\17\14\uffff\5\17",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\17\2\uffff\2\17\3\uffff\1\17\1\uffff\2\17\5\uffff\1\17"+
            "\1\uffff\1\17\25\uffff\1\17\1\uffff\1\17\10\uffff\1\43\16\uffff"+
            "\20\17",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA110_eot = DFA.unpackEncodedString(DFA110_eotS);
    static final short[] DFA110_eof = DFA.unpackEncodedString(DFA110_eofS);
    static final char[] DFA110_min = DFA.unpackEncodedStringToUnsignedChars(DFA110_minS);
    static final char[] DFA110_max = DFA.unpackEncodedStringToUnsignedChars(DFA110_maxS);
    static final short[] DFA110_accept = DFA.unpackEncodedString(DFA110_acceptS);
    static final short[] DFA110_special = DFA.unpackEncodedString(DFA110_specialS);
    static final short[][] DFA110_transition;

    static {
        int numStates = DFA110_transitionS.length;
        DFA110_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA110_transition[i] = DFA.unpackEncodedString(DFA110_transitionS[i]);
        }
    }

    class DFA110 extends DFA {

        public DFA110(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 110;
            this.eot = DFA110_eot;
            this.eof = DFA110_eof;
            this.min = DFA110_min;
            this.max = DFA110_max;
            this.accept = DFA110_accept;
            this.special = DFA110_special;
            this.transition = DFA110_transition;
        }
        public String getDescription() {
            return "637:1: statement : ( block | lc= 'assert' expression ( ':' expression )? ';' -> ^( ASSERT[$lc] expression ( expression )? ) | lc= 'if' parExpression statement ( options {k=1; } : 'else' statement )? -> ^( IF[$lc] parExpression statement ( statement )? ) | lc= 'for' '(' forControl ')' statement -> ^( FOR[$lc] forControl statement ) | lc= 'while' parExpression statement -> ^( WHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'do' statement 'while' parExpression ';' -> ^( DOWHILE[$lc] ^( TEST parExpression ) statement ) | lc= 'try' block ( catches fc= 'finally' block -> ^( TRY[$lc] block catches ^( FINALLY[$fc] block ) ) | catches -> ^( TRY[$lc] block catches ) | fc= 'finally' block -> ^( TRY[$lc] block ^( FINALLY[$fc] block ) ) ) | lc= 'switch' parExpression '{' switchBlockStatementGroups '}' -> ^( SWITCH[$lc] parExpression switchBlockStatementGroups ) | lc= 'synchronized' parExpression block -> ^( SYNCHRONIZED[$lc] parExpression block ) | lc= 'return' ( expression )? ';' -> ^( RETURN[$lc] ( expression )? ) | lc= 'throw' expression ';' -> ^( THROW[$lc] expression ) | lc= 'break' ( Identifier )? ';' -> ^( BREAK[$lc] ( Identifier )? ) | lc= 'continue' ( Identifier )? ';' -> ^( CONTINUE[$lc] ( Identifier )? ) | ';' -> ^( BLOCK ) | statementExpression ';' -> statementExpression | lc= Identifier ':' statement -> ^( LABEL[$lc] Identifier statement ) );";
        }
    }
    static final String DFA107_eotS =
        "\26\uffff";
    static final String DFA107_eofS =
        "\26\uffff";
    static final String DFA107_minS =
        "\1\145\25\uffff";
    static final String DFA107_maxS =
        "\1\u00ce\25\uffff";
    static final String DFA107_acceptS =
        "\1\uffff\1\1\23\uffff\1\2";
    static final String DFA107_specialS =
        "\26\uffff}>";
    static final String[] DFA107_transitionS = {
            "\7\1\15\uffff\1\25\7\uffff\1\1\6\uffff\1\1\16\uffff\13\1\1"+
            "\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA107_eot = DFA.unpackEncodedString(DFA107_eotS);
    static final short[] DFA107_eof = DFA.unpackEncodedString(DFA107_eofS);
    static final char[] DFA107_min = DFA.unpackEncodedStringToUnsignedChars(DFA107_minS);
    static final char[] DFA107_max = DFA.unpackEncodedStringToUnsignedChars(DFA107_maxS);
    static final short[] DFA107_accept = DFA.unpackEncodedString(DFA107_acceptS);
    static final short[] DFA107_special = DFA.unpackEncodedString(DFA107_specialS);
    static final short[][] DFA107_transition;

    static {
        int numStates = DFA107_transitionS.length;
        DFA107_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA107_transition[i] = DFA.unpackEncodedString(DFA107_transitionS[i]);
        }
    }

    class DFA107 extends DFA {

        public DFA107(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 107;
            this.eot = DFA107_eot;
            this.eof = DFA107_eof;
            this.min = DFA107_min;
            this.max = DFA107_max;
            this.accept = DFA107_accept;
            this.special = DFA107_special;
            this.transition = DFA107_transition;
        }
        public String getDescription() {
            return "651:19: ( expression )?";
        }
    }
    static final String DFA111_eotS =
        "\70\uffff";
    static final String DFA111_eofS =
        "\1\1\67\uffff";
    static final String DFA111_minS =
        "\1\12\67\uffff";
    static final String DFA111_maxS =
        "\1\u00ce\67\uffff";
    static final String DFA111_acceptS =
        "\1\uffff\1\2\65\uffff\1\1";
    static final String DFA111_specialS =
        "\70\uffff}>";
    static final String[] DFA111_transitionS = {
            "\1\1\132\uffff\7\1\15\uffff\1\1\1\uffff\1\1\2\uffff\1\1\2\uffff"+
            "\1\1\3\uffff\4\1\4\uffff\25\1\1\uffff\2\1\2\uffff\6\1\1\uffff"+
            "\14\1\1\67\3\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA111_eot = DFA.unpackEncodedString(DFA111_eotS);
    static final short[] DFA111_eof = DFA.unpackEncodedString(DFA111_eofS);
    static final char[] DFA111_min = DFA.unpackEncodedStringToUnsignedChars(DFA111_minS);
    static final char[] DFA111_max = DFA.unpackEncodedStringToUnsignedChars(DFA111_maxS);
    static final short[] DFA111_accept = DFA.unpackEncodedString(DFA111_acceptS);
    static final short[] DFA111_special = DFA.unpackEncodedString(DFA111_specialS);
    static final short[][] DFA111_transition;

    static {
        int numStates = DFA111_transitionS.length;
        DFA111_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA111_transition[i] = DFA.unpackEncodedString(DFA111_transitionS[i]);
        }
    }

    class DFA111 extends DFA {

        public DFA111(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 111;
            this.eot = DFA111_eot;
            this.eof = DFA111_eof;
            this.min = DFA111_min;
            this.max = DFA111_max;
            this.accept = DFA111_accept;
            this.special = DFA111_special;
            this.transition = DFA111_transition;
        }
        public String getDescription() {
            return "()* loopback of 661:16: ( catchClause )*";
        }
    }
    static final String DFA114_eotS =
        "\65\uffff";
    static final String DFA114_eofS =
        "\1\1\64\uffff";
    static final String DFA114_minS =
        "\1\12\64\uffff";
    static final String DFA114_maxS =
        "\1\u00ce\64\uffff";
    static final String DFA114_acceptS =
        "\1\uffff\1\2\3\uffff\1\1\57\uffff";
    static final String DFA114_specialS =
        "\65\uffff}>";
    static final String[] DFA114_transitionS = {
            "\1\5\132\uffff\7\5\15\uffff\1\5\1\uffff\1\5\2\uffff\1\5\2\uffff"+
            "\1\5\3\uffff\1\5\1\1\2\5\4\uffff\25\5\1\uffff\2\5\2\uffff\4"+
            "\5\1\1\1\5\1\uffff\1\5\1\uffff\4\5\1\uffff\5\5\1\uffff\1\1\2"+
            "\5\14\uffff\5\5",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA114_eot = DFA.unpackEncodedString(DFA114_eotS);
    static final short[] DFA114_eof = DFA.unpackEncodedString(DFA114_eofS);
    static final char[] DFA114_min = DFA.unpackEncodedStringToUnsignedChars(DFA114_minS);
    static final char[] DFA114_max = DFA.unpackEncodedStringToUnsignedChars(DFA114_maxS);
    static final short[] DFA114_accept = DFA.unpackEncodedString(DFA114_acceptS);
    static final short[] DFA114_special = DFA.unpackEncodedString(DFA114_specialS);
    static final short[][] DFA114_transition;

    static {
        int numStates = DFA114_transitionS.length;
        DFA114_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA114_transition[i] = DFA.unpackEncodedString(DFA114_transitionS[i]);
        }
    }

    class DFA114 extends DFA {

        public DFA114(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 114;
            this.eot = DFA114_eot;
            this.eof = DFA114_eof;
            this.min = DFA114_min;
            this.max = DFA114_max;
            this.accept = DFA114_accept;
            this.special = DFA114_special;
            this.transition = DFA114_transition;
        }
        public String getDescription() {
            return "()* loopback of 677:16: ( blockStatement )*";
        }
    }
    static final String DFA115_eotS =
        "\30\uffff";
    static final String DFA115_eofS =
        "\30\uffff";
    static final String DFA115_minS =
        "\1\u00ab\1\145\1\uffff\1\0\24\uffff";
    static final String DFA115_maxS =
        "\1\u00bb\1\u00ce\1\uffff\1\0\24\uffff";
    static final String DFA115_acceptS =
        "\2\uffff\1\3\1\uffff\1\1\22\uffff\1\2";
    static final String DFA115_specialS =
        "\3\uffff\1\0\24\uffff}>";
    static final String[] DFA115_transitionS = {
            "\1\2\17\uffff\1\1",
            "\1\3\6\4\25\uffff\1\4\6\uffff\1\4\16\uffff\13\4\1\uffff\2"+
            "\4\2\uffff\3\4\22\uffff\2\4\14\uffff\5\4",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA115_eot = DFA.unpackEncodedString(DFA115_eotS);
    static final short[] DFA115_eof = DFA.unpackEncodedString(DFA115_eofS);
    static final char[] DFA115_min = DFA.unpackEncodedStringToUnsignedChars(DFA115_minS);
    static final char[] DFA115_max = DFA.unpackEncodedStringToUnsignedChars(DFA115_maxS);
    static final short[] DFA115_accept = DFA.unpackEncodedString(DFA115_acceptS);
    static final short[] DFA115_special = DFA.unpackEncodedString(DFA115_specialS);
    static final short[][] DFA115_transition;

    static {
        int numStates = DFA115_transitionS.length;
        DFA115_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA115_transition[i] = DFA.unpackEncodedString(DFA115_transitionS[i]);
        }
    }

    class DFA115 extends DFA {

        public DFA115(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 115;
            this.eot = DFA115_eot;
            this.eof = DFA115_eof;
            this.min = DFA115_min;
            this.max = DFA115_max;
            this.accept = DFA115_accept;
            this.special = DFA115_special;
            this.transition = DFA115_transition;
        }
        public String getDescription() {
            return "680:1: switchLabel : (lc= 'case' constantExpression ':' -> ^( CASE[$lc] constantExpression ) | lc= 'case' enumConstantName ':' -> ^( CASE[$lc] enumConstantName ) | lc= 'default' ':' -> ^( DEFAULT ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA115_3 = input.LA(1);

                         
                        int index115_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred180_Java()) ) {s = 4;}

                        else if ( (synpred181_Java()) ) {s = 23;}

                         
                        input.seek(index115_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 115, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA120_eotS =
        "\u0091\uffff";
    static final String DFA120_eofS =
        "\u0091\uffff";
    static final String DFA120_minS =
        "\6\145\22\uffff\12\145\1\171\30\uffff\1\u008b\1\171\1\uffff\30"+
        "\0\2\uffff\4\0\23\uffff\1\0\1\uffff\1\0\31\uffff\1\0\5\uffff";
    static final String DFA120_maxS =
        "\1\u00ce\1\u00aa\2\145\1\u00cb\1\u008a\22\uffff\1\145\2\u008a\1"+
        "\u00aa\1\145\1\u00aa\1\u008a\3\u00ce\1\u00ad\30\uffff\1\u008b\1"+
        "\u00ad\1\uffff\30\0\2\uffff\4\0\23\uffff\1\0\1\uffff\1\0\31\uffff"+
        "\1\0\5\uffff";
    static final String DFA120_acceptS =
        "\6\uffff\1\2\177\uffff\1\1\12\uffff";
    static final String DFA120_specialS =
        "\76\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1"+
        "\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\2\uffff"+
        "\1\30\1\31\1\32\1\33\23\uffff\1\34\1\uffff\1\35\31\uffff\1\36\5"+
        "\uffff}>";
    static final String[] DFA120_transitionS = {
            "\1\4\6\6\15\uffff\1\6\7\uffff\1\6\6\uffff\1\6\10\uffff\1\1"+
            "\5\uffff\3\3\10\5\1\uffff\2\6\2\uffff\3\6\1\2\21\uffff\2\6\14"+
            "\uffff\5\6",
            "\1\31\53\uffff\1\33\5\uffff\3\30\10\32\10\uffff\1\34",
            "\1\35",
            "\1\36",
            "\1\42\23\uffff\1\6\2\uffff\1\40\1\6\3\uffff\1\37\3\6\5\uffff"+
            "\1\41\1\uffff\1\6\25\uffff\1\6\1\uffff\1\6\27\uffff\20\6",
            "\1\74\26\uffff\1\6\15\uffff\1\73",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\76",
            "\1\102\26\uffff\1\100\4\uffff\1\77\10\uffff\1\101",
            "\1\104\44\uffff\1\103",
            "\1\106\53\uffff\1\110\5\uffff\3\105\10\107\10\uffff\1\111",
            "\1\112",
            "\1\116\26\uffff\1\113\24\uffff\1\120\5\uffff\3\115\10\117"+
            "\2\uffff\1\114\5\uffff\1\121",
            "\1\125\26\uffff\1\123\4\uffff\1\122\10\uffff\1\124",
            "\1\131\6\6\25\uffff\1\6\6\uffff\1\6\3\uffff\1\6\12\uffff\3"+
            "\130\10\132\1\133\2\6\2\uffff\3\6\22\uffff\2\6\14\uffff\5\6",
            "\1\157\30\uffff\1\6\2\uffff\1\6\41\uffff\1\6\52\uffff\1\6",
            "\7\6\25\uffff\1\6\6\uffff\1\6\2\uffff\1\161\13\uffff\13\6"+
            "\1\uffff\2\6\2\uffff\3\6\22\uffff\2\6\14\uffff\5\6",
            "\1\6\10\uffff\1\6\7\uffff\1\6\1\uffff\1\6\40\uffff\1\u0086",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\u008b",
            "\1\6\10\uffff\1\6\7\uffff\1\6\1\uffff\1\6\40\uffff\1\u0086",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA120_eot = DFA.unpackEncodedString(DFA120_eotS);
    static final short[] DFA120_eof = DFA.unpackEncodedString(DFA120_eofS);
    static final char[] DFA120_min = DFA.unpackEncodedStringToUnsignedChars(DFA120_minS);
    static final char[] DFA120_max = DFA.unpackEncodedStringToUnsignedChars(DFA120_maxS);
    static final short[] DFA120_accept = DFA.unpackEncodedString(DFA120_acceptS);
    static final short[] DFA120_special = DFA.unpackEncodedString(DFA120_specialS);
    static final short[][] DFA120_transition;

    static {
        int numStates = DFA120_transitionS.length;
        DFA120_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA120_transition[i] = DFA.unpackEncodedString(DFA120_transitionS[i]);
        }
    }

    class DFA120 extends DFA {

        public DFA120(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 120;
            this.eot = DFA120_eot;
            this.eof = DFA120_eof;
            this.min = DFA120_min;
            this.max = DFA120_max;
            this.accept = DFA120_accept;
            this.special = DFA120_special;
            this.transition = DFA120_transition;
        }
        public String getDescription() {
            return "690:1: forControl options {k=3; } : ( forVarControl -> ^( FOREACH forVarControl ) | ( forInit )? ';' (fc= expression )? ';' (fu= forUpdate )? -> ^( INIT ( forInit )? ) ^( TEST ( expression )? ) ^( STEP ( forUpdate )? ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA120_62 = input.LA(1);

                         
                        int index120_62 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_62);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA120_63 = input.LA(1);

                         
                        int index120_63 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_63);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA120_64 = input.LA(1);

                         
                        int index120_64 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_64);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA120_65 = input.LA(1);

                         
                        int index120_65 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_65);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA120_66 = input.LA(1);

                         
                        int index120_66 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_66);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA120_67 = input.LA(1);

                         
                        int index120_67 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_67);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA120_68 = input.LA(1);

                         
                        int index120_68 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_68);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA120_69 = input.LA(1);

                         
                        int index120_69 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_69);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA120_70 = input.LA(1);

                         
                        int index120_70 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_70);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA120_71 = input.LA(1);

                         
                        int index120_71 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_71);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA120_72 = input.LA(1);

                         
                        int index120_72 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_72);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA120_73 = input.LA(1);

                         
                        int index120_73 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_73);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA120_74 = input.LA(1);

                         
                        int index120_74 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_74);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA120_75 = input.LA(1);

                         
                        int index120_75 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_75);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA120_76 = input.LA(1);

                         
                        int index120_76 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_76);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA120_77 = input.LA(1);

                         
                        int index120_77 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_77);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA120_78 = input.LA(1);

                         
                        int index120_78 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_78);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA120_79 = input.LA(1);

                         
                        int index120_79 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_79);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA120_80 = input.LA(1);

                         
                        int index120_80 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_80);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA120_81 = input.LA(1);

                         
                        int index120_81 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_81);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA120_82 = input.LA(1);

                         
                        int index120_82 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_82);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA120_83 = input.LA(1);

                         
                        int index120_83 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_83);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA120_84 = input.LA(1);

                         
                        int index120_84 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_84);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA120_85 = input.LA(1);

                         
                        int index120_85 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_85);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA120_88 = input.LA(1);

                         
                        int index120_88 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_88);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA120_89 = input.LA(1);

                         
                        int index120_89 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_89);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA120_90 = input.LA(1);

                         
                        int index120_90 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_90);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA120_91 = input.LA(1);

                         
                        int index120_91 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_91);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA120_111 = input.LA(1);

                         
                        int index120_111 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_111);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA120_113 = input.LA(1);

                         
                        int index120_113 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_113);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA120_139 = input.LA(1);

                         
                        int index120_139 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred183_Java()) ) {s = 134;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index120_139);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 120, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA117_eotS =
        "\30\uffff";
    static final String DFA117_eofS =
        "\30\uffff";
    static final String DFA117_minS =
        "\1\145\27\uffff";
    static final String DFA117_maxS =
        "\1\u00ce\27\uffff";
    static final String DFA117_acceptS =
        "\1\uffff\1\1\25\uffff\1\2";
    static final String DFA117_specialS =
        "\30\uffff}>";
    static final String[] DFA117_transitionS = {
            "\7\1\15\uffff\1\27\7\uffff\1\1\6\uffff\1\1\10\uffff\1\1\5\uffff"+
            "\13\1\1\uffff\2\1\2\uffff\4\1\21\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA117_eot = DFA.unpackEncodedString(DFA117_eotS);
    static final short[] DFA117_eof = DFA.unpackEncodedString(DFA117_eofS);
    static final char[] DFA117_min = DFA.unpackEncodedStringToUnsignedChars(DFA117_minS);
    static final char[] DFA117_max = DFA.unpackEncodedStringToUnsignedChars(DFA117_maxS);
    static final short[] DFA117_accept = DFA.unpackEncodedString(DFA117_acceptS);
    static final short[] DFA117_special = DFA.unpackEncodedString(DFA117_specialS);
    static final short[][] DFA117_transition;

    static {
        int numStates = DFA117_transitionS.length;
        DFA117_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA117_transition[i] = DFA.unpackEncodedString(DFA117_transitionS[i]);
        }
    }

    class DFA117 extends DFA {

        public DFA117(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 117;
            this.eot = DFA117_eot;
            this.eof = DFA117_eof;
            this.min = DFA117_min;
            this.max = DFA117_max;
            this.accept = DFA117_accept;
            this.special = DFA117_special;
            this.transition = DFA117_transition;
        }
        public String getDescription() {
            return "693:4: ( forInit )?";
        }
    }
    static final String DFA118_eotS =
        "\26\uffff";
    static final String DFA118_eofS =
        "\26\uffff";
    static final String DFA118_minS =
        "\1\145\25\uffff";
    static final String DFA118_maxS =
        "\1\u00ce\25\uffff";
    static final String DFA118_acceptS =
        "\1\uffff\1\1\23\uffff\1\2";
    static final String DFA118_specialS =
        "\26\uffff}>";
    static final String[] DFA118_transitionS = {
            "\7\1\15\uffff\1\25\7\uffff\1\1\6\uffff\1\1\16\uffff\13\1\1"+
            "\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA118_eot = DFA.unpackEncodedString(DFA118_eotS);
    static final short[] DFA118_eof = DFA.unpackEncodedString(DFA118_eofS);
    static final char[] DFA118_min = DFA.unpackEncodedStringToUnsignedChars(DFA118_minS);
    static final char[] DFA118_max = DFA.unpackEncodedStringToUnsignedChars(DFA118_maxS);
    static final short[] DFA118_accept = DFA.unpackEncodedString(DFA118_acceptS);
    static final short[] DFA118_special = DFA.unpackEncodedString(DFA118_specialS);
    static final short[][] DFA118_transition;

    static {
        int numStates = DFA118_transitionS.length;
        DFA118_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA118_transition[i] = DFA.unpackEncodedString(DFA118_transitionS[i]);
        }
    }

    class DFA118 extends DFA {

        public DFA118(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 118;
            this.eot = DFA118_eot;
            this.eof = DFA118_eof;
            this.min = DFA118_min;
            this.max = DFA118_max;
            this.accept = DFA118_accept;
            this.special = DFA118_special;
            this.transition = DFA118_transition;
        }
        public String getDescription() {
            return "693:19: (fc= expression )?";
        }
    }
    static final String DFA119_eotS =
        "\26\uffff";
    static final String DFA119_eofS =
        "\26\uffff";
    static final String DFA119_minS =
        "\1\145\25\uffff";
    static final String DFA119_maxS =
        "\1\u00ce\25\uffff";
    static final String DFA119_acceptS =
        "\1\uffff\1\1\23\uffff\1\2";
    static final String DFA119_specialS =
        "\26\uffff}>";
    static final String[] DFA119_transitionS = {
            "\7\1\25\uffff\1\1\6\uffff\1\1\16\uffff\13\1\1\uffff\2\1\1\25"+
            "\1\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA119_eot = DFA.unpackEncodedString(DFA119_eotS);
    static final short[] DFA119_eof = DFA.unpackEncodedString(DFA119_eofS);
    static final char[] DFA119_min = DFA.unpackEncodedStringToUnsignedChars(DFA119_minS);
    static final char[] DFA119_max = DFA.unpackEncodedStringToUnsignedChars(DFA119_maxS);
    static final short[] DFA119_accept = DFA.unpackEncodedString(DFA119_acceptS);
    static final short[] DFA119_special = DFA.unpackEncodedString(DFA119_specialS);
    static final short[][] DFA119_transition;

    static {
        int numStates = DFA119_transitionS.length;
        DFA119_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA119_transition[i] = DFA.unpackEncodedString(DFA119_transitionS[i]);
        }
    }

    class DFA119 extends DFA {

        public DFA119(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 119;
            this.eot = DFA119_eot;
            this.eof = DFA119_eof;
            this.min = DFA119_min;
            this.max = DFA119_max;
            this.accept = DFA119_accept;
            this.special = DFA119_special;
            this.transition = DFA119_transition;
        }
        public String getDescription() {
            return "693:38: (fu= forUpdate )?";
        }
    }
    static final String DFA122_eotS =
        "\70\uffff";
    static final String DFA122_eofS =
        "\4\uffff\1\6\63\uffff";
    static final String DFA122_minS =
        "\1\145\2\uffff\3\145\21\uffff\4\0\32\uffff\1\0\2\uffff";
    static final String DFA122_maxS =
        "\1\u00ce\2\uffff\1\145\1\u00cb\1\u008a\21\uffff\4\0\32\uffff\1"+
        "\0\2\uffff";
    static final String DFA122_acceptS =
        "\1\uffff\1\1\4\uffff\1\2\61\uffff";
    static final String DFA122_specialS =
        "\27\uffff\1\0\1\1\1\2\1\3\32\uffff\1\4\2\uffff}>";
    static final String[] DFA122_transitionS = {
            "\1\4\6\6\25\uffff\1\6\6\uffff\1\6\10\uffff\1\1\5\uffff\3\3"+
            "\10\5\1\uffff\2\6\2\uffff\3\6\1\1\21\uffff\2\6\14\uffff\5\6",
            "",
            "",
            "\1\27",
            "\1\1\23\uffff\1\6\2\uffff\1\31\1\6\3\uffff\1\30\3\6\5\uffff"+
            "\1\32\1\uffff\1\6\25\uffff\1\6\1\uffff\1\6\27\uffff\20\6",
            "\1\1\26\uffff\1\6\15\uffff\1\65",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            ""
    };

    static final short[] DFA122_eot = DFA.unpackEncodedString(DFA122_eotS);
    static final short[] DFA122_eof = DFA.unpackEncodedString(DFA122_eofS);
    static final char[] DFA122_min = DFA.unpackEncodedStringToUnsignedChars(DFA122_minS);
    static final char[] DFA122_max = DFA.unpackEncodedStringToUnsignedChars(DFA122_maxS);
    static final short[] DFA122_accept = DFA.unpackEncodedString(DFA122_acceptS);
    static final short[] DFA122_special = DFA.unpackEncodedString(DFA122_specialS);
    static final short[][] DFA122_transition;

    static {
        int numStates = DFA122_transitionS.length;
        DFA122_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA122_transition[i] = DFA.unpackEncodedString(DFA122_transitionS[i]);
        }
    }

    class DFA122 extends DFA {

        public DFA122(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 122;
            this.eot = DFA122_eot;
            this.eof = DFA122_eof;
            this.min = DFA122_min;
            this.max = DFA122_max;
            this.accept = DFA122_accept;
            this.special = DFA122_special;
            this.transition = DFA122_transition;
        }
        public String getDescription() {
            return "696:1: forInit : ( ( variableModifier )* type variableDeclarators -> ^( VARDEF ^( MODIFIERS ( variableModifier )* ) type variableDeclarators ) | expressionList );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA122_23 = input.LA(1);

                         
                        int index122_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred188_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index122_23);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA122_24 = input.LA(1);

                         
                        int index122_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred188_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index122_24);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA122_25 = input.LA(1);

                         
                        int index122_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred188_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index122_25);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA122_26 = input.LA(1);

                         
                        int index122_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred188_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index122_26);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA122_53 = input.LA(1);

                         
                        int index122_53 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred188_Java()) ) {s = 1;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index122_53);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 122, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA125_eotS =
        "\166\uffff";
    static final String DFA125_eofS =
        "\1\14\165\uffff";
    static final String DFA125_minS =
        "\1\171\13\0\152\uffff";
    static final String DFA125_maxS =
        "\1\u00c2\13\0\152\uffff";
    static final String DFA125_acceptS =
        "\14\uffff\1\15\32\uffff\1\1\1\uffff\1\2\1\uffff\1\3\1\uffff\1\4"+
        "\1\uffff\1\5\24\uffff\1\6\24\uffff\1\7\24\uffff\1\10\1\uffff\1\11"+
        "\1\uffff\1\12\1\uffff\1\13\1\14";
    static final String DFA125_specialS =
        "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\152\uffff}>";
    static final String[] DFA125_transitionS = {
            "\1\14\3\uffff\1\4\3\uffff\1\12\1\14\1\13\2\uffff\1\14\4\uffff"+
            "\1\14\1\1\30\uffff\1\14\7\uffff\1\14\16\uffff\1\2\1\3\1\5\1"+
            "\6\1\7\1\10\1\11",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA125_eot = DFA.unpackEncodedString(DFA125_eotS);
    static final short[] DFA125_eof = DFA.unpackEncodedString(DFA125_eofS);
    static final char[] DFA125_min = DFA.unpackEncodedStringToUnsignedChars(DFA125_minS);
    static final char[] DFA125_max = DFA.unpackEncodedStringToUnsignedChars(DFA125_maxS);
    static final short[] DFA125_accept = DFA.unpackEncodedString(DFA125_acceptS);
    static final short[] DFA125_special = DFA.unpackEncodedString(DFA125_specialS);
    static final short[][] DFA125_transition;

    static {
        int numStates = DFA125_transitionS.length;
        DFA125_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA125_transition[i] = DFA.unpackEncodedString(DFA125_transitionS[i]);
        }
    }

    class DFA125 extends DFA {

        public DFA125(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 125;
            this.eot = DFA125_eot;
            this.eof = DFA125_eof;
            this.min = DFA125_min;
            this.max = DFA125_max;
            this.accept = DFA125_accept;
            this.special = DFA125_special;
            this.transition = DFA125_transition;
        }
        public String getDescription() {
            return "729:3: ( '=' expression -> ^( ASSIGN conditionalExpression expression ) | '+' '=' expression -> ^( ASSIGNOP ADD conditionalExpression expression ) | '-' '=' expression -> ^( ASSIGNOP SUB conditionalExpression expression ) | '*' '=' expression -> ^( ASSIGNOP MUL conditionalExpression expression ) | '/' '=' expression -> ^( ASSIGNOP DIV conditionalExpression expression ) | '&=' expression -> ^( ASSIGNOP AND conditionalExpression expression ) | '|=' expression -> ^( ASSIGNOP OR conditionalExpression expression ) | '^=' expression -> ^( ASSIGNOP XOR conditionalExpression expression ) | '%' '=' expression -> ^( ASSIGNOP MOD conditionalExpression expression ) | '<' '<' '=' expression -> ^( ASSIGNOP SHL conditionalExpression expression ) | '>' '>' '=' expression -> ^( ASSIGNOP SHR conditionalExpression expression ) | '>' '>' '>' '=' expression -> ^( ASSIGNOP USHR conditionalExpression expression ) | -> conditionalExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA125_1 = input.LA(1);

                         
                        int index125_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred191_Java()) ) {s = 39;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA125_2 = input.LA(1);

                         
                        int index125_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred192_Java()) ) {s = 41;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA125_3 = input.LA(1);

                         
                        int index125_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred193_Java()) ) {s = 43;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA125_4 = input.LA(1);

                         
                        int index125_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred194_Java()) ) {s = 45;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA125_5 = input.LA(1);

                         
                        int index125_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred195_Java()) ) {s = 47;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA125_6 = input.LA(1);

                         
                        int index125_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred196_Java()) ) {s = 68;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA125_7 = input.LA(1);

                         
                        int index125_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred197_Java()) ) {s = 89;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA125_8 = input.LA(1);

                         
                        int index125_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred198_Java()) ) {s = 110;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_8);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA125_9 = input.LA(1);

                         
                        int index125_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred199_Java()) ) {s = 112;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_9);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA125_10 = input.LA(1);

                         
                        int index125_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred200_Java()) ) {s = 114;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA125_11 = input.LA(1);

                         
                        int index125_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred201_Java()) ) {s = 116;}

                        else if ( (synpred202_Java()) ) {s = 117;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index125_11);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 125, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA126_eotS =
        "\24\uffff";
    static final String DFA126_eofS =
        "\1\2\23\uffff";
    static final String DFA126_minS =
        "\1\171\23\uffff";
    static final String DFA126_maxS =
        "\1\u00c2\23\uffff";
    static final String DFA126_acceptS =
        "\1\uffff\1\1\1\2\21\uffff";
    static final String DFA126_specialS =
        "\24\uffff}>";
    static final String[] DFA126_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\2\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\1\2\uffff\1\2\7\uffff\1\2\16\uffff\7\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA126_eot = DFA.unpackEncodedString(DFA126_eotS);
    static final short[] DFA126_eof = DFA.unpackEncodedString(DFA126_eofS);
    static final char[] DFA126_min = DFA.unpackEncodedStringToUnsignedChars(DFA126_minS);
    static final char[] DFA126_max = DFA.unpackEncodedStringToUnsignedChars(DFA126_maxS);
    static final short[] DFA126_accept = DFA.unpackEncodedString(DFA126_acceptS);
    static final short[] DFA126_special = DFA.unpackEncodedString(DFA126_specialS);
    static final short[][] DFA126_transition;

    static {
        int numStates = DFA126_transitionS.length;
        DFA126_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA126_transition[i] = DFA.unpackEncodedString(DFA126_transitionS[i]);
        }
    }

    class DFA126 extends DFA {

        public DFA126(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 126;
            this.eot = DFA126_eot;
            this.eof = DFA126_eof;
            this.min = DFA126_min;
            this.max = DFA126_max;
            this.accept = DFA126_accept;
            this.special = DFA126_special;
            this.transition = DFA126_transition;
        }
        public String getDescription() {
            return "748:6: ( '?' expression ':' expression -> ^( CONDEXPR conditionalOrExpression expression expression ) | -> conditionalOrExpression )";
        }
    }
    static final String DFA127_eotS =
        "\25\uffff";
    static final String DFA127_eofS =
        "\1\2\24\uffff";
    static final String DFA127_minS =
        "\1\171\24\uffff";
    static final String DFA127_maxS =
        "\1\u00c3\24\uffff";
    static final String DFA127_acceptS =
        "\1\uffff\1\1\1\2\22\uffff";
    static final String DFA127_specialS =
        "\25\uffff}>";
    static final String[] DFA127_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\2\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\7\2\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA127_eot = DFA.unpackEncodedString(DFA127_eotS);
    static final short[] DFA127_eof = DFA.unpackEncodedString(DFA127_eofS);
    static final char[] DFA127_min = DFA.unpackEncodedStringToUnsignedChars(DFA127_minS);
    static final char[] DFA127_max = DFA.unpackEncodedStringToUnsignedChars(DFA127_maxS);
    static final short[] DFA127_accept = DFA.unpackEncodedString(DFA127_acceptS);
    static final short[] DFA127_special = DFA.unpackEncodedString(DFA127_specialS);
    static final short[][] DFA127_transition;

    static {
        int numStates = DFA127_transitionS.length;
        DFA127_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA127_transition[i] = DFA.unpackEncodedString(DFA127_transitionS[i]);
        }
    }

    class DFA127 extends DFA {

        public DFA127(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 127;
            this.eot = DFA127_eot;
            this.eof = DFA127_eof;
            this.min = DFA127_min;
            this.max = DFA127_max;
            this.accept = DFA127_accept;
            this.special = DFA127_special;
            this.transition = DFA127_transition;
        }
        public String getDescription() {
            return "756:6: ( ( '||' conditionalOrExpression ) -> ^( LOR conditionalAndExpression conditionalOrExpression ) | -> conditionalAndExpression )";
        }
    }
    static final String DFA128_eotS =
        "\26\uffff";
    static final String DFA128_eofS =
        "\1\2\25\uffff";
    static final String DFA128_minS =
        "\1\171\25\uffff";
    static final String DFA128_maxS =
        "\1\u00c4\25\uffff";
    static final String DFA128_acceptS =
        "\1\uffff\1\1\1\2\23\uffff";
    static final String DFA128_specialS =
        "\26\uffff}>";
    static final String[] DFA128_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\2\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\10\2\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA128_eot = DFA.unpackEncodedString(DFA128_eotS);
    static final short[] DFA128_eof = DFA.unpackEncodedString(DFA128_eofS);
    static final char[] DFA128_min = DFA.unpackEncodedStringToUnsignedChars(DFA128_minS);
    static final char[] DFA128_max = DFA.unpackEncodedStringToUnsignedChars(DFA128_maxS);
    static final short[] DFA128_accept = DFA.unpackEncodedString(DFA128_acceptS);
    static final short[] DFA128_special = DFA.unpackEncodedString(DFA128_specialS);
    static final short[][] DFA128_transition;

    static {
        int numStates = DFA128_transitionS.length;
        DFA128_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA128_transition[i] = DFA.unpackEncodedString(DFA128_transitionS[i]);
        }
    }

    class DFA128 extends DFA {

        public DFA128(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 128;
            this.eot = DFA128_eot;
            this.eof = DFA128_eof;
            this.min = DFA128_min;
            this.max = DFA128_max;
            this.accept = DFA128_accept;
            this.special = DFA128_special;
            this.transition = DFA128_transition;
        }
        public String getDescription() {
            return "764:6: ( ( '&&' conditionalAndExpression ) -> ^( LAND inclusiveOrExpression conditionalAndExpression ) | -> inclusiveOrExpression )";
        }
    }
    static final String DFA129_eotS =
        "\27\uffff";
    static final String DFA129_eofS =
        "\1\2\26\uffff";
    static final String DFA129_minS =
        "\1\171\26\uffff";
    static final String DFA129_maxS =
        "\1\u00c5\26\uffff";
    static final String DFA129_acceptS =
        "\1\uffff\1\1\1\2\24\uffff";
    static final String DFA129_specialS =
        "\27\uffff}>";
    static final String[] DFA129_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\2\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\11\2\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA129_eot = DFA.unpackEncodedString(DFA129_eotS);
    static final short[] DFA129_eof = DFA.unpackEncodedString(DFA129_eofS);
    static final char[] DFA129_min = DFA.unpackEncodedStringToUnsignedChars(DFA129_minS);
    static final char[] DFA129_max = DFA.unpackEncodedStringToUnsignedChars(DFA129_maxS);
    static final short[] DFA129_accept = DFA.unpackEncodedString(DFA129_acceptS);
    static final short[] DFA129_special = DFA.unpackEncodedString(DFA129_specialS);
    static final short[][] DFA129_transition;

    static {
        int numStates = DFA129_transitionS.length;
        DFA129_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA129_transition[i] = DFA.unpackEncodedString(DFA129_transitionS[i]);
        }
    }

    class DFA129 extends DFA {

        public DFA129(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 129;
            this.eot = DFA129_eot;
            this.eof = DFA129_eof;
            this.min = DFA129_min;
            this.max = DFA129_max;
            this.accept = DFA129_accept;
            this.special = DFA129_special;
            this.transition = DFA129_transition;
        }
        public String getDescription() {
            return "772:9: ( ( '|' inclusiveOrExpression ) -> ^( OR exclusiveOrExpression inclusiveOrExpression ) | -> exclusiveOrExpression )";
        }
    }
    static final String DFA130_eotS =
        "\30\uffff";
    static final String DFA130_eofS =
        "\1\2\27\uffff";
    static final String DFA130_minS =
        "\1\171\27\uffff";
    static final String DFA130_maxS =
        "\1\u00c6\27\uffff";
    static final String DFA130_acceptS =
        "\1\uffff\1\1\1\2\25\uffff";
    static final String DFA130_specialS =
        "\30\uffff}>";
    static final String[] DFA130_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\2\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\12\2\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA130_eot = DFA.unpackEncodedString(DFA130_eotS);
    static final short[] DFA130_eof = DFA.unpackEncodedString(DFA130_eofS);
    static final char[] DFA130_min = DFA.unpackEncodedStringToUnsignedChars(DFA130_minS);
    static final char[] DFA130_max = DFA.unpackEncodedStringToUnsignedChars(DFA130_maxS);
    static final short[] DFA130_accept = DFA.unpackEncodedString(DFA130_acceptS);
    static final short[] DFA130_special = DFA.unpackEncodedString(DFA130_specialS);
    static final short[][] DFA130_transition;

    static {
        int numStates = DFA130_transitionS.length;
        DFA130_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA130_transition[i] = DFA.unpackEncodedString(DFA130_transitionS[i]);
        }
    }

    class DFA130 extends DFA {

        public DFA130(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 130;
            this.eot = DFA130_eot;
            this.eof = DFA130_eof;
            this.min = DFA130_min;
            this.max = DFA130_max;
            this.accept = DFA130_accept;
            this.special = DFA130_special;
            this.transition = DFA130_transition;
        }
        public String getDescription() {
            return "780:5: ( ( '^' exclusiveOrExpression ) -> ^( XOR andExpression exclusiveOrExpression ) | -> andExpression )";
        }
    }
    static final String DFA131_eotS =
        "\31\uffff";
    static final String DFA131_eofS =
        "\1\2\30\uffff";
    static final String DFA131_minS =
        "\1\171\30\uffff";
    static final String DFA131_maxS =
        "\1\u00c6\30\uffff";
    static final String DFA131_acceptS =
        "\1\uffff\1\1\1\2\26\uffff";
    static final String DFA131_specialS =
        "\31\uffff}>";
    static final String[] DFA131_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\3\2\1\1\1\uffff\1\2\4\uffff\2\2\25"+
            "\uffff\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\13\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA131_eot = DFA.unpackEncodedString(DFA131_eotS);
    static final short[] DFA131_eof = DFA.unpackEncodedString(DFA131_eofS);
    static final char[] DFA131_min = DFA.unpackEncodedStringToUnsignedChars(DFA131_minS);
    static final char[] DFA131_max = DFA.unpackEncodedStringToUnsignedChars(DFA131_maxS);
    static final short[] DFA131_accept = DFA.unpackEncodedString(DFA131_acceptS);
    static final short[] DFA131_special = DFA.unpackEncodedString(DFA131_specialS);
    static final short[][] DFA131_transition;

    static {
        int numStates = DFA131_transitionS.length;
        DFA131_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA131_transition[i] = DFA.unpackEncodedString(DFA131_transitionS[i]);
        }
    }

    class DFA131 extends DFA {

        public DFA131(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 131;
            this.eot = DFA131_eot;
            this.eof = DFA131_eof;
            this.min = DFA131_min;
            this.max = DFA131_max;
            this.accept = DFA131_accept;
            this.special = DFA131_special;
            this.transition = DFA131_transition;
        }
        public String getDescription() {
            return "788:5: ( ( '&' andExpression ) -> ^( AND equalityExpression andExpression ) | -> equalityExpression )";
        }
    }
    static final String DFA132_eotS =
        "\33\uffff";
    static final String DFA132_eofS =
        "\1\3\32\uffff";
    static final String DFA132_minS =
        "\1\171\32\uffff";
    static final String DFA132_maxS =
        "\1\u00c8\32\uffff";
    static final String DFA132_acceptS =
        "\1\uffff\1\1\1\2\1\3\27\uffff";
    static final String DFA132_specialS =
        "\33\uffff}>";
    static final String[] DFA132_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\4\3\1\uffff\1\3\4\uffff\2\3\25\uffff"+
            "\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\13\3\1\1\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA132_eot = DFA.unpackEncodedString(DFA132_eotS);
    static final short[] DFA132_eof = DFA.unpackEncodedString(DFA132_eofS);
    static final char[] DFA132_min = DFA.unpackEncodedStringToUnsignedChars(DFA132_minS);
    static final char[] DFA132_max = DFA.unpackEncodedStringToUnsignedChars(DFA132_maxS);
    static final short[] DFA132_accept = DFA.unpackEncodedString(DFA132_acceptS);
    static final short[] DFA132_special = DFA.unpackEncodedString(DFA132_specialS);
    static final short[][] DFA132_transition;

    static {
        int numStates = DFA132_transitionS.length;
        DFA132_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA132_transition[i] = DFA.unpackEncodedString(DFA132_transitionS[i]);
        }
    }

    class DFA132 extends DFA {

        public DFA132(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 132;
            this.eot = DFA132_eot;
            this.eof = DFA132_eof;
            this.min = DFA132_min;
            this.max = DFA132_max;
            this.accept = DFA132_accept;
            this.special = DFA132_special;
            this.transition = DFA132_transition;
        }
        public String getDescription() {
            return "796:5: ( ( '==' instanceOfExpression ) -> ^( EQ instanceOfExpression instanceOfExpression ) | ( '!=' instanceOfExpression ) -> ^( NEQ instanceOfExpression instanceOfExpression ) | -> instanceOfExpression )";
        }
    }
    static final String DFA133_eotS =
        "\34\uffff";
    static final String DFA133_eofS =
        "\1\2\33\uffff";
    static final String DFA133_minS =
        "\1\171\33\uffff";
    static final String DFA133_maxS =
        "\1\u00c9\33\uffff";
    static final String DFA133_acceptS =
        "\1\uffff\1\1\1\2\31\uffff";
    static final String DFA133_specialS =
        "\34\uffff}>";
    static final String[] DFA133_transitionS = {
            "\1\2\3\uffff\1\2\3\uffff\4\2\1\uffff\1\2\4\uffff\2\2\25\uffff"+
            "\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\15\2\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA133_eot = DFA.unpackEncodedString(DFA133_eotS);
    static final short[] DFA133_eof = DFA.unpackEncodedString(DFA133_eofS);
    static final char[] DFA133_min = DFA.unpackEncodedStringToUnsignedChars(DFA133_minS);
    static final char[] DFA133_max = DFA.unpackEncodedStringToUnsignedChars(DFA133_maxS);
    static final short[] DFA133_accept = DFA.unpackEncodedString(DFA133_acceptS);
    static final short[] DFA133_special = DFA.unpackEncodedString(DFA133_specialS);
    static final short[][] DFA133_transition;

    static {
        int numStates = DFA133_transitionS.length;
        DFA133_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA133_transition[i] = DFA.unpackEncodedString(DFA133_transitionS[i]);
        }
    }

    class DFA133 extends DFA {

        public DFA133(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 133;
            this.eot = DFA133_eot;
            this.eof = DFA133_eof;
            this.min = DFA133_min;
            this.max = DFA133_max;
            this.accept = DFA133_accept;
            this.special = DFA133_special;
            this.transition = DFA133_transition;
        }
        public String getDescription() {
            return "805:5: ( ( 'instanceof' type ) -> ^( INSTANCEOF relationalExpression type ) | -> relationalExpression )";
        }
    }
    static final String DFA134_eotS =
        "\107\uffff";
    static final String DFA134_eofS =
        "\1\3\106\uffff";
    static final String DFA134_minS =
        "\1\171\2\145\32\uffff\1\0\51\uffff";
    static final String DFA134_maxS =
        "\1\u00c9\2\u00ce\32\uffff\1\0\51\uffff";
    static final String DFA134_acceptS =
        "\3\uffff\1\5\30\uffff\1\1\1\uffff\1\2\22\uffff\1\3\1\uffff\1\4"+
        "\23\uffff";
    static final String DFA134_specialS =
        "\35\uffff\1\0\51\uffff}>";
    static final String[] DFA134_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\1\1\1\3\1\2\1\3\1\uffff\1\3\4\uffff"+
            "\2\3\25\uffff\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\16\3",
            "\7\36\25\uffff\1\35\6\uffff\1\36\3\uffff\1\34\12\uffff\13"+
            "\36\1\uffff\2\36\2\uffff\3\36\22\uffff\2\36\14\uffff\5\36",
            "\7\63\25\uffff\1\63\1\uffff\1\3\4\uffff\1\63\3\uffff\1\61"+
            "\12\uffff\13\63\1\uffff\2\63\2\uffff\3\63\22\uffff\2\63\14\uffff"+
            "\5\63",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA134_eot = DFA.unpackEncodedString(DFA134_eotS);
    static final short[] DFA134_eof = DFA.unpackEncodedString(DFA134_eofS);
    static final char[] DFA134_min = DFA.unpackEncodedStringToUnsignedChars(DFA134_minS);
    static final char[] DFA134_max = DFA.unpackEncodedStringToUnsignedChars(DFA134_maxS);
    static final short[] DFA134_accept = DFA.unpackEncodedString(DFA134_acceptS);
    static final short[] DFA134_special = DFA.unpackEncodedString(DFA134_specialS);
    static final short[][] DFA134_transition;

    static {
        int numStates = DFA134_transitionS.length;
        DFA134_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA134_transition[i] = DFA.unpackEncodedString(DFA134_transitionS[i]);
        }
    }

    class DFA134 extends DFA {

        public DFA134(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 134;
            this.eot = DFA134_eot;
            this.eof = DFA134_eof;
            this.min = DFA134_min;
            this.max = DFA134_max;
            this.accept = DFA134_accept;
            this.special = DFA134_special;
            this.transition = DFA134_transition;
        }
        public String getDescription() {
            return "813:5: ( ( '<' '=' shiftExpression ) -> ^( LTEQ shiftExpression shiftExpression ) | ( '<' shiftExpression ) -> ^( LT shiftExpression shiftExpression ) | ( '>' '=' shiftExpression ) -> ^( GTEQ shiftExpression shiftExpression ) | ( '>' shiftExpression ) -> ^( GT shiftExpression shiftExpression ) | -> shiftExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA134_29 = input.LA(1);

                         
                        int index134_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred213_Java()) ) {s = 30;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index134_29);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 134, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA138_eotS =
        "\111\uffff";
    static final String DFA138_eofS =
        "\1\3\110\uffff";
    static final String DFA138_minS =
        "\1\171\2\145\31\uffff\1\0\24\uffff\1\0\27\uffff";
    static final String DFA138_maxS =
        "\1\u00c9\2\u00ce\31\uffff\1\0\24\uffff\1\0\27\uffff";
    static final String DFA138_acceptS =
        "\3\uffff\1\3\103\uffff\1\1\1\2";
    static final String DFA138_specialS =
        "\34\uffff\1\0\24\uffff\1\1\27\uffff}>";
    static final String[] DFA138_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\1\1\1\3\1\2\1\3\1\uffff\1\3\4\uffff"+
            "\2\3\25\uffff\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\16\3",
            "\7\3\25\uffff\1\34\6\uffff\1\3\3\uffff\1\3\12\uffff\13\3\1"+
            "\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "\7\3\25\uffff\1\3\1\uffff\1\61\4\uffff\1\3\3\uffff\1\3\12"+
            "\uffff\13\3\1\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5"+
            "\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA138_eot = DFA.unpackEncodedString(DFA138_eotS);
    static final short[] DFA138_eof = DFA.unpackEncodedString(DFA138_eofS);
    static final char[] DFA138_min = DFA.unpackEncodedStringToUnsignedChars(DFA138_minS);
    static final char[] DFA138_max = DFA.unpackEncodedStringToUnsignedChars(DFA138_maxS);
    static final short[] DFA138_accept = DFA.unpackEncodedString(DFA138_acceptS);
    static final short[] DFA138_special = DFA.unpackEncodedString(DFA138_specialS);
    static final short[][] DFA138_transition;

    static {
        int numStates = DFA138_transitionS.length;
        DFA138_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA138_transition[i] = DFA.unpackEncodedString(DFA138_transitionS[i]);
        }
    }

    class DFA138 extends DFA {

        public DFA138(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 138;
            this.eot = DFA138_eot;
            this.eof = DFA138_eof;
            this.min = DFA138_min;
            this.max = DFA138_max;
            this.accept = DFA138_accept;
            this.special = DFA138_special;
            this.transition = DFA138_transition;
        }
        public String getDescription() {
            return "824:5: ( ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+ -> ^( LABINOP additiveExpression ( $i additiveExpression )+ ) | ( '>' '>' '>' additiveExpression )+ -> ^( USHR additiveExpression ( additiveExpression )+ ) | -> additiveExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA138_28 = input.LA(1);

                         
                        int index138_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred218_Java()) ) {s = 71;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index138_28);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA138_49 = input.LA(1);

                         
                        int index138_49 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred218_Java()) ) {s = 71;}

                        else if ( (synpred220_Java()) ) {s = 72;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index138_49);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 138, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA136_eotS =
        "\110\uffff";
    static final String DFA136_eofS =
        "\1\3\107\uffff";
    static final String DFA136_minS =
        "\1\171\2\145\32\uffff\1\0\24\uffff\1\0\25\uffff";
    static final String DFA136_maxS =
        "\1\u00c9\2\u00ce\32\uffff\1\0\24\uffff\1\0\25\uffff";
    static final String DFA136_acceptS =
        "\3\uffff\1\2\103\uffff\1\1";
    static final String DFA136_specialS =
        "\35\uffff\1\0\24\uffff\1\1\25\uffff}>";
    static final String[] DFA136_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\1\1\1\3\1\2\1\3\1\uffff\1\3\4\uffff"+
            "\2\3\25\uffff\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\16\3",
            "\7\3\25\uffff\1\35\6\uffff\1\3\3\uffff\1\3\12\uffff\13\3\1"+
            "\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "\7\3\25\uffff\1\3\1\uffff\1\62\4\uffff\1\3\3\uffff\1\3\12"+
            "\uffff\13\3\1\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5"+
            "\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA136_eot = DFA.unpackEncodedString(DFA136_eotS);
    static final short[] DFA136_eof = DFA.unpackEncodedString(DFA136_eofS);
    static final char[] DFA136_min = DFA.unpackEncodedStringToUnsignedChars(DFA136_minS);
    static final char[] DFA136_max = DFA.unpackEncodedStringToUnsignedChars(DFA136_maxS);
    static final short[] DFA136_accept = DFA.unpackEncodedString(DFA136_acceptS);
    static final short[] DFA136_special = DFA.unpackEncodedString(DFA136_specialS);
    static final short[][] DFA136_transition;

    static {
        int numStates = DFA136_transitionS.length;
        DFA136_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA136_transition[i] = DFA.unpackEncodedString(DFA136_transitionS[i]);
        }
    }

    class DFA136 extends DFA {

        public DFA136(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 136;
            this.eot = DFA136_eot;
            this.eof = DFA136_eof;
            this.min = DFA136_min;
            this.max = DFA136_max;
            this.accept = DFA136_accept;
            this.special = DFA136_special;
            this.transition = DFA136_transition;
        }
        public String getDescription() {
            return "()+ loopback of 825:6: ( (i+= '<' '<' | i+= '>' '>' ) additiveExpression )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA136_29 = input.LA(1);

                         
                        int index136_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred217_Java()) ) {s = 71;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index136_29);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA136_50 = input.LA(1);

                         
                        int index136_50 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred217_Java()) ) {s = 71;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index136_50);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 136, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA137_eotS =
        "\63\uffff";
    static final String DFA137_eofS =
        "\1\1\62\uffff";
    static final String DFA137_minS =
        "\1\171\1\uffff\1\145\32\uffff\1\0\25\uffff";
    static final String DFA137_maxS =
        "\1\u00c9\1\uffff\1\u00ce\32\uffff\1\0\25\uffff";
    static final String DFA137_acceptS =
        "\1\uffff\1\2\60\uffff\1\1";
    static final String DFA137_specialS =
        "\35\uffff\1\0\25\uffff}>";
    static final String[] DFA137_transitionS = {
            "\1\1\3\uffff\1\1\3\uffff\2\1\1\2\1\1\1\uffff\1\1\4\uffff\2"+
            "\1\25\uffff\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\16\1",
            "",
            "\7\1\25\uffff\1\1\1\uffff\1\35\4\uffff\1\1\3\uffff\1\1\12"+
            "\uffff\13\1\1\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5"+
            "\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA137_eot = DFA.unpackEncodedString(DFA137_eotS);
    static final short[] DFA137_eof = DFA.unpackEncodedString(DFA137_eofS);
    static final char[] DFA137_min = DFA.unpackEncodedStringToUnsignedChars(DFA137_minS);
    static final char[] DFA137_max = DFA.unpackEncodedStringToUnsignedChars(DFA137_maxS);
    static final short[] DFA137_accept = DFA.unpackEncodedString(DFA137_acceptS);
    static final short[] DFA137_special = DFA.unpackEncodedString(DFA137_specialS);
    static final short[][] DFA137_transition;

    static {
        int numStates = DFA137_transitionS.length;
        DFA137_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA137_transition[i] = DFA.unpackEncodedString(DFA137_transitionS[i]);
        }
    }

    class DFA137 extends DFA {

        public DFA137(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 137;
            this.eot = DFA137_eot;
            this.eof = DFA137_eof;
            this.min = DFA137_min;
            this.max = DFA137_max;
            this.accept = DFA137_accept;
            this.special = DFA137_special;
            this.transition = DFA137_transition;
        }
        public String getDescription() {
            return "()+ loopback of 827:8: ( '>' '>' '>' additiveExpression )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA137_29 = input.LA(1);

                         
                        int index137_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred219_Java()) ) {s = 50;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index137_29);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 137, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA141_eotS =
        "\106\uffff";
    static final String DFA141_eofS =
        "\1\3\105\uffff";
    static final String DFA141_minS =
        "\1\171\2\145\103\uffff";
    static final String DFA141_maxS =
        "\1\u00c9\2\u00ce\103\uffff";
    static final String DFA141_acceptS =
        "\3\uffff\1\2\31\uffff\1\1\50\uffff";
    static final String DFA141_specialS =
        "\106\uffff}>";
    static final String[] DFA141_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\4\3\1\uffff\1\3\4\uffff\2\3\25\uffff"+
            "\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\1\1\1\2\14\3",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\3\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\3\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA141_eot = DFA.unpackEncodedString(DFA141_eotS);
    static final short[] DFA141_eof = DFA.unpackEncodedString(DFA141_eofS);
    static final char[] DFA141_min = DFA.unpackEncodedStringToUnsignedChars(DFA141_minS);
    static final char[] DFA141_max = DFA.unpackEncodedStringToUnsignedChars(DFA141_maxS);
    static final short[] DFA141_accept = DFA.unpackEncodedString(DFA141_acceptS);
    static final short[] DFA141_special = DFA.unpackEncodedString(DFA141_specialS);
    static final short[][] DFA141_transition;

    static {
        int numStates = DFA141_transitionS.length;
        DFA141_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA141_transition[i] = DFA.unpackEncodedString(DFA141_transitionS[i]);
        }
    }

    class DFA141 extends DFA {

        public DFA141(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 141;
            this.eot = DFA141_eot;
            this.eof = DFA141_eof;
            this.min = DFA141_min;
            this.max = DFA141_max;
            this.accept = DFA141_accept;
            this.special = DFA141_special;
            this.transition = DFA141_transition;
        }
        public String getDescription() {
            return "834:5: ( ( (i+= '+' | i+= '-' ) multiplicativeExpression )+ -> ^( LABINOP multiplicativeExpression ( $i multiplicativeExpression )+ ) | -> multiplicativeExpression )";
        }
    }
    static final String DFA140_eotS =
        "\106\uffff";
    static final String DFA140_eofS =
        "\1\1\105\uffff";
    static final String DFA140_minS =
        "\1\171\21\uffff\2\145\62\uffff";
    static final String DFA140_maxS =
        "\1\u00c9\21\uffff\2\u00ce\62\uffff";
    static final String DFA140_acceptS =
        "\1\uffff\1\2\33\uffff\1\1\50\uffff";
    static final String DFA140_specialS =
        "\106\uffff}>";
    static final String[] DFA140_transitionS = {
            "\1\1\3\uffff\1\1\3\uffff\4\1\1\uffff\1\1\4\uffff\2\1\25\uffff"+
            "\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\1\22\1\23\14\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\1\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\1\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA140_eot = DFA.unpackEncodedString(DFA140_eotS);
    static final short[] DFA140_eof = DFA.unpackEncodedString(DFA140_eofS);
    static final char[] DFA140_min = DFA.unpackEncodedStringToUnsignedChars(DFA140_minS);
    static final char[] DFA140_max = DFA.unpackEncodedStringToUnsignedChars(DFA140_maxS);
    static final short[] DFA140_accept = DFA.unpackEncodedString(DFA140_acceptS);
    static final short[] DFA140_special = DFA.unpackEncodedString(DFA140_specialS);
    static final short[][] DFA140_transition;

    static {
        int numStates = DFA140_transitionS.length;
        DFA140_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA140_transition[i] = DFA.unpackEncodedString(DFA140_transitionS[i]);
        }
    }

    class DFA140 extends DFA {

        public DFA140(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 140;
            this.eot = DFA140_eot;
            this.eof = DFA140_eof;
            this.min = DFA140_min;
            this.max = DFA140_max;
            this.accept = DFA140_accept;
            this.special = DFA140_special;
            this.transition = DFA140_transition;
        }
        public String getDescription() {
            return "()+ loopback of 835:6: ( (i+= '+' | i+= '-' ) multiplicativeExpression )+";
        }
    }
    static final String DFA144_eotS =
        "\133\uffff";
    static final String DFA144_eofS =
        "\1\4\132\uffff";
    static final String DFA144_minS =
        "\1\171\3\145\127\uffff";
    static final String DFA144_maxS =
        "\1\u00c9\3\u00ce\127\uffff";
    static final String DFA144_acceptS =
        "\4\uffff\1\2\30\uffff\1\1\75\uffff";
    static final String DFA144_specialS =
        "\133\uffff}>";
    static final String[] DFA144_transitionS = {
            "\1\4\3\uffff\1\1\3\uffff\4\4\1\uffff\1\4\4\uffff\2\4\25\uffff"+
            "\1\4\2\uffff\1\4\7\uffff\1\4\16\uffff\2\4\1\2\3\4\1\3\7\4",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\4\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\4\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\4\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA144_eot = DFA.unpackEncodedString(DFA144_eotS);
    static final short[] DFA144_eof = DFA.unpackEncodedString(DFA144_eofS);
    static final char[] DFA144_min = DFA.unpackEncodedStringToUnsignedChars(DFA144_minS);
    static final char[] DFA144_max = DFA.unpackEncodedStringToUnsignedChars(DFA144_maxS);
    static final short[] DFA144_accept = DFA.unpackEncodedString(DFA144_acceptS);
    static final short[] DFA144_special = DFA.unpackEncodedString(DFA144_specialS);
    static final short[][] DFA144_transition;

    static {
        int numStates = DFA144_transitionS.length;
        DFA144_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA144_transition[i] = DFA.unpackEncodedString(DFA144_transitionS[i]);
        }
    }

    class DFA144 extends DFA {

        public DFA144(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 144;
            this.eot = DFA144_eot;
            this.eof = DFA144_eof;
            this.min = DFA144_min;
            this.max = DFA144_max;
            this.accept = DFA144_accept;
            this.special = DFA144_special;
            this.transition = DFA144_transition;
        }
        public String getDescription() {
            return "842:5: ( ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+ -> ^( LABINOP unaryExpression ( $i unaryExpression )+ ) | -> unaryExpression )";
        }
    }
    static final String DFA143_eotS =
        "\133\uffff";
    static final String DFA143_eofS =
        "\1\1\132\uffff";
    static final String DFA143_minS =
        "\1\171\23\uffff\2\145\3\uffff\1\145\101\uffff";
    static final String DFA143_maxS =
        "\1\u00c9\23\uffff\2\u00ce\3\uffff\1\u00ce\101\uffff";
    static final String DFA143_acceptS =
        "\1\uffff\1\2\33\uffff\1\1\75\uffff";
    static final String DFA143_specialS =
        "\133\uffff}>";
    static final String[] DFA143_transitionS = {
            "\1\1\3\uffff\1\24\3\uffff\4\1\1\uffff\1\1\4\uffff\2\1\25\uffff"+
            "\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\2\1\1\25\3\1\1\31\7\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\1\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\1\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "",
            "",
            "",
            "\7\35\25\uffff\1\35\6\uffff\1\35\3\uffff\1\1\12\uffff\13\35"+
            "\1\uffff\2\35\2\uffff\3\35\22\uffff\2\35\14\uffff\5\35",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA143_eot = DFA.unpackEncodedString(DFA143_eotS);
    static final short[] DFA143_eof = DFA.unpackEncodedString(DFA143_eofS);
    static final char[] DFA143_min = DFA.unpackEncodedStringToUnsignedChars(DFA143_minS);
    static final char[] DFA143_max = DFA.unpackEncodedStringToUnsignedChars(DFA143_maxS);
    static final short[] DFA143_accept = DFA.unpackEncodedString(DFA143_acceptS);
    static final short[] DFA143_special = DFA.unpackEncodedString(DFA143_specialS);
    static final short[][] DFA143_transition;

    static {
        int numStates = DFA143_transitionS.length;
        DFA143_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA143_transition[i] = DFA.unpackEncodedString(DFA143_transitionS[i]);
        }
    }

    class DFA143 extends DFA {

        public DFA143(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 143;
            this.eot = DFA143_eot;
            this.eof = DFA143_eof;
            this.min = DFA143_min;
            this.max = DFA143_max;
            this.accept = DFA143_accept;
            this.special = DFA143_special;
            this.transition = DFA143_transition;
        }
        public String getDescription() {
            return "()+ loopback of 843:6: ( (i+= '*' | i+= '/' | i+= '%' ) unaryExpression )+";
        }
    }
    static final String DFA145_eotS =
        "\25\uffff";
    static final String DFA145_eofS =
        "\25\uffff";
    static final String DFA145_minS =
        "\1\145\24\uffff";
    static final String DFA145_maxS =
        "\1\u00ce\24\uffff";
    static final String DFA145_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\17\uffff";
    static final String DFA145_specialS =
        "\25\uffff}>";
    static final String[] DFA145_transitionS = {
            "\7\5\25\uffff\1\5\6\uffff\1\5\16\uffff\13\5\1\uffff\2\5\2\uffff"+
            "\3\5\22\uffff\1\1\1\2\14\uffff\1\3\1\4\3\5",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA145_eot = DFA.unpackEncodedString(DFA145_eotS);
    static final short[] DFA145_eof = DFA.unpackEncodedString(DFA145_eofS);
    static final char[] DFA145_min = DFA.unpackEncodedStringToUnsignedChars(DFA145_minS);
    static final char[] DFA145_max = DFA.unpackEncodedStringToUnsignedChars(DFA145_maxS);
    static final short[] DFA145_accept = DFA.unpackEncodedString(DFA145_acceptS);
    static final short[] DFA145_special = DFA.unpackEncodedString(DFA145_specialS);
    static final short[][] DFA145_transition;

    static {
        int numStates = DFA145_transitionS.length;
        DFA145_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA145_transition[i] = DFA.unpackEncodedString(DFA145_transitionS[i]);
        }
    }

    class DFA145 extends DFA {

        public DFA145(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 145;
            this.eot = DFA145_eot;
            this.eof = DFA145_eof;
            this.min = DFA145_min;
            this.max = DFA145_max;
            this.accept = DFA145_accept;
            this.special = DFA145_special;
            this.transition = DFA145_transition;
        }
        public String getDescription() {
            return "848:1: unaryExpression : ( '+' unaryExpression -> unaryExpression | '-' unaryExpression -> ^( NEG unaryExpression ) | '++' unaryExpression -> ^( PREINC unaryExpression ) | '--' unaryExpression -> ^( PREDEC unaryExpression ) | unaryExpressionNotPlusMinus -> unaryExpressionNotPlusMinus );";
        }
    }
    static final String DFA149_eotS =
        "\46\uffff";
    static final String DFA149_eofS =
        "\46\uffff";
    static final String DFA149_minS =
        "\1\145\2\uffff\1\145\15\uffff\24\0\1\uffff";
    static final String DFA149_maxS =
        "\1\u00ce\2\uffff\1\u00ce\15\uffff\24\0\1\uffff";
    static final String DFA149_acceptS =
        "\1\uffff\1\1\1\2\1\uffff\1\4\40\uffff\1\3";
    static final String DFA149_specialS =
        "\21\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1"+
        "\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\uffff}>";
    static final String[] DFA149_transitionS = {
            "\7\4\25\uffff\1\4\6\uffff\1\4\16\uffff\13\4\1\uffff\1\4\1\3"+
            "\2\uffff\3\4\42\uffff\1\1\1\2\1\4",
            "",
            "",
            "\1\41\1\32\1\33\1\34\3\31\25\uffff\1\30\6\uffff\1\43\16\uffff"+
            "\3\40\10\42\1\uffff\1\44\1\27\2\uffff\1\36\2\35\22\uffff\1\21"+
            "\1\22\14\uffff\1\23\1\24\1\25\1\26\1\37",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] DFA149_eot = DFA.unpackEncodedString(DFA149_eotS);
    static final short[] DFA149_eof = DFA.unpackEncodedString(DFA149_eofS);
    static final char[] DFA149_min = DFA.unpackEncodedStringToUnsignedChars(DFA149_minS);
    static final char[] DFA149_max = DFA.unpackEncodedStringToUnsignedChars(DFA149_maxS);
    static final short[] DFA149_accept = DFA.unpackEncodedString(DFA149_acceptS);
    static final short[] DFA149_special = DFA.unpackEncodedString(DFA149_specialS);
    static final short[][] DFA149_transition;

    static {
        int numStates = DFA149_transitionS.length;
        DFA149_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA149_transition[i] = DFA.unpackEncodedString(DFA149_transitionS[i]);
        }
    }

    class DFA149 extends DFA {

        public DFA149(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 149;
            this.eot = DFA149_eot;
            this.eof = DFA149_eof;
            this.min = DFA149_min;
            this.max = DFA149_max;
            this.accept = DFA149_accept;
            this.special = DFA149_special;
            this.transition = DFA149_transition;
        }
        public String getDescription() {
            return "856:1: unaryExpressionNotPlusMinus : ( '~' unaryExpression -> ^( INV unaryExpression ) | '!' unaryExpression -> ^( NOT unaryExpression ) | castExpression | primary ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA149_17 = input.LA(1);

                         
                        int index149_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_17);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA149_18 = input.LA(1);

                         
                        int index149_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_18);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA149_19 = input.LA(1);

                         
                        int index149_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_19);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA149_20 = input.LA(1);

                         
                        int index149_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_20);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA149_21 = input.LA(1);

                         
                        int index149_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_21);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA149_22 = input.LA(1);

                         
                        int index149_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_22);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA149_23 = input.LA(1);

                         
                        int index149_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_23);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA149_24 = input.LA(1);

                         
                        int index149_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_24);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA149_25 = input.LA(1);

                         
                        int index149_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_25);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA149_26 = input.LA(1);

                         
                        int index149_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_26);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA149_27 = input.LA(1);

                         
                        int index149_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_27);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA149_28 = input.LA(1);

                         
                        int index149_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_28);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA149_29 = input.LA(1);

                         
                        int index149_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_29);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA149_30 = input.LA(1);

                         
                        int index149_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_30);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA149_31 = input.LA(1);

                         
                        int index149_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_31);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA149_32 = input.LA(1);

                         
                        int index149_32 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_32);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA149_33 = input.LA(1);

                         
                        int index149_33 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_33);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA149_34 = input.LA(1);

                         
                        int index149_34 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_34);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA149_35 = input.LA(1);

                         
                        int index149_35 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_35);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA149_36 = input.LA(1);

                         
                        int index149_36 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred234_Java()) ) {s = 37;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index149_36);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 149, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA148_eotS =
        "\40\uffff";
    static final String DFA148_eofS =
        "\1\5\37\uffff";
    static final String DFA148_minS =
        "\1\171\37\uffff";
    static final String DFA148_maxS =
        "\1\u00cb\37\uffff";
    static final String DFA148_acceptS =
        "\1\uffff\1\1\1\uffff\1\2\1\3\1\4\32\uffff";
    static final String DFA148_specialS =
        "\40\uffff}>";
    static final String[] DFA148_transitionS = {
            "\1\5\2\uffff\1\1\1\5\3\uffff\4\5\1\uffff\1\5\3\uffff\1\1\2"+
            "\5\25\uffff\1\5\2\uffff\1\5\7\uffff\1\5\16\uffff\16\5\1\3\1"+
            "\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA148_eot = DFA.unpackEncodedString(DFA148_eotS);
    static final short[] DFA148_eof = DFA.unpackEncodedString(DFA148_eofS);
    static final char[] DFA148_min = DFA.unpackEncodedStringToUnsignedChars(DFA148_minS);
    static final char[] DFA148_max = DFA.unpackEncodedStringToUnsignedChars(DFA148_maxS);
    static final short[] DFA148_accept = DFA.unpackEncodedString(DFA148_acceptS);
    static final short[] DFA148_special = DFA.unpackEncodedString(DFA148_specialS);
    static final short[][] DFA148_transition;

    static {
        int numStates = DFA148_transitionS.length;
        DFA148_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA148_transition[i] = DFA.unpackEncodedString(DFA148_transitionS[i]);
        }
    }

    class DFA148 extends DFA {

        public DFA148(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 148;
            this.eot = DFA148_eot;
            this.eof = DFA148_eof;
            this.min = DFA148_min;
            this.max = DFA148_max;
            this.accept = DFA148_accept;
            this.special = DFA148_special;
            this.transition = DFA148_transition;
        }
        public String getDescription() {
            return "861:3: ( ( selector )+ ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) ) | '++' -> ^( POSTINC primary ) | '--' -> ^( POSTDEC primary ) | -> primary )";
        }
    }
    static final String DFA146_eotS =
        "\40\uffff";
    static final String DFA146_eofS =
        "\1\1\37\uffff";
    static final String DFA146_minS =
        "\1\171\37\uffff";
    static final String DFA146_maxS =
        "\1\u00cb\37\uffff";
    static final String DFA146_acceptS =
        "\1\uffff\1\2\34\uffff\1\1\1\uffff";
    static final String DFA146_specialS =
        "\40\uffff}>";
    static final String[] DFA146_transitionS = {
            "\1\1\2\uffff\1\36\1\1\3\uffff\4\1\1\uffff\1\1\3\uffff\1\36"+
            "\2\1\25\uffff\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\20\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA146_eot = DFA.unpackEncodedString(DFA146_eotS);
    static final short[] DFA146_eof = DFA.unpackEncodedString(DFA146_eofS);
    static final char[] DFA146_min = DFA.unpackEncodedStringToUnsignedChars(DFA146_minS);
    static final char[] DFA146_max = DFA.unpackEncodedStringToUnsignedChars(DFA146_maxS);
    static final short[] DFA146_accept = DFA.unpackEncodedString(DFA146_acceptS);
    static final short[] DFA146_special = DFA.unpackEncodedString(DFA146_specialS);
    static final short[][] DFA146_transition;

    static {
        int numStates = DFA146_transitionS.length;
        DFA146_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA146_transition[i] = DFA.unpackEncodedString(DFA146_transitionS[i]);
        }
    }

    class DFA146 extends DFA {

        public DFA146(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 146;
            this.eot = DFA146_eot;
            this.eof = DFA146_eof;
            this.min = DFA146_min;
            this.max = DFA146_max;
            this.accept = DFA146_accept;
            this.special = DFA146_special;
            this.transition = DFA146_transition;
        }
        public String getDescription() {
            return "()+ loopback of 862:4: ( selector )+";
        }
    }
    static final String DFA147_eotS =
        "\36\uffff";
    static final String DFA147_eofS =
        "\1\3\35\uffff";
    static final String DFA147_minS =
        "\1\171\35\uffff";
    static final String DFA147_maxS =
        "\1\u00cb\35\uffff";
    static final String DFA147_acceptS =
        "\1\uffff\1\1\1\2\1\3\32\uffff";
    static final String DFA147_specialS =
        "\36\uffff}>";
    static final String[] DFA147_transitionS = {
            "\1\3\3\uffff\1\3\3\uffff\4\3\1\uffff\1\3\4\uffff\2\3\25\uffff"+
            "\1\3\2\uffff\1\3\7\uffff\1\3\16\uffff\16\3\1\1\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA147_eot = DFA.unpackEncodedString(DFA147_eotS);
    static final short[] DFA147_eof = DFA.unpackEncodedString(DFA147_eofS);
    static final char[] DFA147_min = DFA.unpackEncodedStringToUnsignedChars(DFA147_minS);
    static final char[] DFA147_max = DFA.unpackEncodedStringToUnsignedChars(DFA147_maxS);
    static final short[] DFA147_accept = DFA.unpackEncodedString(DFA147_acceptS);
    static final short[] DFA147_special = DFA.unpackEncodedString(DFA147_specialS);
    static final short[][] DFA147_transition;

    static {
        int numStates = DFA147_transitionS.length;
        DFA147_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA147_transition[i] = DFA.unpackEncodedString(DFA147_transitionS[i]);
        }
    }

    class DFA147 extends DFA {

        public DFA147(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 147;
            this.eot = DFA147_eot;
            this.eof = DFA147_eof;
            this.min = DFA147_min;
            this.max = DFA147_max;
            this.accept = DFA147_accept;
            this.special = DFA147_special;
            this.transition = DFA147_transition;
        }
        public String getDescription() {
            return "863:4: ( '++' -> ^( POSTINC ^( SELECTOR primary ( selector )+ ) ) | '--' -> ^( POSTDEC ^( SELECTOR primary ( selector )+ ) ) | -> ^( SELECTOR primary ( selector )+ ) )";
        }
    }
    static final String DFA150_eotS =
        "\30\uffff";
    static final String DFA150_eofS =
        "\30\uffff";
    static final String DFA150_minS =
        "\1\u00a4\1\145\1\0\17\uffff\2\0\4\uffff";
    static final String DFA150_maxS =
        "\1\u00a4\1\u00ce\1\0\17\uffff\2\0\4\uffff";
    static final String DFA150_acceptS =
        "\3\uffff\1\3\22\uffff\1\1\1\2";
    static final String DFA150_specialS =
        "\2\uffff\1\0\17\uffff\1\1\1\2\4\uffff}>";
    static final String[] DFA150_transitionS = {
            "\1\1",
            "\1\23\6\3\25\uffff\1\3\6\uffff\1\3\16\uffff\3\22\10\2\1\uffff"+
            "\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA150_eot = DFA.unpackEncodedString(DFA150_eotS);
    static final short[] DFA150_eof = DFA.unpackEncodedString(DFA150_eofS);
    static final char[] DFA150_min = DFA.unpackEncodedStringToUnsignedChars(DFA150_minS);
    static final char[] DFA150_max = DFA.unpackEncodedStringToUnsignedChars(DFA150_maxS);
    static final short[] DFA150_accept = DFA.unpackEncodedString(DFA150_acceptS);
    static final short[] DFA150_special = DFA.unpackEncodedString(DFA150_specialS);
    static final short[][] DFA150_transition;

    static {
        int numStates = DFA150_transitionS.length;
        DFA150_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA150_transition[i] = DFA.unpackEncodedString(DFA150_transitionS[i]);
        }
    }

    class DFA150 extends DFA {

        public DFA150(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 150;
            this.eot = DFA150_eot;
            this.eof = DFA150_eof;
            this.min = DFA150_min;
            this.max = DFA150_max;
            this.accept = DFA150_accept;
            this.special = DFA150_special;
            this.transition = DFA150_transition;
        }
        public String getDescription() {
            return "874:1: castExpression : ( '(' primitiveType ')' unaryExpression -> ^( CAST ^( TYPE primitiveType ) unaryExpression ) | '(' type ')' unaryExpressionNotPlusMinus -> ^( CAST type unaryExpressionNotPlusMinus ) | '(' expression ')' unaryExpressionNotPlusMinus ->);";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA150_2 = input.LA(1);

                         
                        int index150_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred241_Java()) ) {s = 22;}

                        else if ( (synpred242_Java()) ) {s = 23;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index150_2);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA150_18 = input.LA(1);

                         
                        int index150_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred242_Java()) ) {s = 23;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index150_18);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA150_19 = input.LA(1);

                         
                        int index150_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred242_Java()) ) {s = 23;}

                        else if ( (true) ) {s = 3;}

                         
                        input.seek(index150_19);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 150, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA165_eotS =
        "\63\uffff";
    static final String DFA165_eofS =
        "\13\uffff\1\23\47\uffff";
    static final String DFA165_minS =
        "\1\145\10\uffff\1\145\1\uffff\1\171\3\uffff\1\0\4\uffff\2\0\7\uffff"+
        "\1\0\25\uffff";
    static final String DFA165_maxS =
        "\1\u00ce\10\uffff\1\u00a1\1\uffff\1\u00cb\3\uffff\1\0\4\uffff\2"+
        "\0\7\uffff\1\0\25\uffff";
    static final String DFA165_acceptS =
        "\1\uffff\1\1\1\2\1\3\6\uffff\1\6\2\uffff\1\7\1\10\1\uffff\1\4\1"+
        "\5\1\uffff\1\11\37\uffff";
    static final String DFA165_specialS =
        "\17\uffff\1\0\4\uffff\1\1\1\2\7\uffff\1\3\25\uffff}>";
    static final String[] DFA165_transitionS = {
            "\1\13\6\3\25\uffff\1\2\6\uffff\1\15\16\uffff\13\12\1\uffff"+
            "\1\16\1\1\2\uffff\3\3\44\uffff\1\11",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\21\33\uffff\1\17\25\uffff\3\21\10\20",
            "",
            "\1\23\2\uffff\1\24\1\23\3\uffff\1\35\3\23\1\uffff\1\23\3\uffff"+
            "\1\25\2\23\25\uffff\1\23\1\uffff\2\23\7\uffff\1\23\16\uffff"+
            "\20\23",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA165_eot = DFA.unpackEncodedString(DFA165_eotS);
    static final short[] DFA165_eof = DFA.unpackEncodedString(DFA165_eofS);
    static final char[] DFA165_min = DFA.unpackEncodedStringToUnsignedChars(DFA165_minS);
    static final char[] DFA165_max = DFA.unpackEncodedStringToUnsignedChars(DFA165_maxS);
    static final short[] DFA165_accept = DFA.unpackEncodedString(DFA165_acceptS);
    static final short[] DFA165_special = DFA.unpackEncodedString(DFA165_specialS);
    static final short[][] DFA165_transition;

    static {
        int numStates = DFA165_transitionS.length;
        DFA165_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA165_transition[i] = DFA.unpackEncodedString(DFA165_transitionS[i]);
        }
    }

    class DFA165 extends DFA {

        public DFA165(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 165;
            this.eot = DFA165_eot;
            this.eof = DFA165_eof;
            this.min = DFA165_min;
            this.max = DFA165_max;
            this.accept = DFA165_accept;
            this.special = DFA165_special;
            this.transition = DFA165_transition;
        }
        public String getDescription() {
            return "880:1: primary : ( parExpression | nonWildcardTypeArguments explicitGenericInvocationSuffix -> ^( INVOKE ^( TYPE_PARAMETER nonWildcardTypeArguments ) explicitGenericInvocationSuffix ) | literal | 'new' ( nonWildcardTypeArguments )? primitiveType ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) ) | 'new' ( nonWildcardTypeArguments )? ( uniMod )? (i+= refComponent ( '.' i+= refComponent )* ) ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) ) | type '.' 'class' -> ^( GETCLASS type ) | 'void' '.' 'class' -> ^( GETCLASS ^( TYPE VOID ) ) | 'super' ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) ) | Identifier ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA165_15 = input.LA(1);

                         
                        int index165_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred251_Java()) ) {s = 16;}

                        else if ( (synpred260_Java()) ) {s = 17;}

                         
                        input.seek(index165_15);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA165_20 = input.LA(1);

                         
                        int index165_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred261_Java()) ) {s = 10;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index165_20);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA165_21 = input.LA(1);

                         
                        int index165_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred261_Java()) ) {s = 10;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index165_21);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA165_29 = input.LA(1);

                         
                        int index165_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred261_Java()) ) {s = 10;}

                        else if ( (true) ) {s = 19;}

                         
                        input.seek(index165_29);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 165, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA155_eotS =
        "\27\uffff";
    static final String DFA155_eofS =
        "\27\uffff";
    static final String DFA155_minS =
        "\1\u008a\1\145\25\uffff";
    static final String DFA155_maxS =
        "\1\u008a\1\u00ce\25\uffff";
    static final String DFA155_acceptS =
        "\2\uffff\1\2\1\1\23\uffff";
    static final String DFA155_specialS =
        "\27\uffff}>";
    static final String[] DFA155_transitionS = {
            "\1\1",
            "\7\3\25\uffff\1\3\6\uffff\1\3\2\uffff\1\2\13\uffff\13\3\1"+
            "\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA155_eot = DFA.unpackEncodedString(DFA155_eotS);
    static final short[] DFA155_eof = DFA.unpackEncodedString(DFA155_eofS);
    static final char[] DFA155_min = DFA.unpackEncodedStringToUnsignedChars(DFA155_minS);
    static final char[] DFA155_max = DFA.unpackEncodedStringToUnsignedChars(DFA155_maxS);
    static final short[] DFA155_accept = DFA.unpackEncodedString(DFA155_acceptS);
    static final short[] DFA155_special = DFA.unpackEncodedString(DFA155_specialS);
    static final short[][] DFA155_transition;

    static {
        int numStates = DFA155_transitionS.length;
        DFA155_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA155_transition[i] = DFA.unpackEncodedString(DFA155_transitionS[i]);
        }
    }

    class DFA155 extends DFA {

        public DFA155(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 155;
            this.eot = DFA155_eot;
            this.eof = DFA155_eof;
            this.min = DFA155_min;
            this.max = DFA155_max;
            this.accept = DFA155_accept;
            this.special = DFA155_special;
            this.transition = DFA155_transition;
        }
        public String getDescription() {
            return "885:6: ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE primitiveType ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE primitiveType ( '[' )* ) arrayInitializer ) )";
        }
    }
    static final String DFA152_eotS =
        "\66\uffff";
    static final String DFA152_eofS =
        "\1\2\65\uffff";
    static final String DFA152_minS =
        "\1\171\1\145\37\uffff\24\0\1\uffff";
    static final String DFA152_maxS =
        "\1\u00cb\1\u00ce\37\uffff\24\0\1\uffff";
    static final String DFA152_acceptS =
        "\2\uffff\1\2\62\uffff\1\1";
    static final String DFA152_specialS =
        "\41\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1"+
        "\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\uffff}>";
    static final String[] DFA152_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\1\1\2\2\25"+
            "\uffff\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\20\2",
            "\1\61\1\52\1\53\1\54\3\51\25\uffff\1\50\6\uffff\1\63\2\uffff"+
            "\1\2\13\uffff\3\60\10\62\1\uffff\1\64\1\47\2\uffff\1\56\2\55"+
            "\22\uffff\1\41\1\42\14\uffff\1\43\1\44\1\45\1\46\1\57",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] DFA152_eot = DFA.unpackEncodedString(DFA152_eotS);
    static final short[] DFA152_eof = DFA.unpackEncodedString(DFA152_eofS);
    static final char[] DFA152_min = DFA.unpackEncodedStringToUnsignedChars(DFA152_minS);
    static final char[] DFA152_max = DFA.unpackEncodedStringToUnsignedChars(DFA152_maxS);
    static final short[] DFA152_accept = DFA.unpackEncodedString(DFA152_acceptS);
    static final short[] DFA152_special = DFA.unpackEncodedString(DFA152_specialS);
    static final short[][] DFA152_transition;

    static {
        int numStates = DFA152_transitionS.length;
        DFA152_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA152_transition[i] = DFA.unpackEncodedString(DFA152_transitionS[i]);
        }
    }

    class DFA152 extends DFA {

        public DFA152(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 152;
            this.eot = DFA152_eot;
            this.eof = DFA152_eof;
            this.min = DFA152_min;
            this.max = DFA152_max;
            this.accept = DFA152_accept;
            this.special = DFA152_special;
            this.transition = DFA152_transition;
        }
        public String getDescription() {
            return "()+ loopback of 886:7: ( '[' expression ']' )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA152_33 = input.LA(1);

                         
                        int index152_33 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_33);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA152_34 = input.LA(1);

                         
                        int index152_34 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_34);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA152_35 = input.LA(1);

                         
                        int index152_35 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_35);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA152_36 = input.LA(1);

                         
                        int index152_36 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_36);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA152_37 = input.LA(1);

                         
                        int index152_37 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_37);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA152_38 = input.LA(1);

                         
                        int index152_38 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_38);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA152_39 = input.LA(1);

                         
                        int index152_39 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_39);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA152_40 = input.LA(1);

                         
                        int index152_40 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_40);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA152_41 = input.LA(1);

                         
                        int index152_41 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_41);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA152_42 = input.LA(1);

                         
                        int index152_42 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_42);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA152_43 = input.LA(1);

                         
                        int index152_43 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_43);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA152_44 = input.LA(1);

                         
                        int index152_44 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_44);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA152_45 = input.LA(1);

                         
                        int index152_45 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_45);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA152_46 = input.LA(1);

                         
                        int index152_46 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_46);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA152_47 = input.LA(1);

                         
                        int index152_47 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_47);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA152_48 = input.LA(1);

                         
                        int index152_48 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_48);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA152_49 = input.LA(1);

                         
                        int index152_49 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_49);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA152_50 = input.LA(1);

                         
                        int index152_50 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_50);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA152_51 = input.LA(1);

                         
                        int index152_51 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_51);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA152_52 = input.LA(1);

                         
                        int index152_52 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred247_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index152_52);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 152, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA153_eotS =
        "\65\uffff";
    static final String DFA153_eofS =
        "\1\1\64\uffff";
    static final String DFA153_minS =
        "\1\171\1\uffff\1\145\62\uffff";
    static final String DFA153_maxS =
        "\1\u00cb\1\uffff\1\u00ce\62\uffff";
    static final String DFA153_acceptS =
        "\1\uffff\1\2\36\uffff\1\1\24\uffff";
    static final String DFA153_specialS =
        "\65\uffff}>";
    static final String[] DFA153_transitionS = {
            "\1\1\2\uffff\2\1\3\uffff\4\1\1\uffff\1\1\3\uffff\1\2\2\1\25"+
            "\uffff\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\20\1",
            "",
            "\7\1\25\uffff\1\1\6\uffff\1\1\2\uffff\1\40\13\uffff\13\1\1"+
            "\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA153_eot = DFA.unpackEncodedString(DFA153_eotS);
    static final short[] DFA153_eof = DFA.unpackEncodedString(DFA153_eofS);
    static final char[] DFA153_min = DFA.unpackEncodedStringToUnsignedChars(DFA153_minS);
    static final char[] DFA153_max = DFA.unpackEncodedStringToUnsignedChars(DFA153_maxS);
    static final short[] DFA153_accept = DFA.unpackEncodedString(DFA153_acceptS);
    static final short[] DFA153_special = DFA.unpackEncodedString(DFA153_specialS);
    static final short[][] DFA153_transition;

    static {
        int numStates = DFA153_transitionS.length;
        DFA153_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA153_transition[i] = DFA.unpackEncodedString(DFA153_transitionS[i]);
        }
    }

    class DFA153 extends DFA {

        public DFA153(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 153;
            this.eot = DFA153_eot;
            this.eof = DFA153_eof;
            this.min = DFA153_min;
            this.max = DFA153_max;
            this.accept = DFA153_accept;
            this.special = DFA153_special;
            this.transition = DFA153_transition;
        }
        public String getDescription() {
            return "()* loopback of 886:29: ( '[' ']' )*";
        }
    }
    static final String DFA162_eotS =
        "\30\uffff";
    static final String DFA162_eofS =
        "\30\uffff";
    static final String DFA162_minS =
        "\1\u008a\1\145\26\uffff";
    static final String DFA162_maxS =
        "\1\u00a4\1\u00ce\26\uffff";
    static final String DFA162_acceptS =
        "\2\uffff\1\3\1\2\1\1\23\uffff";
    static final String DFA162_specialS =
        "\30\uffff}>";
    static final String[] DFA162_transitionS = {
            "\1\1\31\uffff\1\2",
            "\7\4\25\uffff\1\4\6\uffff\1\4\2\uffff\1\3\13\uffff\13\4\1"+
            "\uffff\2\4\2\uffff\3\4\22\uffff\2\4\14\uffff\5\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA162_eot = DFA.unpackEncodedString(DFA162_eotS);
    static final short[] DFA162_eof = DFA.unpackEncodedString(DFA162_eofS);
    static final char[] DFA162_min = DFA.unpackEncodedStringToUnsignedChars(DFA162_minS);
    static final char[] DFA162_max = DFA.unpackEncodedStringToUnsignedChars(DFA162_maxS);
    static final short[] DFA162_accept = DFA.unpackEncodedString(DFA162_acceptS);
    static final short[] DFA162_special = DFA.unpackEncodedString(DFA162_specialS);
    static final short[][] DFA162_transition;

    static {
        int numStates = DFA162_transitionS.length;
        DFA162_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA162_transition[i] = DFA.unpackEncodedString(DFA162_transitionS[i]);
        }
    }

    class DFA162 extends DFA {

        public DFA162(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 162;
            this.eot = DFA162_eot;
            this.eof = DFA162_eof;
            this.min = DFA162_min;
            this.max = DFA162_max;
            this.accept = DFA162_accept;
            this.special = DFA162_special;
            this.transition = DFA162_transition;
        }
        public String getDescription() {
            return "890:6: ( ( '[' expression ']' )+ ( '[' ']' )* -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) ( expression )* ) | ( '[' ']' )+ arrayInitializer -> ^( ARRAYINIT ^( TYPE ( uniMod )? ( $i)+ ( '[' )* ) arrayInitializer ) | classCreatorRest -> ^( NEW ^( TYPE ( uniMod )? ( $i)+ ) ( classCreatorRest )? ) )";
        }
    }
    static final String DFA159_eotS =
        "\66\uffff";
    static final String DFA159_eofS =
        "\1\2\65\uffff";
    static final String DFA159_minS =
        "\1\171\1\145\37\uffff\24\0\1\uffff";
    static final String DFA159_maxS =
        "\1\u00cb\1\u00ce\37\uffff\24\0\1\uffff";
    static final String DFA159_acceptS =
        "\2\uffff\1\2\62\uffff\1\1";
    static final String DFA159_specialS =
        "\41\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1"+
        "\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\uffff}>";
    static final String[] DFA159_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\1\1\2\2\25"+
            "\uffff\1\2\2\uffff\1\2\7\uffff\1\2\16\uffff\20\2",
            "\1\61\1\52\1\53\1\54\3\51\25\uffff\1\50\6\uffff\1\63\2\uffff"+
            "\1\2\13\uffff\3\60\10\62\1\uffff\1\64\1\47\2\uffff\1\56\2\55"+
            "\22\uffff\1\41\1\42\14\uffff\1\43\1\44\1\45\1\46\1\57",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] DFA159_eot = DFA.unpackEncodedString(DFA159_eotS);
    static final short[] DFA159_eof = DFA.unpackEncodedString(DFA159_eofS);
    static final char[] DFA159_min = DFA.unpackEncodedStringToUnsignedChars(DFA159_minS);
    static final char[] DFA159_max = DFA.unpackEncodedStringToUnsignedChars(DFA159_maxS);
    static final short[] DFA159_accept = DFA.unpackEncodedString(DFA159_acceptS);
    static final short[] DFA159_special = DFA.unpackEncodedString(DFA159_specialS);
    static final short[][] DFA159_transition;

    static {
        int numStates = DFA159_transitionS.length;
        DFA159_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA159_transition[i] = DFA.unpackEncodedString(DFA159_transitionS[i]);
        }
    }

    class DFA159 extends DFA {

        public DFA159(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 159;
            this.eot = DFA159_eot;
            this.eof = DFA159_eof;
            this.min = DFA159_min;
            this.max = DFA159_max;
            this.accept = DFA159_accept;
            this.special = DFA159_special;
            this.transition = DFA159_transition;
        }
        public String getDescription() {
            return "()+ loopback of 891:7: ( '[' expression ']' )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA159_33 = input.LA(1);

                         
                        int index159_33 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_33);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA159_34 = input.LA(1);

                         
                        int index159_34 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_34);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA159_35 = input.LA(1);

                         
                        int index159_35 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_35);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA159_36 = input.LA(1);

                         
                        int index159_36 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_36);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA159_37 = input.LA(1);

                         
                        int index159_37 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_37);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA159_38 = input.LA(1);

                         
                        int index159_38 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_38);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA159_39 = input.LA(1);

                         
                        int index159_39 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_39);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA159_40 = input.LA(1);

                         
                        int index159_40 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_40);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA159_41 = input.LA(1);

                         
                        int index159_41 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_41);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA159_42 = input.LA(1);

                         
                        int index159_42 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_42);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA159_43 = input.LA(1);

                         
                        int index159_43 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_43);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA159_44 = input.LA(1);

                         
                        int index159_44 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_44);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA159_45 = input.LA(1);

                         
                        int index159_45 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_45);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA159_46 = input.LA(1);

                         
                        int index159_46 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_46);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA159_47 = input.LA(1);

                         
                        int index159_47 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_47);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA159_48 = input.LA(1);

                         
                        int index159_48 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_48);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA159_49 = input.LA(1);

                         
                        int index159_49 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_49);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA159_50 = input.LA(1);

                         
                        int index159_50 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_50);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA159_51 = input.LA(1);

                         
                        int index159_51 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_51);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA159_52 = input.LA(1);

                         
                        int index159_52 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred255_Java()) ) {s = 53;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index159_52);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 159, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA160_eotS =
        "\65\uffff";
    static final String DFA160_eofS =
        "\1\1\64\uffff";
    static final String DFA160_minS =
        "\1\171\1\uffff\1\145\62\uffff";
    static final String DFA160_maxS =
        "\1\u00cb\1\uffff\1\u00ce\62\uffff";
    static final String DFA160_acceptS =
        "\1\uffff\1\2\36\uffff\1\1\24\uffff";
    static final String DFA160_specialS =
        "\65\uffff}>";
    static final String[] DFA160_transitionS = {
            "\1\1\2\uffff\2\1\3\uffff\4\1\1\uffff\1\1\3\uffff\1\2\2\1\25"+
            "\uffff\1\1\2\uffff\1\1\7\uffff\1\1\16\uffff\20\1",
            "",
            "\7\1\25\uffff\1\1\6\uffff\1\1\2\uffff\1\40\13\uffff\13\1\1"+
            "\uffff\2\1\2\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA160_eot = DFA.unpackEncodedString(DFA160_eotS);
    static final short[] DFA160_eof = DFA.unpackEncodedString(DFA160_eofS);
    static final char[] DFA160_min = DFA.unpackEncodedStringToUnsignedChars(DFA160_minS);
    static final char[] DFA160_max = DFA.unpackEncodedStringToUnsignedChars(DFA160_maxS);
    static final short[] DFA160_accept = DFA.unpackEncodedString(DFA160_acceptS);
    static final short[] DFA160_special = DFA.unpackEncodedString(DFA160_specialS);
    static final short[][] DFA160_transition;

    static {
        int numStates = DFA160_transitionS.length;
        DFA160_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA160_transition[i] = DFA.unpackEncodedString(DFA160_transitionS[i]);
        }
    }

    class DFA160 extends DFA {

        public DFA160(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 160;
            this.eot = DFA160_eot;
            this.eof = DFA160_eof;
            this.min = DFA160_min;
            this.max = DFA160_max;
            this.accept = DFA160_accept;
            this.special = DFA160_special;
            this.transition = DFA160_transition;
        }
        public String getDescription() {
            return "()* loopback of 891:29: ( '[' ']' )*";
        }
    }
    static final String DFA163_eotS =
        "\41\uffff";
    static final String DFA163_eofS =
        "\1\2\40\uffff";
    static final String DFA163_minS =
        "\1\171\40\uffff";
    static final String DFA163_maxS =
        "\1\u00cb\40\uffff";
    static final String DFA163_acceptS =
        "\1\uffff\1\1\1\2\36\uffff";
    static final String DFA163_specialS =
        "\41\uffff}>";
    static final String[] DFA163_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\3\2\25\uffff"+
            "\1\2\1\uffff\1\1\1\2\7\uffff\1\2\16\uffff\20\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA163_eot = DFA.unpackEncodedString(DFA163_eotS);
    static final short[] DFA163_eof = DFA.unpackEncodedString(DFA163_eofS);
    static final char[] DFA163_min = DFA.unpackEncodedStringToUnsignedChars(DFA163_minS);
    static final char[] DFA163_max = DFA.unpackEncodedStringToUnsignedChars(DFA163_maxS);
    static final short[] DFA163_accept = DFA.unpackEncodedString(DFA163_acceptS);
    static final short[] DFA163_special = DFA.unpackEncodedString(DFA163_specialS);
    static final short[][] DFA163_transition;

    static {
        int numStates = DFA163_transitionS.length;
        DFA163_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA163_transition[i] = DFA.unpackEncodedString(DFA163_transitionS[i]);
        }
    }

    class DFA163 extends DFA {

        public DFA163(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 163;
            this.eot = DFA163_eot;
            this.eof = DFA163_eof;
            this.min = DFA163_min;
            this.max = DFA163_max;
            this.accept = DFA163_accept;
            this.special = DFA163_special;
            this.transition = DFA163_transition;
        }
        public String getDescription() {
            return "898:3: ( arguments -> ^( INVOKE 'super' ( arguments )? ) | -> ^( VAR 'super' ) )";
        }
    }
    static final String DFA164_eotS =
        "\41\uffff";
    static final String DFA164_eofS =
        "\1\2\40\uffff";
    static final String DFA164_minS =
        "\1\171\40\uffff";
    static final String DFA164_maxS =
        "\1\u00cb\40\uffff";
    static final String DFA164_acceptS =
        "\1\uffff\1\1\1\2\36\uffff";
    static final String DFA164_specialS =
        "\41\uffff}>";
    static final String[] DFA164_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\3\2\25\uffff"+
            "\1\2\1\uffff\1\1\1\2\7\uffff\1\2\16\uffff\20\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA164_eot = DFA.unpackEncodedString(DFA164_eotS);
    static final short[] DFA164_eof = DFA.unpackEncodedString(DFA164_eofS);
    static final char[] DFA164_min = DFA.unpackEncodedStringToUnsignedChars(DFA164_minS);
    static final char[] DFA164_max = DFA.unpackEncodedStringToUnsignedChars(DFA164_maxS);
    static final short[] DFA164_accept = DFA.unpackEncodedString(DFA164_acceptS);
    static final short[] DFA164_special = DFA.unpackEncodedString(DFA164_specialS);
    static final short[][] DFA164_transition;

    static {
        int numStates = DFA164_transitionS.length;
        DFA164_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA164_transition[i] = DFA.unpackEncodedString(DFA164_transitionS[i]);
        }
    }

    class DFA164 extends DFA {

        public DFA164(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 164;
            this.eot = DFA164_eot;
            this.eof = DFA164_eof;
            this.min = DFA164_min;
            this.max = DFA164_max;
            this.accept = DFA164_accept;
            this.special = DFA164_special;
            this.transition = DFA164_transition;
        }
        public String getDescription() {
            return "903:6: ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( VAR Identifier ) )";
        }
    }
    static final String DFA166_eotS =
        "\41\uffff";
    static final String DFA166_eofS =
        "\1\2\40\uffff";
    static final String DFA166_minS =
        "\1\171\40\uffff";
    static final String DFA166_maxS =
        "\1\u00cb\40\uffff";
    static final String DFA166_acceptS =
        "\1\uffff\1\1\1\2\36\uffff";
    static final String DFA166_specialS =
        "\41\uffff}>";
    static final String[] DFA166_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\1\1\2\3\uffff\3\2\25\uffff\1"+
            "\2\2\uffff\1\2\7\uffff\1\2\16\uffff\20\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA166_eot = DFA.unpackEncodedString(DFA166_eotS);
    static final short[] DFA166_eof = DFA.unpackEncodedString(DFA166_eofS);
    static final char[] DFA166_min = DFA.unpackEncodedStringToUnsignedChars(DFA166_minS);
    static final char[] DFA166_max = DFA.unpackEncodedStringToUnsignedChars(DFA166_maxS);
    static final short[] DFA166_accept = DFA.unpackEncodedString(DFA166_acceptS);
    static final short[] DFA166_special = DFA.unpackEncodedString(DFA166_specialS);
    static final short[][] DFA166_transition;

    static {
        int numStates = DFA166_transitionS.length;
        DFA166_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA166_transition[i] = DFA.unpackEncodedString(DFA166_transitionS[i]);
        }
    }

    class DFA166 extends DFA {

        public DFA166(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 166;
            this.eot = DFA166_eot;
            this.eof = DFA166_eof;
            this.min = DFA166_min;
            this.max = DFA166_max;
            this.accept = DFA166_accept;
            this.special = DFA166_special;
            this.transition = DFA166_transition;
        }
        public String getDescription() {
            return "914:14: ( classBody )?";
        }
    }
    static final String DFA168_eotS =
        "\41\uffff";
    static final String DFA168_eofS =
        "\1\2\40\uffff";
    static final String DFA168_minS =
        "\1\171\40\uffff";
    static final String DFA168_maxS =
        "\1\u00cb\40\uffff";
    static final String DFA168_acceptS =
        "\1\uffff\1\1\1\2\36\uffff";
    static final String DFA168_specialS =
        "\41\uffff}>";
    static final String[] DFA168_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\3\2\25\uffff"+
            "\1\2\1\uffff\1\1\1\2\7\uffff\1\2\16\uffff\20\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA168_eot = DFA.unpackEncodedString(DFA168_eotS);
    static final short[] DFA168_eof = DFA.unpackEncodedString(DFA168_eofS);
    static final char[] DFA168_min = DFA.unpackEncodedStringToUnsignedChars(DFA168_minS);
    static final char[] DFA168_max = DFA.unpackEncodedStringToUnsignedChars(DFA168_maxS);
    static final short[] DFA168_accept = DFA.unpackEncodedString(DFA168_acceptS);
    static final short[] DFA168_special = DFA.unpackEncodedString(DFA168_specialS);
    static final short[][] DFA168_transition;

    static {
        int numStates = DFA168_transitionS.length;
        DFA168_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA168_transition[i] = DFA.unpackEncodedString(DFA168_transitionS[i]);
        }
    }

    class DFA168 extends DFA {

        public DFA168(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 168;
            this.eot = DFA168_eot;
            this.eof = DFA168_eof;
            this.min = DFA168_min;
            this.max = DFA168_max;
            this.accept = DFA168_accept;
            this.special = DFA168_special;
            this.transition = DFA168_transition;
        }
        public String getDescription() {
            return "932:21: ( arguments )?";
        }
    }
    static final String DFA171_eotS =
        "\41\uffff";
    static final String DFA171_eofS =
        "\1\2\40\uffff";
    static final String DFA171_minS =
        "\1\171\40\uffff";
    static final String DFA171_maxS =
        "\1\u00cb\40\uffff";
    static final String DFA171_acceptS =
        "\1\uffff\1\1\1\2\36\uffff";
    static final String DFA171_specialS =
        "\41\uffff}>";
    static final String[] DFA171_transitionS = {
            "\1\2\2\uffff\2\2\3\uffff\4\2\1\uffff\1\2\3\uffff\3\2\25\uffff"+
            "\1\2\1\uffff\1\1\1\2\7\uffff\1\2\16\uffff\20\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA171_eot = DFA.unpackEncodedString(DFA171_eotS);
    static final short[] DFA171_eof = DFA.unpackEncodedString(DFA171_eofS);
    static final char[] DFA171_min = DFA.unpackEncodedStringToUnsignedChars(DFA171_minS);
    static final char[] DFA171_max = DFA.unpackEncodedStringToUnsignedChars(DFA171_maxS);
    static final short[] DFA171_accept = DFA.unpackEncodedString(DFA171_acceptS);
    static final short[] DFA171_special = DFA.unpackEncodedString(DFA171_specialS);
    static final short[][] DFA171_transition;

    static {
        int numStates = DFA171_transitionS.length;
        DFA171_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA171_transition[i] = DFA.unpackEncodedString(DFA171_transitionS[i]);
        }
    }

    class DFA171 extends DFA {

        public DFA171(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 171;
            this.eot = DFA171_eot;
            this.eof = DFA171_eof;
            this.min = DFA171_min;
            this.max = DFA171_max;
            this.accept = DFA171_accept;
            this.special = DFA171_special;
            this.transition = DFA171_transition;
        }
        public String getDescription() {
            return "940:3: ( arguments -> ^( INVOKE Identifier ( arguments )? ) | -> ^( DEREF Identifier ) )";
        }
    }
    static final String DFA173_eotS =
        "\26\uffff";
    static final String DFA173_eofS =
        "\26\uffff";
    static final String DFA173_minS =
        "\1\145\25\uffff";
    static final String DFA173_maxS =
        "\1\u00ce\25\uffff";
    static final String DFA173_acceptS =
        "\1\uffff\1\1\23\uffff\1\2";
    static final String DFA173_specialS =
        "\26\uffff}>";
    static final String[] DFA173_transitionS = {
            "\7\1\25\uffff\1\1\6\uffff\1\1\16\uffff\13\1\1\uffff\2\1\1\25"+
            "\1\uffff\3\1\22\uffff\2\1\14\uffff\5\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA173_eot = DFA.unpackEncodedString(DFA173_eotS);
    static final short[] DFA173_eof = DFA.unpackEncodedString(DFA173_eofS);
    static final char[] DFA173_min = DFA.unpackEncodedStringToUnsignedChars(DFA173_minS);
    static final char[] DFA173_max = DFA.unpackEncodedStringToUnsignedChars(DFA173_maxS);
    static final short[] DFA173_accept = DFA.unpackEncodedString(DFA173_acceptS);
    static final short[] DFA173_special = DFA.unpackEncodedString(DFA173_specialS);
    static final short[][] DFA173_transition;

    static {
        int numStates = DFA173_transitionS.length;
        DFA173_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA173_transition[i] = DFA.unpackEncodedString(DFA173_transitionS[i]);
        }
    }

    class DFA173 extends DFA {

        public DFA173(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 173;
            this.eot = DFA173_eot;
            this.eof = DFA173_eof;
            this.min = DFA173_min;
            this.max = DFA173_max;
            this.accept = DFA173_accept;
            this.special = DFA173_special;
            this.transition = DFA173_transition;
        }
        public String getDescription() {
            return "948:9: ( expressionList )?";
        }
    }
    static final String DFA219_eotS =
        "\27\uffff";
    static final String DFA219_eofS =
        "\27\uffff";
    static final String DFA219_minS =
        "\1\u008a\1\145\25\uffff";
    static final String DFA219_maxS =
        "\1\u008a\1\u00ce\25\uffff";
    static final String DFA219_acceptS =
        "\2\uffff\1\2\1\1\23\uffff";
    static final String DFA219_specialS =
        "\27\uffff}>";
    static final String[] DFA219_transitionS = {
            "\1\1",
            "\7\3\25\uffff\1\3\6\uffff\1\3\2\uffff\1\2\13\uffff\13\3\1"+
            "\uffff\2\3\2\uffff\3\3\22\uffff\2\3\14\uffff\5\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA219_eot = DFA.unpackEncodedString(DFA219_eotS);
    static final short[] DFA219_eof = DFA.unpackEncodedString(DFA219_eofS);
    static final char[] DFA219_min = DFA.unpackEncodedStringToUnsignedChars(DFA219_minS);
    static final char[] DFA219_max = DFA.unpackEncodedStringToUnsignedChars(DFA219_maxS);
    static final short[] DFA219_accept = DFA.unpackEncodedString(DFA219_acceptS);
    static final short[] DFA219_special = DFA.unpackEncodedString(DFA219_specialS);
    static final short[][] DFA219_transition;

    static {
        int numStates = DFA219_transitionS.length;
        DFA219_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA219_transition[i] = DFA.unpackEncodedString(DFA219_transitionS[i]);
        }
    }

    class DFA219 extends DFA {

        public DFA219(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 219;
            this.eot = DFA219_eot;
            this.eof = DFA219_eof;
            this.min = DFA219_min;
            this.max = DFA219_max;
            this.accept = DFA219_accept;
            this.special = DFA219_special;
            this.transition = DFA219_transition;
        }
        public String getDescription() {
            return "885:6: ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer )";
        }
    }
    static final String DFA216_eotS =
        "\30\uffff";
    static final String DFA216_eofS =
        "\1\2\27\uffff";
    static final String DFA216_minS =
        "\1\u008a\1\145\26\uffff";
    static final String DFA216_maxS =
        "\1\u008a\1\u00ce\26\uffff";
    static final String DFA216_acceptS =
        "\2\uffff\1\2\1\uffff\1\1\23\uffff";
    static final String DFA216_specialS =
        "\30\uffff}>";
    static final String[] DFA216_transitionS = {
            "\1\1",
            "\7\4\25\uffff\1\4\6\uffff\1\4\2\uffff\1\2\13\uffff\13\4\1"+
            "\uffff\2\4\2\uffff\3\4\22\uffff\2\4\14\uffff\5\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA216_eot = DFA.unpackEncodedString(DFA216_eotS);
    static final short[] DFA216_eof = DFA.unpackEncodedString(DFA216_eofS);
    static final char[] DFA216_min = DFA.unpackEncodedStringToUnsignedChars(DFA216_minS);
    static final char[] DFA216_max = DFA.unpackEncodedStringToUnsignedChars(DFA216_maxS);
    static final short[] DFA216_accept = DFA.unpackEncodedString(DFA216_acceptS);
    static final short[] DFA216_special = DFA.unpackEncodedString(DFA216_specialS);
    static final short[][] DFA216_transition;

    static {
        int numStates = DFA216_transitionS.length;
        DFA216_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA216_transition[i] = DFA.unpackEncodedString(DFA216_transitionS[i]);
        }
    }

    class DFA216 extends DFA {

        public DFA216(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 216;
            this.eot = DFA216_eot;
            this.eof = DFA216_eof;
            this.min = DFA216_min;
            this.max = DFA216_max;
            this.accept = DFA216_accept;
            this.special = DFA216_special;
            this.transition = DFA216_transition;
        }
        public String getDescription() {
            return "()+ loopback of 886:7: ( '[' expression ']' )+";
        }
    }
    static final String DFA229_eotS =
        "\30\uffff";
    static final String DFA229_eofS =
        "\30\uffff";
    static final String DFA229_minS =
        "\1\u008a\1\145\26\uffff";
    static final String DFA229_maxS =
        "\1\u00a4\1\u00ce\26\uffff";
    static final String DFA229_acceptS =
        "\2\uffff\1\3\1\2\1\1\23\uffff";
    static final String DFA229_specialS =
        "\30\uffff}>";
    static final String[] DFA229_transitionS = {
            "\1\1\31\uffff\1\2",
            "\7\4\25\uffff\1\4\6\uffff\1\4\2\uffff\1\3\13\uffff\13\4\1"+
            "\uffff\2\4\2\uffff\3\4\22\uffff\2\4\14\uffff\5\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA229_eot = DFA.unpackEncodedString(DFA229_eotS);
    static final short[] DFA229_eof = DFA.unpackEncodedString(DFA229_eofS);
    static final char[] DFA229_min = DFA.unpackEncodedStringToUnsignedChars(DFA229_minS);
    static final char[] DFA229_max = DFA.unpackEncodedStringToUnsignedChars(DFA229_maxS);
    static final short[] DFA229_accept = DFA.unpackEncodedString(DFA229_acceptS);
    static final short[] DFA229_special = DFA.unpackEncodedString(DFA229_specialS);
    static final short[][] DFA229_transition;

    static {
        int numStates = DFA229_transitionS.length;
        DFA229_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA229_transition[i] = DFA.unpackEncodedString(DFA229_transitionS[i]);
        }
    }

    class DFA229 extends DFA {

        public DFA229(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 229;
            this.eot = DFA229_eot;
            this.eof = DFA229_eof;
            this.min = DFA229_min;
            this.max = DFA229_max;
            this.accept = DFA229_accept;
            this.special = DFA229_special;
            this.transition = DFA229_transition;
        }
        public String getDescription() {
            return "890:6: ( ( '[' expression ']' )+ ( '[' ']' )* | ( '[' ']' )+ arrayInitializer | classCreatorRest )";
        }
    }
    static final String DFA226_eotS =
        "\30\uffff";
    static final String DFA226_eofS =
        "\1\2\27\uffff";
    static final String DFA226_minS =
        "\1\u008a\1\145\26\uffff";
    static final String DFA226_maxS =
        "\1\u008a\1\u00ce\26\uffff";
    static final String DFA226_acceptS =
        "\2\uffff\1\2\1\uffff\1\1\23\uffff";
    static final String DFA226_specialS =
        "\30\uffff}>";
    static final String[] DFA226_transitionS = {
            "\1\1",
            "\7\4\25\uffff\1\4\6\uffff\1\4\2\uffff\1\2\13\uffff\13\4\1"+
            "\uffff\2\4\2\uffff\3\4\22\uffff\2\4\14\uffff\5\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA226_eot = DFA.unpackEncodedString(DFA226_eotS);
    static final short[] DFA226_eof = DFA.unpackEncodedString(DFA226_eofS);
    static final char[] DFA226_min = DFA.unpackEncodedStringToUnsignedChars(DFA226_minS);
    static final char[] DFA226_max = DFA.unpackEncodedStringToUnsignedChars(DFA226_maxS);
    static final short[] DFA226_accept = DFA.unpackEncodedString(DFA226_acceptS);
    static final short[] DFA226_special = DFA.unpackEncodedString(DFA226_specialS);
    static final short[][] DFA226_transition;

    static {
        int numStates = DFA226_transitionS.length;
        DFA226_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA226_transition[i] = DFA.unpackEncodedString(DFA226_transitionS[i]);
        }
    }

    class DFA226 extends DFA {

        public DFA226(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 226;
            this.eot = DFA226_eot;
            this.eof = DFA226_eof;
            this.min = DFA226_min;
            this.max = DFA226_max;
            this.accept = DFA226_accept;
            this.special = DFA226_special;
            this.transition = DFA226_transition;
        }
        public String getDescription() {
            return "()+ loopback of 891:7: ( '[' expression ']' )+";
        }
    }
 

    public static final BitSet FOLLOW_annotations_in_compilationUnit475 = new BitSet(new long[]{0x0000000000000402L,0x4F00000000000000L,0x00000400007FE080L});
    public static final BitSet FOLLOW_packageDeclaration_in_compilationUnit478 = new BitSet(new long[]{0x0000000000000402L,0x4E00000000000000L,0x00000400007FE080L});
    public static final BitSet FOLLOW_importDeclaration_in_compilationUnit481 = new BitSet(new long[]{0x0000000000000402L,0x4E00000000000000L,0x00000400007FE080L});
    public static final BitSet FOLLOW_typeDeclaration_in_compilationUnit484 = new BitSet(new long[]{0x0000000000000402L,0x4A00000000000000L,0x00000400007FE080L});
    public static final BitSet FOLLOW_120_in_packageDeclaration518 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_qualifiedName_in_packageDeclaration520 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_packageDeclaration522 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_122_in_importDeclaration542 = new BitSet(new long[]{0x0000000000000000L,0x0800002000000000L});
    public static final BitSet FOLLOW_123_in_importDeclaration549 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_importDeclaration553 = new BitSet(new long[]{0x0000000000000000L,0x1200000000000000L});
    public static final BitSet FOLLOW_124_in_importDeclaration556 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_importDeclaration560 = new BitSet(new long[]{0x0000000000000000L,0x1200000000000000L});
    public static final BitSet FOLLOW_124_in_importDeclaration565 = new BitSet(new long[]{0x0000000000000000L,0x2000000000000000L});
    public static final BitSet FOLLOW_125_in_importDeclaration569 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_importDeclaration573 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_importDeclaration592 = new BitSet(new long[]{0x0000000000000000L,0x1200000000000000L});
    public static final BitSet FOLLOW_124_in_importDeclaration595 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_importDeclaration599 = new BitSet(new long[]{0x0000000000000000L,0x1200000000000000L});
    public static final BitSet FOLLOW_124_in_importDeclaration604 = new BitSet(new long[]{0x0000000000000000L,0x2000000000000000L});
    public static final BitSet FOLLOW_125_in_importDeclaration608 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_importDeclaration612 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classOrInterfaceDeclaration_in_typeDeclaration639 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_typeDeclaration649 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modifier_in_classOrInterfaceDeclaration661 = new BitSet(new long[]{0x0000000000000400L,0x4800000000000000L,0x00000400007FE080L});
    public static final BitSet FOLLOW_classDeclaration_in_classOrInterfaceDeclaration668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumDeclaration_in_classOrInterfaceDeclaration689 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_normalInterfaceDeclaration_in_classOrInterfaceDeclaration710 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeDeclaration_in_classOrInterfaceDeclaration731 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_126_in_classDeclaration763 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_classDeclaration765 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_typeParameters_in_classDeclaration768 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_127_in_classDeclaration781 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_classDeclaration783 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_128_in_classDeclaration797 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_classDeclaration799 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_classBody_in_classDeclaration811 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_typeParameters848 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_typeParameter_in_typeParameters852 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x000000000000000CL});
    public static final BitSet FOLLOW_130_in_typeParameters855 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_typeParameter_in_typeParameters859 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x000000000000000CL});
    public static final BitSet FOLLOW_131_in_typeParameters863 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_typeParameter880 = new BitSet(new long[]{0x0000000000000002L,0x8000000000000000L});
    public static final BitSet FOLLOW_127_in_typeParameter883 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_bound_in_typeParameter885 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_bound919 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_132_in_bound922 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_bound926 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_ENUM_in_enumDeclaration945 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_enumDeclaration947 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000021L});
    public static final BitSet FOLLOW_128_in_enumDeclaration950 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_enumDeclaration952 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000021L});
    public static final BitSet FOLLOW_enumBody_in_enumDeclaration956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_enumBody982 = new BitSet(new long[]{0x0000000000000000L,0x0200002000000000L,0x0000040000000044L});
    public static final BitSet FOLLOW_enumConstants_in_enumBody984 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L,0x0000000000000044L});
    public static final BitSet FOLLOW_130_in_enumBody987 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_enumBodyDeclarations_in_enumBody990 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_134_in_enumBody993 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumConstant_in_enumConstants1012 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_enumConstants1015 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000040000000000L});
    public static final BitSet FOLLOW_enumConstant_in_enumConstants1017 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_annotations_in_enumConstant1036 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_enumConstant1039 = new BitSet(new long[]{0x0000000000000002L,0x8000000000000000L,0x0000001000000023L});
    public static final BitSet FOLLOW_arguments_in_enumConstant1042 = new BitSet(new long[]{0x0000000000000002L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_classBody_in_enumConstant1047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_enumBodyDeclarations1082 = new BitSet(new long[]{0x0000000000000402L,0x4A00002000000000L,0x00000403FFFFE1A2L});
    public static final BitSet FOLLOW_classBodyDeclaration_in_enumBodyDeclarations1085 = new BitSet(new long[]{0x0000000000000402L,0x4A00002000000000L,0x00000403FFFFE1A2L});
    public static final BitSet FOLLOW_135_in_normalInterfaceDeclaration1104 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_normalInterfaceDeclaration1106 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000022L});
    public static final BitSet FOLLOW_typeParameters_in_normalInterfaceDeclaration1108 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000022L});
    public static final BitSet FOLLOW_127_in_normalInterfaceDeclaration1112 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_normalInterfaceDeclaration1114 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000022L});
    public static final BitSet FOLLOW_interfaceBody_in_normalInterfaceDeclaration1118 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_typeList1153 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_typeList1156 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_typeList1159 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_133_in_classBody1173 = new BitSet(new long[]{0x0000000000000400L,0x4A00002000000000L,0x00000403FFFFE1E2L});
    public static final BitSet FOLLOW_classBodyDeclaration_in_classBody1176 = new BitSet(new long[]{0x0000000000000400L,0x4A00002000000000L,0x00000403FFFFE1E2L});
    public static final BitSet FOLLOW_134_in_classBody1179 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_interfaceBody1192 = new BitSet(new long[]{0x0000000000000400L,0x4A00002000000000L,0x00000403FFFFE1C2L});
    public static final BitSet FOLLOW_interfaceBodyDeclaration_in_interfaceBody1195 = new BitSet(new long[]{0x0000000000000400L,0x4A00002000000000L,0x00000403FFFFE1C2L});
    public static final BitSet FOLLOW_134_in_interfaceBody1198 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_classBodyDeclaration1210 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_123_in_classBodyDeclaration1216 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_classBodyDeclaration1218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_123_in_classBodyDeclaration1231 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_classBodyDeclaration1234 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modifier_in_classBodyDeclaration1243 = new BitSet(new long[]{0x0000000000000400L,0x4800002000000000L,0x00000403FFFFE182L});
    public static final BitSet FOLLOW_genericMethodOrConstructorDecl_in_classBodyDeclaration1253 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_methodDeclaration_in_classBodyDeclaration1278 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_fieldDeclaration_in_classBodyDeclaration1307 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_136_in_classBodyDeclaration1331 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_classBodyDeclaration1333 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_voidMethodDeclaratorRest_in_classBodyDeclaration1335 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_classBodyDeclaration1372 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_constructorDeclaratorRest_in_classBodyDeclaration1374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_normalInterfaceDeclaration_in_classBodyDeclaration1408 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeDeclaration_in_classBodyDeclaration1434 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classDeclaration_in_classBodyDeclaration1458 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumDeclaration_in_classBodyDeclaration1484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeParameters_in_genericMethodOrConstructorDecl1517 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800100L});
    public static final BitSet FOLLOW_genericMethodOrConstructorRest_in_genericMethodOrConstructorDecl1519 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_genericMethodOrConstructorRest1541 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_genericMethodOrConstructorRest1543 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_methodDeclaratorRest_in_genericMethodOrConstructorRest1545 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_136_in_genericMethodOrConstructorRest1559 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_genericMethodOrConstructorRest1561 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_methodDeclaratorRest_in_genericMethodOrConstructorRest1563 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_genericMethodOrConstructorRest1581 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_constructorDeclaratorRest_in_genericMethodOrConstructorRest1583 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_methodDeclaration1604 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_methodDeclaration1606 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_methodDeclaratorRest_in_methodDeclaration1608 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_fieldDeclaration1628 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclarators_in_fieldDeclaration1630 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_fieldDeclaration1632 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modifier_in_interfaceBodyDeclaration1651 = new BitSet(new long[]{0x0000000000000400L,0x4800002000000000L,0x00000403FFFFE182L});
    public static final BitSet FOLLOW_constantDeclaration_in_interfaceBodyDeclaration1658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_interfaceBodyDeclaration1679 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_interfaceBodyDeclaration1681 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_interfaceMethodDeclaratorRest_in_interfaceBodyDeclaration1683 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_interfaceGenericMethodDecl_in_interfaceBodyDeclaration1713 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_136_in_interfaceBodyDeclaration1734 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_interfaceBodyDeclaration1736 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_voidInterfaceMethodDeclaratorRest_in_interfaceBodyDeclaration1738 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_normalInterfaceDeclaration_in_interfaceBodyDeclaration1772 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeDeclaration_in_interfaceBodyDeclaration1799 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classDeclaration_in_interfaceBodyDeclaration1820 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumDeclaration_in_interfaceBodyDeclaration1846 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_interfaceBodyDeclaration1870 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_formalParameters_in_methodDeclaratorRest1884 = new BitSet(new long[]{0x0000000000000000L,0x0A00000000000000L,0x0000000000000220L});
    public static final BitSet FOLLOW_137_in_methodDeclaratorRest1896 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_methodDeclaratorRest1898 = new BitSet(new long[]{0x0000000000000000L,0x0A00000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_methodBody_in_methodDeclaratorRest1914 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_methodDeclaratorRest1946 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_formalParameters_in_voidMethodDeclaratorRest1984 = new BitSet(new long[]{0x0000000000000000L,0x0A00000000000000L,0x0000000000000220L});
    public static final BitSet FOLLOW_137_in_voidMethodDeclaratorRest1987 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_voidMethodDeclaratorRest1989 = new BitSet(new long[]{0x0000000000000000L,0x0A00000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_methodBody_in_voidMethodDeclaratorRest2005 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_voidMethodDeclaratorRest2037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_formalParameters_in_interfaceMethodDeclaratorRest2075 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L,0x0000000000000200L});
    public static final BitSet FOLLOW_137_in_interfaceMethodDeclaratorRest2078 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_interfaceMethodDeclaratorRest2080 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_interfaceMethodDeclaratorRest2084 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeParameters_in_interfaceGenericMethodDecl2112 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800100L});
    public static final BitSet FOLLOW_type_in_interfaceGenericMethodDecl2118 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_interfaceGenericMethodDecl2120 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_interfaceMethodDeclaratorRest_in_interfaceGenericMethodDecl2122 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_136_in_interfaceGenericMethodDecl2142 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_interfaceGenericMethodDecl2144 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_interfaceMethodDeclaratorRest_in_interfaceGenericMethodDecl2146 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_formalParameters_in_voidInterfaceMethodDeclaratorRest2180 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L,0x0000000000000200L});
    public static final BitSet FOLLOW_137_in_voidInterfaceMethodDeclaratorRest2183 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_voidInterfaceMethodDeclaratorRest2185 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_voidInterfaceMethodDeclaratorRest2189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_formalParameters_in_constructorDeclaratorRest2217 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000220L});
    public static final BitSet FOLLOW_137_in_constructorDeclaratorRest2220 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_constructorDeclaratorRest2222 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_methodBody_in_constructorDeclaratorRest2226 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDeclarator_in_variableDeclarators2259 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_variableDeclarators2262 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclarator_in_variableDeclarators2266 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclarator2285 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001400L});
    public static final BitSet FOLLOW_variableDeclaratorRest_in_variableDeclarator2287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_138_in_variableDeclaratorRest2309 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_variableDeclaratorRest2311 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001400L});
    public static final BitSet FOLLOW_140_in_variableDeclaratorRest2316 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_variableInitializer_in_variableDeclaratorRest2318 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_140_in_variableDeclaratorRest2333 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_variableInitializer_in_variableDeclaratorRest2335 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_constantDeclaration2353 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_constantDeclarators_in_constantDeclaration2355 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_constantDeclaration2357 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_constantDeclarator2374 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001400L});
    public static final BitSet FOLLOW_constantDeclaratorRest_in_constantDeclarator2376 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constantDeclarator_in_constantDeclarators2399 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_constantDeclarators2402 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_constantDeclarator_in_constantDeclarators2406 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_138_in_constantDeclaratorRest2427 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_constantDeclaratorRest2429 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001400L});
    public static final BitSet FOLLOW_140_in_constantDeclaratorRest2433 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_variableInitializer_in_constantDeclaratorRest2435 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaratorId2454 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_variableDeclaratorId2457 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_variableDeclaratorId2459 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_arrayInitializer_in_variableInitializer2472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_variableInitializer2482 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_arrayInitializer2494 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800162L,0x0000000000007C00L});
    public static final BitSet FOLLOW_variableInitializer_in_arrayInitializer2497 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000044L});
    public static final BitSet FOLLOW_130_in_arrayInitializer2500 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_variableInitializer_in_arrayInitializer2502 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000044L});
    public static final BitSet FOLLOW_130_in_arrayInitializer2507 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_134_in_arrayInitializer2514 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_modifier2539 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_141_in_modifier2549 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_142_in_modifier2559 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_143_in_modifier2569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_123_in_modifier2579 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_144_in_modifier2589 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_145_in_modifier2599 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_146_in_modifier2609 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_147_in_modifier2619 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_148_in_modifier2629 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_149_in_modifier2639 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_150_in_modifier2649 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_packageOrTypeName2663 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_packageOrTypeName2666 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_packageOrTypeName2668 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_enumConstantName2686 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_typeName2702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_packageOrTypeName_in_typeName2712 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_typeName2714 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_typeName2716 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_uniMod_in_type2727 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_type2732 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_124_in_type2735 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_type2739 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_type2744 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_type2746 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_primitiveType_in_type2771 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_type2774 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_type2776 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_Identifier_in_refComponent2805 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeArguments_in_refComponent2808 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_uniMod0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_primitiveType0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_145_in_variableModifier2933 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_variableModifier2943 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_typeArguments2954 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000007FF800000L});
    public static final BitSet FOLLOW_typeArgument_in_typeArguments2958 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x000000000000000CL});
    public static final BitSet FOLLOW_130_in_typeArguments2961 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000007FF800000L});
    public static final BitSet FOLLOW_typeArgument_in_typeArguments2965 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x000000000000000CL});
    public static final BitSet FOLLOW_131_in_typeArguments2969 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_typeArgument2987 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_162_in_typeArgument2992 = new BitSet(new long[]{0x0000000000000002L,0x8000000000000000L,0x0000000800000000L});
    public static final BitSet FOLLOW_127_in_typeArgument3001 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_typeArgument3003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_163_in_typeArgument3036 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_typeArgument3038 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qualifiedName_in_qualifiedNameList3080 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_qualifiedNameList3083 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_qualifiedName_in_qualifiedNameList3086 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_164_in_formalParameters3100 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000423FF820000L});
    public static final BitSet FOLLOW_formalParameterDecls_in_formalParameters3102 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_formalParameters3105 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_formalParameterDecls3122 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_formalParameterDecls3125 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000004000000000L});
    public static final BitSet FOLLOW_variableDeclaratorId_in_formalParameterDecls3137 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_formalParameterDecls3140 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_formalParameterDecls_in_formalParameterDecls3142 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_166_in_formalParameterDecls3176 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclaratorId_in_formalParameterDecls3178 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_block_in_methodBody3221 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_qualifiedName3239 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_qualifiedName3242 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_qualifiedName3246 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_integerLiteral_in_literal3269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FloatingPointLiteral_in_literal3287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CharacterLiteral_in_literal3305 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_StringLiteral_in_literal3323 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanLiteral_in_literal3341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_167_in_literal3359 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_integerLiteral0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_booleanLiteral0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_annotations3447 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000040000000000L});
    public static final BitSet FOLLOW_170_in_annotation3459 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_annotationName_in_annotation3461 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_164_in_annotation3464 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x300007BBFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValuePairs_in_annotation3466 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_annotation3469 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_annotationName3494 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_annotationName3497 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_annotationName3499 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L});
    public static final BitSet FOLLOW_elementValuePair_in_elementValuePairs3513 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_elementValuePairs3516 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000079BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValuePair_in_elementValuePairs3518 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_Identifier_in_elementValuePair3533 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_elementValuePair3535 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000079BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValue_in_elementValuePair3538 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementValue_in_elementValuePair3557 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalExpression_in_elementValue3573 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_elementValue3580 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementValueArrayInitializer_in_elementValue3587 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_elementValueArrayInitializer3599 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000079BFF800162L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValue_in_elementValueArrayInitializer3602 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000044L});
    public static final BitSet FOLLOW_130_in_elementValueArrayInitializer3605 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000079BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValue_in_elementValueArrayInitializer3607 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000044L});
    public static final BitSet FOLLOW_134_in_elementValueArrayInitializer3614 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_170_in_annotationTypeDeclaration3635 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000080L});
    public static final BitSet FOLLOW_135_in_annotationTypeDeclaration3637 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_annotationTypeDeclaration3639 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_annotationTypeBody_in_annotationTypeDeclaration3641 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_annotationTypeBody3660 = new BitSet(new long[]{0x0000000000000400L,0x4800002000000000L,0x00000403FFFFE0C0L});
    public static final BitSet FOLLOW_annotationTypeElementDeclarations_in_annotationTypeBody3664 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_134_in_annotationTypeBody3668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeElementDeclaration_in_annotationTypeElementDeclarations3682 = new BitSet(new long[]{0x0000000000000402L,0x4800002000000000L,0x00000403FFFFE080L});
    public static final BitSet FOLLOW_modifier_in_annotationTypeElementDeclaration3697 = new BitSet(new long[]{0x0000000000000400L,0x4800002000000000L,0x00000403FFFFE080L});
    public static final BitSet FOLLOW_type_in_annotationTypeElementDeclaration3709 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_annotationMethodRest_in_annotationTypeElementDeclaration3721 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3723 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationConstantRest_in_annotationTypeElementDeclaration3748 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3750 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classDeclaration_in_annotationTypeElementDeclaration3779 = new BitSet(new long[]{0x0000000000000002L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumDeclaration_in_annotationTypeElementDeclaration3804 = new BitSet(new long[]{0x0000000000000002L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3806 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_normalInterfaceDeclaration_in_annotationTypeElementDeclaration3829 = new BitSet(new long[]{0x0000000000000002L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3831 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeDeclaration_in_annotationTypeElementDeclaration3854 = new BitSet(new long[]{0x0000000000000002L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_annotationTypeElementDeclaration3856 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_annotationMethodRest3889 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_164_in_annotationMethodRest3891 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_annotationMethodRest3894 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000080000000000L});
    public static final BitSet FOLLOW_defaultValue_in_annotationMethodRest3898 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDeclarators_in_annotationConstantRest3915 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_171_in_defaultValue3930 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000079BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_elementValue_in_defaultValue3933 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_133_in_block3947 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1E2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_blockStatement_in_block3949 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1E2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_134_in_block3952 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_localVariableDeclaration_in_blockStatement3973 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classOrInterfaceDeclaration_in_blockStatement3978 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_blockStatement3986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_localVariableDeclaration3998 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_localVariableDeclaration4001 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclarators_in_localVariableDeclaration4003 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_localVariableDeclaration4005 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_block_in_statement4034 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_172_in_statement4044 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_statement4046 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_statement4049 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_statement4051 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4055 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_174_in_statement4077 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_parExpression_in_statement4079 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4081 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000800000000000L});
    public static final BitSet FOLLOW_175_in_statement4091 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4093 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_176_in_statement4119 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_164_in_statement4121 = new BitSet(new long[]{0x0000000000000000L,0x02000FE000000000L,0x3000079BFF820122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_forControl_in_statement4123 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_statement4125 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_177_in_statement4148 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_parExpression_in_statement4150 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4152 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_178_in_statement4177 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4179 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
    public static final BitSet FOLLOW_177_in_statement4181 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_parExpression_in_statement4183 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4185 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_179_in_statement4210 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_statement4212 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0410000000000000L});
    public static final BitSet FOLLOW_catches_in_statement4222 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0010000000000000L});
    public static final BitSet FOLLOW_180_in_statement4226 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_statement4228 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_catches_in_statement4256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_180_in_statement4279 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_statement4281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_181_in_statement4315 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_parExpression_in_statement4317 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_133_in_statement4319 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800080000000040L});
    public static final BitSet FOLLOW_switchBlockStatementGroups_in_statement4321 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_134_in_statement4323 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_147_in_statement4344 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_parExpression_in_statement4346 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_statement4348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_182_in_statement4369 = new BitSet(new long[]{0x0000000000000000L,0x02000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_statement4371 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_183_in_statement4394 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_statement4396 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4398 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_184_in_statement4417 = new BitSet(new long[]{0x0000000000000000L,0x0200002000000000L});
    public static final BitSet FOLLOW_Identifier_in_statement4419 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_185_in_statement4442 = new BitSet(new long[]{0x0000000000000000L,0x0200002000000000L});
    public static final BitSet FOLLOW_Identifier_in_statement4444 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4447 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_121_in_statement4465 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statementExpression_in_statement4480 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_statement4482 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_statement4496 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_statement4498 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_statement4500 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_catchClause_in_catches4522 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0400000000000000L});
    public static final BitSet FOLLOW_catchClause_in_catches4525 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0400000000000000L});
    public static final BitSet FOLLOW_186_in_catchClause4541 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_164_in_catchClause4543 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_formalParameter_in_catchClause4545 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_catchClause4547 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_catchClause4549 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_formalParameter4575 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_formalParameter4578 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclaratorId_in_formalParameter4580 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_switchBlockStatementGroup_in_switchBlockStatementGroups4594 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0800080000000000L});
    public static final BitSet FOLLOW_switchLabel_in_switchBlockStatementGroup4608 = new BitSet(new long[]{0x0000000000000402L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_blockStatement_in_switchBlockStatementGroup4610 = new BitSet(new long[]{0x0000000000000402L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_187_in_switchLabel4638 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_constantExpression_in_switchLabel4640 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_switchLabel4642 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_187_in_switchLabel4658 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_enumConstantName_in_switchLabel4660 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_switchLabel4662 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_171_in_switchLabel4678 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_switchLabel4680 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_130_in_moreStatementExpressions4699 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statementExpression_in_moreStatementExpressions4701 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_forVarControl_in_forControl4722 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forInit_in_forControl4735 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_forControl4738 = new BitSet(new long[]{0x0000000000000000L,0x02000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_forControl4742 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
    public static final BitSet FOLLOW_121_in_forControl4745 = new BitSet(new long[]{0x0000000000000002L,0x00000FE000000000L,0x3000079BFF820122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_forUpdate_in_forControl4749 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_forInit4784 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_forInit4787 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclarators_in_forInit4789 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expressionList_in_forInit4811 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_forVarControl4823 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_forVarControl4826 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_forVarControl4828 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_forVarControl4830 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_forVarControl4832 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expressionList_in_forUpdate4862 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_parExpression4875 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_parExpression4878 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_parExpression4880 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_expressionList4898 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_130_in_expressionList4901 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expressionList4904 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_statementExpression4920 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_constantExpression4932 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalExpression_in_expression4944 = new BitSet(new long[]{0x0000000000000002L,0x2000000000000000L,0xF00000000000100AL,0x0000000000000007L});
    public static final BitSet FOLLOW_140_in_expression4954 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression4956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_188_in_expression4973 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression4975 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression4977 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_189_in_expression4996 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression4998 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_125_in_expression5019 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5021 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_190_in_expression5042 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5044 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5046 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_191_in_expression5068 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5070 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_192_in_expression5089 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5091 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_193_in_expression5110 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_194_in_expression5134 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5136 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5138 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_expression5157 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_expression5159 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5161 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5163 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_expression5182 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_expression5184 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5186 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_expression5207 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_expression5209 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_expression5211 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_expression5213 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_expression5215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_conditionalExpression5258 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_162_in_conditionalExpression5275 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_conditionalExpression5277 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_conditionalExpression5279 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_conditionalExpression5281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalOrExpression5328 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_195_in_conditionalOrExpression5346 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_conditionalOrExpression5348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_inclusiveOrExpression_in_conditionalAndExpression5394 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_196_in_conditionalAndExpression5412 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalAndExpression5414 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression5466 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_197_in_inclusiveOrExpression5488 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_inclusiveOrExpression_in_inclusiveOrExpression5490 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_andExpression_in_exclusiveOrExpression5537 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_198_in_exclusiveOrExpression5553 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_exclusiveOrExpression_in_exclusiveOrExpression5555 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_equalityExpression_in_andExpression5599 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_132_in_andExpression5615 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_andExpression_in_andExpression5617 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_instanceOfExpression_in_equalityExpression5661 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000180L});
    public static final BitSet FOLLOW_199_in_equalityExpression5677 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_instanceOfExpression_in_equalityExpression5679 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_200_in_equalityExpression5700 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_instanceOfExpression_in_equalityExpression5702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_relationalExpression_in_instanceOfExpression5746 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000200L});
    public static final BitSet FOLLOW_201_in_instanceOfExpression5761 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_instanceOfExpression5763 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression5807 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000000000AL});
    public static final BitSet FOLLOW_129_in_relationalExpression5823 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_relationalExpression5825 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression5827 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_relationalExpression5848 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression5850 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_relationalExpression5871 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_relationalExpression5873 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression5875 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_relationalExpression5896 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression5898 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_additiveExpression_in_shiftExpression5943 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000000000AL});
    public static final BitSet FOLLOW_129_in_shiftExpression5962 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_shiftExpression5964 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_131_in_shiftExpression5968 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_shiftExpression5970 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_shiftExpression5973 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000000000AL});
    public static final BitSet FOLLOW_131_in_shiftExpression6007 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_shiftExpression6009 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_shiftExpression6011 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_shiftExpression6013 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression6056 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x3000000000000000L});
    public static final BitSet FOLLOW_188_in_additiveExpression6075 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_189_in_additiveExpression6079 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression6082 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x3000000000000000L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression6133 = new BitSet(new long[]{0x0000000000000002L,0x2000000000000000L,0x4000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_125_in_multiplicativeExpression6153 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_190_in_multiplicativeExpression6157 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_194_in_multiplicativeExpression6161 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression6164 = new BitSet(new long[]{0x0000000000000002L,0x2000000000000000L,0x4000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_188_in_unaryExpression6216 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression6218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_189_in_unaryExpression6230 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression6232 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_202_in_unaryExpression6250 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression6252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_203_in_unaryExpression6270 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression6272 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression6290 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_204_in_unaryExpressionNotPlusMinus6321 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus6323 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_205_in_unaryExpressionNotPlusMinus6340 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus6342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_castExpression_in_unaryExpressionNotPlusMinus6360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primary_in_unaryExpressionNotPlusMinus6367 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L,0x0000000000000400L,0x0000000000000C00L});
    public static final BitSet FOLLOW_selector_in_unaryExpressionNotPlusMinus6377 = new BitSet(new long[]{0x0000000000000002L,0x1000000000000000L,0x0000000000000400L,0x0000000000000C00L});
    public static final BitSet FOLLOW_202_in_unaryExpressionNotPlusMinus6390 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_203_in_unaryExpressionNotPlusMinus6412 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_202_in_unaryExpressionNotPlusMinus6456 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_203_in_unaryExpressionNotPlusMinus6471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_castExpression6510 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_primitiveType_in_castExpression6512 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_castExpression6514 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_castExpression6516 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_castExpression6539 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_castExpression6541 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_castExpression6543 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpressionNotPlusMinus_in_castExpression6545 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_castExpression6564 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_castExpression6566 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_castExpression6568 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpressionNotPlusMinus_in_castExpression6570 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_parExpression_in_primary6590 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_primary6597 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000800000000L});
    public static final BitSet FOLLOW_explicitGenericInvocationSuffix_in_primary6599 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal_in_primary6623 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_206_in_primary6633 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_primary6635 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_primitiveType_in_primary6638 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_primary6654 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_primary6656 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6658 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_primary6663 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6665 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_primary6696 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6698 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_arrayInitializer_in_primary6702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_206_in_primary6734 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_primary6736 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_uniMod_in_primary6739 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_primary6745 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000400L});
    public static final BitSet FOLLOW_124_in_primary6748 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_primary6752 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000400L});
    public static final BitSet FOLLOW_138_in_primary6771 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_primary6773 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6775 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_primary6780 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6782 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_primary6818 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_primary6820 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_arrayInitializer_in_primary6824 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classCreatorRest_in_primary6856 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_primary6891 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_primary6893 = new BitSet(new long[]{0x0000000000000000L,0x4000000000000000L});
    public static final BitSet FOLLOW_126_in_primary6895 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_136_in_primary6917 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_primary6919 = new BitSet(new long[]{0x0000000000000000L,0x4000000000000000L});
    public static final BitSet FOLLOW_126_in_primary6921 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_163_in_primary6942 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_primary6952 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_primary6990 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_primary7006 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_innerCreator7051 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000400L});
    public static final BitSet FOLLOW_classCreatorRest_in_innerCreator7053 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arguments_in_classCreatorRest7075 = new BitSet(new long[]{0x0000000000000002L,0x8000000000000000L,0x0000000000000023L});
    public static final BitSet FOLLOW_classBody_in_classCreatorRest7077 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_explicitGenericInvocation7098 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000800000000L});
    public static final BitSet FOLLOW_explicitGenericInvocationSuffix_in_explicitGenericInvocation7100 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_nonWildcardTypeArguments7112 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_typeList_in_nonWildcardTypeArguments7114 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_nonWildcardTypeArguments7116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_163_in_explicitGenericInvocationSuffix7132 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_superSuffix_in_explicitGenericInvocationSuffix7134 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_explicitGenericInvocationSuffix7148 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_explicitGenericInvocationSuffix7150 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arguments_in_superSuffix7169 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_superSuffix7181 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_superSuffix7183 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_superSuffix7186 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_selector7200 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000800000000L});
    public static final BitSet FOLLOW_163_in_selector7202 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_selector7204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_selector7222 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000004000L});
    public static final BitSet FOLLOW_206_in_selector7224 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_selector7227 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_innerCreator_in_selector7231 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_selector7246 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_selector7248 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000800000000L});
    public static final BitSet FOLLOW_explicitGenericInvocationSuffix_in_selector7250 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_selector7269 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_selector7271 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_arguments_in_selector7281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_138_in_selector7316 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_selector7318 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_selector7320 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_arguments7339 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x300007BBFF820122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expressionList_in_arguments7342 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_arguments7345 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_synpred1_Java475 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_123_in_synpred36_Java1216 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_synpred36_Java1218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_123_in_synpred38_Java1231 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_synpred38_Java1234 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_methodDeclaration_in_synpred41_Java1278 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_fieldDeclaration_in_synpred42_Java1307 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constantDeclaration_in_synpred51_Java1658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_synpred52_Java1679 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_synpred52_Java1681 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_interfaceMethodDeclaratorRest_in_synpred52_Java1683 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_124_in_synpred90_Java2666 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_Identifier_in_synpred90_Java2668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_127_in_synpred111_Java3001 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_synpred111_Java3003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_synpred127_Java3447 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationTypeElementDeclarations_in_synpred137_Java3664 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_localVariableDeclaration_in_synpred151_Java3973 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classOrInterfaceDeclaration_in_synpred152_Java3978 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_175_in_synpred157_Java4091 = new BitSet(new long[]{0x0000000000000400L,0x4A000FE000000000L,0x33EF579BFFFFE1A2L,0x0000000000007C00L});
    public static final BitSet FOLLOW_statement_in_synpred157_Java4093 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_catches_in_synpred162_Java4222 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0010000000000000L});
    public static final BitSet FOLLOW_180_in_synpred162_Java4226 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_block_in_synpred162_Java4228 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_catches_in_synpred163_Java4256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_187_in_synpred180_Java4638 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_constantExpression_in_synpred180_Java4640 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_synpred180_Java4642 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_187_in_synpred181_Java4658 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_enumConstantName_in_synpred181_Java4660 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
    public static final BitSet FOLLOW_173_in_synpred181_Java4662 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forVarControl_in_synpred183_Java4722 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableModifier_in_synpred188_Java4784 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000403FF820000L});
    public static final BitSet FOLLOW_type_in_synpred188_Java4787 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_variableDeclarators_in_synpred188_Java4789 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_140_in_synpred191_Java4954 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred191_Java4956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_188_in_synpred192_Java4973 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred192_Java4975 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred192_Java4977 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_189_in_synpred193_Java4996 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred193_Java4998 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred193_Java5000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_125_in_synpred194_Java5019 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred194_Java5021 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred194_Java5023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_190_in_synpred195_Java5042 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred195_Java5044 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred195_Java5046 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_191_in_synpred196_Java5068 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred196_Java5070 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_192_in_synpred197_Java5089 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred197_Java5091 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_193_in_synpred198_Java5110 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred198_Java5112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_194_in_synpred199_Java5134 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred199_Java5136 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred199_Java5138 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred200_Java5157 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred200_Java5159 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred200_Java5161 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred200_Java5163 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_synpred201_Java5182 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred201_Java5184 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred201_Java5186 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred201_Java5188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_synpred202_Java5207 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred202_Java5209 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred202_Java5211 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_140_in_synpred202_Java5213 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred202_Java5215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred213_Java5848 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_shiftExpression_in_synpred213_Java5850 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred217_Java5962 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred217_Java5964 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_131_in_synpred217_Java5968 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred217_Java5970 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_synpred217_Java5973 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred218_Java5962 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_129_in_synpred218_Java5964 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_131_in_synpred218_Java5968 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred218_Java5970 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_synpred218_Java5973 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000000000AL});
    public static final BitSet FOLLOW_131_in_synpred219_Java6007 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred219_Java6009 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred219_Java6011 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_synpred219_Java6013 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_131_in_synpred220_Java6007 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred220_Java6009 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_131_in_synpred220_Java6011 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_additiveExpression_in_synpred220_Java6013 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_castExpression_in_synpred234_Java6360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_synpred241_Java6510 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_primitiveType_in_synpred241_Java6512 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_synpred241_Java6514 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpression_in_synpred241_Java6516 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_synpred242_Java6539 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_type_in_synpred242_Java6541 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_165_in_synpred242_Java6543 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_unaryExpressionNotPlusMinus_in_synpred242_Java6545 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_138_in_synpred247_Java6654 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred247_Java6656 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred247_Java6658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_206_in_synpred251_Java6633 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_synpred251_Java6635 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x00000003FF800000L});
    public static final BitSet FOLLOW_primitiveType_in_synpred251_Java6638 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_synpred251_Java6654 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred251_Java6656 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred251_Java6658 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_synpred251_Java6663 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred251_Java6665 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_synpred251_Java6696 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred251_Java6698 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_arrayInitializer_in_synpred251_Java6702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_138_in_synpred255_Java6771 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred255_Java6773 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred255_Java6775 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_206_in_synpred260_Java6734 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800002L});
    public static final BitSet FOLLOW_nonWildcardTypeArguments_in_synpred260_Java6736 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_uniMod_in_synpred260_Java6739 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_synpred260_Java6745 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000400L});
    public static final BitSet FOLLOW_124_in_synpred260_Java6748 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L,0x0000000003800000L});
    public static final BitSet FOLLOW_refComponent_in_synpred260_Java6752 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000001000000400L});
    public static final BitSet FOLLOW_138_in_synpred260_Java6771 = new BitSet(new long[]{0x0000000000000000L,0x00000FE000000000L,0x3000039BFF800122L,0x0000000000007C00L});
    public static final BitSet FOLLOW_expression_in_synpred260_Java6773 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred260_Java6775 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_synpred260_Java6780 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred260_Java6782 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_138_in_synpred260_Java6818 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_139_in_synpred260_Java6820 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_arrayInitializer_in_synpred260_Java6824 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classCreatorRest_in_synpred260_Java6856 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_in_synpred261_Java6891 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L});
    public static final BitSet FOLLOW_124_in_synpred261_Java6893 = new BitSet(new long[]{0x0000000000000000L,0x4000000000000000L});
    public static final BitSet FOLLOW_126_in_synpred261_Java6895 = new BitSet(new long[]{0x0000000000000002L});

}